.\"
.\" ripquery.man,v 1.8 1992/10/08 19:53:08 jch Exp
.\"
.\" Gated Release 3.0
.\" Copyright (c) 1990,1991,1992,1993 by Cornell University. All rights reserved.
.\" Refer to Particulars and other Copyright notices at the end of this file.
.\"
.TH RIPQUERY 8 "7 October 1992" "Gated Release 3.0" "Cornell GateDaemon Project"
.SH NAME
ripquery \- query RIP gateways
.SH SYNOPSIS
.B ripquery
.RB [ " \-1 " ]
.RB [ " \-2 " ]
.RB [ " \-n " ]
.RB [ " \-p " ]
.RB [ " \-r " ]
.RB [ " \-v " ]
.RB [ " \-w time" ]
.I gateway \&.\|.\|.
.SH DESCRIPTION
.I Ripquery
is used to request all routes known by a RIP gateway by sending a RIP
request or POLL command.  The routing information in any routing packets
returned is displayed numerically and symbolically.
.I Ripquery
is intended to be used as a tool for debugging gateways, not for network
management.  SNMP is the preferred protocol for network management.
.PP
.I Ripquery
by default uses the RIP POLL command, which is an undocumented extension
to the RIP specification supported by
.I routed
on SunOS 3.x and later and by
.I gated
1.4 and later.
The RIP POLL command is preferred over the RIP REQUEST
command because it is not subject to Split Horizon and/or Poisoned
Reverse.  See the RIP RFC for more information.
.SH OPTIONS
.IP \fB\-1\fP
Send the query as a version 1 packet.
.IP \fB\-2\fP
Send the query as a version 2 packet (default).
.IP \fB\-n\fP
Prevents the address of the responding host from being
looked up to determine the symbolic name.
.IP \fB\-p\fP
Uses the RIP POLL command to request information from the routing table. 
This is the default, but is an undocumented extension supported only by
some versions of SunOS 3.x and later versions of
.I gated.
If there is no response to the RIP POLL command, the RIP REQUEST command
is tried.
.IP \fB\-r\fP
Used the RIP REQUEST command to request information from the gateway's
routing table.  Unlike the RIP POLL command, all gateways should support
the RIP REQUEST.  If there is no response to the RIP REQUEST command,
the RIP POLL command is tried.
.IP \fB\-v\fP
Version information about
.I ripquery
is displayed before querying the gateways.
.IP \fB\-w\fP
Specifies the time in seconds to wait for the initial response from a gateway. 
The default value is 5 seconds.
.SH EXAMPLES
.SH "SEE ALSO"
.IR routed (8)
.IR gated (8)
.IR gated-config (5)
.IR gated-copyright (8)
.br
.nf
RFC1058 - Routing Information Protocol
.fi
.SH BUGS
Some versions of SunOS do not allow looking up the symbolic name of a
subnet.
.SH COPYRIGHT INFORMATION
This software and associated documentation is Copyright \*(CO 1990,
1991, 1992 Cornell University., all rights reserved.
.PP
This daemon contains code that is Copyright \*(CO 1988 Regents of the
University of California., all rights reserved.; it also contains code
that is Copyright \*(CO 1989, 1990, 1991 The University of Maryland,
College Park, Maryland., all rights reserved; and also contains code that 
is Copyright 1991 D.L.S. Associates., all rights reserved.
.\"
.\" ------------------------------------------------------------------------
.\" 
.\" 	GateD, Release 3
.\" 
.\" 	Copyright (c) 1990,1991,1992,1993 by Cornell University
.\" 	    All rights reserved.
.\" 
.\" 	THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY
.\" 	EXPRESS OR IMPLIED WARRANTIES, INCLUDING, WITHOUT
.\" 	LIMITATION, THE IMPLIED WARRANTIES OF MERCHANTABILITY
.\" 	AND FITNESS FOR A PARTICULAR PURPOSE.
.\" 
.\" 	Royalty-free licenses to redistribute GateD Release
.\" 	3 in whole or in part may be obtained by writing to:
.\" 
.\" 	    GateDaemon Project
.\" 	    Information Technologies/Network Resources
.\" 	    200 CCC
.\" 	    Cornell University
.\" 	    Ithaca, NY  14853-2601  USA
.\" 
.\" 	GateD is based on Kirton's EGP, UC Berkeley's routing
.\" 	daemon	 (routed), and DCN's HELLO routing Protocol.
.\" 	Development of GateD has been supported in part by the
.\" 	National Science Foundation.
.\" 
.\" 	Please forward bug fixes, enhancements and questions to the
.\" 	gated mailing list: gated-people@gated.cornell.edu.
.\" 
.\" 	Authors:
.\" 
.\" 		Jeffrey C Honig <jch@gated.cornell.edu>
.\" 		Scott W Brim <swb@gated.cornell.edu>
.\" 
.\" ------------------------------------------------------------------------
.\" 
.\"       Portions of this software may fall under the following
.\"       copyrights:
.\" 
.\" 	Copyright (c) 1988 Regents of the University of California.
.\" 	All rights reserved.
.\" 
.\" 	Redistribution and use in source and binary forms are
.\" 	permitted provided that the above copyright notice and
.\" 	this paragraph are duplicated in all such forms and that
.\" 	any documentation, advertising materials, and other
.\" 	materials related to such distribution and use
.\" 	acknowledge that the software was developed by the
.\" 	University of California, Berkeley.  The name of the
.\" 	University may not be used to endorse or promote
.\" 	products derived from this software without specific
.\" 	prior written permission.  THIS SOFTWARE IS PROVIDED
.\" 	``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES,
.\" 	INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
.\" 	MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
.\"
