/*
 *  6/5/93	 Stuff needed for the MERIT IDRP port to UDP  
 */

/*
----------------------------------------------------------------------
		 from netiso/iso.h 
----------------------------------------------------------------------
*/

/* The following looks like a sockaddr
 * to facilitate using tree lookup routines */
struct iso_addr {
	u_char  isoa_len;               /* length (in bytes) */
	char    isoa_genaddr[20];       /* general opaque address */
};

/* used in the file idrp_sock.c */ 
struct sockaddr_iso {
        u_char                  siso_len;       /* length */
        u_char                  siso_family;    /* family */
        u_char                  siso_plen;      /* presentation selector length */
        u_char                  siso_slen;      /* session selector length */
        u_char                  siso_tlen;      /* transport selector length */
        struct  iso_addr        siso_addr;      /* network address */
        u_char                  siso_pad[6];    /* space for gosip v2 sels */
 
        /* makes struct 32 bytes long */
};


/*
----------------------------------------------------------------------
              from netiso/clnp.h 
----------------------------------------------------------------------
*/

/*
 *      Fixed part of clnp header
 */
struct clnp_fixed {
        u_char  cnf_proto_id;   /* network layer protocol identifier */
        u_char  cnf_hdr_len;    /* length indicator (octets) */
        u_char  cnf_vers;       /* version/protocol identifier extension */
        u_char  cnf_ttl;        /* lifetime (500 milliseconds) */
        u_char  cnf_type;       /* type code */
                                /* Includes err_ok, more_segs, and seg_ok */
        u_char  cnf_seglen_msb; /* pdu segment length (octets) high byte */
        u_char  cnf_seglen_lsb; /* pdu segment length (octets) low byte */
        u_char  cnf_cksum_msb;  /* checksum high byte */
        u_char  cnf_cksum_lsb;  /* checksum low byte */
};

/*
 * for iso_prefix
 */
#include "osi.h"

/*
 * ?? I do not remember (recompile the code without this to find the goal)
 */
#include "iso.h"

/*
 * for the iso field
 * from sockaddr.h  [ This file was patched also ]
 */
/*
#include "sockaddr.h"
*/

/* 
 * needed to include the computation of the ISO (Fletcher) checksum
 * in the file checksum.c
 */
/* reported in the  checksum.c 
#define FLETCHER_CHECKSUM
*
*/
 
