typedef union {
    long	num;
    u_long	u_num;
    bytestr	hex;
    charstr	str;
    flag_t	flag;
    time_t	time;
    as_t	as;
    proto_t	proto;
    pmet_t	metric;
    pref_t	pref;
    if_addr	*ifap;
    if_addr_entry	*ifae;
    adv_entry	*adv;
    gw_entry	*gwp;
    sockaddr_un	*sockaddr;
#ifdef	PROTO_INET
    struct in_addr in_addr;
#endif	/* PROTO_INET */
    dest_mask	dm;
    struct {
	pmet_t metric;
	adv_entry *adv;
    } metric_adv ;
    struct {
	proto_t proto;
	adv_entry **import_list;
	adv_entry **export_list;
	gw_entry **gw_list;
    } proto_lists;
    config_entry *config;
    config_list *conflist;
#ifndef	GATED_LEXER
#ifdef	PROTO_OSPF
    ospf_config_router *ospf_router;
#endif	/* PROTO_OSPF */
#if	defined(PROTO_ASPATHS)
    asmatch_t	*asp_match;
    struct {
	u_short	begin;
	u_short end;
    } asp_range;
    struct {
	flag_t	start[1 + ASP_ACC/ASP_WORD];
	flag_t	state[1 + ASP_ACC/ASP_WORD];
    } asp_stack;
#endif	/* PROTO_ASPATHS */
#endif	/* GATED_LEXER */
} YYSTYPE;
#define	L_EOS	258
#define	L_ERROR	259
#define	L_NUMBER	260
#define	L_STRING	261
#define	L_HNAME	262
#define	L_KEYWORD	263
#define	L_HEXSTRING	264
#define	L_OCTETSTRING	265
#define	L_HEXSTRING_ODD	266
#define	L_ISOADDR	267
#define	T_DIRECT	268
#define	T_INTERFACE	269
#define	T_INTERFACES	270
#define	T_LCLADDR	271
#define	T_PROTO	272
#define	T_METRIC	273
#define	T_METRICIN	274
#define	T_METRICOUT	275
#define	T_INFINITY	276
#define	T_DOWN	277
#define	T_PARSE	278
#define	T_ADV	279
#define	T_DEFAULT	280
#define	T_DEFAULTS	281
#define	T_YYDEBUG	282
#define	T_YYSTATE	283
#define	T_YYQUIT	284
#define	T_DEBUG	285
#define	T_SYSLOG	286
#define	T_UPTO	287
#define	T_EMERG	288
#define	T_ALERT	289
#define	T_CRIT	290
#define	T_ERR	291
#define	T_WARNING	292
#define	T_NOTICE	293
#define	T_INFO	294
#define	T_ON	295
#define	T_OFF	296
#define	T_GATEWAY	297
#define	T_PREFERENCE	298
#define	T_DEFAULTMETRIC	299
#define	T_NONBROADCAST	300
#define	T_BROADCAST	301
#define	T_TYPE	302
#define	T_POINTOPOINT	303
#define	T_MULTICAST	304
#define	T_NETMASK	305
#define	T_DEFINE	306
#define	T_NOP	307
#define	T_NOP1	308
#define	T_PEERAS	309
#define	T_LOCALAS	310
#define	T_NEIGHBOR	311
#define	T_GROUP	312
#define	T_GENDEFAULT	313
#define	T_NOGENDEFAULT	314
#define	T_VERSION	315
#define	T_DEFAULTIN	316
#define	T_DEFAULTOUT	317
#define	T_HOLDTIME	318
#define	T_BGP	319
#define	T_ALLOW	320
#define	T_TEST	321
#define	T_KEEPALL	322
#define	T_SENDBUF	323
#define	T_RECVBUF	324
#define	T_SPOOLBUF	325
#define	T_EGP	326
#define	T_ASPATH	327
#define	T_ORIGIN	328
#define	T_INCOMPLETE	329
#define	T_ANY	330
#define	T_TAG	331
#define	T_TRUSTEDGATEWAYS	332
#define	T_SOURCEGATEWAYS	333
#define	T_IP	334
#define	T_DUAL	335
#define	T_SNPA	336
#define	T_ISIS	337
#define	T_CIRCUIT	338
#define	T_SYSTEMID	339
#define	T_LEVEL	340
#define	T_IPREACH	341
#define	T_TROLL	342
#define	T_SET	343
#define	T_PREFIX	344
#define	T_INTDOMINFO	345
#define	T_MODE	346
#define	T_AREA	347
#define	T_SPF	348
#define	T_HELLOINTERVAL	349
#define	T_ROUTERDEADINTERVAL	350
#define	T_PRIORITY	351
#define	T_IDRP	352
#define	T_RDI	353
#define	T_OSISTATIC	354
#define	T_NSAP	355
#define	T_NET	356
#define	T_NSAPPREFIX	357
#define	T_OSILOCAL	358
#define	T_MULTIEXIT	359
#define	T_PROTOSOCK	360
#define	T_SIP	361
#define	T_PIP	362
#define	T_UDP	363
#define	T_LOCALNODE	364
#define	T_PROTOSUPPORT	365
#define	T_AUTHCODE	366
#define	T_INTRAIS	367
#define	T_RDC	368
#define	T_ASRDI	369
#define	T_OUTPDUS	370
#define	T_MAXPDUSIZE	371
#define	T_REXMIT	372
#define	T_CLOSEWAIT	373
#define	T_RIBCHECK	374
#define	T_MINADV	375
#define	T_MINADVRD	376
#define	T_PROHIBITDIST	377
#define	T_ALLOWDIST	378
#define	T_ROUTESERVER	379
#define	T_LISTENOPEN	380
#define	T_REDIRECT	381
#define	T_NOREDIRECTS	382
#define	T_ICMP	383
#define	T_AUTHTYPE	384
#define	T_AUTHKEY	385
#define	T_NONE	386
#define	T_SIMPLE	387
#define	T_PASSIVE	388
#define	T_SIMPLEX	389
#define	T_STRICTIFS	390
#define	T_SCANINTERVAL	391
#define	T_STATIC	392
#define	T_MARTIANS	393
#define	T_RETAIN	394
#define	T_EXPORT	395
#define	T_IMPORT	396
#define	T_HOST	397
#define	T_MASK	398
#define	T_MASKLEN	399
#define	T_REJECT	400
#define	T_BLACKHOLE	401
#define	T_RESTRICT	402
#define	T_AS	403
#define	T_ROUTERID	404
#define	T_IGP	405
#define	T_OPTIONS	406
#define	T_NOINSTALL	407
#define	T_NOSEND	408
#define	T_NORESOLV	409
#define	T_TRACEOPTIONS	410
#define	T_EXCEPT	411
#define	T_TRACEFILE	412
#define	T_REPLACE	413
#define	T_SIZE	414
#define	T_FILES	415
#define	T_K	416
#define	T_M	417
#define	T_ALL	418
#define	T_GENERAL	419
#define	T_INTERNAL	420
#define	T_EXTERNAL	421
#define	T_ROUTE	422
#define	T_UPDATE	423
#define	T_KERNEL	424
#define	T_TASK	425
#define	T_TIMER	426
#define	T_NOSTAMP	427
#define	T_MARK	428
#define	TISIS_IIH	429
#define	TISIS_DUMPLSP	430
#define	TISIS_EVENTS	431
#define	TISIS_LANADJ	432
#define	TISIS_FLOODING	433
#define	TISIS_BUILDLSP	434
#define	TISIS_CSNP	435
#define	TISIS_PSNP	436
#define	TISIS_LSPINPUT	437
#define	TISIS_P2PADJ	438
#define	TISIS_LSPDB	439
#define	TISIS_PATHS	440
#define	TISIS_LSPCONTENT	441
#define	TISIS_SUMMARY	442
#define	T_INET	443
#define	T_ISO	444


extern YYSTYPE yylval;
