#ifndef _idrp_macros_h
#define _idrp_macros_h

/* Macros for code */

#define IDRP_LIST(peer)  for (peer = idrp_peers; peer; peer = peer->next)
#define IDRP_LIST_END

#define IDRP_INT_PEER(peer) for (peer = idrp_peers; peer != idrp_ext_peers; peer = peer->next)
#define IDRP_INT_PEER_END

#define IDRP_EXT_PEER(peer) for (peer = idrp_ext_peers; peer; peer = peer->next)
#define IDRP_EXT_PEER_END

#define PEER_CNT_LOOP(i)	for (i = 0; i < idrp_neighbors; i++)
#define	PEER_CNT_LOOP_END


#define ATTR_LIST(att)	for (att = idrp_attr_list; att; att = att->next)
#define ATTR_LIST_END

#define NLRI_FAMILY_LOOP(i) for (i = 0; i < IDRP_NLRI_FAMILIES_SUPPORTED; i++) 
#define	NLRI_FAMILY_LOOP_END

#define	RDPATH_LIST(p_can_list,p_can)	for (p_can = p_can_list; p_can; p_can = p_can->p_next) 
#define	RDPATH_LIST_END

#define IDRP_WALK_RT_CHAIN(p_head,p_ch)	for (p_ch = (idrp_rt_chain_walk *) p_head; p_ch; p_ch->p_next)
#define IDRP_WALK_RT_CHAIN_END	

#define ANN_LIST(p_atl,p_ann_list)	for (p_atl = p_ann_list; p_atl; p_atl = p_atl->p_next) 
#define ANN_LIST_END

#define	ANN_WITH_LIST_WALK(p_irt,i,p_atl)	for (p_irt = p_atl->with_nlri[i].head; p_irt; p_irt = p_irt->p_with) 
#define	ANN_WITH_LIST_WALK_END

#define	ANN_WITH_LIST_DEL_WALK(p_irt,i,p_atl,p_rt_next)	for (p_irt = p_atl->with_nlri[i].head; p_irt; p_irt = p_rt_next) 
#define	ANN_WITH_LIST_DEL_WALK_END
#define	ANN_ANN_LIST_WALK(p_irt,i,p_atl)	for (p_irt = p_atl->ann_nlri[i].head; p_irt; p_irt = p_irt->p_ann_nlri)	
#define	ANN_ANN_LIST_WALK_END

#define ANN_ANN_NEXT_NLRI(p_irt,i,p_atl)	for (p_irt = p_atl->ann_nlri[i].head; p_irt; p_irt = p_irt->p_next_nlri)

#define	ANN_ANN_NEXT_NLRI_END

#define	IDRP_STATUS_BIT_CLEAR(p,bit)		p->status &= ~bit
#define	IDRP_STATUS_BIT_SET(p,bit)		p->status |= bit
#define	IDRP_FLAG_BIT_CLEAR(p,bit)		p->idrp_flags &= ~bit
#define	IDRP_FLAG_BIT_SET(p,bit)		p->idrp_flags |= bit

#ifdef ECHOKLUDGE
#define IS_SEQUENCED(type) ((type) == IDRP_OPEN_TYPE || \
			   (type) == IDRP_UPDATE_TYPE || \
			   (type) == IDRP_ECHO_TYPE || /* %% */ \
			   (type) == IDRP_ECHO_REPLY_TYPE || /* %% */ \
			   (type) == IDRP_RIB_REFRESH_TYPE)
#else
#define IS_SEQUENCED(type) ((type) == IDRP_OPEN_TYPE || \
			   (type) == IDRP_UPDATE_TYPE || \
			   (type) == IDRP_RIB_REFRESH_TYPE)
#endif


#define	IDRP_ROUTE_ID_HASH(id)	(id % IDRP_HASH_TABLE_SIZE)

#define PFX_BYTE_LENGTH(pfx) (((pfx).pfx_len + 7) /8)

#endif /* not defined _idrp_macros_h */
