#ifdef	PROTO_IDRP

#include "include.h"
#include "idrp.h"
#include <stdio.h>


/* idrp_dump.c
 * 
 * IDRP DUMP routines
 *	idrp_master_dump
 * 	idrp_peer_dump
 */ 
  


void idrp_master_dump(tp, fd)
task *tp;
FILE *fd;
{
	(void) fprintf(fd, "RIB contents are in the routing table:\n");
	/* here we need to add a walk through the local RIB table via the gated */
	/* dump_local_rib(fd); */
}

			
void idrp_peer_dump(tp, fd)
task *tp;
FILE *fd;
{
/* variables and initialization */
	idrpPeer *peer = (idrpPeer *) tp->task_data;

	/* peer information */
	(void) fprintf(fd, "IDRP peer NET %s, state %s\n", peer->name, trace_state(peer->state, idrpStates));
	(void) fprintf(fd, " SND.NXT = %d, SEND.UWE = %d, SND.UNA = %d\n", peer->send_next,
		peer->upper_window_edge, peer->send_unack);
	(void) fprintf(fd, " RCV.EXP = %d, RCV.CRED = %d, RCV.CREDAV = %d\n", peer->rcv_seq_expected, peer->rcv_credit, 
		peer->rcved_credit_avail);
	(void) fprintf(fd, " HOLDTIME = %d, KEEPALIVETIME = %d\n", peer->hold_time, peer->keepalive_time);
	(void) fprintf(fd, " MAXSENDSIZE = %d, MAXRCVSIZE = %d\n", peer->pdu_maxsendsize, peer->pdu_maxrcvsize);

	/* dump the policy - which is null right now */
	
/* if (idrp_import_list) {
 *          control_exterior_dump(fd, 1, control_import_dump, idrp_import_list);
 *   }
 *      if (bgp_export_list) {
 *         control_exterior_dump(fd, 1, control_export_dump, _export_list);
 * 	   }
 */

}

#endif /* PROTO_IDRP */
