
# line 2 "parser.y"
/*
 *  parser.y,v 1.60 1993/04/10 12:25:26 jch Exp
 */

/* Gated Release 3.0 */
/* Copyright (c) 1990,1991,1992,1993 by Cornell University. All rights reserved. */
/* Refer to Particulars and other Copyright notices at the end of this file. */


#include "include.h"
#ifdef	PROTO_INET
#include "inet.h"
#endif	/* PROTO_INET */
#ifdef	PROTO_ISO
#include "iso.h"
#endif	/* PROTO_ISO */
#include "parse.h"
#include "krt.h"
#ifdef	PROTO_RIP
#include "rip.h"
#endif	/* PROTO_RIP */
#ifdef	PROTO_HELLO
#include "hello.h"
#endif	/* PROTO_HELLO */
#ifdef	PROTO_EGP
#include "egp.h"
#endif	/* PROTO_EGP */
#ifdef	PROTO_BGP
#include "bgp.h"
#endif	/* PROTO_BGP */
#ifdef	PROTO_DVMRP
#include "dvmrp.h"
#endif	/* PROTO_DVMRP */
#ifdef	PROTO_ISODE_SNMP
#include "snmp_isode.h"
#endif	/* PROTO_ISODE_SNMP */
#ifdef	 PROTO_ISIS
#include "isis.h"
#include "isis_test.h"
#include "isis_globals.h"
#endif	/* PROTO_ISIS */
#ifdef	PROTO_IDRP
#include "idrp.h"
#endif /* PROTO_IDRP */
  
char parse_error[LINE_MAX] = { 0 };
char *parse_filename = 0;

static	proto_t	parse_proto;			/* For correctly tagging ADV lists */
static	proto_t	parse_export_proto;		/* For checking metrics */
static	gw_entry	**parse_gwlist;
#if	defined(PROTO_SLSP) || defined(PROTO_EGP) || defined(PROTO_BGP)
static	gw_entry	*parse_gwp;		/* To fake a list for EGP and BGP */
#endif
static  char *parse_serv_proto;
static	int	parse_contig_masks = TRUE;	/* Masks must be contiguous */
static	bgpPeer *bnp;
static	bgpPeerGroup *bgp;
static 	struct bgp_conf *bcp;
static	idrpPeer *idgp, idrp_group, *gr_idrp;
struct	iso_prefix *nlri; 
static	idrpRoute *p_idrp;
static	int idrp_parse_group_index;
static	idrpRoute_options 	idrp_rt_opts;	
static	idrp_canon_rdpath	*p_rdi_head,*p_rdi_tail;
static	idrp_canon_rdpath	*p_idrp_excl_rdi_tail, *p_idrp_excl_rdi_head;
static	idrp_canon_rdpath	*p_idrp_incl_rdi_tail, *p_idrp_incl_rdi_head;
static if_info parse_ifi;	/* Used for configuring interfaces that do not exist */

u_int parse_state = PS_INITIAL;
proto_t protos_seen = 0;

PROTOTYPE(yyerror,
	  static void,
	  (const char *));

#define	free_string(s)	task_mem_free((task *) 0, (caddr_t) s); s = 0
#define	free_charstr(s)	task_mem_free((task *) 0, (caddr_t) (s)->ptr); (s)->ptr = (char *) 0; (s)->len = (s)->type = 0
#define	free_bytestr(s)	task_mem_free((task *) 0, (caddr_t) (s)->ptr); (s)->ptr = (byte *) 0; (s)->len = (s)->type = 0

#define	PARSE_ERROR	yyerror(parse_error); yynerrs++; YYERROR;

#define	PROTO_SEEN(proto) \
	if (BIT_TEST(protos_seen, RTPROTO_BIT(proto))) { \
	    sprintf(parse_error, "parse_proto_seen: duplicate %s clause", gd_lower(trace_state(rt_proto_bits, proto))); \
	    PARSE_ERROR; \
	} else { \
	    BIT_SET(protos_seen, RTPROTO_BIT(proto)); \
	    parse_proto = proto; \
	} \

#ifdef	PROTO_ASPATHS
static unsigned	aspath_state;
static asmatch_t *aspath_current;

#define	ASPATH_NEXT_STATE	if (aspath_state++ == ASP_BITS) { \
	sprintf(parse_error, "too many AS path regexp states"); \
	PARSE_ERROR; \
    }
#endif	/* PROTO_ASPATHS */


# line 106 "parser.y"
typedef union  {
    long	num;
    u_long	u_num;
    bytestr	hex;
    charstr	str;
    flag_t	flag;
    time_t	time;
    as_t	as;
    proto_t	proto;
    pmet_t	metric;
    pref_t	pref;
    if_addr	*ifap;
    if_addr_entry	*ifae;
    adv_entry	*adv;
    gw_entry	*gwp;
    sockaddr_un	*sockaddr;
#ifdef	PROTO_INET
    struct in_addr in_addr;
#endif	/* PROTO_INET */
    dest_mask	dm;
    struct {
	pmet_t metric;
	adv_entry *adv;
    } metric_adv ;
    struct {
	proto_t proto;
	adv_entry **import_list;
	adv_entry **export_list;
	gw_entry **gw_list;
    } proto_lists;
    config_entry *config;
    config_list *conflist;
#ifndef	GATED_LEXER
#ifdef	PROTO_OSPF
    ospf_config_router *ospf_router;
#endif	/* PROTO_OSPF */
#if	defined(PROTO_ASPATHS)
    asmatch_t	*asp_match;
    struct {
	u_short	begin;
	u_short end;
    } asp_range;
    struct {
	flag_t	start[1 + ASP_ACC/ASP_WORD];
	flag_t	state[1 + ASP_ACC/ASP_WORD];
    } asp_stack;
#endif	/* PROTO_ASPATHS */
#endif	/* GATED_LEXER */
} YYSTYPE;
# define L_EOS 257
# define L_ERROR 258
# define L_NUMBER 259
# define L_STRING 260
# define L_HNAME 261
# define L_KEYWORD 262
# define L_HEXSTRING 263
# define L_OCTETSTRING 264
# define L_HEXSTRING_ODD 265
# define L_ISOADDR 266
# define T_DIRECT 267
# define T_INTERFACE 268
# define T_INTERFACES 269
# define T_LCLADDR 270
# define T_PROTO 271
# define T_METRIC 272
# define T_METRICIN 273
# define T_METRICOUT 274
# define T_INFINITY 275
# define T_DOWN 276
# define T_PARSE 277
# define T_ADV 278
# define T_DEFAULT 279
# define T_DEFAULTS 280
# define T_YYDEBUG 281
# define T_YYSTATE 282
# define T_YYQUIT 283
# define T_DEBUG 284
# define T_SYSLOG 285
# define T_UPTO 286
# define T_EMERG 287
# define T_ALERT 288
# define T_CRIT 289
# define T_ERR 290
# define T_WARNING 291
# define T_NOTICE 292
# define T_INFO 293
# define T_ON 294
# define T_OFF 295
# define T_GATEWAY 296
# define T_PREFERENCE 297
# define T_DEFAULTMETRIC 298
# define T_NONBROADCAST 299
# define T_BROADCAST 300
# define T_TYPE 301
# define T_POINTOPOINT 302
# define T_MULTICAST 303
# define T_NETMASK 304
# define T_DEFINE 305
# define T_NOP 306
# define T_NOP1 307
# define T_PEERAS 308
# define T_LOCALAS 309
# define T_NEIGHBOR 310
# define T_GROUP 311
# define T_GENDEFAULT 312
# define T_NOGENDEFAULT 313
# define T_VERSION 314
# define T_DEFAULTIN 315
# define T_DEFAULTOUT 316
# define T_HOLDTIME 317
# define T_BGP 318
# define T_ALLOW 319
# define T_TEST 320
# define T_KEEPALL 321
# define T_SENDBUF 322
# define T_RECVBUF 323
# define T_SPOOLBUF 324
# define T_EGP 325
# define T_ASPATH 326
# define T_ORIGIN 327
# define T_INCOMPLETE 328
# define T_ANY 329
# define T_TAG 330
# define T_TRUSTEDGATEWAYS 331
# define T_SOURCEGATEWAYS 332
# define T_IP 333
# define T_DUAL 334
# define T_SNPA 335
# define T_ISIS 336
# define T_CIRCUIT 337
# define T_SYSTEMID 338
# define T_LEVEL 339
# define T_IPREACH 340
# define T_TROLL 341
# define T_SET 342
# define T_PREFIX 343
# define T_INTDOMINFO 344
# define T_MODE 345
# define T_AREA 346
# define T_SPF 347
# define T_HELLOINTERVAL 348
# define T_ROUTERDEADINTERVAL 349
# define T_PRIORITY 350
# define T_IDRP 351
# define T_RDI 352
# define T_OSISTATIC 353
# define T_NSAP 354
# define T_NET 355
# define T_NSAPPREFIX 356
# define T_OSILOCAL 357
# define T_MULTIEXIT 358
# define T_PROTOSOCK 359
# define T_SIP 360
# define T_PIP 361
# define T_UDP 362
# define T_LOCALNODE 363
# define T_PROTOSUPPORT 364
# define T_AUTHCODE 365
# define T_INTRAIS 366
# define T_RDC 367
# define T_ASRDI 368
# define T_OUTPDUS 369
# define T_MAXPDUSIZE 370
# define T_REXMIT 371
# define T_CLOSEWAIT 372
# define T_RIBCHECK 373
# define T_MINADV 374
# define T_MINADVRD 375
# define T_PROHIBITDIST 376
# define T_ALLOWDIST 377
# define T_ROUTESERVER 378
# define T_LISTENOPEN 379
# define T_REDIRECT 380
# define T_NOREDIRECTS 381
# define T_ICMP 382
# define T_AUTHTYPE 383
# define T_AUTHKEY 384
# define T_NONE 385
# define T_SIMPLE 386
# define T_PASSIVE 387
# define T_SIMPLEX 388
# define T_STRICTIFS 389
# define T_SCANINTERVAL 390
# define T_STATIC 391
# define T_MARTIANS 392
# define T_RETAIN 393
# define T_EXPORT 394
# define T_IMPORT 395
# define T_HOST 396
# define T_MASK 397
# define T_MASKLEN 398
# define T_REJECT 399
# define T_BLACKHOLE 400
# define T_RESTRICT 401
# define T_AS 402
# define T_ROUTERID 403
# define T_IGP 404
# define T_OPTIONS 405
# define T_NOINSTALL 406
# define T_NOSEND 407
# define T_NORESOLV 408
# define T_TRACEOPTIONS 409
# define T_EXCEPT 410
# define T_TRACEFILE 411
# define T_REPLACE 412
# define T_SIZE 413
# define T_FILES 414
# define T_K 415
# define T_M 416
# define T_ALL 417
# define T_GENERAL 418
# define T_INTERNAL 419
# define T_EXTERNAL 420
# define T_ROUTE 421
# define T_UPDATE 422
# define T_KERNEL 423
# define T_TASK 424
# define T_TIMER 425
# define T_NOSTAMP 426
# define T_MARK 427
# define TISIS_IIH 428
# define TISIS_DUMPLSP 429
# define TISIS_EVENTS 430
# define TISIS_LANADJ 431
# define TISIS_FLOODING 432
# define TISIS_BUILDLSP 433
# define TISIS_CSNP 434
# define TISIS_PSNP 435
# define TISIS_LSPINPUT 436
# define TISIS_P2PADJ 437
# define TISIS_LSPDB 438
# define TISIS_PATHS 439
# define TISIS_LSPCONTENT 440
# define TISIS_SUMMARY 441
# define T_INET 442
# define T_ISO 443
#define yyclearin yychar = -1
#define yyerrok yyerrflag = 0
extern int yychar;
extern int yyerrflag;
#ifndef YYMAXDEPTH
#define YYMAXDEPTH 150
#endif
YYSTYPE yylval, yyval;
typedef int yytabelem;
# define YYERRCODE 256

# line 4043 "parser.y"


/*
 *	Log any parsing errors
 */
static void
yyerror(s)
const char *s;
{
    byte *cp;

    trace(TR_ALL, 0, NULL);
    tracef("parse: %s ",
	   parse_where());

    switch (yychar) {
    case L_HEXSTRING:
	tracef("%s at '",
	       s);
	for (cp = yylval.hex.ptr; (cp - yylval.hex.ptr) < yylval.hex.len; cp++) {
	    tracef("%02x", *cp);
	}
	tracef("'");
	break;

    case L_OCTETSTRING:
	tracef("%s at '",
	       s);
	for (cp = yylval.hex.ptr; (cp - yylval.hex.ptr) < yylval.hex.len; cp++) {
	    tracef("%s%u",
		   (cp == yylval.hex.ptr) ? "" : ".",
		   *cp);
	}
	tracef("'");
	break;

    case L_NUMBER:
	tracef("%s at '%d'",
	       s,
	       yylval.num);
	break;

    case L_EOS:
	tracef("%s at 'end-of-statement'",
	       s);
	break;

    case L_ERROR:
	tracef("%s",
	       parse_error);
	break;

#ifdef	YYEOF
    case YYEOF:
#else	/* YYEOF */
    case 0:
#endif	/* YYEOF */
	tracef("%s at 'end-of-file'",
		   s);
	break;

    default:
	if (!parse_keyword_lookup(yychar)) {
#if	YYDEBUG != 0
#ifdef	YYTRANSLATE
	    tracef("%s at '%s'",
		   s,
		   yytname[YYTRANSLATE(yychar)]);
#else	/* YYTRANSLATE */
	    tracef("%s at '%s'",
		   s,
		   yyname[yychar]);
#endif	/* YYTRANSLATE */
#else	/* YYDEBUG */
	    tracef("%s",
		   s);
#endif	/* YYDEBUG */
	    break;
	}
	/* Fall Through */

    case L_STRING:
    case L_HNAME:
    case L_KEYWORD:
	tracef("%s at '%s' length %d",
	       s,
	       yylval.str.ptr,
	       yylval.str.len);
	break;

#ifdef	YYEMPTY
    case YYEMPTY:
	tracef("%s",
	       s);
	break;
#endif	/* YYEMPTY */
    }
    trace(TR_ALL, LOG_ERR, NULL);
    trace(TR_ALL, 0, NULL);
}



/*
 * ------------------------------------------------------------------------
 * 
 * 	GateD, Release 3
 * 
 * 	Copyright (c) 1990,1991,1992,1993 by Cornell University
 * 	    All rights reserved.
 * 
 * 	THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY
 * 	EXPRESS OR IMPLIED WARRANTIES, INCLUDING, WITHOUT
 * 	LIMITATION, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * 	AND FITNESS FOR A PARTICULAR PURPOSE.
 * 
 * 	Royalty-free licenses to redistribute GateD Release
 * 	3 in whole or in part may be obtained by writing to:
 * 
 * 	    GateDaemon Project
 * 	    Information Technologies/Network Resources
 * 	    200 CCC
 * 	    Cornell University
 * 	    Ithaca, NY  14853-2601  USA
 * 
 * 	GateD is based on Kirton's EGP, UC Berkeley's routing
 * 	daemon	 (routed), and DCN's HELLO routing Protocol.
 * 	Development of GateD has been supported in part by the
 * 	National Science Foundation.
 * 
 * 	Please forward bug fixes, enhancements and questions to the
 * 	gated mailing list: gated-people@gated.cornell.edu.
 * 
 * 	Authors:
 * 
 * 		Jeffrey C Honig <jch@gated.cornell.edu>
 * 		Scott W Brim <swb@gated.cornell.edu>
 * 
 * ------------------------------------------------------------------------
 * 
 *       Portions of this software may fall under the following
 *       copyrights:
 * 
 * 	Copyright (c) 1988 Regents of the University of California.
 * 	All rights reserved.
 * 
 * 	Redistribution and use in source and binary forms are
 * 	permitted provided that the above copyright notice and
 * 	this paragraph are duplicated in all such forms and that
 * 	any documentation, advertising materials, and other
 * 	materials related to such distribution and use
 * 	acknowledge that the software was developed by the
 * 	University of California, Berkeley.  The name of the
 * 	University may not be used to endorse or promote
 * 	products derived from this software without specific
 * 	prior written permission.  THIS SOFTWARE IS PROVIDED
 * 	``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES,
 * 	INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
 * 	MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */
yytabelem yyexca[] ={
-1, 0,
	0, 1,
	269, 90,
	318, 133,
	336, 133,
	351, 133,
	380, 133,
	391, 359,
	394, 377,
	395, 377,
	405, 70,
	-2, 57,
-1, 1,
	0, -1,
	-2, 0,
-1, 2,
	0, 2,
	269, 90,
	318, 133,
	336, 133,
	351, 133,
	380, 133,
	391, 359,
	394, 377,
	395, 377,
	405, 70,
	-2, 57,
-1, 402,
	125, 255,
	-2, 257,
-1, 445,
	125, 256,
	-2, 260,
-1, 507,
	409, 334,
	-2, 316,
-1, 535,
	330, 489,
	-2, 490,
-1, 583,
	257, 288,
	-2, 302,
-1, 611,
	257, 289,
	-2, 302,
-1, 739,
	355, 469,
	-2, 338,
	};
# define YYNPROD 516
# define YYLAST 1017
yytabelem yyact[]={

   238,   239,   448,    89,   250,   184,   702,   336,   575,   449,
   703,   183,   525,   524,   698,   340,   363,   574,   165,   327,
   630,   249,   595,   613,   647,   294,    46,   614,   615,   202,
   611,   316,   464,   649,   337,   196,    87,   199,    82,   245,
   150,   648,   456,   364,   193,   383,   400,   447,    84,   604,
    88,    70,   191,   192,    90,    91,    80,   197,   576,   427,
   230,    47,    48,    69,   560,   188,   439,   440,   207,   383,
   223,   371,   393,   394,   208,   209,   579,   114,   116,   323,
   453,    21,   589,   518,   205,    12,    13,   577,   441,   519,
   520,   562,   561,   505,   717,   198,   521,   194,   222,   260,
   142,   144,    41,   120,   434,   120,   241,   240,   437,   428,
    14,    15,    16,   605,   119,   372,   634,   305,   164,   385,
   386,   260,   138,   139,   141,   145,   373,   374,   375,   376,
   377,   378,   379,   380,   381,   382,   384,   387,   388,   372,
    44,    43,   672,   385,   386,   210,   678,   189,   190,   162,
   373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
   384,   387,   388,    77,   450,   152,   466,   723,   578,   467,
   462,   189,   190,   542,   559,   304,   220,   158,   216,    83,
   189,   190,   219,   267,   268,   545,   679,   187,   433,   284,
    74,   343,   237,   591,    88,    70,   191,   192,    90,    91,
   409,   197,   552,   431,   432,   254,   255,   586,   529,   244,
   143,   164,   152,   200,   185,   254,   255,   482,   242,   466,
   272,   453,   467,   716,   158,   256,   616,   365,   596,   619,
   620,   451,   452,   718,   224,   740,   254,   255,    17,   154,
    18,   194,   261,   276,   164,   465,   324,   120,   307,   617,
   258,   181,   254,   255,    88,    70,   191,   192,    90,    91,
   422,   197,   277,   117,   164,   549,   548,   619,   620,   618,
   331,    30,   254,   255,   185,   315,   212,   319,   318,   235,
   553,   616,   254,   255,    73,    75,    76,   236,   214,   607,
   252,    77,   164,   204,    47,    48,   362,   543,   465,   353,
   101,   194,   164,   310,   617,    37,   361,   234,   164,   218,
   269,   603,    88,    70,   191,   192,    90,    91,    74,   197,
   286,   203,   450,    38,   618,   215,   391,   357,   442,   544,
    23,   187,   223,   389,   152,   331,   345,   100,    39,   397,
   368,   369,   248,   405,   390,    26,   148,   395,    30,   311,
   733,   424,   401,   425,   406,   309,   204,   344,   266,   194,
   222,   287,   288,   421,   720,    83,   742,    36,   472,    88,
    70,   191,   192,    90,    91,   290,   197,   331,   186,    88,
    70,   191,   192,    90,    91,    25,   197,    90,    91,   451,
   452,   187,   612,   279,   616,    28,    29,   514,   163,   515,
   164,   308,    90,    91,    63,   281,   635,    81,   154,   416,
   111,   112,    73,    75,    76,   329,   194,   617,   721,   164,
   609,   328,   396,    70,   697,   213,   194,   722,   163,   479,
   480,   443,    90,    91,   280,   619,   620,   618,   186,   189,
   190,   477,   436,   341,   338,   455,   164,   346,   347,   187,
   470,    65,   507,    88,   166,    85,   598,    90,    91,   348,
   349,   189,   190,   573,   572,   571,   528,   570,   282,    66,
   569,   568,   527,   289,   610,   358,   567,   486,    88,    70,
   191,   192,    90,    91,    67,   197,   481,   204,   513,   565,
   468,   476,    49,    54,   506,   750,   224,   401,   516,   474,
   509,   597,   550,   749,   485,   726,   187,   508,   725,   484,
   710,   709,   708,   707,   475,   677,   535,   554,   563,   564,
   682,   319,   318,   566,   676,   194,   314,   529,    88,   107,
   675,   555,    90,    91,   420,   197,   164,   270,   674,   637,
   636,   582,   332,   106,   581,   557,   283,   583,   556,   534,
    55,    56,    57,    58,    59,    60,    64,    61,    62,   109,
   110,   533,   332,   587,   585,   523,   522,   588,   592,   593,
   594,   510,   411,   417,   590,   317,   407,   313,   601,   602,
   599,   399,   107,   606,   319,   318,    88,    70,   191,   192,
    90,    91,   354,   197,   131,   164,   123,   124,   125,   126,
   127,   128,   129,   130,   457,   164,   164,   164,   398,   621,
   367,   291,   366,   622,   360,   625,   626,   627,   359,   352,
   645,   164,   351,    63,   339,   355,   624,   334,   330,   111,
   112,   321,   271,   194,    85,   639,   631,   632,   633,   640,
   312,   275,   642,   641,   651,   650,   652,    63,   274,   273,
   131,   684,   646,   124,   125,   126,   127,   128,   129,   130,
   164,   264,   694,   693,   687,   673,   263,   262,   642,   640,
    65,   233,   232,   164,   164,   164,   228,   688,   695,   690,
   696,   689,   164,   706,   160,   700,   189,   190,    66,   680,
   137,   528,   680,   136,    65,   135,   134,   527,   104,   711,
   103,   102,   512,    67,   699,   699,   701,   713,   259,   514,
    94,   515,    66,   705,    93,   714,    92,    50,    45,   257,
   681,   164,   644,   643,   243,   724,   180,    67,   526,   531,
   729,   487,   730,   530,   122,   459,   189,   190,   737,    63,
   738,   745,   293,   748,   747,   606,   746,   744,   743,   751,
   736,   734,   489,   201,   410,   731,   686,   629,   259,   404,
   402,    52,   335,   661,   322,   178,   176,   656,   174,    55,
    56,    57,    58,    59,    60,    64,    61,    62,   109,   110,
    88,    70,   191,   192,   739,    91,    65,   197,   172,   659,
   660,   412,   413,    55,    56,    57,    58,    59,    60,    64,
    61,    62,   657,   146,    66,   133,   658,   664,   666,   667,
   662,   132,   414,   497,   668,   669,   670,   671,   105,    67,
   151,   298,   147,   295,   296,   304,   300,   194,   303,   301,
   302,    72,   299,   429,   546,   419,   532,   251,   471,   704,
   429,     3,   246,   195,    19,   685,   460,   179,    27,    99,
   278,   225,   171,    95,   492,   504,   167,   511,   168,   732,
   490,   638,   229,   494,   493,   495,   558,   499,   498,   500,
   501,   502,   415,    86,   491,   496,    30,   429,   488,   503,
   665,   445,   608,   454,   580,    55,    56,    57,    58,    59,
    60,    64,    61,    62,   446,   297,   403,   444,   306,   221,
   177,    98,   663,   118,   728,   727,   231,   719,   655,   712,
   206,   654,   600,   285,   226,   173,    96,   551,   483,   435,
   292,   227,   157,   175,   155,   159,   247,    97,    35,    34,
    33,    32,   547,   478,   423,   350,   265,   211,   169,    78,
    71,    79,   113,    42,    11,    40,    10,    31,     9,    24,
     8,    22,     7,    20,     6,     5,     4,     2,     1,    -1,
   628,   653,   683,   418,   473,   458,   408,   320,   170,   253,
   217,   692,   691,   584,    -1,    -1,   333,   540,   539,   538,
   541,   156,   149,   115,   342,   161,    68,    53,    51,    -1,
   108,   715,   517,   182,   356,   426,   370,   392,   438,    -1,
   140,   537,   623,    -1,    -1,    -1,   536,   461,   463,   469,
   325,   326,   735,   741,   153,   430,   121 };
yytabelem yypact[]={

  -171, -1000,  -171, -1000, -1000, -1000,  -324,    61,    -7,   -13,
  -289,  -254,   461, -1000,     0,   233,   460,   376,   163, -1000,
 -1000,  -122, -1000, -1000, -1000, -1000,   144,   102,   196,   194,
 -1000, -1000,   459,   457,   453, -1000, -1000, -1000, -1000, -1000,
 -1000, -1000, -1000,    66,    29, -1000,   444, -1000, -1000,   443,
 -1000,   441, -1000,   133, -1000, -1000, -1000, -1000, -1000, -1000,
 -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,  -336,  -334,
 -1000,     6, -1000, -1000,   -50, -1000, -1000,   310,   688,   682,
   439, -1000,   438, -1000,   436, -1000,   433, -1000, -1000, -1000,
 -1000, -1000, -1000, -1000, -1000,     0,     0,  -233,     0,   680,
    28,  -141, -1000, -1000, -1000, -1000,   352, -1000, -1000, -1000,
 -1000, -1000, -1000,   427,   139, -1000, -1000, -1000, -1000, -1000,
   195,   366, -1000,   366, -1000, -1000, -1000, -1000, -1000, -1000,
 -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,   665,   645,
   643, -1000, -1000, -1000, -1000,   642,    -5,  -307,  -113,    25,
 -1000, -1000, -1000, -1000, -1000,  -318,    25, -1000, -1000, -1000,
 -1000,  -346,  -341, -1000, -1000, -1000, -1000, -1000, -1000,    20,
    53, -1000, -1000, -1000, -1000, -1000, -1000,   419, -1000,   -65,
   415,   414,    11, -1000, -1000, -1000,     8,   327,  -291, -1000,
 -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,   196,  -192,
 -1000,  -192, -1000,   327,   327,   196,  -151,   139, -1000, -1000,
   410,   409,   404,  -206,   120,   327,   392,   391,   384, -1000,
 -1000, -1000, -1000, -1000,   -36,   137,    64,   486, -1000,    -8,
 -1000,   383, -1000, -1000,   327,   327, -1000, -1000, -1000, -1000,
   139,   269,  -192,   374, -1000,   641,   375,   371,   327, -1000,
 -1000,   327, -1000, -1000, -1000, -1000,  -151,   370, -1000,   639,
   169, -1000, -1000, -1000, -1000,  -206, -1000, -1000,   184,    60,
 -1000,   327, -1000, -1000, -1000, -1000, -1000, -1000,   365,   362,
   195,   120,   327,   468, -1000,   361,   357,   195,   169,   468,
   -74, -1000,   355,   353, -1000,   163,   163,  -278,   139,   163,
  -164,  -347,   163,   161,   139, -1000,   351,   324,   468,   637,
 -1000,   636, -1000,   219,   -50, -1000, -1000, -1000, -1000, -1000,
   319, -1000, -1000,  -127,   630,   375,   749, -1000, -1000,   375,
 -1000, -1000, -1000,   316, -1000, -1000, -1000, -1000, -1000, -1000,
 -1000,   777,    60, -1000,   195,   -37, -1000, -1000, -1000, -1000,
    51, -1000, -1000, -1000,  -272,   327, -1000,   468, -1000, -1000,
 -1000, -1000, -1000, -1000,   468,  -216, -1000, -1000, -1000, -1000,
  -302, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
 -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
 -1000,  -353,    56, -1000, -1000, -1000,   139, -1000, -1000, -1000,
 -1000,   468, -1000,  -188, -1000,   -50, -1000, -1000,   479,  -159,
   375, -1000, -1000, -1000, -1000,   139,   797, -1000,   243,   232,
 -1000, -1000,   195, -1000,   327,   327,  -272, -1000, -1000, -1000,
   -91, -1000, -1000, -1000, -1000, -1000, -1000,  -278,   327, -1000,
 -1000, -1000,   139, -1000,   606,   496,   -30, -1000, -1000,  -329,
   144, -1000, -1000,   468,   446, -1000,  -310, -1000,   309,   308,
  -209, -1000, -1000,   609, -1000, -1000, -1000, -1000, -1000,   604,
   792, -1000, -1000,   304,   292,   -94,   776, -1000,   -38, -1000,
 -1000, -1000,   196,   -70, -1000,   269,   163, -1000,   291,   288,
  -269,     0,     0, -1000, -1000,   230,     0,   217,   212,   211,
   208,   206,   205,   204,  -275, -1000, -1000, -1000, -1000, -1000,
 -1000,   287,   284,   134, -1000, -1000,  -310, -1000, -1000, -1000,
 -1000, -1000, -1000, -1000,  -194, -1000, -1000, -1000, -1000, -1000,
  -106, -1000,   139, -1000, -1000,  -320,  -113,  -137,    88,    88,
    88,  -173, -1000, -1000, -1000, -1000,   197, -1000,   269, -1000,
 -1000, -1000,  -164,  -164,    39, -1000, -1000, -1000, -1000, -1000,
  -394, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
 -1000, -1000, -1000,  -252,  -275, -1000, -1000, -1000, -1000, -1000,
   164, -1000, -1000,    59, -1000, -1000, -1000, -1000, -1000,   196,
  -173,   139,  -173,  -173,  -173, -1000, -1000,   634, -1000, -1000,
 -1000,   139,   139,   139,  -245,   143, -1000, -1000,   283,   282,
 -1000,  -109,   -54,  -147,   467,   466,   124,   139, -1000,   134,
   134,  -173, -1000,  -173, -1000, -1000, -1000, -1000, -1000, -1000,
   493, -1000, -1000, -1000,  -218, -1000, -1000, -1000,     0,  -147,
   281,   -54,   273,   267,   258,  -212,  -149,   134,   464, -1000,
   134, -1000, -1000,   395,   633, -1000,   169,   196, -1000,   327,
   195,   327,   184,   468,   165, -1000, -1000, -1000, -1000,   139,
   139,   139, -1000,   -84, -1000, -1000, -1000, -1000,   139,   124,
   256,   255, -1000,   254,   253,  -209, -1000, -1000, -1000, -1000,
 -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
 -1000, -1000,   327, -1000,   102, -1000, -1000, -1000, -1000, -1000,
 -1000,  -178,   108,  -185, -1000, -1000, -1000,   169, -1000,   251,
   248, -1000, -1000,   -84, -1000, -1000, -1000,   327,   632,    82,
 -1000, -1000,  -275,   521,   493,   110,  -275,   -84,   327, -1000,
 -1000,   246,   238, -1000, -1000, -1000,  -329, -1000, -1000, -1000,
 -1000, -1000 };
yytabelem yypgo[]={

     0,   734,  1016,  1015,    14,    16,  1014,  1013,  1012,    37,
    79,   246,  1011,  1010,  1009,  1008,    32,  1007,  1006,  1005,
  1004,  1003,  1002,  1001,  1000,   999,    25,   998,   997,   996,
    71,    46,    56,     6,    10,    33,    59,   995,   994,   993,
    42,   992,    34,     3,     7,   501,   991,    15,    26,    43,
   475,   990,   989,   988,   987,   818,   986,   985,   984,   191,
   983,    40,   822,   982,   981,   820,   980,   979,   978,   977,
    19,   975,   974,    18,    39,   973,   972,     1,    31,     4,
    65,   971,   843,    36,    35,    21,    13,    11,     5,    12,
   728,   970,   290,   969,   632,    29,   310,   753,   342,   968,
   966,   965,   724,   964,   963,   962,   961,   960,   719,    22,
    44,     0,   959,   958,   957,   841,   956,   955,   954,   953,
   952,   951,   950,   949,   948,   947,   946,   945,   944,   943,
   942,   941,   839,   940,   831,   939,   938,   937,   936,   935,
   934,   933,   358,   932,   931,   930,   929,   928,   927,   923,
   921,   920,   919,   918,   917,   916,   915,   914,   913,   912,
    20,   911,   909,   908,   907,   905,   904,   901,   900,   898,
   897,   896,   894,   884,   883,   882,   881,   878,   866,   864,
   863,    17,   862,   861,   859,     9,   857,    30,    23,    27,
    28,    24,    41,    47,     2,     8,   853,   852,   851,   850,
   849,   847,   726,   846,   845,   842 };
yytabelem yyr1[]={

     0,   113,   113,   114,   114,   115,   115,   115,   115,   115,
   115,   115,   115,   115,   115,   116,   116,   116,   117,   117,
    56,    56,    57,    57,    57,    60,    60,   130,   130,    53,
    53,    54,    54,    54,    55,    55,    52,    52,    49,    49,
    51,    51,    51,    51,    50,    50,    50,    50,    50,    50,
    50,    50,    50,    50,    50,    50,    50,   122,   131,   123,
   123,   123,   123,   123,    99,    99,    99,    91,    91,    91,
   118,   119,   133,   133,   134,   134,   134,   134,   134,     2,
     2,     2,     1,     1,     1,     1,     1,     1,     1,     1,
   120,   135,   121,   136,   136,   136,   137,   137,   139,   137,
   138,   138,   142,   142,   140,   140,   140,   141,   141,   143,
   143,    58,    58,    59,    59,    59,    59,    59,    59,    95,
    95,    97,    97,    96,    96,    94,    94,    92,    93,    93,
    76,    81,    81,   124,   125,   125,   125,   125,   148,   146,
    24,    24,    24,    24,   149,   149,   150,   150,   150,   151,
   152,   151,   151,   151,   151,   151,   151,   151,   151,   151,
    26,    26,    25,    25,    25,   153,   153,   154,   154,    27,
    27,    27,    28,    28,    29,    29,    29,    30,    30,    30,
    30,    30,    30,    30,    30,    30,    30,    30,    30,    30,
    30,    30,    30,    30,   155,   145,   156,   156,   157,   157,
   157,   158,   158,   158,   159,   161,   158,   160,   160,   162,
   162,   162,   165,   164,   166,   164,   163,   163,   163,   163,
   163,   163,   163,   163,   163,   163,   163,   163,   163,   163,
   163,   163,     4,     3,     3,     3,     3,     5,     6,     8,
     8,     8,     7,     7,     7,   167,   147,   169,   169,   171,
   169,   169,   173,   173,   173,   170,   170,   176,   176,   176,
   177,   177,   177,   177,   177,   177,   177,   177,   177,   177,
   177,   177,   177,   177,   179,   179,   180,   180,   168,   168,
   182,   182,   182,   183,   175,   174,   174,   174,   186,   186,
   186,   186,   186,   187,   187,   189,   189,   189,   189,   189,
   188,   188,   190,   190,   190,   191,   191,   192,   184,   184,
   184,   184,   184,   172,   172,   172,   172,   193,   193,   193,
   181,   181,   181,   195,   195,   195,   195,   178,   178,   178,
   178,   178,   178,   185,   185,   194,    33,    33,    34,    32,
    35,    35,   132,    31,   196,   144,   197,   197,   198,   198,
   198,   199,   199,   199,   199,    37,    37,    36,    38,   126,
   200,   127,   201,   201,   201,   202,   202,    39,    39,    39,
    39,    40,    40,    41,    41,    41,    41,   128,   129,   129,
   129,   129,   129,    62,    63,   102,   102,   100,   100,   100,
   203,   101,    64,   108,   108,   104,   104,   104,   103,   103,
   103,   103,   103,   103,   103,    67,    68,    69,    66,   109,
   109,   107,   107,   106,   106,   106,   204,   105,    77,    77,
    77,    86,    86,    86,    86,    89,    90,    90,    90,    78,
    78,    78,    98,    98,    85,    79,    79,    87,    80,    80,
    88,    88,    88,    82,    83,    83,   111,   111,   111,    65,
    61,    61,    48,    48,    44,    44,    45,    45,    46,    46,
    46,    74,    74,    75,    75,    73,   110,    42,    42,    43,
    43,    47,    47,    47,   112,   112,    70,    71,    71,    72,
    72,    21,    21,    20,    20,    20,    19,    19,    22,    23,
    18,   205,     9,    17,    17,    15,    15,    16,    16,    16,
    10,    10,    11,    11,    13,    13,    13,    13,    13,    12,
    12,    12,    14,    14,    14,    84 };
yytabelem yyr2[]={

     0,     0,     2,     2,     4,     2,     2,     4,     4,     4,
     4,     4,     4,     5,     2,     7,     7,     5,     7,     9,
     1,     5,     2,     5,     5,     1,     3,     0,     9,     3,
     3,     2,     5,     7,     2,     2,     3,     2,     2,     5,
     3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
     3,     3,     3,     3,     3,     3,     3,     1,     1,    13,
     7,     7,     7,     7,     1,     7,     7,     2,     2,     2,
     1,     6,     2,     4,     3,     5,     3,     3,     5,     3,
     5,     5,     3,     3,     3,     3,     3,     3,     3,     3,
     1,     1,    12,     0,     6,     7,     4,     7,     1,    11,
     2,     4,     3,     5,     5,     5,     1,     0,     4,     5,
     3,     2,     5,     5,     7,     3,     3,     3,     3,     1,
     5,     2,     5,     3,     2,     3,     5,     3,     3,     3,
     3,     2,     3,     1,     4,     4,     4,     2,     1,     9,
     2,     3,     3,     3,     0,     6,     0,     6,     7,     3,
     1,     9,     5,     5,     5,     5,    15,    11,     5,     7,
     5,     1,     3,     3,     3,     0,     4,     7,     7,     3,
     3,     3,     3,     3,     2,     5,     7,     3,     3,     3,
     3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
     3,     3,     3,     3,     1,     9,     0,     6,     0,     6,
     7,     5,     5,     5,     1,     1,    23,     0,     4,     0,
     6,     7,     1,     9,     1,    11,     5,     5,     3,     5,
     5,     5,     5,     5,     5,     3,     3,     3,     3,     5,
     5,     5,     3,     3,     3,     3,     3,     2,     3,     1,
     7,     7,     2,     2,     2,     1,    11,     5,     8,     1,
    12,     8,     0,     6,     7,     0,     2,     0,     6,     7,
     0,     4,     5,     5,     2,     2,     5,     5,     5,     5,
     5,     5,     5,     5,     5,     9,     0,     5,     0,     6,
     0,     6,     7,     1,    21,     0,     6,     7,     5,     7,
     9,     7,     9,     6,     7,     5,     5,     9,     9,     3,
     6,     7,     0,     5,     5,     6,     7,     3,     0,     5,
     5,     7,     7,     2,     4,     2,     4,     5,     3,     3,
     0,     4,     2,     3,     3,     3,     3,     3,     3,     5,
     9,     3,     3,     0,     4,     5,     2,     5,     2,     2,
     2,     2,     2,     2,     1,     9,     0,     6,     0,     6,
     7,     5,     7,     5,     5,     2,     5,     3,     2,     1,
     1,    11,     4,     6,     5,    13,    11,     2,     3,     3,
     5,     1,     5,     3,     3,     3,     3,     1,    15,    13,
    13,    15,    13,     3,     3,     3,     9,     1,     7,     7,
     1,     7,     3,     3,     9,     1,     7,     7,    11,     9,
    11,     9,     9,     9,     7,     3,     3,     3,     3,     3,
     5,     1,     7,     1,     7,     7,     1,     7,     3,     2,
     2,     2,     2,     2,     2,     3,     3,     3,     5,     3,
     3,     3,     3,     5,     3,     3,     3,     5,     3,     3,
     3,     7,     7,     3,     3,     3,     3,     3,     2,     3,
     3,     2,     3,     3,     3,     3,     1,     5,     1,     3,
     5,     1,     5,     2,     3,     3,     3,     2,     3,     2,
     2,     3,     7,    11,     3,     3,     3,     3,     5,     1,
     5,     1,     5,     2,     3,     5,     1,     5,     3,     2,
     2,     1,    11,     3,     2,     2,     7,     3,     3,     3,
     3,     7,     3,     5,     3,     5,     5,     5,     9,     3,
     3,     7,     3,     5,     7,     3 };
yytabelem yychk[]={

 -1000,  -113,  -114,  -115,  -116,  -117,  -118,  -120,  -122,  -124,
  -126,  -128,   256,   257,   281,   282,   283,   409,   411,  -115,
  -119,   405,  -121,   269,  -123,   392,   352,  -132,   402,   403,
   355,  -125,  -144,  -145,  -146,  -147,   380,   318,   336,   351,
  -127,   391,  -129,   395,   394,   257,   -48,   294,   295,   259,
   257,   -53,   385,   -54,   -50,   417,   418,   419,   420,   421,
   422,   424,   425,   271,   423,   318,   336,   351,   -56,  -110,
   260,  -133,  -134,   406,   312,   407,   408,   285,  -135,  -131,
   -32,   263,   -34,   263,   -70,   259,   -82,   -83,   259,   -43,
   263,   264,   257,   257,   257,  -196,  -155,  -148,  -167,  -200,
   271,   271,   257,   257,   257,   -55,   410,   -50,   -51,   426,
   427,   277,   278,  -130,   413,   -60,   412,   257,  -134,   -74,
   297,    -2,    -1,   286,   287,   288,   289,   290,   291,   292,
   293,   284,   123,   123,   257,   257,   257,   257,   -48,   -48,
   -24,   -48,   333,   443,   334,   -48,   123,   -62,   318,   -63,
   -61,   -65,   306,    -6,   380,   -62,   -64,   -65,   318,   -55,
   257,   -57,   -42,   259,   -43,   -73,   259,    -1,    -1,  -136,
   -99,  -197,   123,  -156,   123,  -149,   123,  -168,   123,  -201,
  -202,   256,   -39,   -87,   -88,   279,   443,   396,   -80,  -111,
   -77,   261,   262,  -110,   306,   -82,   -84,   266,   402,    -9,
   326,   -97,   -95,   296,   268,   402,   -97,   414,   415,   416,
   125,  -137,   256,   405,   268,   305,   125,   -91,   256,   -87,
   -88,   -90,   307,   279,   443,  -198,  -157,  -150,   257,  -182,
   125,  -202,   257,   257,   296,   268,   279,   -79,  -111,   -77,
   398,   397,   -70,  -102,   401,   -74,  -205,  -102,   -98,   -85,
   -79,   -94,   -92,   -93,  -111,   -77,   -70,  -108,   401,   -45,
   272,   -42,   257,   257,   257,  -138,  -142,   389,   390,   -96,
   417,   -94,   -79,   257,   257,   257,   279,   125,  -199,   256,
   297,   268,   331,   409,   125,  -158,   256,   297,   298,   409,
   311,   125,  -151,   256,   -26,   337,   338,   409,   335,   346,
   340,   343,   344,   342,   339,   125,  -169,   256,   409,   363,
   311,   357,   257,   -98,   -92,   -42,   -78,   306,   -83,   -84,
  -102,   257,   123,   -10,   -11,   -13,   -12,   -70,    46,    40,
   257,   -85,   -92,  -108,   257,   123,   -44,   -42,   275,  -142,
   -47,   259,   -58,   -59,   297,   276,   387,   388,   399,   400,
  -139,   257,   257,   -73,   -96,   -98,   -38,   -49,   -50,   257,
   257,   -73,   -44,    -5,   -49,   301,   257,   257,  -110,  -110,
   -29,   -30,   417,   428,   429,   430,   431,   432,   433,   434,
   435,   436,   437,   347,   438,   421,   422,   439,   440,   -42,
  -110,   -26,   -28,   419,   420,  -110,   261,   -42,   257,   257,
   -31,   -49,   123,  -171,   123,   -95,   -74,   257,  -100,   327,
   124,   -11,    42,    43,    63,   123,   -10,   257,  -104,    58,
   -59,   -73,   297,  -140,   300,   302,   -37,   -36,   381,   -50,
    -3,   419,   420,   404,   320,  -152,   -30,   410,   -27,   419,
   420,   441,   272,   -42,  -170,  -176,  -172,  -193,  -194,  -185,
   352,   419,   420,   409,  -174,   -74,   -40,   125,  -101,   256,
  -203,   -17,   329,   -15,   -16,   404,   325,   328,   -10,   -14,
   -42,    41,   125,  -103,   256,   271,   259,   -73,  -141,   -79,
   -79,   -36,   308,  -153,   -30,   -80,   -42,   125,  -177,   256,
   364,   378,   358,  -179,  -180,   369,   379,   317,   372,   371,
   373,   374,   375,   383,   359,   123,  -193,  -194,   -32,   -31,
   125,  -186,   256,   -35,   263,   265,   -40,   -41,   393,   399,
   400,   406,   257,   257,   -86,   -89,   -90,   -87,   -88,   417,
   124,   125,    44,   257,   257,   -61,   -18,   -23,   -67,   -68,
   -69,   -66,   267,   391,   423,   279,    58,  -143,   304,   303,
   -70,  -154,   272,   350,   -78,  -110,   257,   257,  -178,   443,
   333,   361,   360,   -48,   -48,   259,   -48,   259,   259,   259,
   259,   259,   259,   259,  -181,  -195,   333,   362,   443,   351,
  -173,   257,   257,   -35,   -75,   -74,   401,   -16,   -42,   402,
    -9,   330,   -95,   -95,   -95,  -109,   401,   -45,   259,   -78,
  -159,   -26,   -26,   272,   443,   365,  -195,   125,  -175,   256,
   310,  -187,   333,  -188,  -189,  -190,   335,   358,   378,   376,
   377,   -70,  -109,   -22,   -42,  -109,  -109,  -109,  -107,   123,
  -160,   -42,   -42,   -42,   361,   263,   257,   257,  -183,  -188,
  -189,  -187,  -190,   256,   256,   -43,   -42,  -191,  -192,   -35,
  -191,  -109,  -109,  -106,  -161,  -163,   274,   309,   313,   296,
   297,   270,   317,   409,   314,   387,   315,   316,   321,   322,
   323,   324,   360,   -48,   257,   257,   257,   257,   358,   335,
  -192,   256,   125,  -105,   256,  -204,   123,   -44,   -70,   -85,
   -73,   -76,   -81,   -77,  -111,   -47,    -5,   259,    -4,   -42,
    -4,   -42,   -33,   -34,  -132,   -42,   -43,   257,   257,   257,
   257,   -86,  -162,   -79,   -34,   -46,   401,   272,   125,  -164,
   256,   310,   319,   352,   -44,   257,   257,  -165,  -166,   -33,
   -79,   123,  -184,   268,  -160,    -8,  -181,   -79,   -33,   263,
   125,    -7,   256,   -89,   -87,   -88,  -185,   -33,   -79,   257,
   257,  -194 };
yytabelem yydef[]={

    -2,    -2,    -2,     3,     5,     6,     0,     0,     0,     0,
     0,     0,     0,    14,     0,     0,     0,     0,    20,     4,
     7,     0,     8,    91,     9,    58,     0,     0,     0,     0,
   342,    10,     0,     0,     0,   137,   344,   194,   138,   245,
    11,   360,    12,     0,     0,    13,     0,   452,   453,     0,
    17,     0,    29,    30,    31,    44,    45,    46,    47,    48,
    49,    50,    51,    52,    53,    54,    55,    56,    27,    25,
   466,     0,    72,    74,   461,    76,    77,     0,     0,     0,
     0,   339,     0,   338,     0,   476,     0,   443,   444,   445,
   469,   470,   134,   135,   136,     0,     0,     0,     0,     0,
     0,     0,    15,    16,    18,    32,     0,    34,    35,    40,
    41,    42,    43,     0,     0,    21,    26,    71,    73,    75,
     0,    78,    79,     0,    82,    83,    84,    85,    86,    87,
    88,    89,    93,    64,    60,    61,    62,    63,   346,   196,
   144,   140,   141,   142,   143,   278,     0,     0,   238,   119,
   383,   384,   450,   451,   449,     0,   119,   392,   238,    33,
    19,     0,    22,   467,   468,   462,   465,    81,    80,     0,
     0,   345,   348,   195,   198,   139,   146,     0,   280,     0,
     0,     0,     0,   367,   368,   369,     0,     0,   440,   438,
   439,   446,   447,   448,   418,   419,   420,   515,     0,   461,
   491,   461,   121,     0,     0,     0,   456,     0,    23,    24,
     0,     0,     0,     0,     0,     0,     0,     0,     0,    67,
    68,    69,   426,   427,     0,     0,     0,   161,   246,     0,
   361,     0,   362,   364,     0,     0,   370,   437,   435,   436,
     0,     0,   461,     0,   385,     0,     0,     0,   122,   432,
   434,   120,   125,   127,   128,   129,   456,     0,   393,     0,
     0,    28,    92,    94,    95,    96,   100,   102,     0,     0,
   123,   124,    98,    59,    65,    66,   428,   347,     0,     0,
     0,     0,     0,     0,   197,     0,     0,     0,     0,     0,
     0,   145,     0,     0,   149,     0,     0,     0,     0,     0,
   161,     0,     0,     0,     0,   279,     0,     0,     0,     0,
   249,     0,   363,   119,   461,   441,   442,   429,   430,   431,
     0,   379,   387,     0,   500,   502,   504,   509,   510,     0,
   380,   433,   126,     0,   382,   395,   457,   454,   455,   101,
   103,   471,    97,   111,     0,     0,   115,   116,   117,   118,
   106,   349,   350,   351,     0,   353,   354,   358,    38,   199,
   200,   201,   202,   203,   237,     0,   147,   148,   150,   152,
   153,   174,   177,   178,   179,   180,   181,   182,   183,   184,
   185,   186,   187,   188,   189,   190,   191,   192,   193,   154,
   155,     0,     0,   172,   173,   158,     0,   160,   281,   282,
   247,   343,    -2,     0,   285,   461,   371,   378,   390,     0,
     0,   503,   505,   506,   507,     0,     0,   381,     0,     0,
   112,   113,     0,   107,     0,     0,   352,   355,   357,    39,
     0,   233,   234,   235,   236,   165,   175,     0,     0,   169,
   170,   171,     0,   159,     0,    -2,     0,   313,   315,     0,
     0,   318,   319,     0,     0,   371,   366,   386,     0,     0,
     0,   492,   493,   494,   495,   497,   498,   499,   501,     0,
   512,   511,   394,     0,     0,     0,   472,   114,    99,   104,
   105,   356,     0,   151,   176,     0,     0,   248,     0,     0,
     0,     0,     0,   264,   265,     0,     0,     0,     0,     0,
     0,     0,     0,     0,   320,   252,   314,    -2,   317,   335,
   251,     0,     0,     0,   340,   341,   365,   372,   373,   374,
   375,   376,   388,   389,   461,   421,   422,   423,   424,   425,
     0,   508,   513,   396,   397,    -2,     0,     0,   119,   119,
   119,   456,   405,   406,   407,   408,     0,   108,     0,   110,
   204,   166,   161,   161,     0,   157,   258,   259,   261,   327,
   328,   331,   332,   262,   263,   266,   267,   268,   269,   270,
   271,   272,   273,   274,   277,   322,   323,   324,   325,   326,
     0,   286,   287,    -2,   391,   463,   464,   496,   514,     0,
   456,     0,   456,   456,   456,   404,   409,   411,   473,   109,
   207,     0,     0,     0,   329,     0,   321,   250,     0,     0,
   283,    -2,     0,   291,     0,     0,     0,     0,   299,     0,
     0,   456,   399,   456,   488,   401,   402,   403,   410,   413,
   205,   167,   168,   156,     0,   275,   253,   254,     0,   292,
     0,   290,     0,     0,     0,   295,   296,   303,     0,   307,
   304,   398,   400,   416,     0,   208,     0,     0,   218,     0,
     0,     0,     0,     0,     0,   225,   226,   227,   228,     0,
     0,     0,   330,     0,   293,   300,   294,   301,     0,     0,
     0,     0,   412,     0,     0,     0,   209,   216,   217,   219,
   220,   221,   130,   131,   132,   222,   223,   224,   229,   232,
   230,   231,     0,   336,     0,   298,   297,   305,   306,   414,
   415,   458,     0,     0,   337,   417,   459,     0,   206,     0,
     0,   212,   214,     0,   460,   210,   211,     0,     0,   308,
   207,   239,   320,     0,   213,     0,   333,   309,   310,    -2,
   215,     0,     0,   242,   243,   244,   284,   311,   312,   240,
   241,   334 };
typedef struct { char *t_name; int t_val; } yytoktype;
#ifndef YYDEBUG
#	define YYDEBUG	0	/* don't allow debugging */
#endif

#if YYDEBUG

yytoktype yytoks[] =
{
	"L_EOS",	257,
	"L_ERROR",	258,
	"L_NUMBER",	259,
	"L_STRING",	260,
	"L_HNAME",	261,
	"L_KEYWORD",	262,
	"L_HEXSTRING",	263,
	"L_OCTETSTRING",	264,
	"L_HEXSTRING_ODD",	265,
	"L_ISOADDR",	266,
	"T_DIRECT",	267,
	"T_INTERFACE",	268,
	"T_INTERFACES",	269,
	"T_LCLADDR",	270,
	"T_PROTO",	271,
	"T_METRIC",	272,
	"T_METRICIN",	273,
	"T_METRICOUT",	274,
	"T_INFINITY",	275,
	"T_DOWN",	276,
	"T_PARSE",	277,
	"T_ADV",	278,
	"T_DEFAULT",	279,
	"T_DEFAULTS",	280,
	"T_YYDEBUG",	281,
	"T_YYSTATE",	282,
	"T_YYQUIT",	283,
	"T_DEBUG",	284,
	"T_SYSLOG",	285,
	"T_UPTO",	286,
	"T_EMERG",	287,
	"T_ALERT",	288,
	"T_CRIT",	289,
	"T_ERR",	290,
	"T_WARNING",	291,
	"T_NOTICE",	292,
	"T_INFO",	293,
	"T_ON",	294,
	"T_OFF",	295,
	"T_GATEWAY",	296,
	"T_PREFERENCE",	297,
	"T_DEFAULTMETRIC",	298,
	"T_NONBROADCAST",	299,
	"T_BROADCAST",	300,
	"T_TYPE",	301,
	"T_POINTOPOINT",	302,
	"T_MULTICAST",	303,
	"T_NETMASK",	304,
	"T_DEFINE",	305,
	"T_NOP",	306,
	"T_NOP1",	307,
	"T_PEERAS",	308,
	"T_LOCALAS",	309,
	"T_NEIGHBOR",	310,
	"T_GROUP",	311,
	"T_GENDEFAULT",	312,
	"T_NOGENDEFAULT",	313,
	"T_VERSION",	314,
	"T_DEFAULTIN",	315,
	"T_DEFAULTOUT",	316,
	"T_HOLDTIME",	317,
	"T_BGP",	318,
	"T_ALLOW",	319,
	"T_TEST",	320,
	"T_KEEPALL",	321,
	"T_SENDBUF",	322,
	"T_RECVBUF",	323,
	"T_SPOOLBUF",	324,
	"T_EGP",	325,
	"T_ASPATH",	326,
	"T_ORIGIN",	327,
	"T_INCOMPLETE",	328,
	"T_ANY",	329,
	"T_TAG",	330,
	"T_TRUSTEDGATEWAYS",	331,
	"T_SOURCEGATEWAYS",	332,
	"T_IP",	333,
	"T_DUAL",	334,
	"T_SNPA",	335,
	"T_ISIS",	336,
	"T_CIRCUIT",	337,
	"T_SYSTEMID",	338,
	"T_LEVEL",	339,
	"T_IPREACH",	340,
	"T_TROLL",	341,
	"T_SET",	342,
	"T_PREFIX",	343,
	"T_INTDOMINFO",	344,
	"T_MODE",	345,
	"T_AREA",	346,
	"T_SPF",	347,
	"T_HELLOINTERVAL",	348,
	"T_ROUTERDEADINTERVAL",	349,
	"T_PRIORITY",	350,
	"T_IDRP",	351,
	"T_RDI",	352,
	"T_OSISTATIC",	353,
	"T_NSAP",	354,
	"T_NET",	355,
	"T_NSAPPREFIX",	356,
	"T_OSILOCAL",	357,
	"T_MULTIEXIT",	358,
	"T_PROTOSOCK",	359,
	"T_SIP",	360,
	"T_PIP",	361,
	"T_UDP",	362,
	"T_LOCALNODE",	363,
	"T_PROTOSUPPORT",	364,
	"T_AUTHCODE",	365,
	"T_INTRAIS",	366,
	"T_RDC",	367,
	"T_ASRDI",	368,
	"T_OUTPDUS",	369,
	"T_MAXPDUSIZE",	370,
	"T_REXMIT",	371,
	"T_CLOSEWAIT",	372,
	"T_RIBCHECK",	373,
	"T_MINADV",	374,
	"T_MINADVRD",	375,
	"T_PROHIBITDIST",	376,
	"T_ALLOWDIST",	377,
	"T_ROUTESERVER",	378,
	"T_LISTENOPEN",	379,
	"T_REDIRECT",	380,
	"T_NOREDIRECTS",	381,
	"T_ICMP",	382,
	"T_AUTHTYPE",	383,
	"T_AUTHKEY",	384,
	"T_NONE",	385,
	"T_SIMPLE",	386,
	"T_PASSIVE",	387,
	"T_SIMPLEX",	388,
	"T_STRICTIFS",	389,
	"T_SCANINTERVAL",	390,
	"T_STATIC",	391,
	"T_MARTIANS",	392,
	"T_RETAIN",	393,
	"T_EXPORT",	394,
	"T_IMPORT",	395,
	"T_HOST",	396,
	"T_MASK",	397,
	"T_MASKLEN",	398,
	"T_REJECT",	399,
	"T_BLACKHOLE",	400,
	"T_RESTRICT",	401,
	"T_AS",	402,
	"T_ROUTERID",	403,
	"T_IGP",	404,
	"T_OPTIONS",	405,
	"T_NOINSTALL",	406,
	"T_NOSEND",	407,
	"T_NORESOLV",	408,
	"T_TRACEOPTIONS",	409,
	"T_EXCEPT",	410,
	"T_TRACEFILE",	411,
	"T_REPLACE",	412,
	"T_SIZE",	413,
	"T_FILES",	414,
	"T_K",	415,
	"T_M",	416,
	"T_ALL",	417,
	"T_GENERAL",	418,
	"T_INTERNAL",	419,
	"T_EXTERNAL",	420,
	"T_ROUTE",	421,
	"T_UPDATE",	422,
	"T_KERNEL",	423,
	"T_TASK",	424,
	"T_TIMER",	425,
	"T_NOSTAMP",	426,
	"T_MARK",	427,
	"TISIS_IIH",	428,
	"TISIS_DUMPLSP",	429,
	"TISIS_EVENTS",	430,
	"TISIS_LANADJ",	431,
	"TISIS_FLOODING",	432,
	"TISIS_BUILDLSP",	433,
	"TISIS_CSNP",	434,
	"TISIS_PSNP",	435,
	"TISIS_LSPINPUT",	436,
	"TISIS_P2PADJ",	437,
	"TISIS_LSPDB",	438,
	"TISIS_PATHS",	439,
	"TISIS_LSPCONTENT",	440,
	"TISIS_SUMMARY",	441,
	"T_INET",	442,
	"T_ISO",	443,
	"-unknown-",	-1	/* ends search */
};

char * yyreds[] =
{
	"-no such reduction-",
      "config : /* empty */",
      "config : statements",
      "statements : statement",
      "statements : statements statement",
      "statement : parse_statement",
      "statement : trace_statement",
      "statement : option_order option_statement",
      "statement : interface_order interface_statement",
      "statement : define_order define_statement",
      "statement : proto_order proto_statement",
      "statement : route_order route_statement",
      "statement : control_order control_statement",
      "statement : error L_EOS",
      "statement : L_EOS",
      "parse_statement : T_YYDEBUG onoff_option L_EOS",
      "parse_statement : T_YYSTATE L_NUMBER L_EOS",
      "parse_statement : T_YYQUIT L_EOS",
      "trace_statement : T_TRACEOPTIONS trace_trace_options_none L_EOS",
      "trace_statement : T_TRACEFILE trace_file trace_limits L_EOS",
      "trace_file : /* empty */",
      "trace_file : string trace_replace",
      "trace_size : number",
      "trace_size : number T_K",
      "trace_size : number T_M",
      "trace_replace : /* empty */",
      "trace_replace : T_REPLACE",
      "trace_limits : /* empty */",
      "trace_limits : T_SIZE trace_size T_FILES number",
      "trace_trace_options_none : T_NONE",
      "trace_trace_options_none : trace_trace_options",
      "trace_trace_options : trace_option",
      "trace_trace_options : trace_trace_options trace_trace_option",
      "trace_trace_options : trace_trace_options T_EXCEPT trace_trace_option",
      "trace_trace_option : trace_option",
      "trace_trace_option : trace_option_global",
      "trace_options_none : T_NONE",
      "trace_options_none : trace_options",
      "trace_options : trace_option",
      "trace_options : trace_options trace_option",
      "trace_option_global : T_NOSTAMP",
      "trace_option_global : T_MARK",
      "trace_option_global : T_PARSE",
      "trace_option_global : T_ADV",
      "trace_option : T_ALL",
      "trace_option : T_GENERAL",
      "trace_option : T_INTERNAL",
      "trace_option : T_EXTERNAL",
      "trace_option : T_ROUTE",
      "trace_option : T_UPDATE",
      "trace_option : T_TASK",
      "trace_option : T_TIMER",
      "trace_option : T_PROTO",
      "trace_option : T_KERNEL",
      "trace_option : T_BGP",
      "trace_option : T_ISIS",
      "trace_option : T_IDRP",
      "define_order : /* empty */",
      "define_statement : T_MARTIANS",
      "define_statement : T_MARTIANS '{' martian_list '}' L_EOS",
      "define_statement : T_RDI osi_rdi L_EOS",
      "define_statement : osi_address_name osi_nsap L_EOS",
      "define_statement : T_AS as L_EOS",
      "define_statement : T_ROUTERID ip_addr L_EOS",
      "martian_list : /* empty */",
      "martian_list : martian_list martian L_EOS",
      "martian_list : martian_list error L_EOS",
      "martian : host_mask",
      "martian : network_mask",
      "martian : default_mask",
      "option_order : /* empty */",
      "option_statement : T_OPTIONS option_list L_EOS",
      "option_list : option",
      "option_list : option_list option",
      "option : T_NOINSTALL",
      "option : T_GENDEFAULT preference_option",
      "option : T_NOSEND",
      "option : T_NORESOLV",
      "option : T_SYSLOG syslog_mask",
      "syslog_mask : syslog_level",
      "syslog_mask : T_UPTO syslog_level",
      "syslog_mask : syslog_mask syslog_level",
      "syslog_level : T_EMERG",
      "syslog_level : T_ALERT",
      "syslog_level : T_CRIT",
      "syslog_level : T_ERR",
      "syslog_level : T_WARNING",
      "syslog_level : T_NOTICE",
      "syslog_level : T_INFO",
      "syslog_level : T_DEBUG",
      "interface_order : /* empty */",
      "interface_statement : T_INTERFACES",
      "interface_statement : T_INTERFACES '{' interface_stmts '}' L_EOS",
      "interface_stmts : /* empty */",
      "interface_stmts : interface_stmts interface_stmt L_EOS",
      "interface_stmts : interface_stmts error L_EOS",
      "interface_stmt : T_OPTIONS interface_options",
      "interface_stmt : T_INTERFACE interface_all_list interface_define_options",
      "interface_stmt : T_DEFINE host",
      "interface_stmt : T_DEFINE host interface_type_options interface_common_options",
      "interface_options : interface_option",
      "interface_options : interface_options interface_option",
      "interface_option : T_STRICTIFS",
      "interface_option : T_SCANINTERVAL time",
      "interface_type_options : T_BROADCAST host",
      "interface_type_options : T_POINTOPOINT host",
      "interface_type_options : /* empty */",
      "interface_common_options : /* empty */",
      "interface_common_options : interface_common_options interface_common_option",
      "interface_common_option : T_NETMASK mask",
      "interface_common_option : T_MULTICAST",
      "interface_define_options : interface_define_option",
      "interface_define_options : interface_define_options interface_define_option",
      "interface_define_option : T_PREFERENCE preference",
      "interface_define_option : T_DOWN T_PREFERENCE preference",
      "interface_define_option : T_PASSIVE",
      "interface_define_option : T_SIMPLEX",
      "interface_define_option : T_REJECT",
      "interface_define_option : T_BLACKHOLE",
      "interface_list_option : /* empty */",
      "interface_list_option : T_INTERFACE interface_list",
      "interface_gateway_list : interface_list_option",
      "interface_gateway_list : T_GATEWAY gateway_list",
      "interface_all_list : T_ALL",
      "interface_all_list : interface_list",
      "interface_list : interface_all",
      "interface_list : interface_list interface_all",
      "interface_all : interface_all_adv",
      "interface_all_adv : host_name",
      "interface_all_adv : addr",
      "interface_local : interface_addr",
      "interface_addr : addr",
      "interface_addr : host_name",
      "proto_order : /* empty */",
      "proto_statement : redirect_statement L_EOS",
      "proto_statement : bgp_statement L_EOS",
      "proto_statement : isis_statement L_EOS",
      "proto_statement : idrp_statement",
      "isis_statement : T_ISIS",
      "isis_statement : T_ISIS isis_option isis_group",
      "isis_option : onoff_option",
      "isis_option : T_IP",
      "isis_option : T_ISO",
      "isis_option : T_DUAL",
      "isis_group : /* empty */",
      "isis_group : '{' isis_group_stmts '}'",
      "isis_group_stmts : /* empty */",
      "isis_group_stmts : isis_group_stmts isis_group_stmt L_EOS",
      "isis_group_stmts : isis_group_stmts error L_EOS",
      "isis_group_stmt : isis_level",
      "isis_group_stmt : T_CIRCUIT string",
      "isis_group_stmt : T_CIRCUIT string isis_coptions",
      "isis_group_stmt : T_SYSTEMID string",
      "isis_group_stmt : T_TRACEOPTIONS isis_trace_options",
      "isis_group_stmt : T_SNPA number",
      "isis_group_stmt : T_AREA string",
      "isis_group_stmt : T_IPREACH isis_level ipreach_type network mask T_METRIC number",
      "isis_group_stmt : T_PREFIX prefix_type T_METRIC number string",
      "isis_group_stmt : T_INTDOMINFO string",
      "isis_group_stmt : T_SET L_HNAME number",
      "isis_level : T_LEVEL number",
      "isis_level : /* empty */",
      "isis_mode : T_IP",
      "isis_mode : T_ISO",
      "isis_mode : T_DUAL",
      "isis_coptions : /* empty */",
      "isis_coptions : isis_coptions isis_coption",
      "isis_coption : T_METRIC isis_level number",
      "isis_coption : T_PRIORITY isis_level number",
      "ipreach_type : T_INTERNAL",
      "ipreach_type : T_EXTERNAL",
      "ipreach_type : TISIS_SUMMARY",
      "prefix_type : T_INTERNAL",
      "prefix_type : T_EXTERNAL",
      "isis_trace_options : isis_trace_option",
      "isis_trace_options : isis_trace_options isis_trace_option",
      "isis_trace_options : isis_trace_options T_EXCEPT isis_trace_option",
      "isis_trace_option : T_ALL",
      "isis_trace_option : TISIS_IIH",
      "isis_trace_option : TISIS_DUMPLSP",
      "isis_trace_option : TISIS_EVENTS",
      "isis_trace_option : TISIS_LANADJ",
      "isis_trace_option : TISIS_FLOODING",
      "isis_trace_option : TISIS_BUILDLSP",
      "isis_trace_option : TISIS_CSNP",
      "isis_trace_option : TISIS_PSNP",
      "isis_trace_option : TISIS_LSPINPUT",
      "isis_trace_option : TISIS_P2PADJ",
      "isis_trace_option : T_SPF",
      "isis_trace_option : TISIS_LSPDB",
      "isis_trace_option : T_ROUTE",
      "isis_trace_option : T_UPDATE",
      "isis_trace_option : TISIS_PATHS",
      "isis_trace_option : TISIS_LSPCONTENT",
      "bgp_statement : T_BGP",
      "bgp_statement : T_BGP onoff_option bgp_group",
      "bgp_group : /* empty */",
      "bgp_group : '{' bgp_group_stmts '}'",
      "bgp_group_stmts : /* empty */",
      "bgp_group_stmts : bgp_group_stmts bgp_group_stmt L_EOS",
      "bgp_group_stmts : bgp_group_stmts error L_EOS",
      "bgp_group_stmt : T_PREFERENCE preference",
      "bgp_group_stmt : T_DEFAULTMETRIC metric",
      "bgp_group_stmt : T_TRACEOPTIONS bgp_trace_options",
      "bgp_group_stmt : T_GROUP T_TYPE bgp_linktype T_PEERAS as",
      "bgp_group_stmt : T_GROUP T_TYPE bgp_linktype T_PEERAS as bgp_peer_options",
      "bgp_group_stmt : T_GROUP T_TYPE bgp_linktype T_PEERAS as bgp_peer_options '{' bgp_peer_stmts '}'",
      "bgp_peer_options : /* empty */",
      "bgp_peer_options : bgp_peer_options bgp_peer_option",
      "bgp_peer_stmts : /* empty */",
      "bgp_peer_stmts : bgp_peer_stmts bgp_peer_stmt L_EOS",
      "bgp_peer_stmts : bgp_peer_stmts error L_EOS",
      "bgp_peer_stmt : T_NEIGHBOR",
      "bgp_peer_stmt : T_NEIGHBOR host bgp_peer_options",
      "bgp_peer_stmt : T_ALLOW",
      "bgp_peer_stmt : T_ALLOW '{' bgp_allow_list '}'",
      "bgp_peer_option : T_METRICOUT metric",
      "bgp_peer_option : T_LOCALAS as",
      "bgp_peer_option : T_NOGENDEFAULT",
      "bgp_peer_option : T_GATEWAY gateway",
      "bgp_peer_option : T_PREFERENCE preference",
      "bgp_peer_option : T_LCLADDR interface_local",
      "bgp_peer_option : T_HOLDTIME time",
      "bgp_peer_option : T_TRACEOPTIONS bgp_trace_options",
      "bgp_peer_option : T_VERSION L_NUMBER",
      "bgp_peer_option : T_PASSIVE",
      "bgp_peer_option : T_DEFAULTIN",
      "bgp_peer_option : T_DEFAULTOUT",
      "bgp_peer_option : T_KEEPALL",
      "bgp_peer_option : T_SENDBUF bgp_kbufsize",
      "bgp_peer_option : T_RECVBUF bgp_kbufsize",
      "bgp_peer_option : T_SPOOLBUF number",
      "bgp_kbufsize : number",
      "bgp_linktype : T_INTERNAL",
      "bgp_linktype : T_EXTERNAL",
      "bgp_linktype : T_IGP",
      "bgp_linktype : T_TEST",
      "bgp_trace_options : trace_options",
      "bgp_prop_init : T_BGP",
      "bgp_allow_list : /* empty */",
      "bgp_allow_list : bgp_allow_list bgp_allow L_EOS",
      "bgp_allow_list : bgp_allow_list error L_EOS",
      "bgp_allow : all_mask",
      "bgp_allow : host_mask",
      "bgp_allow : network_mask",
      "idrp_statement : T_IDRP",
      "idrp_statement : T_IDRP onoff_option idrp_group L_EOS",
      "idrp_group_stmt : T_TRACEOPTIONS idrp_trace_options",
      "idrp_group_stmt : T_LOCALNODE '{' idrp_local_node '}'",
      "idrp_group_stmt : T_GROUP",
      "idrp_group_stmt : T_GROUP idrp_group_options '{' idrp_peer_stmts '}'",
      "idrp_group_stmt : T_OSILOCAL '{' idrp_local_routes '}'",
      "idrp_peer_stmts : /* empty */",
      "idrp_peer_stmts : idrp_peer_stmts idrp_peer_stmt L_EOS",
      "idrp_peer_stmts : idrp_peer_stmts error L_EOS",
      "idrp_local_node : /* empty */",
      "idrp_local_node : idrp_local_node_stmts",
      "idrp_local_node_stmts : /* empty */",
      "idrp_local_node_stmts : idrp_local_node_stmts idrp_local_node_stmt L_EOS",
      "idrp_local_node_stmts : idrp_local_node_stmts error L_EOS",
      "idrp_local_node_stmt : /* empty */",
      "idrp_local_node_stmt : T_PROTOSUPPORT idrp_proto_supp",
      "idrp_local_node_stmt : T_ROUTESERVER onoff_option",
      "idrp_local_node_stmt : T_MULTIEXIT onoff_option",
      "idrp_local_node_stmt : idrp_auth",
      "idrp_local_node_stmt : idrp_sock_support",
      "idrp_local_node_stmt : T_OUTPDUS L_NUMBER",
      "idrp_local_node_stmt : T_LISTENOPEN onoff_option",
      "idrp_local_node_stmt : T_HOLDTIME L_NUMBER",
      "idrp_local_node_stmt : T_CLOSEWAIT L_NUMBER",
      "idrp_local_node_stmt : T_REXMIT L_NUMBER",
      "idrp_local_node_stmt : T_RIBCHECK L_NUMBER",
      "idrp_local_node_stmt : T_MINADV L_NUMBER",
      "idrp_local_node_stmt : T_MINADVRD L_NUMBER",
      "idrp_auth : T_AUTHTYPE L_NUMBER",
      "idrp_auth : T_AUTHTYPE L_NUMBER T_AUTHCODE L_HEXSTRING",
      "idrp_sock_support : /* empty */",
      "idrp_sock_support : T_PROTOSOCK idrp_sock_options",
      "idrp_group : /* empty */",
      "idrp_group : '{' idrp_group_stmts '}'",
      "idrp_group_stmts : /* empty */",
      "idrp_group_stmts : idrp_group_stmts idrp_group_stmt L_EOS",
      "idrp_group_stmts : idrp_group_stmts error L_EOS",
      "idrp_peer_stmt : T_NEIGHBOR",
      "idrp_peer_stmt : T_NEIGHBOR onoff_option osi_address host T_RDI osi_address idrp_intf_option idrp_sock_options idrp_peer_options",
      "idrp_local_routes : /* empty */",
      "idrp_local_routes : idrp_local_routes idrp_local_route L_EOS",
      "idrp_local_routes : idrp_local_routes error L_EOS",
      "idrp_local_route : osi_prefix osi_prefix",
      "idrp_local_route : osi_prefix osi_prefix idrp_route_options",
      "idrp_local_route : osi_prefix osi_prefix T_IP idrp_route_options",
      "idrp_local_route : osi_prefix osi_prefix idrp_dist_options",
      "idrp_local_route : osi_prefix osi_prefix idrp_route_options idrp_dist_options",
      "idrp_route_options : idrp_route_options idrp_route_option L_EOS",
      "idrp_route_options : idrp_route_option error L_EOS",
      "idrp_route_option : T_SNPA byte_string",
      "idrp_route_option : T_MULTIEXIT number",
      "idrp_route_option : T_MULTIEXIT number T_SNPA byte_string",
      "idrp_route_option : T_SNPA byte_string T_MULTIEXIT number",
      "idrp_route_option : T_ROUTESERVER",
      "idrp_dist_options : idrp_dist_options idrp_dist_option L_EOS",
      "idrp_dist_options : idrp_dist_option error L_EOS",
      "idrp_dist_option : /* empty */",
      "idrp_dist_option : T_PROHIBITDIST idrp_dist_list",
      "idrp_dist_option : T_ALLOWDIST idrp_dist_list",
      "idrp_dist_list : idrp_dist_list idrp_dist_rdi L_EOS",
      "idrp_dist_list : idrp_dist_rdi error L_EOS",
      "idrp_dist_rdi : osi_prefix",
      "idrp_intf_option : /* empty */",
      "idrp_intf_option : T_INTERFACE host",
      "idrp_intf_option : T_INTERFACE osi_address",
      "idrp_intf_option : T_INTERFACE host osi_address",
      "idrp_intf_option : T_INTERFACE osi_address host",
      "idrp_group_options : idrp_group_option",
      "idrp_group_options : idrp_group_options idrp_group_option",
      "idrp_group_options : idrp_peer_option",
      "idrp_group_options : idrp_peer_options idrp_peer_option",
      "idrp_group_option : T_RDI osi_rdi",
      "idrp_group_option : T_INTERNAL",
      "idrp_group_option : T_EXTERNAL",
      "idrp_sock_options : /* empty */",
      "idrp_sock_options : idrp_sock_options idrp_sock_option",
      "idrp_sock_options : idrp_sock_option",
      "idrp_sock_option : T_IP",
      "idrp_sock_option : T_UDP",
      "idrp_sock_option : T_ISO",
      "idrp_sock_option : T_IDRP",
      "idrp_proto_supp : T_ISO",
      "idrp_proto_supp : T_IP",
      "idrp_proto_supp : T_IP T_ISO",
      "idrp_proto_supp : T_IP T_ISO T_PIP T_SIP",
      "idrp_proto_supp : T_PIP",
      "idrp_proto_supp : T_SIP",
      "idrp_peer_options : /* empty */",
      "idrp_peer_options : idrp_peer_options idrp_peer_option",
      "idrp_peer_option : T_TRACEOPTIONS idrp_trace_options",
      "osi_address : osi_nsap",
      "osi_address : osi_address_name osi_nsap",
      "osi_nsap : L_HEXSTRING",
      "osi_rdi : L_HEXSTRING",
      "osi_prefix : L_HEXSTRING",
      "osi_prefix : L_HEXSTRING_ODD",
      "osi_address_name : T_NET",
      "idrp_trace_options : trace_options",
      "redirect_statement : T_REDIRECT",
      "redirect_statement : T_REDIRECT onoff_option redirect_group",
      "redirect_group : /* empty */",
      "redirect_group : '{' redirect_group_stmts '}'",
      "redirect_group_stmts : /* empty */",
      "redirect_group_stmts : redirect_group_stmts redirect_group_stmt L_EOS",
      "redirect_group_stmts : redirect_group_stmts error L_EOS",
      "redirect_group_stmt : T_PREFERENCE preference",
      "redirect_group_stmt : T_INTERFACE interface_all_list redirect_interface_options",
      "redirect_group_stmt : T_TRUSTEDGATEWAYS gateway_list",
      "redirect_group_stmt : T_TRACEOPTIONS redirect_trace_options",
      "redirect_interface_options : redirect_interface_option",
      "redirect_interface_options : redirect_interface_options redirect_interface_option",
      "redirect_interface_option : T_NOREDIRECTS",
      "redirect_trace_options : trace_options",
      "route_order : /* empty */",
      "route_statement : T_STATIC",
      "route_statement : T_STATIC '{' route_stmts '}'",
      "route_stmts : route_stmt L_EOS",
      "route_stmts : route_stmts route_stmt L_EOS",
      "route_stmts : error L_EOS",
      "route_stmt : route_dest T_GATEWAY gateway_list interface_list_option preference_option rts_options",
      "route_stmt : route_dest T_INTERFACE interface_all preference_option rts_options",
      "route_dest : host_mask",
      "route_dest : network_mask",
      "route_dest : T_DEFAULT",
      "route_dest : T_ISO T_DEFAULT",
      "rts_options : /* empty */",
      "rts_options : rts_options rts_option",
      "rts_option : T_RETAIN",
      "rts_option : T_REJECT",
      "rts_option : T_BLACKHOLE",
      "rts_option : T_NOINSTALL",
      "control_order : /* empty */",
      "control_statement : T_IMPORT T_PROTO control_exterior T_AS as import_option L_EOS",
      "control_statement : T_IMPORT T_PROTO T_BGP aspath_match import_option L_EOS",
      "control_statement : T_IMPORT T_PROTO import_interior interface_gateway_list import_option L_EOS",
      "control_statement : T_EXPORT T_PROTO control_exterior T_AS as prop_source_option L_EOS",
      "control_statement : T_EXPORT T_PROTO export_interior interface_gateway_list prop_source_option L_EOS",
      "control_exterior : proto_exterior",
      "import_interior : proto_interior",
      "import_option : T_RESTRICT",
      "import_option : preference_option '{' import_list '}'",
      "import_list : /* empty */",
      "import_list : import_list import_listen L_EOS",
      "import_list : import_list error L_EOS",
      "import_listen : /* empty */",
      "import_listen : dest_mask preference_restrict_option",
      "export_interior : proto_interior",
      "prop_source_option : T_RESTRICT",
      "prop_source_option : metric_option '{' prop_source_list '}'",
      "prop_source_list : /* empty */",
      "prop_source_list : prop_source_list prop_source L_EOS",
      "prop_source_list : prop_source_list error L_EOS",
      "prop_source : T_PROTO proto_exterior T_AS as prop_metric_option",
      "prop_source : T_PROTO aspath_prop_init aspath_match prop_metric_option",
      "prop_source : T_PROTO tag_prop_init T_TAG tag prop_metric_option",
      "prop_source : T_PROTO prop_direct interface_list_option prop_metric_option",
      "prop_source : T_PROTO prop_static interface_list_option prop_metric_option",
      "prop_source : T_PROTO prop_kernel interface_list_option prop_metric_option",
      "prop_source : T_PROTO prop_default prop_metric_option",
      "prop_direct : T_DIRECT",
      "prop_static : T_STATIC",
      "prop_kernel : T_KERNEL",
      "prop_default : T_DEFAULT",
      "prop_metric_option : T_RESTRICT",
      "prop_metric_option : metric_option prop_restrict_list_option",
      "prop_restrict_list_option : /* empty */",
      "prop_restrict_list_option : '{' prop_restrict_list '}'",
      "prop_restrict_list : /* empty */",
      "prop_restrict_list : prop_restrict_list prop_restrict L_EOS",
      "prop_restrict_list : prop_restrict_list error L_EOS",
      "prop_restrict : /* empty */",
      "prop_restrict : dest_mask metric_restrict_option",
      "addr : T_NOP",
      "addr : ip_addr",
      "addr : iso_addr",
      "dest_mask : all_mask",
      "dest_mask : default_mask",
      "dest_mask : host_mask",
      "dest_mask : network_mask",
      "all_mask : T_ALL",
      "default_mask : T_NOP1",
      "default_mask : T_DEFAULT",
      "default_mask : T_ISO T_DEFAULT",
      "mask : T_NOP",
      "mask : in_addr",
      "mask : iso_addr",
      "gateway_list : gateway",
      "gateway_list : gateway_list gateway",
      "gateway : host",
      "host : host_name",
      "host : addr",
      "host_mask : T_HOST host",
      "network : host_name",
      "network : addr",
      "network_mask : network",
      "network_mask : network T_MASKLEN number",
      "network_mask : network T_MASK mask",
      "ip_addr : in_addr",
      "in_addr : L_NUMBER",
      "in_addr : byte_string",
      "host_name : L_HNAME",
      "host_name : L_KEYWORD",
      "host_name : string",
      "proto_interior : T_REDIRECT",
      "proto_exterior : T_NOP",
      "proto_exterior : bgp_prop_init",
      "onoff_option : T_ON",
      "onoff_option : T_OFF",
      "metric : number",
      "metric : T_INFINITY",
      "metric_option : /* empty */",
      "metric_option : T_METRIC metric",
      "metric_restrict_option : /* empty */",
      "metric_restrict_option : T_RESTRICT",
      "metric_restrict_option : T_METRIC metric",
      "preference_option : /* empty */",
      "preference_option : T_PREFERENCE preference",
      "preference_restrict_option : preference_option",
      "preference_restrict_option : T_RESTRICT",
      "preference : L_NUMBER",
      "string : L_STRING",
      "number : L_NUMBER",
      "number : byte_string",
      "byte_string : L_HEXSTRING",
      "byte_string : L_OCTETSTRING",
      "time : L_NUMBER",
      "time : L_NUMBER ':' L_NUMBER",
      "time : L_NUMBER ':' L_NUMBER ':' L_NUMBER",
      "port : L_NUMBER",
      "port : L_KEYWORD",
      "as : L_NUMBER",
      "as_list : as",
      "as_list : as_list as",
      "as_list_option : /* empty */",
      "as_list_option : T_AS as_list",
      "tag_as_option : /* empty */",
      "tag_as_option : T_TAG tag_as",
      "tag_as : tag",
      "tag_as : T_AS",
      "tag_as : T_AS number",
      "tag_option : /* empty */",
      "tag_option : T_TAG tag",
      "tag : number",
      "tag_prop_init : proto_exterior",
      "aspath_prop_init : proto_exterior",
      "aspath_match : T_ASPATH",
      "aspath_match : T_ASPATH aspath_regex T_ORIGIN aspath_origin",
      "aspath_origin : T_ANY",
      "aspath_origin : aspath_origin_list",
      "aspath_origin_list : aspath_origins",
      "aspath_origin_list : aspath_origin_list '|' aspath_origins",
      "aspath_origins : T_IGP",
      "aspath_origins : T_EGP",
      "aspath_origins : T_INCOMPLETE",
      "aspath_regex : aspath_sum",
      "aspath_regex : aspath_sum '|' aspath_regex",
      "aspath_sum : aspath_term",
      "aspath_sum : aspath_term aspath_sum",
      "aspath_term : aspath_symbol",
      "aspath_term : aspath_symbol '*'",
      "aspath_term : aspath_symbol '+'",
      "aspath_term : aspath_symbol '?'",
      "aspath_term : aspath_symbol '{' aspath_range '}'",
      "aspath_symbol : as",
      "aspath_symbol : '.'",
      "aspath_symbol : '(' aspath_regex ')'",
      "aspath_range : number",
      "aspath_range : number ','",
      "aspath_range : number ',' number",
      "iso_addr : L_ISOADDR",
};
#endif /* YYDEBUG */
/* @(#)27       1.7  com/cmd/lang/yacc/yaccpar, bos, bos320 8/12/91 16:09:43 */
/*
 * COMPONENT_NAME: (CMDLANG) Language Utilities
 *
 * FUNCTIONS: yyparse
 * ORIGINS: 03
 */
/*
** Skeleton parser driver for yacc output
*/

/*
** yacc user known macros and defines
*/
#ifdef YYSPLIT
#   define YYERROR      return(-2)
#else
#   define YYERROR      goto yyerrlab
#endif
#ifdef YACC_MSG
#ifndef _XOPEN_SOURCE
#define _XOPEN_SOURCE
#endif
#include <nl_types.h>
nl_catd catd;
#endif
#define YYACCEPT        return(0)
#define YYABORT         return(1)
#ifndef YACC_MSG
#define YYBACKUP( newtoken, newvalue )\
{\
        if ( yychar >= 0 || ( yyr2[ yytmp ] >> 1 ) != 1 )\
        {\
                yyerror( "syntax error - cannot backup" );\
                YYERROR;\
        }\
        yychar = newtoken;\
        yystate = *yyps;\
        yylval = newvalue;\
        goto yynewstate;\
}
#else
#define YYBACKUP( newtoken, newvalue )\
{\
        if ( yychar >= 0 || ( yyr2[ yytmp ] >> 1 ) != 1 )\
        {\
                catd=catopen("yacc_user.cat",0);\
                yyerror(catgets(catd,1,1,"syntax error - cannot backup" ));\
                YYERROR;\
        }\
        yychar = newtoken;\
        yystate = *yyps;\
        yylval = newvalue;\
        goto yynewstate;\
}
#endif
#define YYRECOVERING()  (!!yyerrflag)
#ifndef YYDEBUG
#       define YYDEBUG  1       /* make debugging available */
#endif

/*
** user known globals
*/
int yydebug;                    /* set to 1 to get debugging */

/*
** driver internal defines
*/
#define YYFLAG          (-1000)

#ifdef YYSPLIT
#   define YYSCODE { \
                        extern int (*_yyf[])(); \
                        register int yyret; \
                        if (_yyf[yytmp]) \
                            if ((yyret=(*_yyf[yytmp])()) == -2) \
                                    goto yyerrlab; \
                                else if (yyret>=0) return(yyret); \
                   }
#endif

/*
** global variables used by the parser
*/
YYSTYPE yyv[ YYMAXDEPTH ];      /* value stack */
int yys[ YYMAXDEPTH ];          /* state stack */

YYSTYPE *yypv;                  /* top of value stack */
YYSTYPE *yypvt;                 /* top of value stack for $vars */
int *yyps;                      /* top of state stack */

int yystate;                    /* current state */
int yytmp;                      /* extra var (lasts between blocks) */

int yynerrs;                    /* number of errors */
int yyerrflag;                  /* error recovery flag */
int yychar;                     /* current input token number */



/*
** yyparse - return 0 if worked, 1 if syntax error not recovered from
*/
int
yyparse()
{
        /*
        ** Initialize externals - yyparse may be called more than once
        */
        yypv = &yyv[-1];
        yyps = &yys[-1];
        yystate = 0;
        yytmp = 0;
        yynerrs = 0;
        yyerrflag = 0;
        yychar = -1;
#ifdef YACC_MSG
        catd=catopen("yacc_user.cat",0);
#endif
        goto yystack;
        {
                register YYSTYPE *yy_pv;        /* top of value stack */
                register int *yy_ps;            /* top of state stack */
                register int yy_state;          /* current state */
                register int  yy_n;             /* internal state number info */

                /*
                ** get globals into registers.
                ** branch to here only if YYBACKUP was called.
                */
        yynewstate:
                yy_pv = yypv;
                yy_ps = yyps;
                yy_state = yystate;
                goto yy_newstate;

                /*
                ** get globals into registers.
                ** either we just started, or we just finished a reduction
                */
        yystack:
                yy_pv = yypv;
                yy_ps = yyps;
                yy_state = yystate;

                /*
                ** top of for (;;) loop while no reductions done
                */
        yy_stack:
                /*
                ** put a state and value onto the stacks
                */
#if YYDEBUG
                /*
                ** if debugging, look up token value in list of value vs.
                ** name pairs.  0 and negative (-1) are special values.
                ** Note: linear search is used since time is not a real
                ** consideration while debugging.
                */
                if ( yydebug )
                {
                        register int yy_i;

                        printf( "State %d, token ", yy_state );
                        if ( yychar == 0 )
                                printf( "end-of-file\n" );
                        else if ( yychar < 0 )
                                printf( "-none-\n" );
                        else
                        {
                                for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
                                        yy_i++ )
                                {
                                        if ( yytoks[yy_i].t_val == yychar )
                                                break;
                                }
                                printf( "%s\n", yytoks[yy_i].t_name );
                        }
                }
#endif /* YYDEBUG */
                if ( ++yy_ps >= &yys[ YYMAXDEPTH ] )    /* room on stack? */
                {
#ifndef YACC_MSG
                        yyerror( "yacc stack overflow" );
#else
                        yyerror(catgets(catd,1,2,"yacc stack overflow" ));
#endif
                        YYABORT;
                }
                *yy_ps = yy_state;
                *++yy_pv = yyval;

                /*
                ** we have a new state - find out what to do
                */
        yy_newstate:
                if ( ( yy_n = yypact[ yy_state ] ) <= YYFLAG )
                        goto yydefault;         /* simple state */
#if YYDEBUG
                /*
                ** if debugging, need to mark whether new token grabbed
                */
                yytmp = yychar < 0;
#endif
                if ( ( yychar < 0 ) && ( ( yychar = yylex() ) < 0 ) )
                        yychar = 0;             /* reached EOF */
#if YYDEBUG
                if ( yydebug && yytmp )
                {
                        register int yy_i;

                        printf( "Received token " );
                        if ( yychar == 0 )
                                printf( "end-of-file\n" );
                        else if ( yychar < 0 )
                                printf( "-none-\n" );
                        else
                        {
                                for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
                                        yy_i++ )
                                {
                                        if ( yytoks[yy_i].t_val == yychar )
                                                break;
                                }
                                printf( "%s\n", yytoks[yy_i].t_name );
                        }
                }
#endif /* YYDEBUG */
                if ( ( ( yy_n += yychar ) < 0 ) || ( yy_n >= YYLAST ) )
                        goto yydefault;
                if ( yychk[ yy_n = yyact[ yy_n ] ] == yychar )  /*valid shift*/
                {
                        yychar = -1;
                        yyval = yylval;
                        yy_state = yy_n;
                        if ( yyerrflag > 0 )
                                yyerrflag--;
                        goto yy_stack;
                }

        yydefault:
                if ( ( yy_n = yydef[ yy_state ] ) == -2 )
                {
#if YYDEBUG
                        yytmp = yychar < 0;
#endif
                        if ( ( yychar < 0 ) && ( ( yychar = yylex() ) < 0 ) )
                                yychar = 0;             /* reached EOF */
#if YYDEBUG
                        if ( yydebug && yytmp )
                        {
                                register int yy_i;

                                printf( "Received token " );
                                if ( yychar == 0 )
                                        printf( "end-of-file\n" );
                                else if ( yychar < 0 )
                                        printf( "-none-\n" );
                                else
                                {
                                        for ( yy_i = 0;
                                                yytoks[yy_i].t_val >= 0;
                                                yy_i++ )
                                        {
                                                if ( yytoks[yy_i].t_val
                                                        == yychar )
                                                {
                                                        break;
                                                }
                                        }
                                        printf( "%s\n", yytoks[yy_i].t_name );
                                }
                        }
#endif /* YYDEBUG */
                        /*
                        ** look through exception table
                        */
                        {
                                register int *yyxi = yyexca;

                                while ( ( *yyxi != -1 ) ||
                                        ( yyxi[1] != yy_state ) )
                                {
                                        yyxi += 2;
                                }
                                while ( ( *(yyxi += 2) >= 0 ) &&
                                        ( *yyxi != yychar ) )
                                        ;
                                if ( ( yy_n = yyxi[1] ) < 0 )
                                        YYACCEPT;
                        }
                }

                /*
                ** check for syntax error
                */
                if ( yy_n == 0 )        /* have an error */
                {
                        /* no worry about speed here! */
                        switch ( yyerrflag )
                        {
                        case 0:         /* new error */
#ifndef YACC_MSG
                                yyerror( "syntax error" );
#else
                                yyerror(catgets(catd,1,3,"syntax error" ));
#endif
                                goto skip_init;
                        yyerrlab:
                                /*
                                ** get globals into registers.
                                ** we have a user generated syntax type error
                                */
                                yy_pv = yypv;
                                yy_ps = yyps;
                                yy_state = yystate;
                                yynerrs++;
                        skip_init:
                        case 1:
                        case 2:         /* incompletely recovered error */
                                        /* try again... */
                                yyerrflag = 3;
                                /*
                                ** find state where "error" is a legal
                                ** shift action
                                */
                                while ( yy_ps >= yys )
                                {
                                        yy_n = yypact[ *yy_ps ] + YYERRCODE;
                                        if ( yy_n >= 0 && yy_n < YYLAST &&
                                                yychk[yyact[yy_n]] == YYERRCODE)                                        {
                                                /*
                                                ** simulate shift of "error"
                                                */
                                                yy_state = yyact[ yy_n ];
                                                goto yy_stack;
                                        }
                                        /*
                                        ** current state has no shift on
                                        ** "error", pop stack
                                        */
#if YYDEBUG
#       define _POP_ "Error recovery pops state %d, uncovers state %d\n"
                                        if ( yydebug )
                                                printf( _POP_, *yy_ps,
                                                        yy_ps[-1] );
#       undef _POP_
#endif
                                        yy_ps--;
                                        yy_pv--;
                                }
                                /*
                                ** there is no state on stack with "error" as
                                ** a valid shift.  give up.
                                */
                                YYABORT;
                        case 3:         /* no shift yet; eat a token */
#if YYDEBUG
                                /*
                                ** if debugging, look up token in list of
                                ** pairs.  0 and negative shouldn't occur,
                                ** but since timing doesn't matter when
                                ** debugging, it doesn't hurt to leave the
                                ** tests here.
                                */
                                if ( yydebug )
                                {
                                        register int yy_i;

                                        printf( "Error recovery discards " );
                                        if ( yychar == 0 )
                                                printf( "token end-of-file\n" );
                                        else if ( yychar < 0 )
                                                printf( "token -none-\n" );
                                        else
                                        {
                                                for ( yy_i = 0;
                                                        yytoks[yy_i].t_val >= 0;
                                                        yy_i++ )
                                                {
                                                        if ( yytoks[yy_i].t_val
                                                                == yychar )
                                                        {
                                                                break;
                                                        }
                                                }
                                                printf( "token %s\n",
                                                        yytoks[yy_i].t_name );
                                        }
                                }
#endif /* YYDEBUG */
                                if ( yychar == 0 )      /* reached EOF. quit */
                                        YYABORT;
                                yychar = -1;
                                goto yy_newstate;
                        }
                }/* end if ( yy_n == 0 ) */
                /*
                ** reduction by production yy_n
                ** put stack tops, etc. so things right after switch
                */
#if YYDEBUG
                /*
                ** if debugging, print the string that is the user's
                ** specification of the reduction which is just about
                ** to be done.
                */
                if ( yydebug )
                        printf( "Reduce by (%d) \"%s\"\n",
                                yy_n, yyreds[ yy_n ] );
#endif
                yytmp = yy_n;                   /* value to switch over */
                yypvt = yy_pv;                  /* $vars top of value stack */
                /*
                ** Look in goto table for next state
                ** Sorry about using yy_state here as temporary
                ** register variable, but why not, if it works...
                ** If yyr2[ yy_n ] doesn't have the low order bit
                ** set, then there is no action to be done for
                ** this reduction.  So, no saving & unsaving of
                ** registers done.  The only difference between the
                ** code just after the if and the body of the if is
                ** the goto yy_stack in the body.  This way the test
                ** can be made before the choice of what to do is needed.
                */
                {
                        /* length of production doubled with extra bit */
                        register int yy_len = yyr2[ yy_n ];

                        if ( !( yy_len & 01 ) )
                        {
                                yy_len >>= 1;
                                yyval = ( yy_pv -= yy_len )[1]; /* $$ = $1 */
                                yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
                                        *( yy_ps -= yy_len ) + 1;
                                if ( yy_state >= YYLAST ||
                                        yychk[ yy_state =
                                        yyact[ yy_state ] ] != -yy_n )
                                {
                                        yy_state = yyact[ yypgo[ yy_n ] ];
                                }
                                goto yy_stack;
                        }
                        yy_len >>= 1;
                        yyval = ( yy_pv -= yy_len )[1]; /* $$ = $1 */
                        yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
                                *( yy_ps -= yy_len ) + 1;
                        if ( yy_state >= YYLAST ||
                                yychk[ yy_state = yyact[ yy_state ] ] != -yy_n )
                        {
                                yy_state = yyact[ yypgo[ yy_n ] ];
                        }
                }
                                        /* save until reenter driver code */
                yystate = yy_state;
                yyps = yy_ps;
                yypv = yy_pv;
        }
        /*
        ** code supplied by user is placed in this switch
        */

                switch(yytmp){

case 13:
# line 344 "parser.y"
{
				yyerrok;
			} /*NOTREACHED*/ break;
case 15:
# line 353 "parser.y"
{
#if	YYDEBUG != 0
			    if (yypvt[-1].num == T_OFF) {
				yydebug = 0;
			    } else {
				yydebug = 1;
			    }
#endif	/* YYDEBUG */
			} /*NOTREACHED*/ break;
case 16:
# line 363 "parser.y"
{
#if	YYDEBUG != 0
			    if (yypvt[-1].num < 0 || yypvt[-1].num > PS_MAX) {
				(void) sprintf(parse_error, "invalid yystate value: %d",
					       yypvt[-1].num);
				PARSE_ERROR;
			    }
			    parse_state = yypvt[-1].num;
#endif	/* YYDEBUG */
			} /*NOTREACHED*/ break;
case 17:
# line 374 "parser.y"
{
#if	YYDEBUG != 0
			    task_quit(0);
#endif	/* YYDEBUG */
			} /*NOTREACHED*/ break;
case 18:
# line 384 "parser.y"
{
			    if (!BIT_TEST(task_state, TASKS_TEST)) {
				if (yypvt[-1].flag) {
				    if (trace_flags) {
					trace_flags = trace_flags_save = yypvt[-1].flag;
					trace_display(trace_flags, TR_PARSE);
				    } else if (trace_opened) {
					trace_flags = trace_flags_save = yypvt[-1].flag;
					trace_display(trace_flags, TR_PARSE);
				    }
				} else {
				    if (trace_flags) {
					trace_flags = trace_flags_save = yypvt[-1].flag;
					trace_display(trace_flags, TR_PARSE);
					trace_off();
				    }
				}
			    }
			} /*NOTREACHED*/ break;
case 19:
# line 404 "parser.y"
{
			    if (!BIT_TEST(task_state, TASKS_TEST)) {
				if (yypvt[-2].str.len) {
				    int append = (int) yypvt[-2].str.type;

				    if (trace_flags) {
					trace_flags_save = trace_flags;
					trace_off();
				    }
				    trace_on(yypvt[-2].str.ptr, append);
				}
			    }
			} /*NOTREACHED*/ break;
case 20:
# line 420 "parser.y"
{
			    yyval.str.len = 0;
			} /*NOTREACHED*/ break;
case 21:
# line 424 "parser.y"
{
			    yyval.str = yypvt[-1].str;
			    yyval.str.type = yypvt[-0].num;
			} /*NOTREACHED*/ break;
case 23:
# line 432 "parser.y"
{
			    yyval.num = yypvt[-1].num * 1024;
			} /*NOTREACHED*/ break;
case 24:
# line 436 "parser.y"
{
			    yyval.num = yypvt[-1].num * 1024 * 1024;
			} /*NOTREACHED*/ break;
case 25:
# line 441 "parser.y"
{ yyval.num = TRUE; } /*NOTREACHED*/ break;
case 26:
# line 442 "parser.y"
{ yyval.num = FALSE; } /*NOTREACHED*/ break;
case 28:
# line 447 "parser.y"
{
			    if (parse_limit_check("file-size",
						  (u_int) yypvt[-2].num,
						  TRACE_LIMIT_FILE_SIZE)) {
				PARSE_ERROR;
			    }
			    trace_limit_size = yypvt[-2].num;

			    if (parse_limit_check("files",
						  (u_int) yypvt[-0].num,
						  TRACE_LIMIT_FILE_COUNT)) {
				PARSE_ERROR;
			    }
			    trace_limit_files = yypvt[-0].num;
			} /*NOTREACHED*/ break;
case 29:
# line 466 "parser.y"
{
			    yyval.flag = (flag_t) 0;
			} /*NOTREACHED*/ break;
case 30:
# line 470 "parser.y"
{
			    yyval.flag = yyval.flag;
			} /*NOTREACHED*/ break;
case 32:
# line 478 "parser.y"
{
			    yyval.flag = yypvt[-1].flag | yypvt[-0].flag;
			} /*NOTREACHED*/ break;
case 33:
# line 482 "parser.y"
{
			    yyval.flag = yypvt[-2].flag & ~yypvt[-0].flag;
			} /*NOTREACHED*/ break;
case 36:
# line 494 "parser.y"
{
			    yyval.flag = (flag_t) 0;
			} /*NOTREACHED*/ break;
case 39:
# line 502 "parser.y"
{
			    yyval.flag = yypvt[-1].flag | yypvt[-0].flag;
			} /*NOTREACHED*/ break;
case 40:
# line 510 "parser.y"
{
			    yyval.flag = TR_NOSTAMP;
			} /*NOTREACHED*/ break;
case 41:
# line 514 "parser.y"
{
			    yyval.flag = TR_MARK;
			} /*NOTREACHED*/ break;
case 42:
# line 518 "parser.y"
{
			    yyval.flag = TR_PARSE;
			} /*NOTREACHED*/ break;
case 43:
# line 522 "parser.y"
{
#ifdef	TR_ADV
			    yyval.flag = TR_ADV;
#else	/* TR_ADV */
			    yyval.flag = 0;
#endif	/* TR_ADV */
			} /*NOTREACHED*/ break;
case 44:
# line 533 "parser.y"
{
			    yyval.flag = TR_ALL;
			} /*NOTREACHED*/ break;
case 45:
# line 537 "parser.y"
{
			    yyval.flag = TR_INT|TR_EXT|TR_RT;
			} /*NOTREACHED*/ break;
case 46:
# line 541 "parser.y"
{
			    yyval.flag = TR_INT;
			} /*NOTREACHED*/ break;
case 47:
# line 545 "parser.y"
{
			    yyval.flag = TR_EXT;
			} /*NOTREACHED*/ break;
case 48:
# line 549 "parser.y"
{
			    yyval.flag = TR_RT;
			} /*NOTREACHED*/ break;
case 49:
# line 553 "parser.y"
{
			    yyval.flag = TR_UPDATE;
			} /*NOTREACHED*/ break;
case 50:
# line 557 "parser.y"
{
			    yyval.flag = TR_TASK;
			} /*NOTREACHED*/ break;
case 51:
# line 561 "parser.y"
{
			    yyval.flag = TR_TIMER;
			} /*NOTREACHED*/ break;
case 52:
# line 565 "parser.y"
{
			    yyval.flag = TR_PROTOCOL;
			} /*NOTREACHED*/ break;
case 53:
# line 569 "parser.y"
{
			    yyval.flag = TR_KRT;
			} /*NOTREACHED*/ break;
case 54:
# line 573 "parser.y"
{
			    yyval.flag = TR_BGP;
			} /*NOTREACHED*/ break;
case 55:
# line 577 "parser.y"
{
			    yyval.flag = TR_ISIS;
			} /*NOTREACHED*/ break;
case 56:
# line 580 "parser.y"
{ yyval.flag = TR_IDRP; } /*NOTREACHED*/ break;
case 57:
# line 586 "parser.y"
{
				if (parse_new_state(PS_DEFINE)) {
					PARSE_ERROR;
				}
			} /*NOTREACHED*/ break;
case 58:
# line 595 "parser.y"
{
			    parse_contig_masks = FALSE;
			} /*NOTREACHED*/ break;
case 59:
# line 599 "parser.y"
{
			    parse_contig_masks = TRUE;
			    if (parse_adv_append(&martian_list, yypvt[-2].adv, TRUE)) {
				PARSE_ERROR;
			    }
			} /*NOTREACHED*/ break;
case 60:
# line 608 "parser.y"
{
				/* RDI indicates the Routing Domain IDRP peer in
				 * there for both IP and CLNP 
				 * - Kludge for now to save as AS_RDI until
				 * - more parsing code is written for IP 
				 */
 
                                bcopy(yypvt[-1].hex.ptr,&rt_rdi.isoa_genaddr, yypvt[-1].hex.len);
                                rt_rdi.isoa_len = yypvt[-1].hex.len;
				trace (TR_PARSE,0,"rdi xxxx configured for idrp %A ", 
					sockbuild_iso(rt_rdi.isoa_genaddr, rt_rdi.isoa_len));
				rt_as_rdi.isoa_len = yypvt[-1].hex.len - 2;
				bcopy(yypvt[-1].hex.ptr,&rt_as_rdi.isoa_genaddr,rt_as_rdi.isoa_len);
				rt_as_rdi.isoa_family = AF_ISO;
				trace (TR_PARSE,0, "idrp finished call to rdi in parser.y");
                        } /*NOTREACHED*/ break;
case 61:
# line 625 "parser.y"
{ 
				/* need an NET for this node 
				 * if we configure multiple ISO host addresses, 
				 * we need to nominate one as NET.
				 * Eventually maybe this could be discovered
				 */

                                bcopy(yypvt[-1].hex.ptr, rt_net.isoa_genaddr, yypvt[-1].hex.len);
                                rt_net.isoa_len = yypvt[-1].hex.len;
                        } /*NOTREACHED*/ break;
case 62:
# line 637 "parser.y"
{
			    if (inet_autonomous_system != yypvt[-1].as) {
				if (inet_autonomous_system) {
				    inet_as_unlink(inet_autonomous_system);
				}
				inet_autonomous_system = yypvt[-1].as;
				inet_as_link(inet_autonomous_system);
			    }
			} /*NOTREACHED*/ break;
case 63:
# line 647 "parser.y"
{
			    if (inet_parse_routerid(yypvt[-1].sockaddr, parse_error)) {
				PARSE_ERROR;
			    }
			} /*NOTREACHED*/ break;
case 64:
# line 656 "parser.y"
{
			    yyval.adv = (adv_entry *) 0;
			} /*NOTREACHED*/ break;
case 65:
# line 660 "parser.y"
{
			    yyval.adv = adv_alloc(ADVFT_DM, (proto_t) 0);
			    yyval.adv->adv_dm = yypvt[-1].dm;
			    yyval.adv = parse_adv_dm_append(yypvt[-2].adv, yyval.adv);
			    if (!yyval.adv) {
				PARSE_ERROR;
			    }
			} /*NOTREACHED*/ break;
case 66:
# line 669 "parser.y"
{
			    yyerrok;
			} /*NOTREACHED*/ break;
case 70:
# line 683 "parser.y"
{
				if (parse_new_state(PS_OPTIONS)) {
					PARSE_ERROR;
				}
			} /*NOTREACHED*/ break;
case 74:
# line 700 "parser.y"
{
			    krt_install = FALSE;
			} /*NOTREACHED*/ break;
case 75:
# line 704 "parser.y"
{
			    rt_default_needed = TRUE;
			    if (PARSE_METRIC_ISSET(&yypvt[-0].metric)) {
				rt_default_rtparms.rtp_preference = yypvt[-0].metric.metric;
			    }
			} /*NOTREACHED*/ break;
case 76:
# line 711 "parser.y"
{
			    task_newstate(TASKS_NOSEND, 0);
			} /*NOTREACHED*/ break;
case 77:
# line 715 "parser.y"
{
			    task_newstate(TASKS_NORESOLV, 0);
			} /*NOTREACHED*/ break;
case 78:
# line 719 "parser.y"
{
#ifdef	LOG_DAEMON
			    (void) setlogmask(yypvt[-0].num);
#else	/* LOG_DAEMON */
			    (void) sprintf(parse_error, "system does not support setlogmask()");
			    PARSE_ERROR;
#endif	/* LOG_DAEMON */
			} /*NOTREACHED*/ break;
case 79:
# line 731 "parser.y"
{
#ifdef	LOG_DAEMON
			    yyval.num = LOG_MASK(yypvt[-0].num);
#endif	/* LOG_DAEMON */
			} /*NOTREACHED*/ break;
case 80:
# line 737 "parser.y"
{
#ifdef	LOG_DAEMON
			    yyval.num = LOG_UPTO(yypvt[-0].num);
#endif	/* LOG_DAEMON */
			} /*NOTREACHED*/ break;
case 81:
# line 743 "parser.y"
{
#ifdef	LOG_DAEMON
			    yyval.num = yypvt[-1].num | LOG_MASK(yypvt[-0].num);
#endif	/* LOG_DAEMON */
			} /*NOTREACHED*/ break;
case 82:
# line 751 "parser.y"
{
			    yyval.num = LOG_EMERG;
			} /*NOTREACHED*/ break;
case 83:
# line 755 "parser.y"
{
			    yyval.num = LOG_ALERT;
			} /*NOTREACHED*/ break;
case 84:
# line 759 "parser.y"
{
			    yyval.num = LOG_CRIT;
			} /*NOTREACHED*/ break;
case 85:
# line 763 "parser.y"
{
			    yyval.num = LOG_ERR;
			} /*NOTREACHED*/ break;
case 86:
# line 767 "parser.y"
{
			    yyval.num = LOG_WARNING;
			} /*NOTREACHED*/ break;
case 87:
# line 771 "parser.y"
{
			    yyval.num = LOG_NOTICE;
			} /*NOTREACHED*/ break;
case 88:
# line 775 "parser.y"
{
			    yyval.num = LOG_INFO;
			} /*NOTREACHED*/ break;
case 89:
# line 779 "parser.y"
{
			    yyval.num = LOG_EMERG;
			} /*NOTREACHED*/ break;
case 90:
# line 787 "parser.y"
{
			    if (parse_new_state(PS_INTERFACE)) {
				PARSE_ERROR;
			    }
			} /*NOTREACHED*/ break;
case 91:
# line 796 "parser.y"
{
			    PROTO_SEEN(RTPROTO_DIRECT);
			} /*NOTREACHED*/ break;
case 95:
# line 806 "parser.y"
{
			    yyerrok;
			} /*NOTREACHED*/ break;
case 97:
# line 814 "parser.y"
{
			    config_list *list = config_list_alloc(yypvt[-0].config, 0);

			    parse_adv_propagate_config(yypvt[-1].adv, list, (proto_t) 0);

			    if (parse_adv_append(&int_policy, yypvt[-1].adv, TRUE)) {
				PARSE_ERROR;
			    }

			    config_list_free(list);
			} /*NOTREACHED*/ break;
case 98:
# line 826 "parser.y"
{
			    bzero((caddr_t) &parse_ifi, sizeof (parse_ifi));

			    parse_ifi.ifi_addr = yypvt[-0].sockaddr;
			} /*NOTREACHED*/ break;
case 99:
# line 832 "parser.y"
{
			    if (if_parse_add(&parse_ifi, parse_error)) {
				PARSE_ERROR;
			    }
			} /*NOTREACHED*/ break;
case 102:
# line 846 "parser.y"
{
			    task_newstate(TASKS_STRICTIFS, 0);
			} /*NOTREACHED*/ break;
case 103:
# line 850 "parser.y"
{
			    if (parse_limit_check("scan-interval",
						  (u_int) yypvt[-0].time,
						  KRT_LIMIT_SCANTIMER)) {
				PARSE_ERROR;
			    }
			    
			    timer_set(krt_task->task_timer[KRT_TIMER_IFCHECK],
				      yypvt[-0].time,
				      (time_t) 0);
			} /*NOTREACHED*/ break;
case 104:
# line 865 "parser.y"
{
			    parse_ifi.ifi_addr_broadcast = yypvt[-0].sockaddr;
			    BIT_SET(parse_ifi.ifi_state, IFS_BROADCAST);
			} /*NOTREACHED*/ break;
case 105:
# line 870 "parser.y"
{
			    parse_ifi.ifi_addr_local = yypvt[-0].sockaddr;
			    BIT_SET(parse_ifi.ifi_state, IFS_POINTOPOINT);
			} /*NOTREACHED*/ break;
case 106:
# line 875 "parser.y"
{
			} /*NOTREACHED*/ break;
case 109:
# line 886 "parser.y"
{
			    parse_ifi.ifi_subnetmask = yypvt[-0].sockaddr;
			} /*NOTREACHED*/ break;
case 110:
# line 890 "parser.y"
{
			    BIT_SET(parse_ifi.ifi_state, IFS_MULTICAST);
			} /*NOTREACHED*/ break;
case 112:
# line 898 "parser.y"
{
			    yyval.config = config_append(yypvt[-1].config, yypvt[-0].config);
			    if (!yyval.config) {
				PARSE_ERROR;
			    }
			} /*NOTREACHED*/ break;
case 113:
# line 908 "parser.y"
{
			    yyval.config = config_alloc(IF_CONFIG_PREFERENCE_UP, (void_t) yypvt[-0].pref);
			} /*NOTREACHED*/ break;
case 114:
# line 912 "parser.y"
{
			    yyval.config = config_alloc(IF_CONFIG_PREFERENCE_DOWN, (void_t) yypvt[-0].pref);
			} /*NOTREACHED*/ break;
case 115:
# line 916 "parser.y"
{
			    yyval.config = config_alloc(IF_CONFIG_PASSIVE, (void_t) TRUE);
			} /*NOTREACHED*/ break;
case 116:
# line 920 "parser.y"
{
			    yyval.config = config_alloc(IF_CONFIG_SIMPLEX, (void_t) TRUE);
			} /*NOTREACHED*/ break;
case 117:
# line 924 "parser.y"
{
			    yyval.config = config_alloc(IF_CONFIG_REJECT, (void_t) TRUE);
			} /*NOTREACHED*/ break;
case 118:
# line 928 "parser.y"
{
			    yyval.config = config_alloc(IF_CONFIG_BLACKHOLE, (void_t) TRUE);
			} /*NOTREACHED*/ break;
case 119:
# line 935 "parser.y"
{
			    yyval.adv = adv_alloc(ADVFT_ANY|ADVF_FIRST, (proto_t) 0);
			} /*NOTREACHED*/ break;
case 120:
# line 939 "parser.y"
{
			    yyval.adv = yypvt[-0].adv;
			} /*NOTREACHED*/ break;
case 122:
# line 947 "parser.y"
{
			    yyval.adv = yypvt[-0].adv;
			} /*NOTREACHED*/ break;
case 123:
# line 954 "parser.y"
{
			    yyval.adv = adv_alloc(ADVFT_ANY|ADVF_FIRST, (proto_t) 0);
			} /*NOTREACHED*/ break;
case 125:
# line 962 "parser.y"
{
			    BIT_SET(yypvt[-0].adv->adv_flag, ADVF_FIRST);
			    yyval.adv = yypvt[-0].adv;
			} /*NOTREACHED*/ break;
case 126:
# line 967 "parser.y"
{
			    yyval.adv = yypvt[-1].adv;
			    if (parse_adv_append(&yyval.adv, yypvt[-0].adv, TRUE)) {
				PARSE_ERROR;
			    }
			} /*NOTREACHED*/ break;
case 127:
# line 976 "parser.y"
{
			    switch (yypvt[-0].adv->adv_flag & ADVF_TYPE) {

			    case ADVFT_IFN:
				trace(TR_PARSE, 0, "parse: %s INTERFACE: %A*",
				      parse_where(),
				      yyval.adv->adv_ifn->ifae_addr);
				break;
				
			    case ADVFT_IFAE:
				trace(TR_PARSE, 0, "parse: %s INTERFACE: %A",
				      parse_where(),
				      yyval.adv->adv_ifae->ifae_addr);
			    }
			} /*NOTREACHED*/ break;
case 128:
# line 995 "parser.y"
{
			    int valid_ifname = yypvt[-0].str.type == L_KEYWORD && yypvt[-0].str.len <= IFNAMSIZ;

			    if (valid_ifname) {
				/* First try to look up as an interface name */

				yyval.adv = if_parse_name(yypvt[-0].str.ptr, FALSE);
			    } else {
				/* Doesn't meet the criteria to be a name */

				yyval.adv = (adv_entry *) 0;
			    }
			    
			    if (!yyval.adv && !BIT_TEST(task_state, TASKS_NORESOLV)) {
				/* Try to resolve as a host name */

				sockaddr_un *addr = parse_addr_hostname(yypvt[-0].str.ptr);

				if (addr) {
				    yyval.adv = if_parse_address(addr);
				}

			    }

			    if (!yyval.adv) {
				if (valid_ifname && !BIT_TEST(task_state, TASKS_STRICTIFS)) {
				    /* Assume it is a reference to an interface that does not exist */

				    yyval.adv = if_parse_name(yypvt[-0].str.ptr, TRUE);
				} else {
				    /* Time to give up */
				    
				    (void) sprintf(parse_error, "Interface not found at '%s'",
						   yypvt[-0].str.ptr);
				    PARSE_ERROR;
				}
			    }
				
			    free_charstr(&yypvt[-0].str);
			} /*NOTREACHED*/ break;
case 129:
# line 1036 "parser.y"
{
			    yyval.adv = if_parse_address(yypvt[-0].sockaddr);
			    if (!yyval.adv) {
				(void) sprintf(parse_error, "Interface not found at '%A'",
					       yypvt[-0].sockaddr);
				PARSE_ERROR;
			    }

			    sockfree(yypvt[-0].sockaddr);
			} /*NOTREACHED*/ break;
case 130:
# line 1049 "parser.y"
{
			    if_addr *ifap;
			    
			    ifap = if_withlcladdr(yypvt[-0].sockaddr, FALSE);
			    if (ifap) {
				yyval.ifae = ifae_alloc(ifap->ifa_addrent_local);
			    } else {
				if (BIT_TEST(task_state, TASKS_STRICTIFS)) {
				    (void) sprintf(parse_error, "Invalid interface at '%A'",
						   yypvt[-0].sockaddr);
				    PARSE_ERROR;
				} else {
				    yyval.ifae = ifae_locate(yypvt[-0].sockaddr, &if_local_list);
				}
			    }
			    sockfree(yypvt[-0].sockaddr);
			    trace(TR_PARSE, 0, "parse: %s LOCAL ADDRESS: %A",
				  parse_where(),
				  yyval.ifae->ifae_addr);
			} /*NOTREACHED*/ break;
case 132:
# line 1073 "parser.y"
{
			    sockaddr_un *addr;

			    if (BIT_TEST(task_state, TASKS_NORESOLV)
				|| !(addr = parse_addr_hostname(yypvt[-0].str.ptr))) {
				PARSE_ERROR;
			    }
			    yyval.sockaddr = sockdup(addr);
			    free_charstr(&yypvt[-0].str);
			} /*NOTREACHED*/ break;
case 133:
# line 1088 "parser.y"
{
			    if (parse_new_state(PS_PROTO)) {
				PARSE_ERROR;
			    }
			} /*NOTREACHED*/ break;
case 138:
# line 1117 "parser.y"
{
			    PROTO_SEEN(RTPROTO_ISIS);

#ifdef	notyet
			    parse_gwlist = &isis.gw_list;

			    isis_trace_flags = trace_flags;
#endif	/* notyet */

			    /* XXX - should be done by above */
			    isis_plevel = 1;
                        } /*NOTREACHED*/ break;
case 139:
# line 1130 "parser.y"
{

			    ip_supported = 0;
			    clnp_supported = 0;
			    switch (yypvt[-1].num) {
			    case T_OFF:
				break;
			    /* XXX - Check validity of configuration for the following */
			    case T_IP:
				ip_supported = 1;
				doing_isis = TRUE;
				break;
			    case T_ISO:
				clnp_supported = 1;
				doing_isis = TRUE;
				break;
			    case T_ON:
			    case T_DUAL:
				ip_supported = clnp_supported = 1;
				doing_isis = TRUE;
			    }
			} /*NOTREACHED*/ break;
case 141:
# line 1155 "parser.y"
{ yyval.num = T_IP; } /*NOTREACHED*/ break;
case 142:
# line 1156 "parser.y"
{ yyval.num = T_ISO; } /*NOTREACHED*/ break;
case 143:
# line 1157 "parser.y"
{ yyval.num = T_DUAL; } /*NOTREACHED*/ break;
case 148:
# line 1167 "parser.y"
{
				yyerrok;
			} /*NOTREACHED*/ break;
case 149:
# line 1173 "parser.y"
{
			    isis_plevel = yypvt[-0].num;
			} /*NOTREACHED*/ break;
case 150:
# line 1177 "parser.y"
{
			    if (BIT_TEST(task_state, TASKS_RECONFIG)) {
				if ((isis_ci = isis_GetIspcByName(yypvt[-0].str)) == 0) {
				    /* this is a config of a new circuit */    
				    isis_ci = ++isis_circuits_parsed;
				    bzero(&isis_ca[isis_ci], sizeof(struct is_pc));
				    strcpy(isis_ca[isis_ci].name, yypvt[-0].str.ptr);
			    	    /* isis_init_ca(&isis_ca[isis_ci], $2); */
				    trace(TR_ISIS, LOG_INFO, "IS-IS reconfig parsed new circuit #%d -> %s", isis_ci, yypvt[-0].str);
				} else {
					trace(TR_ISIS, LOG_INFO, "IS-IS reconfig parsed existing circuit #%d -> %s", isis_ci, yypvt[-0].str);
				} 
			    } else {
				/* remember new circuit */
			    	isis_ci = ++isis_circuits_parsed;
				trace(TR_ISIS, LOG_INFO, "IS-IS config parsed new circuit #%d -> %s", isis_ci, yypvt[-0].str);
				bzero(&isis_ca[isis_ci], sizeof(struct is_pc));
				strcpy(isis_ca[isis_ci].name, yypvt[-0].str.ptr);
			    	/* isis_init_ca(&isis_ca[isis_ci], $2); */
			    }
			} /*NOTREACHED*/ break;
case 151:
# line 1199 "parser.y"
{
			} /*NOTREACHED*/ break;
case 152:
# line 1202 "parser.y"
{
			    isis_set_sysid(yypvt[-0].str);
			} /*NOTREACHED*/ break;
case 153:
# line 1206 "parser.y"
{
			    isis_save_trace(yypvt[-0].flag);
			} /*NOTREACHED*/ break;
case 154:
# line 1210 "parser.y"
{
			    /* we need an index in lieu of the NSAP address; used to use getpid */
			    isis_snpa = yypvt[-0].num;
			} /*NOTREACHED*/ break;
case 155:
# line 1215 "parser.y"
{
			    isis_saveArea(yypvt[-0].str);
			} /*NOTREACHED*/ break;
case 156:
# line 1219 "parser.y"
{
			    save_ipreach(yypvt[-5].num,yypvt[-4].num,&yypvt[-3].sockaddr,&yypvt[-2].sockaddr,yypvt[-0].num);
			} /*NOTREACHED*/ break;
case 157:
# line 1223 "parser.y"
{
			    isis_savePrefix(yypvt[-0].str.ptr, yypvt[-1].num, yypvt[-3].num);
			} /*NOTREACHED*/ break;
case 158:
# line 1227 "parser.y"
{
			    isis_saveInterDomInfo(yypvt[-0].str);
			} /*NOTREACHED*/ break;
case 159:
# line 1231 "parser.y"
{
			    isis_set_parm(yypvt[-1].str,yypvt[-0].num);
			} /*NOTREACHED*/ break;
case 160:
# line 1238 "parser.y"
{
			    yyval.num = yypvt[-0].num;
			} /*NOTREACHED*/ break;
case 161:
# line 1242 "parser.y"
{
			    yyval.num = 1;
			} /*NOTREACHED*/ break;
case 162:
# line 1248 "parser.y"
{
			    yyval.num = T_IP;
			} /*NOTREACHED*/ break;
case 163:
# line 1252 "parser.y"
{
			    yyval.num = T_ISO;
			} /*NOTREACHED*/ break;
case 164:
# line 1256 "parser.y"
{
			    yyval.num = T_DUAL;
			} /*NOTREACHED*/ break;
case 167:
# line 1266 "parser.y"
{
			    if (yypvt[-1].num == 2) {
				isis_ca[isis_ci].l2metric = yypvt[-0].num;
			    } else {
				isis_ca[isis_ci].metric = yypvt[-0].num;
			    }
			} /*NOTREACHED*/ break;
case 168:
# line 1274 "parser.y"
{
			    if (yypvt[-1].num == 2) {
				isis_ca[isis_ci].l2prior = yypvt[-0].num;
			    } else {
				isis_ca[isis_ci].prior = yypvt[-0].num;
			    }
			} /*NOTREACHED*/ break;
case 169:
# line 1284 "parser.y"
{
			    yyval.num = ISIS_INTERNAL;
			} /*NOTREACHED*/ break;
case 170:
# line 1288 "parser.y"
{
			    yyval.num = ISIS_EXTERNAL;
			} /*NOTREACHED*/ break;
case 171:
# line 1292 "parser.y"
{
			    yyval.num = ISIS_SUMMARY;
			} /*NOTREACHED*/ break;
case 172:
# line 1298 "parser.y"
{
			    yyval.num = ISIS_INTERNAL;
			} /*NOTREACHED*/ break;
case 173:
# line 1302 "parser.y"
{
			    yyval.num = ISIS_EXTERNAL;
			} /*NOTREACHED*/ break;
case 175:
# line 1309 "parser.y"
{
				    yyval.flag = yypvt[-1].flag | yypvt[-0].flag;
				} /*NOTREACHED*/ break;
case 176:
# line 1313 "parser.y"
{
				    yyval.flag = yypvt[-2].flag & ~yypvt[-1].num;
				} /*NOTREACHED*/ break;
case 177:
# line 1319 "parser.y"
{ yyval.flag = T_ISISALL; } /*NOTREACHED*/ break;
case 178:
# line 1320 "parser.y"
{ yyval.flag = T_DUMPIIH; } /*NOTREACHED*/ break;
case 179:
# line 1321 "parser.y"
{ yyval.flag = T_DUMPLSP; } /*NOTREACHED*/ break;
case 180:
# line 1322 "parser.y"
{ yyval.flag = T_EVENTS; } /*NOTREACHED*/ break;
case 181:
# line 1323 "parser.y"
{ yyval.flag = T_LANADJ; } /*NOTREACHED*/ break;
case 182:
# line 1324 "parser.y"
{ yyval.flag = T_FLOODING; } /*NOTREACHED*/ break;
case 183:
# line 1325 "parser.y"
{ yyval.flag = T_BUILDLSP; } /*NOTREACHED*/ break;
case 184:
# line 1326 "parser.y"
{ yyval.flag = T_CSNP; } /*NOTREACHED*/ break;
case 185:
# line 1327 "parser.y"
{ yyval.flag = T_PSNP; } /*NOTREACHED*/ break;
case 186:
# line 1328 "parser.y"
{ yyval.flag = T_LSPINPUT; } /*NOTREACHED*/ break;
case 187:
# line 1329 "parser.y"
{ yyval.flag = T_P2PADJ; } /*NOTREACHED*/ break;
case 188:
# line 1330 "parser.y"
{ yyval.flag = T_TRSPF; } /*NOTREACHED*/ break;
case 189:
# line 1331 "parser.y"
{ yyval.flag = T_DUMPDB; } /*NOTREACHED*/ break;
case 190:
# line 1332 "parser.y"
{ yyval.flag = T_ROUTE2; } /*NOTREACHED*/ break;
case 191:
# line 1333 "parser.y"
{ yyval.flag = T_ROUTE1; } /*NOTREACHED*/ break;
case 192:
# line 1334 "parser.y"
{ yyval.flag = T_ROUTE3; } /*NOTREACHED*/ break;
case 193:
# line 1335 "parser.y"
{ yyval.flag = T_LSPCONTENT; } /*NOTREACHED*/ break;
case 194:
# line 1353 "parser.y"
{
			    PROTO_SEEN(RTPROTO_BGP);

			    parse_gwlist = &parse_gwp;

			    bgp_default_trace_flags = trace_flags;
			} /*NOTREACHED*/ break;
case 195:
# line 1361 "parser.y"
{
			    switch (yypvt[-1].num) {
			    case T_ON:
				doing_bgp = TRUE;

				if (!bgp_conf_check(parse_error)) {
				    PARSE_ERROR;
				}
				break;

			    case T_OFF:
				doing_bgp = FALSE;
			    }

			    parse_gwlist = (gw_entry **) 0;
			} /*NOTREACHED*/ break;
case 200:
# line 1386 "parser.y"
{
			    yyerrok;
			} /*NOTREACHED*/ break;
case 201:
# line 1392 "parser.y"
{
			    bgp_default_preference = yypvt[-0].pref;
			} /*NOTREACHED*/ break;
case 202:
# line 1396 "parser.y"
{
			    if (parse_metric_check(RTPROTO_BGP, &yypvt[-0].metric)) {
				PARSE_ERROR;
			    }
			    bgp_default_metric = yypvt[-0].metric.metric;
			} /*NOTREACHED*/ break;
case 203:
# line 1403 "parser.y"
{
			    bgp_default_trace_flags = yypvt[-0].flag;
			} /*NOTREACHED*/ break;
case 204:
# line 1407 "parser.y"
{
			    /* Allocate a Group structure */
			    bgp = bgp_conf_group_alloc();

			    /* Set the type and AS */
			    bgp->bgpg_type = yypvt[-2].num;
			    bgp->bgpg_peer_as = yypvt[-0].as;

			    /* Point at this configuration information */
			    bcp = &bgp->bgpg_conf;

			    /* Inherit global trace flags */
			    bgp->bgpg_trace_flags = bgp_default_trace_flags;
			} /*NOTREACHED*/ break;
case 205:
# line 1422 "parser.y"
{
			    /* Add this group */
			    bgp = bgp_conf_group_add(bgp, parse_error);
			    if (!bgp) {
				PARSE_ERROR;
			    }
			} /*NOTREACHED*/ break;
case 206:
# line 1430 "parser.y"
{
			    /* Check group */
			    if (!bgp_conf_group_check(bgp, parse_error)) {
				PARSE_ERROR;
			    }
			} /*NOTREACHED*/ break;
case 211:
# line 1446 "parser.y"
{
				yyerrok;
			} /*NOTREACHED*/ break;
case 212:
# line 1452 "parser.y"
{
			    /* Allocate this peer */
			    bnp = bgp_conf_peer_alloc(bgp);

			    /* Point at this configuration information */
			    bcp = &bnp->bgp_conf;
			} /*NOTREACHED*/ break;
case 213:
# line 1460 "parser.y"
{
			    /* Set peer address */
			    bnp->bgp_addr = yypvt[-1].sockaddr;

			    bnp = bgp_conf_peer_add(bgp, bnp, parse_error);
			    if (!bnp) {
				PARSE_ERROR;
			    }
			} /*NOTREACHED*/ break;
case 214:
# line 1470 "parser.y"
{
			    parse_contig_masks = FALSE;
			} /*NOTREACHED*/ break;
case 215:
# line 1474 "parser.y"
{
			    parse_contig_masks = TRUE;

			    if (parse_adv_append(&bgp->bgpg_allow, yypvt[-1].adv, TRUE)) {
				PARSE_ERROR;
			    }
			} /*NOTREACHED*/ break;
case 216:
# line 1484 "parser.y"
{
			    if (parse_metric_check(RTPROTO_BGP, &yypvt[-0].metric)) {
				PARSE_ERROR;
			    }
			    BIT_SET(bcp->bgpc_options, BGPO_METRIC_OUT);
			    bcp->bgpc_metric_out = yypvt[-0].metric.metric;
			} /*NOTREACHED*/ break;
case 217:
# line 1492 "parser.y"
{
			    BIT_SET(bcp->bgpc_options, BGPO_LOCAL_AS);
			    bcp->bgpc_local_as = yypvt[-0].as;
			} /*NOTREACHED*/ break;
case 218:
# line 1497 "parser.y"
{
			    BIT_SET(bcp->bgpc_options, BGPO_NOGENDEFAULT);
			} /*NOTREACHED*/ break;
case 219:
# line 1501 "parser.y"
{
			    if (bcp->bgpc_gateway) {
				/* Free the old one */
				sockfree(bcp->bgpc_gateway);
			    }
			    BIT_SET(bcp->bgpc_options, BGPO_GATEWAY);
			    bcp->bgpc_gateway = sockdup(yypvt[-0].gwp->gw_addr);
			    gw_freelist(*parse_gwlist);
			    *parse_gwlist = parse_gwp = (gw_entry *) 0;
			} /*NOTREACHED*/ break;
case 220:
# line 1512 "parser.y"
{
			    BIT_SET(bcp->bgpc_options, BGPO_PREFERENCE);
			    bcp->bgpc_preference = yypvt[-0].pref;
			} /*NOTREACHED*/ break;
case 221:
# line 1517 "parser.y"
{
			    if (bcp->bgpc_lcladdr) {
				/* Free the old one */
				ifae_free(bcp->bgpc_lcladdr);
			    }
			    BIT_SET(bcp->bgpc_options, BGPO_LCLADDR);
			    bcp->bgpc_lcladdr = yypvt[-0].ifae;
			} /*NOTREACHED*/ break;
case 222:
# line 1526 "parser.y"
{
			    if (parse_limit_check("hold time",
						  (u_int) yypvt[-0].time,
						  BGP_LIMIT_HOLDTIME)) {
				PARSE_ERROR;
			    }
			    BIT_SET(bcp->bgpc_options, BGPO_HOLDTIME);
			    bcp->bgpc_holdtime_out = yypvt[-0].time;
			} /*NOTREACHED*/ break;
case 223:
# line 1536 "parser.y"
{
			    bcp->bgpc_trace_flags = yypvt[-0].flag;
			} /*NOTREACHED*/ break;
case 224:
# line 1540 "parser.y"
{
			    if (!BGP_KNOWN_VERSION(yypvt[-0].num)) {
				(void) sprintf(parse_error, "unsupported BGP version: %d",
					       yypvt[-0].num);
				PARSE_ERROR;
			    }
			    BIT_SET(bcp->bgpc_options, BGPO_VERSION);
			    bcp->bgpc_conf_version = yypvt[-0].num;
			} /*NOTREACHED*/ break;
case 225:
# line 1550 "parser.y"
{
			    BIT_SET(bcp->bgpc_options, BGPO_PASSIVE);
			} /*NOTREACHED*/ break;
case 226:
# line 1554 "parser.y"
{
			    BIT_SET(bcp->bgpc_options, BGPO_DEFAULTIN);
			} /*NOTREACHED*/ break;
case 227:
# line 1558 "parser.y"
{
			    BIT_SET(bcp->bgpc_options, BGPO_DEFAULTOUT);
			} /*NOTREACHED*/ break;
case 228:
# line 1562 "parser.y"
{
			    BIT_SET(bcp->bgpc_options, BGPO_KEEPALL);
			} /*NOTREACHED*/ break;
case 229:
# line 1566 "parser.y"
{
			    bcp->bgpc_send_bufsize = yypvt[-0].num;
			} /*NOTREACHED*/ break;
case 230:
# line 1570 "parser.y"
{
			    bcp->bgpc_recv_bufsize = yypvt[-0].num;
			} /*NOTREACHED*/ break;
case 231:
# line 1574 "parser.y"
{
			    if (parse_limit_check("spool buffer size",
						  (u_int) yypvt[-0].num,
						  BGP_LIMIT_SBUF)) {
				PARSE_ERROR;
			    }
			    bcp->bgpc_spool_bufsize = yypvt[-0].num;
			} /*NOTREACHED*/ break;
case 232:
# line 1585 "parser.y"
{
			    if (parse_limit_check("kernel buffer size",
						  (u_int) yypvt[-0].num,
						  BGP_LIMIT_KBUF)) {
				PARSE_ERROR;
			    }
			    yyval.num = yypvt[-0].num;
			} /*NOTREACHED*/ break;
case 233:
# line 1596 "parser.y"
{
			    yyval.num = BGPG_INTERNAL;
			} /*NOTREACHED*/ break;
case 234:
# line 1600 "parser.y"
{
			    yyval.num = BGPG_EXTERNAL;
			} /*NOTREACHED*/ break;
case 235:
# line 1604 "parser.y"
{
			    yyval.num = BGPG_INTERNAL_IGP;
			} /*NOTREACHED*/ break;
case 236:
# line 1608 "parser.y"
{
			    yyval.num = BGPG_TEST;
			} /*NOTREACHED*/ break;
case 238:
# line 1619 "parser.y"
{
			    yyval.proto = parse_proto = RTPROTO_BGP;
			    parse_gwlist = (gw_entry **) 0;
			    trace(TR_PARSE, 0, "parse: %s PROTO: %s",
				  parse_where(),
				  gd_lower(trace_state(rt_proto_bits, yyval.proto)));
			} /*NOTREACHED*/ break;
case 239:
# line 1630 "parser.y"
{
			    yyval.adv = (adv_entry *) 0;
			} /*NOTREACHED*/ break;
case 240:
# line 1634 "parser.y"
{
			    yyval.adv = adv_alloc(ADVFT_DM, (proto_t) 0);
			    yyval.adv->adv_dm = yypvt[-1].dm;
			    yyval.adv = parse_adv_dm_append(yypvt[-2].adv, yyval.adv);
			    if (!yyval.adv) {
				PARSE_ERROR;
			    }
			} /*NOTREACHED*/ break;
case 241:
# line 1643 "parser.y"
{
			    yyerrok;
			} /*NOTREACHED*/ break;
case 245:
# line 1660 "parser.y"
{
					/* global parameters for protocol */
	
                                        idrp_trace_flags = trace_flags;
                                        parse_proto = RTPROTO_IDRP;
                                        idrp_parse_group_index = 0;
                                } /*NOTREACHED*/ break;
case 246:
# line 1668 "parser.y"
{
			    		PROTO_SEEN(RTPROTO_IDRP);
                                        if (yypvt[-2].num == T_OFF) {
                                                doing_idrp = FALSE;
                                                trace(TR_PARSE, 0, "parse: %s idrp off ;", parse_where());
                                        } else {
						/* set flag and initialize local nodes idrpPeer struct */
                                                doing_idrp = TRUE;
						idrp_local_peer_init();

						/* check to make sure RDI specified */
                                                if (!rt_rdi.isoa_len) {
                                                        (void) sprintf(parse_error, "RDI not specified");
                                                        PARSE_ERROR;
                                                }
                                                /* %% */
						/* here we need to change for */
						/* idrp for IP */
		
                                                if (!rt_net.isoa_len) {
                                                        (void) sprintf(parse_error, "NET not specified");
                                                        PARSE_ERROR;
                                                }

                                                if (!idrp_neighbors) {
                                                        (void) sprintf(parse_error, "no IDRP neighbors specified");
                                                        PARSE_ERROR;
                                                }
                                                IDRP_LIST(idgp) {
                                                        trace(TR_PARSE, 0, "parse:  %s, IDRP neighbor %s, addr %A",
								parse_where(), idgp->name, 
								sockbuild_iso((byte *)idgp->neighbor.isoa_genaddr,
								idgp->neighbor.isoa_len));
                                                } IDRP_LIST_END;
                                        }
                                } /*NOTREACHED*/ break;
case 247:
# line 1708 "parser.y"
{
                                        idrp_trace_flags = yypvt[-0].flag;
                                } /*NOTREACHED*/ break;
case 249:
# line 1716 "parser.y"
{
					/* zero the group address functions */
 
                                        bzero((caddr_t) &idrp_group, sizeof(idrp_group));
                                        gr_idrp = &idrp_group;
                                        gr_idrp->trace_flags = idrp_trace_flags;
                                        idrp_parse_group_index++;
                                } /*NOTREACHED*/ break;
case 254:
# line 1732 "parser.y"
{
                                        yyerrok;
                                } /*NOTREACHED*/ break;
case 259:
# line 1745 "parser.y"
{
                                        yyerrok;
                                } /*NOTREACHED*/ break;
case 262:
# line 1753 "parser.y"
{
				idrp_this_node.route_server = FALSE;
				if (yypvt[-0].num == T_ON)
					{
					idrp_this_node.route_server = TRUE;
					}
				} /*NOTREACHED*/ break;
case 263:
# line 1762 "parser.y"
{
				idrp_this_node.multi_exit = FALSE;
				if (yypvt[-0].num == T_ON)
					{
					idrp_this_node.multi_exit = TRUE;
					}
				} /*NOTREACHED*/ break;
case 266:
# line 1773 "parser.y"
{
				idrp_this_node.rcv_credit = yypvt[-0].num;
				} /*NOTREACHED*/ break;
case 267:
# line 1778 "parser.y"
{
				idrp_this_node.listen_for_open = FALSE;
				if (yypvt[-0].num == T_ON)
					{
					idrp_this_node.listen_for_open = TRUE;
					}
				} /*NOTREACHED*/ break;
case 268:
# line 1787 "parser.y"
{
				idrp_this_node.hold_time = yypvt[-0].num;
				} /*NOTREACHED*/ break;
case 269:
# line 1792 "parser.y"
{
				idrp_this_node.close_wait = yypvt[-0].num;
				} /*NOTREACHED*/ break;
case 270:
# line 1797 "parser.y"
{
				idrp_this_node.rexmit_time = yypvt[-0].num;
				} /*NOTREACHED*/ break;
case 271:
# line 1801 "parser.y"
{
				idrp_this_node.ribcheck_timer = yypvt[-0].num;
				} /*NOTREACHED*/ break;
case 272:
# line 1805 "parser.y"
{
				idrp_this_node.min_adv_time = yypvt[-0].num;
				} /*NOTREACHED*/ break;
case 273:
# line 1809 "parser.y"
{
				idrp_this_node.min_advRD_time = yypvt[-0].num;
				} /*NOTREACHED*/ break;
case 274:
# line 1815 "parser.y"
{
				idrp_this_node.AuthType = yypvt[-0].num; 
				} /*NOTREACHED*/ break;
case 275:
# line 1819 "parser.y"
{
				idrp_this_node.AuthType = yypvt[-2].num;
				bcopy(yypvt[-0].hex.ptr,&idrp_this_node.AuthCode[0],yypvt[-0].hex.len);
				} /*NOTREACHED*/ break;
case 277:
# line 1827 "parser.y"
{
				idgp = &idrp_this_node;
				} /*NOTREACHED*/ break;
case 282:
# line 1839 "parser.y"
{
                                        yyerrok;
                                } /*NOTREACHED*/ break;
case 283:
# line 1846 "parser.y"
{
					/* allocate a peer */

					idgp = idrp_peer_alloc(0);

					/* if group has not been initialized - do it now */
					/* all of idrpPeer structure will be zero       */
	 
       	                               if (!gr_idrp)
						{	
						gr_idrp = idrp_peer_alloc(&idrp_group);
						}
                                } /*NOTREACHED*/ break;
case 284:
# line 1860 "parser.y"
{
                                        idrpPeer *idgp2;

                                        if (yypvt[-7].num == T_OFF)
						 {
						 idgp->idrp_flags = IDRPF_IDLED;
						}
					else	
						{
						idgp->idrp_flags = IDRPF_TRY_CONNECT;
						}   		

					/* copy in group trace flags 
					 * in this sequence, the RDI is not copied 
					 */
 
					idgp->trace_flags = gr_idrp->trace_flags;
					idgp->type = gr_idrp->type;

					/* copy rdi, NET, IP address for now */
					/* need to put interface someplace */

					bcopy(yypvt[-6].hex.ptr, idgp->neighbor.isoa_genaddr,yypvt[-6].hex.len);
					idgp->neighbor.isoa_len = yypvt[-6].hex.len;
					idgp->neighbor.isoa_family = AF_ISO;
                                        bcopy(yypvt[-3].hex.ptr, idgp->rdi.isoa_genaddr,yypvt[-3].hex.len);
                                        idgp->rdi.isoa_len = yypvt[-3].hex.len;

				        sprintf(idgp->name, "%A", 
						sockbuild_iso((byte *) idgp->neighbor.isoa_genaddr, 
						idgp->neighbor.isoa_len));
	
					/* is it my rdi - if so, internal neighbor */

					if (idgp->type == IDRP_PEER_INTERNAL)
						{
						if (isoaddrcmp(&idgp->rdi,&rt_rdi))
							{
							/* rdi does not match */
							trace ( TR_IDRP,0,"internal neighbor %s has internal neighbor but rdi is not ours", \
							idgp->name);
							}					 
						}

                                        idgp->ip_neighbor = yypvt[-5].sockaddr;
                                        idgp->gw.gw_proto = RTPROTO_IDRP;
					idgp->gw.gw_addr->in.sin_port = IDRP_PORT;

					/* if reparsing - check for this peer in
					 * existing list
					 */

					/* check for this peer being on the chain
					 * already
					 */

					idgp2 = idrp_find_peer(idgp);
					if (idgp2)
						{
						/* found a peer structure */
						if (idrp_reparsing)
							{
							/* re-use old structure, update
							 * with the new parameters  so far
							 * and free duplicate peer structure
							 */
 
							idrp_peer_update(idgp2,idgp);
							idrp_big_blk_free(idgp);
							idgp = idgp2;	
							}
						else
							{
							trace (TR_IDRP,0,"duplicate peer %s",idgp->name);
							PARSE_ERROR;
							}	
						}
					else
						{
						/* not a duplicate and not a reparsing re-used
						 * peer structure 
						 */
		
						idrp_link_peer(idgp);
						}
                                } /*NOTREACHED*/ break;
case 287:
# line 1951 "parser.y"
{
                                        yyerrok;
                                } /*NOTREACHED*/ break;
case 288:
# line 1958 "parser.y"
{
				/* create a local route with this NLRI information */

				int bits; 
				idrpRoute_options	*p_opts = 0; 

				bits = yypvt[-1].hex.len * 8; 
				if (!idrp_local_rt(yypvt[-1].hex.ptr,yypvt[-1].hex.len,bits,AF_ISO,yypvt[-0].hex.ptr,yypvt[-0].hex.len,p_opts))
					{ 
					trace (TR_PARSE,0,"maximum number of local routes exceeded, no more added to routing table");
					}
                                } /*NOTREACHED*/ break;
case 289:
# line 1971 "parser.y"
{
				int bits; 
				bits = yypvt[-2].hex.len * 8;
				if (!idrp_local_rt(yypvt[-2].hex.ptr,yypvt[-2].hex.len,bits,AF_ISO,yypvt[-1].hex.ptr,yypvt[-1].hex.len,&idrp_rt_opts))
					{ 
					trace (TR_PARSE,0,"maximum number of local routes exceeded, no more added to routing table");
					}
                                } /*NOTREACHED*/ break;
case 290:
# line 1981 "parser.y"
{
				int bits; 
				bits = yypvt[-3].hex.len * 8;
				if (!idrp_local_rt(yypvt[-3].hex.ptr,yypvt[-3].hex.len,bits,AF_INET,yypvt[-2].hex.ptr,yypvt[-2].hex.len,&idrp_rt_opts))
					{ 
					trace (TR_PARSE,0,"maximum number of local routes exceeded, no more added to routing table");
					}
				} /*NOTREACHED*/ break;
case 291:
# line 1991 "parser.y"
{
				int bits;
				bits = yypvt[-2].hex.len * 8;
				if (!idrp_local_rt(yypvt[-2].hex.ptr,yypvt[-2].hex.len,bits,AF_ISO,yypvt[-1].hex.ptr,yypvt[-1].hex.len,&idrp_rt_opts))
					{ 
					trace (TR_PARSE,0,"maximum number of local routes exceeded, no more added to routing table");
					}
				} /*NOTREACHED*/ break;
case 292:
# line 2001 "parser.y"
{
				int bits;
				bits = yypvt[-3].hex.len * 8;
				if (!idrp_local_rt(yypvt[-3].hex.ptr,yypvt[-3].hex.len,bits,AF_ISO,yypvt[-2].hex.ptr,yypvt[-2].hex.len,&idrp_rt_opts))
					{ 
					trace (TR_PARSE,0,"maximum number of local routes exceeded, no more added to routing table");
					}
				} /*NOTREACHED*/ break;
case 294:
# line 2013 "parser.y"
{
                                        yyerrok;
				} /*NOTREACHED*/ break;
case 295:
# line 2019 "parser.y"
{
				/* note I am using byte string and next hop gateway
				 * as the operative thing to insert into
				 * - gateway table, but this may have to be re-examined
				 * - is uses a number and then gets the byte string
				 */ 

				bcopy(yypvt[-0].hex.ptr,&idrp_rt_opts.next_hop_snpas.snpa1.snpa,yypvt[-0].hex.len);
				idrp_rt_opts.next_hop_snpas.cnt = 1;	
				idrp_rt_opts.next_hop_snpas.pdu_len = yypvt[-0].hex.len; 
				} /*NOTREACHED*/ break;
case 296:
# line 2032 "parser.y"
{
				idrp_rt_opts.multi_exit = yypvt[-0].num;
				} /*NOTREACHED*/ break;
case 297:
# line 2036 "parser.y"
{
				idrp_rt_opts.multi_exit = yypvt[-2].num;
				bcopy(yypvt[-0].hex.ptr,&idrp_rt_opts.next_hop_snpas.snpa1.snpa,yypvt[-0].hex.len);
				idrp_rt_opts.next_hop_snpas.cnt = 1;	
				idrp_rt_opts.next_hop_snpas.pdu_len = yypvt[-0].hex.len; 
				} /*NOTREACHED*/ break;
case 298:
# line 2043 "parser.y"
{
				bcopy(yypvt[-2].hex.ptr,&idrp_rt_opts.next_hop_snpas.snpa1.snpa,yypvt[-2].hex.len);
				idrp_rt_opts.next_hop_snpas.cnt = 1;	
				idrp_rt_opts.next_hop_snpas.pdu_len = yypvt[-2].hex.len; 
				idrp_rt_opts.multi_exit = yypvt[-0].num;
				} /*NOTREACHED*/ break;
case 299:
# line 2050 "parser.y"
{
				idrp_rt_opts.route_server = IDRP_SERVER_ALLOWED;
				} /*NOTREACHED*/ break;
case 301:
# line 2057 "parser.y"
{
                                        yyerrok;
				} /*NOTREACHED*/ break;
case 303:
# line 2064 "parser.y"
{
				if (idrp_rt_opts.p_DIST_LIST_EXCL)
					{
					p_idrp_excl_rdi_tail->p_next = p_rdi_head;
					p_idrp_excl_rdi_tail = p_rdi_tail;
					}
				else
					{
					p_idrp_excl_rdi_tail = p_idrp_excl_rdi_head = p_rdi_head;
					idrp_rt_opts.p_DIST_LIST_EXCL = p_rdi_head;
					} 
				} /*NOTREACHED*/ break;
case 304:
# line 2078 "parser.y"
{
				if (idrp_rt_opts.p_DIST_LIST_INCL)
					{
					p_idrp_incl_rdi_tail->p_next = p_rdi_head;
					}
				else
					{
					p_idrp_incl_rdi_tail = p_idrp_incl_rdi_head = p_rdi_head;
					idrp_rt_opts.p_DIST_LIST_INCL = p_rdi_head;
					}
				} /*NOTREACHED*/ break;
case 306:
# line 2094 "parser.y"
{
                                        yyerrok;
				} /*NOTREACHED*/ break;
case 307:
# line 2100 "parser.y"
{
				if (!p_rdi_head)
					{
					p_rdi_head = p_rdi_tail = create_local_rd_path(yypvt[-0].hex.len,yypvt[-0].hex.ptr);
					}
				else
					{
					p_rdi_tail->p_next = create_local_rd_path(yypvt[-0].hex.len,yypvt[-0].hex.ptr);
					p_rdi_tail = p_rdi_tail->p_next;
					p_rdi_tail->p_next = (idrp_canon_rdpath *) 0;
					}
				} /*NOTREACHED*/ break;
case 309:
# line 2117 "parser.y"
{
                                        idgp->ip_intf_addr = yypvt[-0].sockaddr;
					idgp->ip_intf_addr->in.sin_port = IDRP_PORT;
					trace (TR_PARSE, 0, "ip interface address configed"); 
                                } /*NOTREACHED*/ break;
case 310:
# line 2123 "parser.y"
{
					idrp_set_iso_sockun((struct sockadd_un *)&idgp->iso_gw_addr,yypvt[-0].hex.len,yypvt[-0].hex.ptr);	
					trace (TR_PARSE, 0, "iso interface address configed"); 
				} /*NOTREACHED*/ break;
case 311:
# line 2128 "parser.y"
{
	                                idgp->ip_intf_addr = yypvt[-1].sockaddr;
					idgp->ip_intf_addr->in.sin_port = IDRP_PORT;
					trace (TR_PARSE, 0, "ip interface address configed"); 
					idrp_set_iso_sockun((struct sockadd_un *)&idgp->iso_gw_addr,yypvt[-0].hex.len,yypvt[-0].hex.ptr);	
					trace (TR_PARSE, 0, "iso interface address configured"); 
				} /*NOTREACHED*/ break;
case 312:
# line 2136 "parser.y"
{
	                                idgp->ip_intf_addr = yypvt[-0].sockaddr;
					idgp->ip_intf_addr->in.sin_port = IDRP_PORT;
					trace (TR_PARSE, 0, "ip interface address configed"); 
					idrp_set_iso_sockun((struct sockadd_un *)&idgp->iso_gw_addr,yypvt[-1].hex.len,yypvt[-1].hex.ptr);	
					trace (TR_PARSE, 0, "iso interface address configured"); 
				} /*NOTREACHED*/ break;
case 317:
# line 2153 "parser.y"
{
                                        bcopy(yypvt[-0].hex.ptr,&gr_idrp->rdi.isoa_genaddr, yypvt[-0].hex.len);
                                        gr_idrp->rdi.isoa_len = yypvt[-0].hex.len;
                                } /*NOTREACHED*/ break;
case 318:
# line 2158 "parser.y"
{
                                        gr_idrp->type = IDRP_PEER_INTERNAL;
                                } /*NOTREACHED*/ break;
case 319:
# line 2162 "parser.y"
{
                                        gr_idrp->type = IDRP_PEER_EXTERNAL;
                                } /*NOTREACHED*/ break;
case 323:
# line 2174 "parser.y"
{
				idgp->proto_sock = IDRP_PDU_PROTO_IP_RAW;
				} /*NOTREACHED*/ break;
case 324:
# line 2178 "parser.y"
{
				idgp->proto_sock = IDRP_PDU_PROTO_UDP;
				} /*NOTREACHED*/ break;
case 325:
# line 2183 "parser.y"
{
				/*  raw clnp socket */
				idgp->proto_sock = IDRP_PDU_PROTO_CLNP;
				} /*NOTREACHED*/ break;
case 326:
# line 2188 "parser.y"
{
				idgp->proto_sock = IDRP_PDU_PROTO_IDRP;
				} /*NOTREACHED*/ break;
case 327:
# line 2193 "parser.y"
{
				idrp_this_node.nlri_supp[IDRP_NLRI_ISO] = TRUE;
				} /*NOTREACHED*/ break;
case 328:
# line 2197 "parser.y"
{
				idrp_this_node.nlri_supp[IDRP_NLRI_IP] = TRUE;
				} /*NOTREACHED*/ break;
case 329:
# line 2201 "parser.y"
{
				idrp_this_node.nlri_supp[IDRP_NLRI_IP] = TRUE;
				idrp_this_node.nlri_supp[IDRP_NLRI_ISO] = TRUE;
				idrp_this_node.nlri_supp[IDRP_NLRI_PIP] = TRUE;
				} /*NOTREACHED*/ break;
case 330:
# line 2208 "parser.y"
{
				idrp_this_node.nlri_supp[IDRP_NLRI_IP] = TRUE;
				idrp_this_node.nlri_supp[IDRP_NLRI_ISO] = TRUE;
				idrp_this_node.nlri_supp[IDRP_NLRI_PIP] = TRUE;
				idrp_this_node.nlri_supp[IDRP_NLRI_SIP] = TRUE;
				} /*NOTREACHED*/ break;
case 331:
# line 2215 "parser.y"
{
				idrp_this_node.nlri_supp[IDRP_NLRI_PIP] = TRUE;
				} /*NOTREACHED*/ break;
case 332:
# line 2219 "parser.y"
{
				idrp_this_node.nlri_supp[IDRP_NLRI_SIP] = TRUE;
				} /*NOTREACHED*/ break;
case 335:
# line 2229 "parser.y"
{
                                        idgp->trace_flags = yypvt[-0].flag;
                                } /*NOTREACHED*/ break;
case 337:
# line 2236 "parser.y"
{
                                        yyval.hex = yypvt[-0].hex;
                                } /*NOTREACHED*/ break;
case 344:
# line 2262 "parser.y"
{
#if	defined(PROTO_ICMP) || defined(KRT_RT_SOCK)
			    PROTO_SEEN(RTPROTO_REDIRECT);

			    parse_gwlist = &redirect_gw_list;

			    redirect_trace_flags = trace_flags;
#endif	/* defined(PROTO_ICMP) || defined(KRT_RT_SOCK) */
			} /*NOTREACHED*/ break;
case 345:
# line 2272 "parser.y"
{
#if	defined(PROTO_ICMP) || defined(KRT_RT_SOCK)
			    switch (yypvt[-1].num) {
			    case T_ON:
				/* Enabled by default */
				break;

			    case T_OFF:
				redirect_disable(RTPROTO_REDIRECT);
				break;
			    }
#endif	/* defined(PROTO_ICMP) || defined(KRT_RT_SOCK) */
			} /*NOTREACHED*/ break;
case 350:
# line 2295 "parser.y"
{
			    yyerrok;
			} /*NOTREACHED*/ break;
case 351:
# line 2301 "parser.y"
{
#if	defined(PROTO_ICMP) || defined(KRT_RT_SOCK)
			    redirect_preference = yypvt[-0].pref;
#endif	/* defined(PROTO_ICMP) || defined(KRT_RT_SOCK) */
			} /*NOTREACHED*/ break;
case 352:
# line 2307 "parser.y"
{
#if	defined(PROTO_ICMP) || defined(KRT_RT_SOCK)
			    config_list *list = config_list_alloc(yypvt[-0].config, 0);

			    parse_adv_propagate_config(yypvt[-1].adv, list, RTPROTO_REDIRECT);

			    if (parse_adv_append(&redirect_int_policy, yypvt[-1].adv, TRUE)) {
				PARSE_ERROR;
			    }

			    config_list_free(list);
#endif	/* defined(PROTO_ICMP) || defined(KRT_RT_SOCK) */
			} /*NOTREACHED*/ break;
case 353:
# line 2321 "parser.y"
{
#if	defined(PROTO_ICMP) || defined(KRT_RT_SOCK)
			    redirect_n_trusted += parse_gw_flag(yypvt[-0].adv, RTPROTO_REDIRECT, GWF_TRUSTED);
			    if (!redirect_n_trusted) {
				PARSE_ERROR;
			    }
#endif	/* defined(PROTO_ICMP) || defined(KRT_RT_SOCK) */
			} /*NOTREACHED*/ break;
case 354:
# line 2330 "parser.y"
{
			    redirect_trace_flags = yypvt[-0].flag;
			} /*NOTREACHED*/ break;
case 356:
# line 2338 "parser.y"
{
			    yyval.config = config_append(yypvt[-1].config, yypvt[-0].config);
			    if (!yyval.config) {
				PARSE_ERROR;
			    }
			} /*NOTREACHED*/ break;
case 357:
# line 2348 "parser.y"
{
#if	defined(PROTO_ICMP) || defined(KRT_RT_SOCK)
			    yyval.config = config_alloc(REDIRECT_CONFIG_NOIN, (void_t) TRUE);
#endif	/* defined(PROTO_ICMP) || defined(KRT_RT_SOCK) */
			} /*NOTREACHED*/ break;
case 359:
# line 2369 "parser.y"
{
			    if (parse_new_state(PS_ROUTE)) {
				PARSE_ERROR;
			    }
			} /*NOTREACHED*/ break;
case 360:
# line 2377 "parser.y"
{
			    /* Need to set this for static routes, not used for interface routes */
			    parse_proto = RTPROTO_STATIC;
			    parse_gwlist = &rt_gw_list;
			    rt_open(rt_task);
			} /*NOTREACHED*/ break;
case 361:
# line 2384 "parser.y"
{
			    rt_close(rt_task, (gw_entry *) 0, 0, NULL);
			} /*NOTREACHED*/ break;
case 364:
# line 2392 "parser.y"
{
				yyerrok;
			} /*NOTREACHED*/ break;
case 365:
# line 2398 "parser.y"
{
			    /* Route to a gateway */

			    if (rt_parse_route(yypvt[-5].dm.dm_dest,
					       yypvt[-5].dm.dm_mask,
					       yypvt[-3].adv,
					       yypvt[-2].adv,
					       PARSE_METRIC_ISSET(&yypvt[-1].metric) ? (pref_t) yypvt[-1].metric.metric : RTPREF_STATIC,
					       yypvt[-0].flag | RTS_GATEWAY,
					       parse_error)) {
				PARSE_ERROR;
			    }

			    sockfree(yypvt[-5].dm.dm_dest);
			} /*NOTREACHED*/ break;
case 366:
# line 2414 "parser.y"
{
			    /* Route to an interface */

			    if (rt_parse_route(yypvt[-4].dm.dm_dest,
					       yypvt[-4].dm.dm_mask,
					       (adv_entry *) 0,
					       yypvt[-2].adv,
					       PARSE_METRIC_ISSET(&yypvt[-1].metric) ? (pref_t) yypvt[-1].metric.metric : RTPREF_STATIC,
					       yypvt[-0].flag,
					       parse_error)) {
				PARSE_ERROR;
			    }

			    sockfree(yypvt[-4].dm.dm_dest);
			} /*NOTREACHED*/ break;
case 368:
# line 2433 "parser.y"
{
#ifndef	VARIABLE_MASKS
#ifdef	PROTO_INET
			    if (socktype(yypvt[-0].dm.dm_dest) == AF_INET) {
				sockaddr_un *ifmask = inet_ifsubnetmask(sock2in(yypvt[-0].dm.dm_dest));

				if (!ifmask) {
				    ifmask = inet_mask_natural(yypvt[-0].dm.dm_dest);
				}

				if (ifmask != yypvt[-0].dm.dm_mask) {
				    sprintf(parse_error, "variable subnet masks not supported on this system");
				    PARSE_ERROR;
				}
			    }
#endif	/* PROTO_INET */
#endif	/* VARIABLE_MASKS */
			    yyval.dm = yypvt[-0].dm;			/* struct copy */
			} /*NOTREACHED*/ break;
case 369:
# line 2453 "parser.y"
{
			    yyval.dm.dm_dest = sockdup(inet_addr_default);
			    yyval.dm.dm_mask = inet_mask_default;
			    trace(TR_PARSE, 0, "parse: %s DEST: %A MASK: %A",
				  parse_where(),
				  yyval.dm.dm_dest,
				  yyval.dm.dm_mask);
			} /*NOTREACHED*/ break;
case 370:
# line 2462 "parser.y"
{
			    yyval.dm.dm_dest = iso_addr_default;
			    yyval.dm.dm_mask = iso_mask_default;
			    trace(TR_PARSE, 0, "parse: %s DEST: %A MASK: %A",
				  parse_where(),
				  yyval.dm.dm_dest,
				  yyval.dm.dm_mask);
			} /*NOTREACHED*/ break;
case 371:
# line 2473 "parser.y"
{
			    yyval.flag = 0;
			} /*NOTREACHED*/ break;
case 372:
# line 2477 "parser.y"
{
			    yyval.flag = yypvt[-1].flag | yypvt[-0].flag;
			} /*NOTREACHED*/ break;
case 373:
# line 2483 "parser.y"
{
			    yyval.flag = RTS_RETAIN;
			} /*NOTREACHED*/ break;
case 374:
# line 2487 "parser.y"
{
			    yyval.flag = RTS_REJECT;
			} /*NOTREACHED*/ break;
case 375:
# line 2491 "parser.y"
{
			    yyval.flag = RTS_BLACKHOLE;
			} /*NOTREACHED*/ break;
case 376:
# line 2495 "parser.y"
{
			    yyval.flag = RTS_NOTINSTALL;
			} /*NOTREACHED*/ break;
case 377:
# line 2503 "parser.y"
{
			    if (parse_new_state(PS_CONTROL)) {
				PARSE_ERROR;
			    }
			} /*NOTREACHED*/ break;
case 378:
# line 2512 "parser.y"
{
#if	defined(PROTO_EGP) || defined(PROTO_BGP)
			    adv_entry *adv;
			    pmet_t *pp = &yypvt[-1].metric_adv.metric;

			    /*
			     *	Tack the list of destinations onto the end of the list
			     *	for neighbors with the specified AS.
			     */
			    adv = adv_alloc(ADVFT_AS, yypvt[-4].proto_lists.proto);
			    adv->adv_as = yypvt[-2].as;
			    adv->adv_list = yypvt[-1].metric_adv.adv;
			    if (PARSE_METRIC_ISSET(pp)) {
				if (PARSE_METRIC_ISRESTRICT(pp)) {
				    BIT_SET(adv->adv_flag, ADVF_NO);
				} else {
				    BIT_SET(adv->adv_flag, ADVFOT_PREFERENCE);
				    adv->adv_result.res_preference = pp->metric;
				}
			    }

			    if (!parse_adv_as(yypvt[-4].proto_lists.import_list, adv)) {
				PARSE_ERROR;
			    }
#endif	/* defined(PROTO_EGP) || defined(PROTO_BGP) */
			} /*NOTREACHED*/ break;
case 379:
# line 2539 "parser.y"
{
			    adv_entry *adv;
			    pmet_t *pp = &yypvt[-1].metric_adv.metric;

			    /*
			     *	Tack the list of destinations onto the end of the list
			     *	for neighbors with the specified AS.
			     */
			    adv = adv_alloc(ADVFT_ASPATH, RTPROTO_BGP);
			    adv->adv_aspath = (caddr_t) yypvt[-2].asp_match;
			    adv->adv_list = yypvt[-1].metric_adv.adv;
			    if (PARSE_METRIC_ISSET(pp)) {
				if (PARSE_METRIC_ISRESTRICT(pp)) {
				    BIT_SET(adv->adv_flag, ADVF_NO);
				} else {
				    BIT_SET(adv->adv_flag, ADVFOT_PREFERENCE);
				    adv->adv_result.res_preference = pp->metric;
				}
			    }

			    if (parse_adv_append(&bgp_import_aspath_list, adv, TRUE)) {
				PARSE_ERROR;
			    }
			} /*NOTREACHED*/ break;
case 380:
# line 2564 "parser.y"
{
			    /*
			     *	Append the dest_mask list to the end of the import list
			     *	for the specified protocol.
			     */
			    if (!parse_adv_propagate_preference(yypvt[-2].adv, yypvt[-3].proto_lists.proto, &yypvt[-1].metric_adv.metric, yypvt[-1].metric_adv.adv)) {
				PARSE_ERROR;
			    }

			    adv_free_list(yypvt[-1].metric_adv.adv);

			    switch (yypvt[-2].adv->adv_flag & ADVF_TYPE) {
			    case ADVFT_GW:
				/* Gateway list */
			        {
				    adv_entry *adv = yypvt[-2].adv;
				    adv_entry *advn;

				    do {
					advn = adv->adv_next;
					adv->adv_next = NULL;
					/* Reset the type */
					adv->adv_flag = (adv->adv_flag & ~ADVF_TYPE) | ADVFT_ANY;
					if (parse_adv_append(&adv->adv_gwp->gw_import, adv, TRUE)) {
					    PARSE_ERROR;
					}
				    } while (adv = advn);
				}
				break;

			    case ADVFT_ANY:
				/* Global list */
				if (parse_adv_append(yypvt[-3].proto_lists.import_list, yypvt[-2].adv, TRUE)) {
				    PARSE_ERROR;
				}
				break;

			    case ADVFT_IFN:
			    case ADVFT_IFAE:
				/* Interface list */
				if (parse_adv_append(&int_import[yypvt[-3].proto_lists.proto], yypvt[-2].adv, TRUE)) {
				    PARSE_ERROR;
				}
				break;

			    default:
				assert(FALSE);
			    }
			} /*NOTREACHED*/ break;
case 381:
# line 2614 "parser.y"
{
#if	defined(PROTO_EGP) || defined(PROTO_BGP)
			    adv_entry *adv;
			    adv_entry *adv_prop = yypvt[-1].metric_adv.adv;
			    pmet_t *mp = &yypvt[-1].metric_adv.metric;

			    /*
			     *	Tack the list of destinations onto the end of the list
			     *	for neighbors with the specified AS.
			     */
			    adv = adv_alloc(ADVFT_AS, yypvt[-4].proto_lists.proto);
			    adv->adv_as = yypvt[-2].as;
			    adv->adv_list = adv_prop;
			    if (PARSE_METRIC_ISRESTRICT(mp)) {
				BIT_SET(adv->adv_flag, ADVF_NO);
			    } else if (PARSE_METRIC_ISSET(mp)) {
				BIT_SET(adv->adv_flag, ADVFOT_METRIC);
				adv->adv_result.res_metric = mp->metric;
			    }

			    if (!parse_adv_as(yypvt[-4].proto_lists.export_list, adv)) {
				PARSE_ERROR;
			    }
#endif	/* defined(PROTO_EGP) || defined(PROTO_BGP) */
			} /*NOTREACHED*/ break;
case 382:
# line 2640 "parser.y"
{
			    /*
			     *	Append the dest_mask list to the end of the export list
			     *	for the specified protocol.
			     */

			    if (!parse_adv_propagate_metric(yypvt[-2].adv, yypvt[-3].proto_lists.proto, &yypvt[-1].metric_adv.metric, yypvt[-1].metric_adv.adv)) {
				PARSE_ERROR;
			    }

			    adv_free_list(yypvt[-1].metric_adv.adv);

			    switch (yypvt[-2].adv->adv_flag & ADVF_TYPE) {
			    case ADVFT_GW:
				/* Gateway list */
			        {
				    adv_entry *adv = yypvt[-2].adv;
				    adv_entry *advn;
				
				    do {
					advn = adv->adv_next;
					adv->adv_next = NULL;
					if (parse_adv_append(&adv->adv_gwp->gw_export, adv, TRUE)) {
					    PARSE_ERROR;
					}
				    } while (adv = advn);
				}
				break;

			    case ADVFT_ANY:
				/* Global list for the protocol */
				if (parse_adv_append(yypvt[-3].proto_lists.export_list, yypvt[-2].adv, TRUE)) {
				    PARSE_ERROR;
				}
				break;

			    case ADVFT_IFN:
			    case ADVFT_IFAE:
				/* Interface list */
				if (parse_adv_append(&int_export[yypvt[-3].proto_lists.proto], yypvt[-2].adv, TRUE)) {
				    PARSE_ERROR;
				}
				break;

			    default:
				assert(FALSE);
			    }
			} /*NOTREACHED*/ break;
case 383:
# line 2698 "parser.y"
{
			    parse_export_proto = yyval.proto_lists.proto = yypvt[-0].proto;

			    switch (yypvt[-0].proto) {
#if	defined(PROTO_EGP)
			    case RTPROTO_EGP:
				yyval.proto_lists.import_list = &egp_import_list;
				yyval.proto_lists.export_list = &egp_export_list;
				break;
#endif

#if	defined(PROTO_BGP)
			    case RTPROTO_BGP:
				yyval.proto_lists.import_list = &bgp_import_list;
				yyval.proto_lists.export_list = &bgp_export_list;
				break;
#endif

			    default:
				(void) sprintf(parse_error,
					       "unknown import protocol: %s",
					       gd_lower(trace_state(rt_proto_bits, yypvt[-0].proto)));
				PARSE_ERROR;
			    }
			} /*NOTREACHED*/ break;
case 384:
# line 2727 "parser.y"
{
			    yyval.proto_lists = yypvt[-0].proto_lists;
			    
			    parse_proto = yypvt[-0].proto_lists.proto;
			    parse_gwlist = yypvt[-0].proto_lists.gw_list;

			    if (!yypvt[-0].proto_lists.import_list) {
				(void) sprintf(parse_error,
					       "unknown import protocol: %s",
					       gd_lower(trace_state(rt_proto_bits, yypvt[-0].proto_lists.proto)));
				PARSE_ERROR;
			    }
			    
			    trace(TR_PARSE, 0, "parse: %s PROTO: %s",
				  parse_where(),
				  gd_lower(trace_state(rt_proto_bits, yypvt[-0].proto_lists.proto)));
			} /*NOTREACHED*/ break;
case 385:
# line 2748 "parser.y"
{
			    PARSE_METRIC_RESTRICT(&yyval.metric_adv.metric);
			    yyval.metric_adv.adv = (adv_entry *) 0;
			} /*NOTREACHED*/ break;
case 386:
# line 2753 "parser.y"
{
			    yyval.metric_adv.metric = yypvt[-3].metric;
			    yyval.metric_adv.adv = yypvt[-1].adv;
			} /*NOTREACHED*/ break;
case 387:
# line 2760 "parser.y"
{
			    yyval.adv = (adv_entry *) 0;
			} /*NOTREACHED*/ break;
case 388:
# line 2764 "parser.y"
{
			    
			    yyval.adv = parse_adv_dm_append(yypvt[-2].adv, yypvt[-1].adv);
			    if (!yyval.adv) {
				PARSE_ERROR;
			    }
			} /*NOTREACHED*/ break;
case 389:
# line 2772 "parser.y"
{
			    yyerrok;
			} /*NOTREACHED*/ break;
case 390:
# line 2778 "parser.y"
{
			    parse_contig_masks = FALSE;
			} /*NOTREACHED*/ break;
case 391:
# line 2782 "parser.y"
{
			    parse_contig_masks = TRUE;

			    yyval.adv = adv_alloc(ADVFT_DM, parse_proto);
			    yyval.adv->adv_dm = yypvt[-1].dm;
			    if (PARSE_METRIC_ISSET(&yypvt[-0].metric)) {
				if (PARSE_METRIC_ISRESTRICT(&yypvt[-0].metric)) {
				    BIT_SET(yyval.adv->adv_flag, ADVF_NO);
				} else {
				    BIT_SET(yyval.adv->adv_flag, ADVFOT_PREFERENCE);
				    yyval.adv->adv_result.res_preference = yypvt[-0].metric.metric;
				}
			    }
			} /*NOTREACHED*/ break;
case 392:
# line 2803 "parser.y"
{
			    yyval.proto_lists = yypvt[-0].proto_lists;
			    
			    parse_export_proto = parse_proto = yypvt[-0].proto_lists.proto;
			    parse_gwlist = yypvt[-0].proto_lists.gw_list;

			    if (!yypvt[-0].proto_lists.export_list) {
				(void) sprintf(parse_error,
					       "unknown export protocol: %s",
					       gd_lower(trace_state(rt_proto_bits, yypvt[-0].proto_lists.proto)));
				PARSE_ERROR;
			    }
			    
			    trace(TR_PARSE, 0, "parse: %s PROTO: %s",
				  parse_where(),
				  gd_lower(trace_state(rt_proto_bits, yypvt[-0].proto_lists.proto)));
			} /*NOTREACHED*/ break;
case 393:
# line 2827 "parser.y"
{
			    PARSE_METRIC_RESTRICT(&yyval.metric_adv.metric);
			    yyval.metric_adv.adv = (adv_entry *) 0;
			} /*NOTREACHED*/ break;
case 394:
# line 2832 "parser.y"
{
			    yyval.metric_adv.metric = yypvt[-3].metric;
			    yyval.metric_adv.adv = yypvt[-1].adv;
			} /*NOTREACHED*/ break;
case 395:
# line 2840 "parser.y"
{
			    yyval.adv = (adv_entry *) 0;
			} /*NOTREACHED*/ break;
case 396:
# line 2844 "parser.y"
{
			    yyval.adv = yypvt[-2].adv;
			    if (parse_adv_append(&yyval.adv, yypvt[-1].adv, TRUE)) {
				PARSE_ERROR;
			    }
			} /*NOTREACHED*/ break;
case 397:
# line 2851 "parser.y"
{
			    yyerrok;
			} /*NOTREACHED*/ break;
case 398:
# line 2857 "parser.y"
{
			    yyval.adv = adv_alloc(ADVFT_AS | ADVF_FIRST, (proto_t) 0);
			    yyval.adv->adv_as = yypvt[-1].as;
			    yyval.adv = parse_adv_propagate_metric(yyval.adv, yypvt[-3].proto, &yypvt[-0].metric_adv.metric, yypvt[-0].metric_adv.adv);
			} /*NOTREACHED*/ break;
case 399:
# line 2864 "parser.y"
{
			    yyval.adv = adv_alloc(ADVFT_ASPATH | ADVF_FIRST, (proto_t) 0);
			    yyval.adv->adv_aspath = (caddr_t) yypvt[-1].asp_match;
			    yyval.adv = parse_adv_propagate_metric(yyval.adv, yypvt[-2].proto, &yypvt[-0].metric_adv.metric, yypvt[-0].metric_adv.adv);
			} /*NOTREACHED*/ break;
case 400:
# line 2871 "parser.y"
{
			    yyval.adv = adv_alloc(ADVFT_TAG|ADVF_FIRST, (proto_t) 0);
			    yyval.adv->adv_tag = yypvt[-1].metric.metric;
			    yyval.adv = parse_adv_propagate_metric(yyval.adv, yypvt[-3].proto, &yypvt[-0].metric_adv.metric, yypvt[-0].metric_adv.adv);
			} /*NOTREACHED*/ break;
case 401:
# line 2878 "parser.y"
{
			    yyval.adv = parse_adv_propagate_metric(yypvt[-1].adv, yypvt[-2].proto, &yypvt[-0].metric_adv.metric, yypvt[-0].metric_adv.adv);
			} /*NOTREACHED*/ break;
case 402:
# line 2883 "parser.y"
{
			    yyval.adv = parse_adv_propagate_metric(yypvt[-1].adv, yypvt[-2].proto, &yypvt[-0].metric_adv.metric, yypvt[-0].metric_adv.adv);
			} /*NOTREACHED*/ break;
case 403:
# line 2888 "parser.y"
{
			    yyval.adv = parse_adv_propagate_metric(yypvt[-1].adv, yypvt[-2].proto, &yypvt[-0].metric_adv.metric, yypvt[-0].metric_adv.adv);
			} /*NOTREACHED*/ break;
case 404:
# line 2893 "parser.y"
{
			    yyval.adv = adv_alloc(ADVFT_ANY | ADVF_FIRST, (proto_t) 0);
			    yyval.adv = parse_adv_propagate_metric(yyval.adv, yypvt[-1].proto, &yypvt[-0].metric_adv.metric, yypvt[-0].metric_adv.adv);
			} /*NOTREACHED*/ break;
case 405:
# line 2900 "parser.y"
{
			    yyval.proto = parse_proto = RTPROTO_DIRECT;
			    parse_gwlist = (gw_entry **)0;
			    trace(TR_PARSE, 0, "parse: %s PROTO: %s",
				  parse_where(),
				  gd_lower(trace_state(rt_proto_bits, yyval.proto)));
			} /*NOTREACHED*/ break;
case 406:
# line 2910 "parser.y"
{
			    yyval.proto = parse_proto = RTPROTO_STATIC;
			    parse_gwlist = &rt_gw_list;
			    trace(TR_PARSE, 0, "parse: %s PROTO: %s",
				  parse_where(),
				  gd_lower(trace_state(rt_proto_bits, yyval.proto)));
			} /*NOTREACHED*/ break;
case 407:
# line 2920 "parser.y"
{
			    yyval.proto = parse_proto = RTPROTO_KERNEL;
			    parse_gwlist = &krt_gw_list;
			    trace(TR_PARSE, 0, "parse: %s PROTO: %s",
				  parse_where(),
				  gd_lower(trace_state(rt_proto_bits, yyval.proto)));
			} /*NOTREACHED*/ break;
case 408:
# line 2930 "parser.y"
{
			    yyval.proto = parse_proto = RTPROTO_DEFAULT;
			    parse_gwlist = (gw_entry **)0;
			    trace(TR_PARSE, 0, "parse: %s PROTO: %s",
				  parse_where(),
				  gd_lower(trace_state(rt_proto_bits, yyval.proto)));
			} /*NOTREACHED*/ break;
case 409:
# line 2941 "parser.y"
{
			    PARSE_METRIC_RESTRICT(&yyval.metric_adv.metric);
			    yyval.metric_adv.adv = (adv_entry *) 0;
			} /*NOTREACHED*/ break;
case 410:
# line 2946 "parser.y"
{
			    yyval.metric_adv.metric = yypvt[-1].metric;
			    yyval.metric_adv.adv = yypvt[-0].adv;
			} /*NOTREACHED*/ break;
case 411:
# line 2954 "parser.y"
{
			    yyval.adv = (adv_entry *) 0;
			} /*NOTREACHED*/ break;
case 412:
# line 2958 "parser.y"
{
			    yyval.adv = yypvt[-1].adv;
			} /*NOTREACHED*/ break;
case 413:
# line 2966 "parser.y"
{
			    yyval.adv = (adv_entry *) 0;
			} /*NOTREACHED*/ break;
case 414:
# line 2970 "parser.y"
{
			    yyval.adv = parse_adv_dm_append(yypvt[-2].adv, yypvt[-1].adv);
			    if (!yyval.adv) {
				PARSE_ERROR;
			    }
			} /*NOTREACHED*/ break;
case 415:
# line 2977 "parser.y"
{
			    yyerrok;
			} /*NOTREACHED*/ break;
case 416:
# line 2983 "parser.y"
{
			    parse_contig_masks = FALSE;
			} /*NOTREACHED*/ break;
case 417:
# line 2987 "parser.y"
{
			    parse_contig_masks = TRUE;

			    yyval.adv = adv_alloc(ADVFT_DM, (proto_t) 0);
			    yyval.adv->adv_dm = yypvt[-1].dm;
			    if (PARSE_METRIC_ISRESTRICT(&yypvt[-0].metric)) {
				BIT_SET(yyval.adv->adv_flag, ADVF_NO);
			    } else if (PARSE_METRIC_ISSET(&yypvt[-0].metric)) {
				yyval.adv->adv_result.res_metric = yypvt[-0].metric.metric;
				BIT_SET(yyval.adv->adv_flag, ADVFOT_METRIC);
			    }
			} /*NOTREACHED*/ break;
case 418:
# line 3006 "parser.y"
{
			    assert(FALSE);
			} /*NOTREACHED*/ break;
case 425:
# line 3022 "parser.y"
{
			    yyval.dm.dm_dest = yyval.dm.dm_mask = (sockaddr_un *) 0;
			    trace(TR_PARSE, 0, "parse: %s DEST: all",
				  parse_where());
			} /*NOTREACHED*/ break;
case 426:
# line 3030 "parser.y"
{
			    assert(FALSE);
			} /*NOTREACHED*/ break;
case 427:
# line 3034 "parser.y"
{
			    yyval.dm.dm_dest = sockdup(inet_addr_default);
			    yyval.dm.dm_mask = inet_mask_host;
			    trace(TR_PARSE, 0, "parse: %s DEST: %A",
				  parse_where(),
				  yyval.dm.dm_dest);
			} /*NOTREACHED*/ break;
case 428:
# line 3042 "parser.y"
{
#ifdef	XXX
			    yyval.dm.dm_dest = sockdup(iso_addr_default);
			    yyval.dm.dm_dest = iso_mask_natural(iso_addr_default);
#endif	/* XXX */
			    assert(FALSE);
			} /*NOTREACHED*/ break;
case 429:
# line 3052 "parser.y"
{
			    assert(FALSE);
			} /*NOTREACHED*/ break;
case 430:
# line 3056 "parser.y"
{
			    yyval.sockaddr = inet_mask_locate(yypvt[-0].in_addr.s_addr);
			    if (!yyval.sockaddr) {
				if (parse_contig_masks) {
				    (void) sprintf(parse_error, "mask not contiguous");
				    PARSE_ERROR;
				} else {
				    yyval.sockaddr = mask_locate(sockbuild_in(0, yypvt[-0].in_addr.s_addr));
				}
			    }
			    trace(TR_PARSE, 0, "parse: %s MASK: %A",
				  parse_where(),
				  yyval.sockaddr);
			} /*NOTREACHED*/ break;
case 431:
# line 3071 "parser.y"
{
			    yyval.sockaddr = iso_mask_locate(yypvt[-0].sockaddr);
			    sockfree(yypvt[-0].sockaddr);
			    trace(TR_PARSE, 0, "parse: %s MASK: %A",
				  parse_where(),
				  yyval.sockaddr);
			} /*NOTREACHED*/ break;
case 432:
# line 3082 "parser.y"
{
			    yyval.adv = adv_alloc(ADVFT_GW | ADVF_FIRST, (proto_t) 0);
			    yyval.adv->adv_gwp = yypvt[-0].gwp;
			} /*NOTREACHED*/ break;
case 433:
# line 3087 "parser.y"
{
			    adv_entry *adv = adv_alloc(ADVFT_GW, (proto_t) 0);

			    adv->adv_gwp = yypvt[-0].gwp;
			    yyval.adv = yypvt[-1].adv;
			    if (parse_adv_append(&yyval.adv, adv, TRUE)) {
				PARSE_ERROR;
			    }
			} /*NOTREACHED*/ break;
case 434:
# line 3100 "parser.y"
{
			    /*
			     *	Make sure host is on a locally attached network then
			     *	find or create a gw structure for it.  Requires that
			     *	parse_proto and parse_gwlist are previously set
			     */
			    if (!if_parse_withdst(yypvt[-0].sockaddr)) {
				(void) sprintf(parse_error, "gateway not a host address on an attached network: '%A'",
					       yypvt[-0].sockaddr);
				if (BIT_TEST(task_state, TASKS_STRICTIFS)) {
				    PARSE_ERROR;
				} else {
				    yyerror(parse_error);
				}
			    }
			    if (!parse_gwlist) {
				(void) sprintf(parse_error, "gateway specification not valid for %s",
					       trace_state(rt_proto_bits, parse_proto));
				PARSE_ERROR;
			    }
			    yyval.gwp = gw_locate(parse_gwlist,
					   parse_proto,
					   (task *) 0,
					   (as_t) 0,
					   (as_t) 0,
					   (time_t) 0,
					   yypvt[-0].sockaddr,
					   (flag_t) 0);
			    trace(TR_PARSE, 0, "parse: %s GATEWAY: %A  PROTO: %s",
				  parse_where(),
				  yyval.gwp->gw_addr,
				  gd_lower(trace_state(rt_proto_bits, yyval.gwp->gw_proto)));
			    sockfree(yypvt[-0].sockaddr);
			} /*NOTREACHED*/ break;
case 435:
# line 3138 "parser.y"
{ 
			    sockaddr_un *addr;

			    if (BIT_TEST(task_state, TASKS_NORESOLV)
				|| !(addr = parse_addr_hostname(yypvt[-0].str.ptr))) {
				PARSE_ERROR;
			    }
			    yyval.sockaddr = sockdup(addr);
			    trace(TR_PARSE, 0, "parse: %s HOST: %A",
				  parse_where(),
				  yyval.sockaddr);
			    free_charstr(&yypvt[-0].str);
			} /*NOTREACHED*/ break;
case 436:
# line 3152 "parser.y"
{
			    yyval.sockaddr = yypvt[-0].sockaddr;
			    trace(TR_PARSE, 0, "parse: %s HOST: %A",
				  parse_where(),
				  yyval.sockaddr);
			} /*NOTREACHED*/ break;
case 437:
# line 3161 "parser.y"
{
			    yyval.dm.dm_dest = yypvt[-0].sockaddr;
			    yyval.dm.dm_mask = sockhostmask(yypvt[-0].sockaddr);

			    trace(TR_PARSE, 0, "parse: %s DEST: %A",
				  parse_where(),
				  yyval.dm.dm_dest);
			} /*NOTREACHED*/ break;
case 438:
# line 3173 "parser.y"
{
			    sockaddr_un *addr;

			    if (BIT_TEST(task_state, TASKS_NORESOLV)
				|| !(addr = parse_addr_netname(yypvt[-0].str.ptr))) {
				PARSE_ERROR;
			    }
			    yyval.sockaddr = sockdup(addr);
			    trace(TR_PARSE, 0, "parse: %s NETWORK: %A",
				  parse_where(),
				  yyval.sockaddr);
			    free_charstr(&yypvt[-0].str);
			} /*NOTREACHED*/ break;
case 439:
# line 3187 "parser.y"
{
			    yyval.sockaddr = yypvt[-0].sockaddr;
			    trace(TR_PARSE, 0, "parse: %s NETWORK: %A",
				  parse_where(),
				  yyval.sockaddr);
			} /*NOTREACHED*/ break;
case 440:
# line 3196 "parser.y"
{
			    yyval.dm.dm_dest = yypvt[-0].sockaddr;
			    switch (socktype(yypvt[-0].sockaddr)) {
#ifdef	PROTO_INET
			    case AF_INET:
				yyval.dm.dm_mask = inet_mask_natural(yypvt[-0].sockaddr);
				if (sock2ip(yyval.dm.dm_dest) & ~sock2ip(yyval.dm.dm_mask)) {
				    sprintf(parse_error, "host or mask option needed");
				    PARSE_ERROR;
				}
				break;
#endif	/* PROTO_INET */
#ifdef	PROTO_ISO
			    case AF_ISO:
				yyval.dm.dm_mask = iso_mask_natural(yypvt[-0].sockaddr);
				break;
#endif	/* PROTO_ISO */
			    default:
				assert(FALSE);
			    }
			    
			    trace(TR_PARSE, 0, "parse: %s DEST: %A MASK: %A",
				  parse_where(),
				  yyval.dm.dm_dest,
				  yyval.dm.dm_mask);
			} /*NOTREACHED*/ break;
case 441:
# line 3223 "parser.y"
{
			    yyval.dm.dm_dest = yypvt[-2].sockaddr;
			    switch (socktype(yypvt[-2].sockaddr)) {
#ifdef	PROTO_INET
			    case AF_INET:
				if (parse_limit_check("inet mask bits",
						      (u_int) yypvt[-0].num,
						      INET_LIMIT_MASKLEN)) {
				    PARSE_ERROR;
				}
				yyval.dm.dm_mask = inet_masks[yypvt[-0].num];
				break;
#endif	/* PROTO_INET */
#ifdef	PROTO_ISO
			    case AF_ISO:
				if (parse_limit_check("iso mask bits",
						      (u_int) yypvt[-0].num,
						      ISO_LIMIT_MASKLEN)) {
				    PARSE_ERROR;
				}
				yyval.dm.dm_mask = iso_masks[yypvt[-0].num];
				break;
#endif	/* PROTO_ISO */
			    default:
				assert(FALSE);
			    }
			    trace(TR_PARSE, 0, "parse: %s DEST: %A MASK: %A",
				  parse_where(),
				  yyval.dm.dm_dest,
				  yyval.dm.dm_mask);
			} /*NOTREACHED*/ break;
case 442:
# line 3255 "parser.y"
{
			    register byte *ap = yypvt[-2].sockaddr->a.sa_data;
			    register byte *mp = yypvt[-0].sockaddr->a.sa_data;
			    register byte *alp = (byte *) yypvt[-2].sockaddr + socksize(yypvt[-2].sockaddr);
			    register byte *mlp = (byte *) yypvt[-0].sockaddr + socksize(yypvt[-0].sockaddr);

			    if (socktype(yypvt[-2].sockaddr) != socktype(yypvt[-0].sockaddr)) {
				sprintf(parse_error, "Network %A and mask %A are not the same family",
					yypvt[-2].sockaddr,
					yypvt[-0].sockaddr);
				PARSE_ERROR;
			    }
			    
			    /* Skip zero fields */
			    while (!*ap && ap < alp) {
				ap++, mp++;
			    }
			    
			    while (ap < alp) {
				if (mp < mlp) {
				    if (*ap++ & ~*mp++) {
					break;
				    }
				} else {
				    if (*ap++) {
					break;
				    }
				}
			    }
			    if (ap < alp) {
				sprintf(parse_error, "Non-masked bits not zero for %A mask %A",
					yypvt[-2].sockaddr,
					yypvt[-0].sockaddr);
				PARSE_ERROR;
			    }

			    yyval.dm.dm_dest = yypvt[-2].sockaddr;
			    yyval.dm.dm_mask = yypvt[-0].sockaddr;
			    trace(TR_PARSE, 0, "parse: %s DEST: %A MASK: %A",
				  parse_where(),
				  yyval.dm.dm_dest,
				  yyval.dm.dm_mask);
			} /*NOTREACHED*/ break;
case 443:
# line 3302 "parser.y"
{
			    yyval.sockaddr = sockdup(sockbuild_in(0, yypvt[-0].in_addr.s_addr));

			    trace(TR_PARSE, 0, "parse: %s IP_ADDR: %A",
				  parse_where(),
				  yyval.sockaddr);
			} /*NOTREACHED*/ break;
case 444:
# line 3312 "parser.y"
{
			    u_int32 addr = yypvt[-0].num;
			    
			    if (addr) {
				/* Normalize the address */
				while (!(addr & 0xff000000)) {
				    addr <<= 8;
				}
			    }
			    yyval.in_addr.s_addr = htonl(addr);
			} /*NOTREACHED*/ break;
case 445:
# line 3324 "parser.y"
{
			    int i;
			    u_int32 addr = 0;

			    if (yypvt[-0].hex.len > sizeof(addr)) {
				sprintf(parse_error, "octet or hex string too long to be an IP address");
				PARSE_ERROR;
			    }

			    for (i = 0; i < sizeof(addr); i++) {
				addr <<= 8;
				if (i < yypvt[-0].hex.len) {
				    BIT_SET(addr, yypvt[-0].hex.ptr[i]);
				}
			    }
			    yyval.in_addr.s_addr = htonl(addr);
			    free_bytestr(&yypvt[-0].hex);
			} /*NOTREACHED*/ break;
case 446:
# line 3346 "parser.y"
{
			    yyval.str = yypvt[-0].str;
			    yyval.str.ptr = task_mem_strdup((task *) 0, yypvt[-0].str.ptr);
			} /*NOTREACHED*/ break;
case 447:
# line 3351 "parser.y"
{
			    yyval.str = yypvt[-0].str;
			    yyval.str.ptr = task_mem_strdup((task *) 0, yypvt[-0].str.ptr);
			} /*NOTREACHED*/ break;
case 449:
# line 3360 "parser.y"
{
#if	defined(PROTO_ICMP) || defined(KRT_RT_SOCK)
			    yyval.proto_lists.proto = RTPROTO_REDIRECT;
			    yyval.proto_lists.import_list = &redirect_import_list;
			    yyval.proto_lists.export_list = (adv_entry **) 0;
			    yyval.proto_lists.gw_list = &redirect_gw_list;
#endif	/* defined(PROTO_ICMP) || defined(KRT_RT_SOCK) */
			} /*NOTREACHED*/ break;
case 450:
# line 3372 "parser.y"
{
			    assert(FALSE);
			} /*NOTREACHED*/ break;
case 452:
# line 3378 "parser.y"
{ yyval.num = T_ON; } /*NOTREACHED*/ break;
case 453:
# line 3379 "parser.y"
{ yyval.num = T_OFF; } /*NOTREACHED*/ break;
case 454:
# line 3385 "parser.y"
{
			    PARSE_METRIC_SET(&yyval.metric, yypvt[-0].num);
			    trace(TR_PARSE, 0, "parse: %s METRIC: %d",
				  parse_where(),
				  yyval.metric.metric);
			} /*NOTREACHED*/ break;
case 455:
# line 3392 "parser.y"
{
			    PARSE_METRIC_INFINITY(&yyval.metric);
			    trace(TR_PARSE, 0, "parse: %s METRIC: infinity",
				  parse_where());
			} /*NOTREACHED*/ break;
case 456:
# line 3400 "parser.y"
{
			    PARSE_METRIC_CLEAR(&yyval.metric);
			} /*NOTREACHED*/ break;
case 457:
# line 3404 "parser.y"
{
			    yyval.metric = yypvt[-0].metric;
			} /*NOTREACHED*/ break;
case 458:
# line 3411 "parser.y"
{
			    PARSE_METRIC_CLEAR(&yyval.metric);
			} /*NOTREACHED*/ break;
case 459:
# line 3415 "parser.y"
{
			    PARSE_METRIC_RESTRICT(&yyval.metric);
			} /*NOTREACHED*/ break;
case 460:
# line 3419 "parser.y"
{
			    if (parse_metric_check(parse_export_proto, &yypvt[-0].metric)) {
				PARSE_ERROR;
			    }
			    yyval.metric = yypvt[-0].metric;
			} /*NOTREACHED*/ break;
case 461:
# line 3430 "parser.y"
{
			    PARSE_METRIC_CLEAR(&yyval.metric);
			} /*NOTREACHED*/ break;
case 462:
# line 3434 "parser.y"
{
			    PARSE_METRIC_SET(&yyval.metric, yypvt[-0].pref);
			} /*NOTREACHED*/ break;
case 464:
# line 3442 "parser.y"
{
			    PARSE_METRIC_RESTRICT(&yyval.metric);
			} /*NOTREACHED*/ break;
case 465:
# line 3448 "parser.y"
{
			    if (parse_limit_check("preference",
						  (u_int) yypvt[-0].num,
						  LIMIT_PREFERENCE)) {
				PARSE_ERROR;
			    }
			    yyval.pref = yypvt[-0].num;
			} /*NOTREACHED*/ break;
case 466:
# line 3461 "parser.y"
{
			    /* Remove quotes from the string if present */
			    char *cp;

			    yyval.str = yypvt[-0].str;
				
			    switch (*yyval.str.ptr) {
			    case '<':
				*yyval.str.ptr = '>';
				/* Fall through */

			    case '"':
				cp = &yyval.str.ptr[yyval.str.len-1];
				if (*cp == *yyval.str.ptr) {
				    *cp = (char) 0;
				    yyval.str.len -= 2;
				    cp = yyval.str.ptr + 1;
				    break;
				}
				/* Fall Through */

			    default:
				cp = yyval.str.ptr;
			    }

			    yyval.str.ptr = task_mem_strdup((task *) 0, cp);
			    trace(TR_PARSE, 0, "parse: %s STRING: \"%s\" length: %d",
				  parse_where(),
				  yyval.str.ptr,
				  yyval.str.len);
			} /*NOTREACHED*/ break;
case 468:
# line 3497 "parser.y"
{
			    int i = 0;
			    int len = sizeof(yyval.num);

			    yyval.num = 0;
			    if (yypvt[-0].hex.len > len) {
				sprintf(parse_error, "octet or hex string too long to be a number");
				PARSE_ERROR;
			    } else if (yypvt[-0].hex.len < len) {
				len = yypvt[-0].hex.len;
			    }

			    while (i < len) {
				yyval.num = (yyval.num << 8) | yypvt[-0].hex.ptr[i++];
			    }
			    free_bytestr(&yypvt[-0].hex);
			} /*NOTREACHED*/ break;
case 471:
# line 3522 "parser.y"
{
			    if (parse_limit_check("seconds",
						  (u_int) yypvt[-0].num,
						  LIMIT_NATURAL)) {
				PARSE_ERROR;
			    };
			    yyval.time = yypvt[-0].num;
			} /*NOTREACHED*/ break;
case 472:
# line 3531 "parser.y"
{
			    if (parse_limit_check("minutes",
						  (u_int) yypvt[-2].num,
						  LIMIT_NATURAL)) {
				PARSE_ERROR;
			    }
			    if (parse_limit_check("seconds",
						  (u_int) yypvt[-0].num,
						  LIMIT_SECONDS)) {
				PARSE_ERROR;
			    }
			    yyval.time = (yypvt[-2].num * 60) + yypvt[-0].num;
			} /*NOTREACHED*/ break;
case 473:
# line 3545 "parser.y"
{
			    if (parse_limit_check("hours",
						  (u_int) yypvt[-4].num,
						  LIMIT_NATURAL)) {
				PARSE_ERROR;
			    }
			    if (parse_limit_check("minutes",
						  (u_int) yypvt[-2].num,
						  LIMIT_MINUTES)) {
				PARSE_ERROR;
			    }
			    if (parse_limit_check("seconds",
						  (u_int) yypvt[-0].num,
						  LIMIT_SECONDS)) {
				PARSE_ERROR;
			    }
			    yyval.time = ((yypvt[-4].num * 60) + yypvt[-2].num) * 60 + yypvt[-0].num;
			} /*NOTREACHED*/ break;
case 474:
# line 3567 "parser.y"
{
			    if (parse_limit_check("port",
						  (u_int) yypvt[-0].num,
						  LIMIT_PORT)) {
				PARSE_ERROR;
			    }
			    yyval.num = htons(yypvt[-0].num);
			} /*NOTREACHED*/ break;
case 475:
# line 3576 "parser.y"
{
			    const struct servent *sp;

			    if (!(sp = getservbyname(yypvt[-0].str.ptr, parse_serv_proto))) {
				(void) sprintf(parse_error, "unknown protocol %s/%s",
					yypvt[-0].str.ptr, parse_serv_proto);
				PARSE_ERROR;
			    }

			    yyval.num = sp->s_port;

			    trace(TR_PARSE, 0, "parse: %s PORT %s (%d)",
				  parse_where(),
				  yypvt[-0].str.ptr,
				  ntohs(yyval.num));
			} /*NOTREACHED*/ break;
case 476:
# line 3598 "parser.y"
{
			    if (parse_limit_check("autonomous system",
						  (u_int) yypvt[-0].num,
						  LIMIT_AS)) {
				PARSE_ERROR;
			    }
			    yyval.as = yypvt[-0].num;
			} /*NOTREACHED*/ break;
case 477:
# line 3609 "parser.y"
{
			    yyval.adv = adv_alloc(ADVFT_AS | ADVF_FIRST, (proto_t) 0);
			    yyval.adv->adv_as = yypvt[-0].as;
			} /*NOTREACHED*/ break;
case 478:
# line 3614 "parser.y"
{
			    adv_entry *adv = adv_alloc(ADVFT_AS, (proto_t) 0);

			    adv->adv_as = yypvt[-0].as;
			    yyval.adv = yypvt[-1].adv;
			    if (parse_adv_append(&yyval.adv, adv, TRUE)) {
				PARSE_ERROR;
			    }
			} /*NOTREACHED*/ break;
case 479:
# line 3626 "parser.y"
{
			    yyval.adv = (adv_entry *) 0;
			} /*NOTREACHED*/ break;
case 480:
# line 3630 "parser.y"
{
			    yyval.adv = yypvt[-0].adv;
			} /*NOTREACHED*/ break;
case 481:
# line 3641 "parser.y"
{
			    PARSE_METRIC_CLEAR(&yyval.metric);
			} /*NOTREACHED*/ break;
case 482:
# line 3645 "parser.y"
{
			    yyval.metric = yypvt[-0].metric;
			} /*NOTREACHED*/ break;
case 484:
# line 3652 "parser.y"
{
			    PARSE_METRIC_ALTERNATE(&yyval.metric, 0);
			} /*NOTREACHED*/ break;
case 485:
# line 3656 "parser.y"
{
			    if (parse_limit_check("external-route-tag",
						  (u_int) yypvt[-0].num,
						  PATH_OSPF_TAG_USR_LIMIT)) {
				PARSE_ERROR;
			    }
			    PARSE_METRIC_ALTERNATE(&yyval.metric, yypvt[-0].num);
			} /*NOTREACHED*/ break;
case 486:
# line 3667 "parser.y"
{
			    PARSE_METRIC_CLEAR(&yyval.metric);
			} /*NOTREACHED*/ break;
case 487:
# line 3671 "parser.y"
{
			    yyval.metric = yypvt[-0].metric;
			} /*NOTREACHED*/ break;
case 488:
# line 3677 "parser.y"
{
			    if (parse_limit_check("external-route-tag",
						  (u_int) yypvt[-0].num,
						  PATH_OSPF_TAG_LIMIT)) {
				PARSE_ERROR;
			    }
			    PARSE_METRIC_SET(&yyval.metric, yypvt[-0].num);
			} /*NOTREACHED*/ break;
case 491:
# line 3700 "parser.y"
{
			    aspath_state = 0;
			    aspath_current = (asmatch_t *) task_block_alloc(aspath_match_index);
			} /*NOTREACHED*/ break;
case 492:
# line 3705 "parser.y"
{
			    yyval.asp_match = aspath_current;
			    yyval.asp_match->origin_mask = yypvt[-0].flag;
			    trace(TR_PARSE, 0, "%s: path %X origins %s",
				  parse_where(),
				  yyval.asp_match,
				  aspath_adv_origins(yyval.asp_match->origin_mask));
			    aspath_current = (asmatch_t *) 0;
			} /*NOTREACHED*/ break;
case 493:
# line 3717 "parser.y"
{
			    /* Set all bits on */
			    yyval.flag = -1;
			} /*NOTREACHED*/ break;
case 496:
# line 3727 "parser.y"
{
			    yyval.flag = yypvt[-2].flag | yypvt[-0].flag;
			} /*NOTREACHED*/ break;
case 497:
# line 3733 "parser.y"
{
			    yyval.flag = (1 << PATH_ORG_IGP);
			} /*NOTREACHED*/ break;
case 498:
# line 3737 "parser.y"
{
			    yyval.flag = (1 << PATH_ORG_EGP);
			} /*NOTREACHED*/ break;
case 499:
# line 3741 "parser.y"
{
			    yyval.flag = (1 << PATH_ORG_XX);
			} /*NOTREACHED*/ break;
case 500:
# line 3747 "parser.y"
{
			    NFA_ASG(yyval.asp_stack.start, yypvt[-0].asp_stack.start);
			    NFA_ASG(aspath_current->start, yyval.asp_stack.start);
			    trace(TR_PARSE, 0, "%s: REDUCED:	regex : sum",
				  parse_where());
			} /*NOTREACHED*/ break;
case 501:
# line 3754 "parser.y"
{
			    NFA_OR(yyval.asp_stack.start, yypvt[-2].asp_stack.start, yypvt[-0].asp_stack.start);
			    NFA_OR(yyval.asp_stack.state, yypvt[-2].asp_stack.state, yypvt[-0].asp_stack.state);
			    NFA_ASG(aspath_current->start, yyval.asp_stack.start);
			    trace(TR_PARSE, 0, "%s: REDUCED:	regex : sum | regex",
				  parse_where());
			} /*NOTREACHED*/ break;
case 502:
# line 3764 "parser.y"
{
			    trace(TR_PARSE, 0, "%s: REDUCED:	sum : term",
				  parse_where());
			} /*NOTREACHED*/ break;
case 503:
# line 3769 "parser.y"
{
			    int i;
			    
			    NFA_OR(yyval.asp_stack.state, yypvt[-1].asp_stack.state, yypvt[-0].asp_stack.state);

			    for (i = 0; i < ASP_ACC; i++) {
				int nonzero;
				
				if (NFA_ISSET(yypvt[-1].asp_stack.state, i)) {
				    if (NFA_ISSET(aspath_current->nfa[i].next, ASP_ACC)) {
					NFA_CLR(aspath_current->nfa[i].next, ASP_ACC);
					NFA_OR(aspath_current->nfa[i].next, aspath_current->nfa[i].next, yypvt[-0].asp_stack.start);
				    }
				    NFA_CLR(yypvt[-1].asp_stack.state, i);
				    NFA_NONZERO(yypvt[-1].asp_stack.state, nonzero);
				    if (nonzero) {
					break;
				    }
				}
			    }
			    if (i > ASP_ACC) {
				YYERROR;
			    }
			    if (NFA_ISSET(yypvt[-1].asp_stack.start, ASP_ACC)) {
				NFA_CLR(yypvt[-1].asp_stack.start, ASP_ACC);
				NFA_OR(yypvt[-1].asp_stack.start, yypvt[-1].asp_stack.start, yypvt[-0].asp_stack.start);
			    }
			    NFA_ASG(yyval.asp_stack.start, yypvt[-1].asp_stack.start);
			    trace(TR_PARSE, 0, "%s: REDUCED:	sum : term sum",
				  parse_where());
			} /*NOTREACHED*/ break;
case 504:
# line 3803 "parser.y"
{
			    trace(TR_PARSE, 0, "%s: REDUCED:	term : symbol",
				  parse_where());
			} /*NOTREACHED*/ break;
case 505:
# line 3808 "parser.y"
{
			    int i;
			    
			    for (i = 0; i < ASP_ACC; i++) {
				if (NFA_ISSET(yypvt[-1].asp_stack.state, i)) {
				    int nonzero;
				
				    if (NFA_ISSET(aspath_current->nfa[i].next, ASP_ACC)) {
					NFA_OR(aspath_current->nfa[i].next, aspath_current->nfa[i].next, yypvt[-1].asp_stack.start);
				    }
				    NFA_CLR(yypvt[-1].asp_stack.state, i);
				    NFA_NONZERO(yypvt[-1].asp_stack.state, nonzero);
				    if (nonzero) {
					break;
				    }
				}
			    }
			    NFA_ASG(yyval.asp_stack.start, yypvt[-1].asp_stack.start);
			    NFA_SET(yyval.asp_stack.start, ASP_ACC);
			    trace(TR_PARSE, 0, "%s: REDUCED:	term : symbol *",
				  parse_where());
			} /*NOTREACHED*/ break;
case 506:
# line 3831 "parser.y"
{
			    int i;
			    
			    for (i = 0; i < ASP_ACC; i++) {
				if (NFA_ISSET(yypvt[-1].asp_stack.state, i)) {
				    int nonzero;
				    
				    if (NFA_ISSET(aspath_current->nfa[i].next, ASP_ACC)) {
					NFA_OR(aspath_current->nfa[i].next, aspath_current->nfa[i].next, yypvt[-1].asp_stack.start);
				    }
				    NFA_CLR(yypvt[-1].asp_stack.state, i);
				    NFA_NONZERO(yypvt[-1].asp_stack.state, nonzero);
				    if (nonzero) {
					break;
				    }
				}
			    }
			    NFA_ASG(yyval.asp_stack.start, yypvt[-1].asp_stack.start);
			    trace(TR_PARSE, 0, "%s: REDUCED:	term : symbol +",
				  parse_where());
			} /*NOTREACHED*/ break;
case 507:
# line 3853 "parser.y"
{
			    NFA_ASG(yyval.asp_stack.start, yypvt[-1].asp_stack.start);
			    NFA_SET(yyval.asp_stack.start, ASP_ACC);
			    trace(TR_PARSE, 0, "%s: REDUCED:	term : symbol ?",
				  parse_where());
			} /*NOTREACHED*/ break;
case 508:
# line 3860 "parser.y"
{
			    int copy;
			    flag_t finalstate[1 + ASP_ACC / ASP_WORD];
			    flag_t newstate[1 + ASP_ACC / ASP_WORD];
			    flag_t oldstate[1 + ASP_ACC / ASP_WORD];
			    flag_t newstart[1 + ASP_ACC / ASP_WORD];
			    
			    NFA_ASG(finalstate, yypvt[-3].asp_stack.state);
			    NFA_ASG(newstate, yypvt[-3].asp_stack.state);
			    NFA_ASG(yyval.asp_stack.start, yypvt[-3].asp_stack.start);
			    NFA_ASG(newstart, yypvt[-3].asp_stack.start);
			    if (!yypvt[-1].asp_range.begin) {
				NFA_SET(yyval.asp_stack.start, ASP_ACC);
			    }
			    for (copy = 1; copy < yypvt[-1].asp_range.begin; copy++) {
				int i;
				
				NFA_ASG(oldstate, yypvt[-3].asp_stack.state);
				NFA_ZERO(newstart);
				NFA_ZERO(newstate);
				for (i = 0; i < ASP_ACC; i++) {
				    if (NFA_ISSET(yypvt[-3].asp_stack.state, i)) {
					aspath_current->nfa[aspath_state].as = aspath_current->nfa[i].as;
					NFA_ASG(aspath_current->nfa[aspath_state].next, aspath_current->nfa[i].next);
					NFA_SHIFT(aspath_current->nfa[aspath_state].next, aspath_state-i);
					NFA_SET(newstate, aspath_state);
					if (NFA_ISSET(yypvt[-3].asp_stack.start, i)) {
					    int nonzero;
					    
					    NFA_SET(newstart, aspath_state);
					    ASPATH_NEXT_STATE;
					    NFA_CLR(yypvt[-3].asp_stack.state, i);
					    NFA_NONZERO(yypvt[-3].asp_stack.state, nonzero);
					    if (nonzero) {
						break;
					    }
					}
				    }
				    if (NFA_ISSET(yyval.asp_stack.start, ASP_ACC)) {
					NFA_OR(yyval.asp_stack.start,yyval.asp_stack.start,newstart);
				    }
				    for (i = 0; i < ASP_ACC; i++) {
					if (NFA_ISSET(oldstate, i)) {
					    int nonzero;
					    
					    if (NFA_ISSET(aspath_current->nfa[i].next, ASP_ACC)) {
						if (copy < yypvt[-1].asp_range.begin) {
						    NFA_CLR(aspath_current->nfa[i].next, ASP_ACC);
						}
						NFA_OR(aspath_current->nfa[i].next, aspath_current->nfa[i].next, newstart);
					    }
					    NFA_CLR(oldstate, i);
					    NFA_NONZERO(oldstate, nonzero);
					    if (nonzero) {
						break;
					    }
					}
				    }
				    NFA_OR(finalstate, finalstate, newstate);
				    NFA_ASG(yypvt[-3].asp_stack.start, newstart);
				    NFA_ASG(yypvt[-3].asp_stack.state, newstate);
				}
				if (yypvt[-1].asp_range.end) {
				    for (i = 0; i < ASP_ACC; i++) {
					if (NFA_ISSET(newstate, i)) {
					    int nonzero;
					    
					    if (NFA_ISSET(aspath_current->nfa[i].next, ASP_ACC)) {
						NFA_OR(aspath_current->nfa[i].next, aspath_current->nfa[i].next, newstart);
					    }
					    NFA_CLR(newstate, i);
					    NFA_NONZERO(newstate, nonzero);
					    if (nonzero) {
						break;
					    }
					}
				    }
				}	
				NFA_ASG(yyval.asp_stack.state, finalstate);
				trace(TR_PARSE, 0, "%s: REDUCED:	term : symbol { range }",
				      parse_where());
			    }
			} /*NOTREACHED*/ break;
case 509:
# line 3946 "parser.y"
{
			    NFA_ZERO(yyval.asp_stack.start);
			    NFA_ZERO(yyval.asp_stack.state);
			    NFA_SET(yyval.asp_stack.start, aspath_state);
			    NFA_SET(yyval.asp_stack.state, aspath_state);
			    aspath_current->nfa[aspath_state].as = htons(yypvt[-0].as);
			    NFA_SET(aspath_current->nfa[aspath_state].next, ASP_ACC);
			    ASPATH_NEXT_STATE;
			    trace(TR_PARSE, 0, "%s: REDUCED:	symbol : %d",
				  parse_where(),
				  yypvt[-0].as);
			} /*NOTREACHED*/ break;
case 510:
# line 3959 "parser.y"
{
			    NFA_ZERO(yyval.asp_stack.start);
			    NFA_ZERO(yyval.asp_stack.state);
			    NFA_SET(yyval.asp_stack.start, aspath_state);
			    NFA_SET(yyval.asp_stack.state, aspath_state);
			    NFA_SET(aspath_current->nfa[aspath_state].next, ASP_ACC);
			    aspath_current->nfa[aspath_state].as = 0;
			    ASPATH_NEXT_STATE;
			    trace(TR_PARSE, 0, "%s: REDUCED:	symbol : .",
				  parse_where());
			} /*NOTREACHED*/ break;
case 511:
# line 3971 "parser.y"
{
			    NFA_ASG(yyval.asp_stack.state, yypvt[-1].asp_stack.state);
			    NFA_ASG(yyval.asp_stack.start, yypvt[-1].asp_stack.start);
			    trace(TR_PARSE, 0, "%s: REDUCED:	symbol : ( regex )",
				  parse_where());
			} /*NOTREACHED*/ break;
case 512:
# line 3979 "parser.y"
{
			    yyval.asp_range.begin = yypvt[-0].num;
			    yyval.asp_range.end = 0;
			    if (!yypvt[-0].num) {
				sprintf(parse_error, "invalid range start: %d",
					yypvt[-0].num);
				PARSE_ERROR;
			    }
			    trace(TR_PARSE, 0, "%s: RANGE: {%d}",
				  parse_where(),
				  yyval.asp_range.begin);
			} /*NOTREACHED*/ break;
case 513:
# line 3992 "parser.y"
{
			    yyval.asp_range.begin = yypvt[-1].num;
			    yyval.asp_range.end = 1;
			    if (!yypvt[-1].num) {
				sprintf(parse_error, "invalid range start: %d",
					yypvt[-1].num);
				PARSE_ERROR;
			    }
			    trace(TR_PARSE, 0, "%s: RANGE: {%d,}",
				  parse_where(),
				  yyval.asp_range.begin);
			} /*NOTREACHED*/ break;
case 514:
# line 4005 "parser.y"
{
			    yyval.asp_range.begin = yypvt[-2].num;
			    yyval.asp_range.end = yypvt[-0].num;
			    if (!yypvt[-2].num) {
				sprintf(parse_error, "invalid range start: %d",
					yypvt[-2].num);
				PARSE_ERROR;
			    }
			    if (yypvt[-0].num < yypvt[-2].num || !yypvt[-0].num) {
				sprintf(parse_error, "invalid range end: %d",
					yypvt[-0].num);
				PARSE_ERROR;
			    }
			    trace(TR_PARSE, 0, "%s: RANGE: {%d,%d}",
				  parse_where(),
				  yyval.asp_range.begin,
				  yyval.asp_range.end);
			} /*NOTREACHED*/ break;
case 515:
# line 4027 "parser.y"
{
			    if (yypvt[-0].hex.len > ISO_MAXADDRLEN) {
				sprintf(parse_error, "ISO address has too many bytes (%d), %d maximum",
					yypvt[-0].hex.len,
					ISO_MAXADDRLEN);
				PARSE_ERROR;
			    }
			    
			    yyval.sockaddr = sockdup(sockbuild_iso(yypvt[-0].hex.ptr, yypvt[-0].hex.len));

			    trace(TR_PARSE, 0, "parse: %s ISO_ADDR: %A",
				  parse_where(),
				  yyval.sockaddr);

			    free_bytestr(&yypvt[-0].hex);
			} /*NOTREACHED*/ break;
}


        goto yystack;           /* reset registers in driver code */
}
