#ifndef lint
static char yysccsid[] = "@(#)yaccpar	1.8 (Berkeley) 01/20/90";
#endif
#define YYBYACC 1
#line 2 "parser.y"
/*
 *  parser.y,v 1.60 1993/04/10 12:25:26 jch Exp
 */

/* Gated Release 3.0 */
/* Copyright (c) 1990,1991,1992,1993 by Cornell University. All rights reserved. */
/* Refer to Particulars and other Copyright notices at the end of this file. */


#include "include.h"
#ifdef	PROTO_INET
#include "inet.h"
#endif	/* PROTO_INET */
#ifdef	PROTO_ISO
#include "iso.h"
#endif	/* PROTO_ISO */
#include "parse.h"
#include "krt.h"
#ifdef	PROTO_RIP
#include "rip.h"
#endif	/* PROTO_RIP */
#ifdef	PROTO_HELLO
#include "hello.h"
#endif	/* PROTO_HELLO */
#ifdef	PROTO_EGP
#include "egp.h"
#endif	/* PROTO_EGP */
#ifdef	PROTO_BGP
#include "bgp.h"
#endif	/* PROTO_BGP */
#ifdef	PROTO_DVMRP
#include "dvmrp.h"
#endif	/* PROTO_DVMRP */
#ifdef	PROTO_ISODE_SNMP
#include "snmp_isode.h"
#endif	/* PROTO_ISODE_SNMP */
#ifdef	 PROTO_ISIS
#include "isis.h"
#include "isis_test.h"
#include "isis_globals.h"
#endif	/* PROTO_ISIS */
#ifdef	PROTO_IDRP
#include "idrp.h"
#endif /* PROTO_IDRP */
  
char parse_error[LINE_MAX] = { 0 };
char *parse_filename = 0;

static	proto_t	parse_proto;			/* For correctly tagging ADV lists */
static	proto_t	parse_export_proto;		/* For checking metrics */
static	gw_entry	**parse_gwlist;
#if	defined(PROTO_SLSP) || defined(PROTO_EGP) || defined(PROTO_BGP)
static	gw_entry	*parse_gwp;		/* To fake a list for EGP and BGP */
#endif
static  char *parse_serv_proto;
static	int	parse_contig_masks = TRUE;	/* Masks must be contiguous */
static	bgpPeer *bnp;
static	bgpPeerGroup *bgp;
static 	struct bgp_conf *bcp;
static	idrpPeer *idgp, idrp_group, *gr_idrp;
struct	iso_prefix *nlri; 
static	idrpRoute *p_idrp;
static	int idrp_parse_group_index;
static	idrpRoute_options 	idrp_rt_opts;	
static	idrp_canon_rdpath	*p_rdi_head,*p_rdi_tail;
static	idrp_canon_rdpath	*p_idrp_excl_rdi_tail, *p_idrp_excl_rdi_head;
static	idrp_canon_rdpath	*p_idrp_incl_rdi_tail, *p_idrp_incl_rdi_head;
static if_info parse_ifi;	/* Used for configuring interfaces that do not exist */

u_int parse_state = PS_INITIAL;
proto_t protos_seen = 0;

PROTOTYPE(yyerror,
	  static void,
	  (const char *));

#define	free_string(s)	task_mem_free((task *) 0, (caddr_t) s); s = 0
#define	free_charstr(s)	task_mem_free((task *) 0, (caddr_t) (s)->ptr); (s)->ptr = (char *) 0; (s)->len = (s)->type = 0
#define	free_bytestr(s)	task_mem_free((task *) 0, (caddr_t) (s)->ptr); (s)->ptr = (byte *) 0; (s)->len = (s)->type = 0

#define	PARSE_ERROR	yyerror(parse_error); yynerrs++; YYERROR;

#define	PROTO_SEEN(proto) \
	if (BIT_TEST(protos_seen, RTPROTO_BIT(proto))) { \
	    sprintf(parse_error, "parse_proto_seen: duplicate %s clause", gd_lower(trace_state(rt_proto_bits, proto))); \
	    PARSE_ERROR; \
	} else { \
	    BIT_SET(protos_seen, RTPROTO_BIT(proto)); \
	    parse_proto = proto; \
	} \

#ifdef	PROTO_ASPATHS
static unsigned	aspath_state;
static asmatch_t *aspath_current;

#define	ASPATH_NEXT_STATE	if (aspath_state++ == ASP_BITS) { \
	sprintf(parse_error, "too many AS path regexp states"); \
	PARSE_ERROR; \
    }
#endif	/* PROTO_ASPATHS */

#line 106 "parser.y"
typedef union {
    long	num;
    u_long	u_num;
    bytestr	hex;
    charstr	str;
    flag_t	flag;
    time_t	time;
    as_t	as;
    proto_t	proto;
    pmet_t	metric;
    pref_t	pref;
    if_addr	*ifap;
    if_addr_entry	*ifae;
    adv_entry	*adv;
    gw_entry	*gwp;
    sockaddr_un	*sockaddr;
#ifdef	PROTO_INET
    struct in_addr in_addr;
#endif	/* PROTO_INET */
    dest_mask	dm;
    struct {
	pmet_t metric;
	adv_entry *adv;
    } metric_adv ;
    struct {
	proto_t proto;
	adv_entry **import_list;
	adv_entry **export_list;
	gw_entry **gw_list;
    } proto_lists;
    config_entry *config;
    config_list *conflist;
#ifndef	GATED_LEXER
#ifdef	PROTO_OSPF
    ospf_config_router *ospf_router;
#endif	/* PROTO_OSPF */
#if	defined(PROTO_ASPATHS)
    asmatch_t	*asp_match;
    struct {
	u_short	begin;
	u_short end;
    } asp_range;
    struct {
	flag_t	start[1 + ASP_ACC/ASP_WORD];
	flag_t	state[1 + ASP_ACC/ASP_WORD];
    } asp_stack;
#endif	/* PROTO_ASPATHS */
#endif	/* GATED_LEXER */
} YYSTYPE;
#line 158 "y.tab.c"
#define L_EOS 257
#define L_ERROR 258
#define L_NUMBER 259
#define L_STRING 260
#define L_HNAME 261
#define L_KEYWORD 262
#define L_HEXSTRING 263
#define L_OCTETSTRING 264
#define L_HEXSTRING_ODD 265
#define L_ISOADDR 266
#define T_DIRECT 267
#define T_INTERFACE 268
#define T_INTERFACES 269
#define T_LCLADDR 270
#define T_PROTO 271
#define T_METRIC 272
#define T_METRICIN 273
#define T_METRICOUT 274
#define T_INFINITY 275
#define T_DOWN 276
#define T_PARSE 277
#define T_ADV 278
#define T_DEFAULT 279
#define T_DEFAULTS 280
#define T_YYDEBUG 281
#define T_YYSTATE 282
#define T_YYQUIT 283
#define T_DEBUG 284
#define T_SYSLOG 285
#define T_UPTO 286
#define T_EMERG 287
#define T_ALERT 288
#define T_CRIT 289
#define T_ERR 290
#define T_WARNING 291
#define T_NOTICE 292
#define T_INFO 293
#define T_ON 294
#define T_OFF 295
#define T_GATEWAY 296
#define T_PREFERENCE 297
#define T_DEFAULTMETRIC 298
#define T_NONBROADCAST 299
#define T_BROADCAST 300
#define T_TYPE 301
#define T_POINTOPOINT 302
#define T_MULTICAST 303
#define T_NETMASK 304
#define T_DEFINE 305
#define T_NOP 306
#define T_NOP1 307
#define T_PEERAS 308
#define T_LOCALAS 309
#define T_NEIGHBOR 310
#define T_GROUP 311
#define T_GENDEFAULT 312
#define T_NOGENDEFAULT 313
#define T_VERSION 314
#define T_DEFAULTIN 315
#define T_DEFAULTOUT 316
#define T_HOLDTIME 317
#define T_BGP 318
#define T_ALLOW 319
#define T_TEST 320
#define T_KEEPALL 321
#define T_SENDBUF 322
#define T_RECVBUF 323
#define T_SPOOLBUF 324
#define T_EGP 325
#define T_ASPATH 326
#define T_ORIGIN 327
#define T_INCOMPLETE 328
#define T_ANY 329
#define T_TAG 330
#define T_TRUSTEDGATEWAYS 331
#define T_SOURCEGATEWAYS 332
#define T_IP 333
#define T_DUAL 334
#define T_SNPA 335
#define T_ISIS 336
#define T_CIRCUIT 337
#define T_SYSTEMID 338
#define T_LEVEL 339
#define T_IPREACH 340
#define T_TROLL 341
#define T_SET 342
#define T_PREFIX 343
#define T_INTDOMINFO 344
#define T_MODE 345
#define T_AREA 346
#define T_SPF 347
#define T_HELLOINTERVAL 348
#define T_ROUTERDEADINTERVAL 349
#define T_PRIORITY 350
#define T_IDRP 351
#define T_RDI 352
#define T_OSISTATIC 353
#define T_NSAP 354
#define T_NET 355
#define T_NSAPPREFIX 356
#define T_OSILOCAL 357
#define T_MULTIEXIT 358
#define T_PROTOSOCK 359
#define T_SIP 360
#define T_PIP 361
#define T_UDP 362
#define T_LOCALNODE 363
#define T_PROTOSUPPORT 364
#define T_AUTHCODE 365
#define T_INTRAIS 366
#define T_RDC 367
#define T_ASRDI 368
#define T_OUTPDUS 369
#define T_MAXPDUSIZE 370
#define T_REXMIT 371
#define T_CLOSEWAIT 372
#define T_RIBCHECK 373
#define T_MINADV 374
#define T_MINADVRD 375
#define T_PROHIBITDIST 376
#define T_ALLOWDIST 377
#define T_ROUTESERVER 378
#define T_LISTENOPEN 379
#define T_REDIRECT 380
#define T_NOREDIRECTS 381
#define T_ICMP 382
#define T_AUTHTYPE 383
#define T_AUTHKEY 384
#define T_NONE 385
#define T_SIMPLE 386
#define T_PASSIVE 387
#define T_SIMPLEX 388
#define T_STRICTIFS 389
#define T_SCANINTERVAL 390
#define T_STATIC 391
#define T_MARTIANS 392
#define T_RETAIN 393
#define T_EXPORT 394
#define T_IMPORT 395
#define T_HOST 396
#define T_MASK 397
#define T_MASKLEN 398
#define T_REJECT 399
#define T_BLACKHOLE 400
#define T_RESTRICT 401
#define T_AS 402
#define T_ROUTERID 403
#define T_IGP 404
#define T_OPTIONS 405
#define T_NOINSTALL 406
#define T_NOSEND 407
#define T_NORESOLV 408
#define T_TRACEOPTIONS 409
#define T_EXCEPT 410
#define T_TRACEFILE 411
#define T_REPLACE 412
#define T_SIZE 413
#define T_FILES 414
#define T_K 415
#define T_M 416
#define T_ALL 417
#define T_GENERAL 418
#define T_INTERNAL 419
#define T_EXTERNAL 420
#define T_ROUTE 421
#define T_UPDATE 422
#define T_KERNEL 423
#define T_TASK 424
#define T_TIMER 425
#define T_NOSTAMP 426
#define T_MARK 427
#define TISIS_IIH 428
#define TISIS_DUMPLSP 429
#define TISIS_EVENTS 430
#define TISIS_LANADJ 431
#define TISIS_FLOODING 432
#define TISIS_BUILDLSP 433
#define TISIS_CSNP 434
#define TISIS_PSNP 435
#define TISIS_LSPINPUT 436
#define TISIS_P2PADJ 437
#define TISIS_LSPDB 438
#define TISIS_PATHS 439
#define TISIS_LSPCONTENT 440
#define TISIS_SUMMARY 441
#define T_INET 442
#define T_ISO 443
#define YYERRCODE 256
short yylhs[] = {                                        -1,
    0,    0,  113,  113,  114,  114,  114,  114,  114,  114,
  114,  114,  114,  114,  115,  115,  115,  116,  116,   56,
   56,   57,   57,   57,   60,   60,  129,  129,   53,   53,
   54,   54,   54,   55,   55,   52,   52,   49,   49,   51,
   51,   51,   51,   50,   50,   50,   50,   50,   50,   50,
   50,   50,   50,   50,   50,   50,  121,  130,  122,  122,
  122,  122,  122,   99,   99,   99,   91,   91,   91,  117,
  118,  132,  132,  133,  133,  133,  133,  133,    2,    2,
    2,    1,    1,    1,    1,    1,    1,    1,    1,  119,
  134,  120,  135,  135,  135,  136,  136,  139,  136,  137,
  137,  141,  141,  138,  138,  138,  140,  140,  142,  142,
   58,   58,   59,   59,   59,   59,   59,   59,   95,   95,
   97,   97,   96,   96,   94,   94,   92,   93,   93,   76,
   81,   81,  123,  124,  124,  124,  124,  147,  145,   24,
   24,   24,   24,  148,  148,  149,  149,  149,  150,  152,
  150,  150,  150,  150,  150,  150,  150,  150,  150,   26,
   26,   25,   25,   25,  151,  151,  153,  153,   27,   27,
   27,   28,   28,   29,   29,   29,   30,   30,   30,   30,
   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,
   30,   30,   30,  154,  144,  155,  155,  156,  156,  156,
  157,  157,  157,  159,  160,  157,  158,  158,  161,  161,
  161,  164,  163,  165,  163,  162,  162,  162,  162,  162,
  162,  162,  162,  162,  162,  162,  162,  162,  162,  162,
  162,    4,    3,    3,    3,    3,    5,    6,    8,    8,
    8,    7,    7,    7,  166,  146,  168,  168,  171,  168,
  168,  172,  172,  172,  169,  169,  175,  175,  175,  176,
  176,  176,  176,  176,  176,  176,  176,  176,  176,  176,
  176,  176,  176,  178,  178,  179,  179,  167,  167,  181,
  181,  181,  182,  174,  173,  173,  173,  185,  185,  185,
  185,  185,  186,  186,  188,  188,  188,  188,  188,  187,
  187,  189,  189,  189,  190,  190,  191,  183,  183,  183,
  183,  183,  170,  170,  170,  170,  192,  192,  192,  180,
  180,  180,  194,  194,  194,  194,  177,  177,  177,  177,
  177,  177,  184,  184,  193,   33,   33,   34,   32,   35,
   35,  131,   31,  195,  143,  196,  196,  197,  197,  197,
  198,  198,  198,  198,   37,   37,   36,   38,  125,  199,
  126,  200,  200,  200,  201,  201,   39,   39,   39,   39,
   40,   40,   41,   41,   41,   41,  127,  128,  128,  128,
  128,  128,   62,   63,  102,  102,  100,  100,  100,  202,
  101,   64,  108,  108,  104,  104,  104,  103,  103,  103,
  103,  103,  103,  103,   67,   68,   69,   66,  109,  109,
  107,  107,  106,  106,  106,  203,  105,   77,   77,   77,
   86,   86,   86,   86,   89,   90,   90,   90,   78,   78,
   78,   98,   98,   85,   79,   79,   87,   80,   80,   88,
   88,   88,   82,   83,   83,  111,  111,  111,   65,   61,
   61,   48,   48,   44,   44,   45,   45,   46,   46,   46,
   74,   74,   75,   75,   73,  110,   42,   42,   43,   43,
   47,   47,   47,  112,  112,   70,   71,   71,   72,   72,
   21,   21,   20,   20,   20,   19,   19,   22,   23,   18,
  204,    9,   17,   17,   15,   15,   16,   16,   16,   10,
   10,   11,   11,   13,   13,   13,   13,   13,   12,   12,
   12,   14,   14,   14,   84,
};
short yylen[] = {                                         2,
    0,    1,    1,    2,    1,    1,    2,    2,    2,    2,
    2,    2,    2,    1,    3,    3,    2,    3,    4,    0,
    2,    1,    2,    2,    0,    1,    0,    4,    1,    1,
    1,    2,    3,    1,    1,    1,    1,    1,    2,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    0,    0,    6,    3,
    3,    3,    3,    0,    3,    3,    1,    1,    1,    0,
    3,    1,    2,    1,    2,    1,    1,    2,    1,    2,
    2,    1,    1,    1,    1,    1,    1,    1,    1,    0,
    0,    6,    0,    3,    3,    2,    3,    0,    5,    1,
    2,    1,    2,    2,    2,    0,    0,    2,    2,    1,
    1,    2,    2,    3,    1,    1,    1,    1,    0,    2,
    1,    2,    1,    1,    1,    2,    1,    1,    1,    1,
    1,    1,    0,    2,    2,    2,    1,    0,    4,    1,
    1,    1,    1,    0,    3,    0,    3,    3,    1,    0,
    4,    2,    2,    2,    2,    7,    5,    2,    3,    2,
    0,    1,    1,    1,    0,    2,    3,    3,    1,    1,
    1,    1,    1,    1,    2,    3,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    0,    4,    0,    3,    0,    3,    3,
    2,    2,    2,    0,    0,   11,    0,    2,    0,    3,
    3,    0,    4,    0,    5,    2,    2,    1,    2,    2,
    2,    2,    2,    2,    1,    1,    1,    1,    2,    2,
    2,    1,    1,    1,    1,    1,    1,    1,    0,    3,
    3,    1,    1,    1,    0,    5,    2,    4,    0,    6,
    4,    0,    3,    3,    0,    1,    0,    3,    3,    0,
    2,    2,    2,    1,    1,    2,    2,    2,    2,    2,
    2,    2,    2,    2,    4,    0,    2,    0,    3,    0,
    3,    3,    0,   10,    0,    3,    3,    2,    3,    4,
    3,    4,    3,    3,    2,    2,    4,    4,    1,    3,
    3,    0,    2,    2,    3,    3,    1,    0,    2,    2,
    3,    3,    1,    2,    1,    2,    2,    1,    1,    0,
    2,    1,    1,    1,    1,    1,    1,    1,    2,    4,
    1,    1,    0,    2,    2,    1,    2,    1,    1,    1,
    1,    1,    1,    0,    4,    0,    3,    0,    3,    3,
    2,    3,    2,    2,    1,    2,    1,    1,    0,    0,
    5,    2,    3,    2,    6,    5,    1,    1,    1,    2,
    0,    2,    1,    1,    1,    1,    0,    7,    6,    6,
    7,    6,    1,    1,    1,    4,    0,    3,    3,    0,
    3,    1,    1,    4,    0,    3,    3,    5,    4,    5,
    4,    4,    4,    3,    1,    1,    1,    1,    1,    2,
    0,    3,    0,    3,    3,    0,    3,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    2,    1,    1,
    1,    1,    2,    1,    1,    1,    2,    1,    1,    1,
    3,    3,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    0,    2,    0,    1,    2,
    0,    2,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    3,    5,    1,    1,    1,    1,    2,    0,    2,
    0,    2,    1,    1,    2,    0,    2,    1,    1,    1,
    0,    5,    1,    1,    1,    3,    1,    1,    1,    1,
    3,    1,    2,    1,    2,    2,    2,    4,    1,    1,
    3,    1,    2,    3,    1,
};
short yydefred[] = {                                      0,
    0,   14,    0,    0,    0,    0,    0,    0,    0,    3,
    5,    6,    0,    0,    0,    0,    0,    0,   13,  452,
  453,    0,    0,   17,   52,   54,   55,   56,   29,   44,
   45,   46,   47,   48,   49,   53,   50,   51,   31,    0,
    0,  466,    0,    0,    4,    0,    7,   91,    8,    0,
  342,   58,    0,    0,    9,    0,  194,  138,  245,  344,
   10,    0,    0,    0,  137,  360,   11,    0,    0,   12,
   15,   16,   18,   42,   43,    0,   40,   41,   34,   35,
   32,    0,    0,   26,   21,    0,    0,   74,   76,   77,
    0,   72,    0,  339,    0,    0,  476,    0,  444,  469,
  470,  445,    0,  443,  338,    0,    0,    0,    0,    0,
  134,  135,  136,    0,    0,    0,   33,  467,    0,  468,
    0,   19,   89,    0,   82,   83,   84,   85,   86,   87,
   88,   79,    0,    0,   75,   71,   73,   93,   60,   64,
   62,   63,   61,    0,  141,  143,  142,    0,  140,    0,
    0,    0,  450,  238,  449,  451,  383,    0,    0,  392,
    0,    0,    0,  384,   23,   24,    0,   80,   81,  465,
  462,    0,    0,  198,  195,  146,  139,  280,    0,  348,
  345,    0,  446,  447,  515,  369,  418,    0,    0,    0,
  439,    0,  419,  420,  367,  368,  448,  438,    0,    0,
    0,    0,    0,  121,    0,  491,    0,    0,    0,   28,
    0,    0,    0,    0,    0,    0,    0,  427,  426,    0,
    0,   67,   68,   69,    0,    0,    0,    0,  246,    0,
  364,  436,  437,  435,  370,    0,    0,    0,    0,  361,
    0,  362,    0,  129,  125,  127,    0,  128,  434,  432,
    0,    0,  393,    0,    0,    0,  385,    0,    0,    0,
    0,   95,  123,    0,    0,   98,  102,    0,    0,  100,
   92,   94,   66,  428,   59,   65,    0,    0,    0,    0,
    0,  197,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  145,  149,    0,    0,  249,    0,
    0,    0,  279,    0,    0,    0,    0,    0,    0,  347,
    0,    0,    0,  429,  442,  430,  431,  441,  363,    0,
  126,  433,  455,  454,  457,  395,  382,  510,    0,    0,
    0,    0,    0,  509,  387,  379,    0,  380,    0,    0,
  115,  116,  117,  118,    0,  111,    0,    0,  103,  101,
  200,  201,  202,    0,  203,    0,   38,  199,  148,  154,
  150,  152,  160,    0,    0,  172,  173,    0,  158,  155,
  188,  177,  190,  191,  178,  179,  180,  181,  182,  183,
  184,  185,  186,  187,  189,  192,  193,    0,  174,  147,
  282,    0,  285,    0,  247,    0,  281,  350,    0,  351,
    0,  354,    0,  349,  371,    0,  381,    0,    0,    0,
    0,    0,  505,  506,  507,  503,    0,  378,    0,  113,
  112,    0,    0,  107,    0,  236,  235,  233,  234,    0,
   39,  165,  169,  170,  171,    0,  159,    0,    0,  175,
    0,    0,  318,  319,    0,    0,  313,  315,    0,    0,
    0,  357,  355,    0,    0,  371,    0,    0,  394,    0,
  511,  498,  499,  493,  497,    0,  495,  492,  501,    0,
    0,    0,  386,    0,    0,  114,  104,  105,    0,    0,
    0,    0,    0,    0,  176,  317,  335,  252,  314,    0,
    0,  340,  341,  251,    0,    0,  248,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  264,  265,  356,  373,  374,  375,  376,  372,
    0,  397,  405,  408,  406,  407,    0,    0,    0,    0,
    0,    0,    0,  396,    0,  508,    0,  389,  388,  425,
    0,  423,  424,  421,  422,  110,    0,  108,    0,  204,
    0,    0,  166,    0,  157,    0,  287,    0,  286,  259,
  268,  263,  323,  326,  324,  325,    0,  322,    0,  332,
  331,  327,  261,  266,  270,  269,  271,  272,  273,  262,
  267,    0,  258,    0,    0,    0,  409,    0,  404,    0,
    0,    0,  496,  514,  464,  463,  391,  109,  473,  207,
    0,    0,    0,    0,  283,  250,    0,    0,    0,    0,
    0,    0,  299,    0,    0,    0,    0,  321,    0,    0,
  399,    0,  488,    0,  413,  410,  401,  402,  403,    0,
  167,  168,  156,  254,    0,  253,    0,    0,    0,  307,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  275,
  400,  398,    0,    0,    0,    0,    0,    0,  218,    0,
  226,  227,    0,  228,    0,    0,    0,  225,    0,    0,
  208,    0,    0,    0,    0,    0,  293,  300,  294,  301,
  330,    0,  412,    0,    0,  221,  131,  130,  132,  216,
  219,  220,  217,  224,  222,  229,  232,  230,  231,  223,
  209,    0,  336,    0,  298,  297,  305,  306,  415,  414,
    0,    0,    0,  337,    0,  459,  417,    0,  212,  214,
  206,    0,    0,  460,  211,    0,    0,  210,    0,  207,
  239,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  215,    0,  243,  244,  242,  312,  311,    0,  241,  240,
  334,
};
short yydgoto[] = {                                       8,
  132,  133,  430,  696,  355,  156,  742,  735,  207,  330,
  331,  332,  333,  470,  466,  467,  468,  527,    0,    0,
    0,  622,  528,  148,    0,  296,  436,  368,  388,  389,
  395,   95,  702,  703,  640,  453,  454,  402,  190,  455,
  520,  324,  102,  325,  588,  717,  349,   22,  356,  357,
   80,    0,   40,   41,   81,   43,  121,  345,  346,   85,
  157,  158,  163,  159,  160,  530,  531,  532,  533,  334,
    0,    0,  171,  258,  597,  686,  232,  315,  249,  192,
  688,  193,  104,  194,  250,  541,  195,  196,  544,  545,
  225,  245,  246,  264,  204,  265,  205,  251,  173,  417,
  474,  259,  460,  408,  684,  653,  626,  255,  589,  197,
  234,    0,    9,   10,   11,   12,   13,   47,   14,   49,
   15,   55,   16,   61,   17,   67,   18,   70,   83,   96,
  704,   91,   92,   93,  172,  216,  269,  424,  347,  479,
  270,  548,   62,   63,   64,   65,  108,  177,  227,  297,
  482,  432,  553,  107,  175,  226,  283,  630,  600,  670,
  712,  671,  722,  726,  727,  109,  179,  304,  450,  445,
  392,  556,  449,  607,  451,  512,  573,  513,  514,  567,
  228,  635,  733,  446,  496,  614,  615,  616,  617,  641,
  642,  447,  448,  568,  110,  181,  230,  311,  114,  199,
  200,  475,  685,  256,
};
short yysindex[] = {                                   -135,
 -187,    0,   74, -176, -168,  544, -166,    0, -135,    0,
    0,    0, -308, -155,  295,   57, -287,  136,    0,    0,
    0, -138, -104,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    6,
  492,    0, -172, -227,    0,  222,    0,    0,    0,   -6,
    0,    0,   10,  441,    0,   39,    0,    0,    0,    0,
    0,   18,   68,   94,    0,    0,    0,  110,  114,    0,
    0,    0,    0,    0,    0,  586,    0,    0,    0,    0,
    0,  454,  130,    0,    0,  658,   97,    0,    0,    0,
   93,    0,  268,    0,  141,  286,    0,  156,    0,    0,
    0,    0,  165,    0,    0,  168,   74, -231,   74,   74,
    0,    0,    0,  308, -251,  -35,    0,    0, -122,    0,
   20,    0,    0,  812,    0,    0,    0,    0,    0,    0,
    0,    0,  812,  189,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  319,    0,    0,    0,  327,    0,  349,
  354,  226,    0,    0,    0,    0,    0,   51,   32,    0,
  153,   79,   32,    0,    0,    0,  454,    0,    0,    0,
    0,  -95,  -84,    0,    0,    0,    0,    0,  236,    0,
    0,  241,    0,    0,    0,    0,    0,  831,  227,   56,
    0,  157,    0,    0,    0,    0,    0,    0,  -73,  262,
   10,  831,  831,    0, -167,    0, -238,   10, -238,    0,
  302,  473,  831,  151,  304,  306,  310,    0,    0,  264,
  315,    0,    0,    0,  321,  -82,  127,   -8,    0,  -72,
    0,    0,    0,    0,    0,  831,  831,  376,  454,    0,
  334,    0, -167,    0,    0,    0,  831,    0,    0,    0,
  831,  408,    0,  453,  338,    8,    0,  464,  356, -238,
  358,    0,    0,  831,  183,    0,    0,  347,  151,    0,
    0,    0,    0,    0,    0,    0,  364,  189,  408,  322,
  602,    0,  384,  386,  454, -166, -166,  454,  272,  372,
  137, -166, -166,  649,    0,    0,  389,  395,    0,  537,
  542,  602,    0,  413,  416,  473,  189,  831,  602,    0,
  423,   97,  769,    0,    0,    0,    0,    0,    0,  428,
    0,    0,    0,    0,    0,    0,    0,    0,    8,  361,
  577,   37,    8,    0,    0,    0,  459,    0,  431,  189,
    0,    0,    0,    0,  183,    0,  -23,  662,    0,    0,
    0,    0,    0, -278,    0,  602,    0,    0,    0,    0,
    0,    0,    0,   13,  454,    0,    0,  485,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  624,    0,    0,
    0,   75,    0,    0,    0,  602,    0,    0,  350,    0,
  831,    0,  602,    0,    0,   97,    0,  -16,  721,  280,
    8,  454,    0,    0,    0,    0,  -18,    0,  189,    0,
    0,  831,  831,    0,  509,    0,    0,    0,    0,  470,
    0,    0,    0,    0,    0,  831,    0,  454,  649,    0,
   -6,  602,    0,    0,  -99,  363,    0,    0,   24,  642,
  616,    0,    0,  350,  296,    0,  525,  123,    0,  526,
    0,    0,    0,    0,    0,  668,    0,    0,    0,  675,
  764,  555,    0,  560,  415,    0,    0,    0,  298,  760,
   10, -206,  376, -166,    0,    0,    0,    0,    0,    0,
  566,    0,    0,    0, -132,  567,    0,  568,  571,   74,
  -61, -193,  572,  575,  576,  578,  580,  587,   74,   74,
  588,  569,    0,    0,    0,    0,    0,    0,    0,    0,
  296,    0,    0,    0,    0,    0,  153,  497,  427, -159,
  584,  584,  584,    0, -108,    0,  454,    0,    0,    0,
 -237,    0,    0,    0,    0,    0,  376,    0,  589,    0,
  272,  272,    0,  564,    0,  -32,    0,  333,    0,    0,
    0,    0,    0,    0,    0,    0,  -61,    0,  411,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  480,    0, -159,  454,   10,    0,  732,    0, -159,
 -159, -159,    0,    0,    0,    0,    0,    0,    0,    0,
  454,  454,  454,  599,    0,    0,  604,   19,  368,  454,
 -132, -132,    0,  133,  330,  603,  609,    0,  507,  606,
    0, -159,    0, -159,    0,    0,    0,    0,    0,  570,
    0,    0,    0,    0,   74,    0,   19,  512,  536,    0,
 -132,  618, -132,  330,  619,  620,  631,  648,  515,    0,
    0,    0,  -17,  831,  408,  831,  189,   10,    0,  622,
    0,    0,  347,    0,  454,  454,  454,    0,  602,  783,
    0, -128,  454,  368,  650,  651,    0,    0,    0,    0,
    0,  664,    0,  666,  415,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  831,    0,   39,    0,    0,    0,    0,    0,    0,
 -152,  -37,  573,    0,  408,    0,    0,  667,    0,    0,
    0,  669, -128,    0,    0,  831,  804,    0,  660,    0,
    0,  637,  -61,  570,   80,    0,  831, -128,  -61,  673,
    0,  677,    0,    0,    0,    0,    0,  363,    0,    0,
    0,
};
short yyrindex[] = {                                     12,
    0,    0,    0,    0,    0,    0, -219,    0,   44,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  678,    0,  683, -200,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  131,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  518,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  143,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  684,    0,    0,    0,  697,    0,  698,
  699,    0,    0,    0,    0,    0,    0,    0,  -25,    0,
  556,    0,  -97,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  307,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  836,    0,  849,    0,  849,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  716,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  836,    0,    0,    0,  -27,    0,    0,    0,
  -41,    0,    0,    0,    0,    0,    0,    0,    0,  849,
    0,    0,    0,  181,    0,    0,    0,    0,  719,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   55,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   52,  245,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  -10,  -13,  -12,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  720,    0, -165,  303,    0,    0,
    0,    0,    0,    0,    0,  429,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  724,    0,    0,
    0,    0,    0,  402,    0,  -98,    0,    0,    0,    0,
  725,    0,  384,    0,    0,   52,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  535,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  -74,    0,    0,  726,  727,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  -36,    0,    0,    0,    0,
  868,    0,    0,    0,    0,    0,    0,    0,  740,  340,
    0,  741,    0,    0,    0,    0,    0,    0,    0, -101,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  743,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  744,    0,    0,    0,    0,    0,    0,    0,    3,  -55,
  -54,  -54,  -54,    0,    0,    0,  877,    0,    0,    0,
  757,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  495,  495,    0,    0,    0,    0,    0,  458,    0,    0,
    0,    0,    0,    0,    0,    0,  758,    0,  759,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  761,    0,  -55,    0,    0,    0,  779,    0,  -55,
  -55,  -55,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  467,  781,    0,    0,    0,  782,    0,
    0,  -55,    0,  -55,    0,    0,    0,    0,    0,  894,
    0,    0,    0,    0,    0,    0,  785,  484,  491,    0,
  499,    0,  508,  786,    0,    0,    0,    0,    0,    0,
    0,    0,  543,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  787,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, -217,    0,
    0,    0, -212,  790,    0,  527, -208, -181, -210,    0,
    0,    0,    0,    0,    0,    0,    0,  791,    0,    0,
    0,
};
short yygindex[] = {                                      0,
   -9,    0,    0,  374,  380,    0,    0,    0,  523, -279,
  718,    0,    0,    0,    0,  530,    0,    0,    0,    0,
    0,    0,    0,    0,    0, -254,    0,    0,    0, -311,
  625,  627, -220,  -56, -142,  615,    0,    0,    0,  617,
    0,  -77,  -81, -271,  -87,    0,  409,  -90, -228,   15,
    0,    0,    0,    0,  998,    0,    0,    0,  731,    0,
  640,  990,    0,    0,  991,    0,    0,    0,    0,  -51,
    0,    0, -268,  -80,    0,    0, -141, -410, -179,  672,
    0, 1055, -225, -215, -235,  425, -170, -169,  377,  938,
    0,  176,    0,  911, -267,  808,  952, -153,    0,    0,
    0, -124,    0,    0,    0,    0,    0,  873,  229,   -1,
 -137,    0,    0, 1108,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1103,    0, 1028,    0,    0,    0,    0,    0,    0,    0,
  851,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  391,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  390,
    0,    0,    0,  383,    0,  516,  511, -377, -514,  514,
 -285,  682, -432, -530,    0,    0,    0,    0,    0,    0,
  929,    0,    0,    0,
};
#define YYTABLESIZE 1137
short yytable[] = {                                     106,
  120,   98,  222,  223,  119,   44,  135,  353,  233,  352,
  191,    1,  316,  490,  198,  322,  144,  149,  150,  151,
   39,  316,  317,  488,  343,  119,  504,  504,  502,  215,
  500,  191,  504,  266,  364,  198,  618,   20,  400,  308,
  221,  426,  282,    2,  320,  406,  333,  329,  310,  409,
  256,  240,  310,  328,  153,   79,   25,  191,  134,  134,
  244,  198,   20,   21,  248,  551,  154,  456,  119,   19,
  244,  420,  554,  396,  248,  309,  440,  322,  413,  414,
  403,  122,   23,  313,  261,  120,  494,  721,   24,  210,
   79,  106,  606,   42,  244,  120,   46,  119,  248,  415,
  646,  145,  146,   66,  252,  244,  473,  683,  459,  248,
  504,  502,  252,   48,  168,  308,  303,  254,   71,  715,
    1,    2,  244,  169,  310,  427,  248,  485,  155,  646,
  492,  469,  493,  308,  105,  337,  598,  106,  106,  569,
  428,  429,  310,  552,  308,    3,    4,    5,  494,  243,
  476,  309,   72,  310,  401,  254,  260,  120,  343,  412,
  211,  318,  257,  595,  244,  322,  570,  571,  248,  309,
  120,  217,  212,  277,   99,   42,  183,  184,  100,  101,
  309,  185,  260,  305,   84,   99,   42,  183,  184,  100,
  101,  308,  185,   20,  218,  306,  320,  120,  333,  119,
  310,  456,  119,  120,  741,  186,  120,  360,  618,  213,
  363,  147,   25,  396,  278,  279,  462,  119,  718,  463,
  494,  187,  219,  604,  307,  308,   51,  309,  280,  120,
  122,  405,  187,  253,  310,  494,  645,  472,  682,  457,
   82,  587,  477,  478,  120,  504,  119,  298,  716,  572,
  316,  295,  441,  343,  458,  122,   94,  316,  308,  645,
  494,  309,   73,  590,  591,  592,   97,  317,   97,  120,
  153,  563,  719,    6,  111,    7,  422,  605,  423,  491,
   90,  720,  161,  120,  361,  362,  492,  437,  493,  564,
  369,  370,  165,  166,  191,  465,  601,  602,  198,  202,
  565,  105,  299,  119,  542,  543,  495,  334,  461,  214,
  343,  188,   90,  504,  502,  751,  500,  316,  316,  443,
  444,  316,  188,  236,  112,  456,  281,  203,  490,  133,
  120,  317,  489,  191,  471,  740,  309,  198,   99,   42,
  183,  184,  100,  101,  155,  185,  119,  133,  300,  136,
  113,  237,  558,  609,  301,  675,  120,  675,  220,  122,
  484,  133,  133,   57,  494,  120,   57,   20,   21,  189,
  431,  120,  120,  120,   57,  119,  610,   86,  120,  133,
  115,  566,  284,  690,  116,  187,  122,  461,  692,  523,
  138,  133,   58,  134,  133,   57,  613,  139,   57,   78,
  302,  524,  359,   57,   87,  377,  377,   59,  140,  562,
  431,  312,  141,   57,   57,  461,   70,  431,  580,  581,
  691,  142,  321,  133,  143,  471,  441,   78,  153,  550,
  152,  433,  434,  167,  359,   57,   60,  377,  377,  321,
  154,  174,  461,  724,  461,   57,   57,  170,   70,  176,
  461,  461,  201,  435,   78,  120,  124,  461,  339,  594,
  596,  285,  472,  286,  287,  288,  289,  609,  290,  291,
  292,  178,  293,  161,  161,  188,  180,  124,  206,  340,
  208,  182,  555,  442,   99,   42,  183,  184,  100,  101,
  610,  185,  229,  443,  444,  161,  540,  231,   88,   89,
   90,  119,  729,  120,  186,  235,   86,  623,  611,  612,
  613,  737,  687,  525,  542,  543,  689,  747,  242,  120,
  120,  120,  713,  631,  632,  633,  255,  638,  120,   68,
   69,  187,  639,   87,  624,  294,  461,  461,  461,  267,
  268,  119,  274,  191,  672,  526,  730,  198,   78,   78,
   78,  237,  738,  238,  239,  366,  367,  746,  262,  471,
  271,  124,  272,  440,  743,  744,  273,  124,  124,  341,
  342,  275,  471,  120,  440,  326,  471,  276,  440,  124,
  124,  343,  344,  120,  120,  120,  335,  697,  697,  699,
  319,  120,  706,  191,  327,  705,  472,  198,  471,  471,
  546,  547,  440,  440,  462,  348,  693,  463,  464,  472,
  288,  471,  336,  472,  338,  471,  471,  471,  471,  471,
  351,  188,  354,  471,  471,  471,  471,   88,   89,   90,
  100,  101,  365,  120,   99,  472,  472,  119,  100,  101,
  358,  185,  359,  119,  119,  390,   50,  714,  472,   51,
  119,  391,  472,  472,  472,  472,  472,  257,  257,  393,
  472,  472,  472,  472,  394,  608,  118,  609,  189,  397,
  100,  101,  398,   99,   42,  183,  184,  100,  101,  404,
  185,  314,  323,  465,  407,  237,   52,  410,  516,  471,
  610,  471,  471,  218,  517,  518,   53,   54,  237,   99,
  411,  519,  237,  100,  101,  611,  612,  440,  611,  612,
  613,  471,  118,  302,  288,  418,  100,  101,  257,  425,
  187,  219,  302,  289,  237,  237,  472,  419,  472,  472,
  452,   99,   42,  183,  184,  100,  101,  237,  185,  295,
  295,  237,  237,  237,  237,  237,  296,  296,  472,  237,
  237,  237,  237,  161,  303,  303,  438,  161,  161,  257,
  257,  461,   25,  304,  304,  257,  497,  480,   74,   75,
  257,  442,  257,  257,  257,  257,  257,  481,  187,  257,
  257,  522,  534,  338,  257,  338,  338,  338,  338,  338,
  338,  535,  338,  390,  390,  390,  390,  390,  390,  536,
  390,  416,  416,  416,  416,  416,  416,  537,  416,   26,
  188,  538,  621,  390,   25,  237,  539,  549,  627,  628,
  629,  416,  557,  559,  560,  583,  585,   27,  586,  561,
  574,  540,  338,  575,  576,  603,  577,  237,  578,  654,
  390,  390,   28,  655,  620,  579,  582,  599,  416,  416,
  651,  202,  652,  619,  625,  634,   25,  220,  647,  338,
  636,   26,   74,   75,  648,  656,  657,  649,  650,  673,
  674,  498,   25,  676,  681,  677,  678,  338,  658,   27,
  694,  469,  659,  660,  661,  662,  663,  679,  338,  263,
  664,  665,  666,  667,   28,   99,   42,  183,  184,  736,
  101,   76,  185,   26,  680,  701,  707,  708,   30,   31,
   32,   33,   34,   35,   36,   37,   38,   77,   78,   26,
  709,   27,  710,  725,  723,  728,  731,  732,   29,  749,
  390,   22,  499,  750,   30,  338,   28,   27,  416,   27,
  196,  123,  187,  124,  125,  126,  127,  128,  129,  130,
  131,  390,   28,  144,  278,  346,  668,  238,  456,  416,
   30,   31,   32,   33,   34,   35,   36,   37,   38,  338,
  371,  461,  161,  500,  501,   96,   97,  390,  669,  502,
  153,  353,  352,  366,  503,  416,  504,  505,  506,  507,
  508,   51,  512,  509,  510,  371,   99,  151,  511,  320,
  365,  513,   30,   31,   32,   33,   34,   35,   36,   37,
   38,   77,   78,  461,  277,  328,  205,  274,   30,   31,
   32,   33,   34,   35,   36,   37,   38,   99,   42,  183,
  184,  100,  101,  439,  185,  411,  202,  291,  329,  698,
  372,  290,  292,  458,  373,  374,  213,  284,  700,  584,
  416,  375,  376,  377,  378,  379,  380,  381,  382,  383,
  384,  385,  386,  387,  593,  372,  487,  486,  515,  373,
  374,  695,  521,  117,  187,  421,  375,  376,  377,  378,
  379,  380,  381,  382,  383,  384,  385,  386,  387,   99,
   42,  183,  184,  100,  101,  123,  185,  529,  125,  126,
  127,  128,  129,  130,  131,  162,  164,  483,  103,  711,
  224,  745,  247,  399,  209,  320,   45,   56,  137,  350,
  734,  748,  739,  637,  644,  643,  489,  241,    0,    0,
    0,    0,    0,    0,    0,    0,  187,
};
short yycheck[] = {                                      56,
   82,   53,  173,  173,   82,    7,   87,  279,  188,  278,
  152,    0,  238,  446,  152,  251,  107,  108,  109,  110,
    6,  123,  238,  123,  123,  123,   40,   41,   41,  125,
   41,  173,   46,  213,  289,  173,  567,  257,  307,  257,
  125,  320,  125,    0,  257,  313,  257,   40,  257,  329,
  125,  125,  125,   46,  306,   41,  257,  199,  297,  297,
  202,  199,  294,  295,  202,  272,  318,  123,  123,  257,
  212,  340,  483,  302,  212,  257,  388,  313,   42,   43,
  309,  123,  259,  237,  209,  167,  123,  125,  257,  167,
   76,  257,  125,  260,  236,  123,  405,  123,  236,   63,
  615,  333,  334,  391,  272,  247,  125,  125,  125,  247,
  124,  124,  272,  269,  124,  333,  125,  205,  257,  272,
  256,  257,  264,  133,  333,  404,  264,  439,  380,  644,
  263,  411,  265,  351,  263,  260,  547,  303,  304,  333,
  419,  420,  351,  350,  362,  281,  282,  283,  125,  201,
  419,  333,  257,  362,  308,  243,  208,  239,  257,  123,
  256,  239,  401,  401,  306,  401,  360,  361,  306,  351,
  252,  256,  268,  256,  259,  260,  261,  262,  263,  264,
  362,  266,  257,  256,  412,  259,  260,  261,  262,  263,
  264,  409,  266,  413,  279,  268,  409,  279,  409,  297,
  409,  257,  257,  285,  125,  279,  288,  285,  739,  305,
  288,  443,  413,  442,  297,  298,  325,  272,  256,  328,
  257,  306,  307,  256,  297,  443,  355,  409,  311,  257,
  272,  312,  306,  401,  443,  272,  614,  256,  256,  256,
  413,  401,  422,  423,  272,  259,  272,  256,  401,  443,
  352,  125,  352,  352,  271,  297,  263,  483,  331,  637,
  297,  443,  257,  531,  532,  533,  259,  483,  259,  297,
  306,  333,  310,  409,  257,  411,  300,  310,  302,  256,
  269,  319,  318,  365,  286,  287,  263,  365,  265,  351,
  292,  293,  415,  416,  436,  404,  551,  552,  436,  268,
  362,  263,  311,  401,  475,  475,  449,  409,  257,  405,
  409,  396,  269,  327,  327,  748,  327,  419,  420,  419,
  420,  547,  396,  268,  257,  406,  409,  296,  326,  318,
  412,  547,  330,  475,  412,  256,  409,  475,  259,  260,
  261,  262,  263,  264,  380,  266,  401,  336,  357,  257,
  257,  296,  495,  335,  363,  641,  438,  643,  443,  401,
  438,  318,  351,  352,  401,  393,  355,  294,  295,  443,
  356,  399,  400,  401,  318,  401,  358,  285,  406,  336,
  271,  443,  256,  655,  271,  306,  257,  257,  657,  267,
  123,  380,  336,  297,  351,  352,  378,  257,  355,  257,
  409,  279,  391,  392,  312,  394,  395,  351,  123,  500,
  396,  236,  257,  402,  403,  285,  405,  403,  509,  510,
  656,  257,  247,  380,  257,  123,  352,  285,  306,  481,
  123,  419,  420,  414,  391,  392,  380,  394,  395,  264,
  318,  123,  312,  715,  393,  402,  403,  259,  405,  123,
  399,  400,  402,  441,  312,  537,  276,  406,  276,  537,
  541,  335,  123,  337,  338,  339,  340,  335,  342,  343,
  344,  123,  346,  419,  420,  396,  123,  297,  326,  297,
  402,  256,  484,  409,  259,  260,  261,  262,  263,  264,
  358,  266,  257,  419,  420,  441,  417,  257,  406,  407,
  408,  257,  723,  585,  279,  279,  285,  585,  376,  377,
  378,  732,  654,  391,  685,  685,  654,  738,  257,  601,
  602,  603,  702,  601,  602,  603,  125,  609,  610,  394,
  395,  306,  610,  312,  586,  409,  406,  407,  408,  389,
  390,  297,  279,  685,  635,  423,  726,  685,  406,  407,
  408,  123,  732,  397,  398,  419,  420,  737,  257,  257,
  257,  381,  257,  257,  735,  735,  257,  387,  388,  387,
  388,  257,  270,  655,  268,  123,  274,  257,  272,  399,
  400,  399,  400,  665,  666,  667,  123,  665,  666,  667,
  257,  673,  674,  735,  257,  673,  257,  735,  296,  297,
  303,  304,  296,  297,  325,  259,  658,  328,  329,  270,
  339,  309,  257,  274,  257,  313,  314,  315,  316,  317,
  257,  396,  301,  321,  322,  323,  324,  406,  407,  408,
  263,  264,  261,  715,  259,  296,  297,  393,  263,  264,
  257,  266,  257,  399,  400,  257,  352,  704,  309,  355,
  406,  257,  313,  314,  315,  316,  317,  256,  257,  123,
  321,  322,  323,  324,  123,  333,  259,  335,  443,  257,
  263,  264,  257,  259,  260,  261,  262,  263,  264,  257,
  266,  306,  275,  404,  257,  257,  392,  327,  393,  387,
  358,  389,  390,  279,  399,  400,  402,  403,  270,  259,
  124,  406,  274,  263,  264,  376,  377,  401,  376,  377,
  378,  409,  259,  256,  257,  257,  263,  264,  317,   58,
  306,  307,  256,  257,  296,  297,  387,  297,  389,  390,
  381,  259,  260,  261,  262,  263,  264,  309,  266,  256,
  257,  313,  314,  315,  316,  317,  256,  257,  409,  321,
  322,  323,  324,  259,  256,  257,  272,  263,  264,  358,
  359,   41,  271,  256,  257,  364,  125,  259,  277,  278,
  369,  409,  371,  372,  373,  374,  375,  308,  306,  378,
  379,  257,  257,  257,  383,  259,  260,  261,  262,  263,
  264,  124,  266,  259,  260,  261,  262,  263,  264,  125,
  266,  259,  260,  261,  262,  263,  264,   44,  266,  318,
  396,  257,  584,  279,  271,  387,  257,   58,  590,  591,
  592,  279,  257,  257,  257,  257,  330,  336,  402,  259,
  259,  417,  306,  259,  259,  272,  259,  409,  259,  270,
  306,  307,  351,  274,  365,  259,  259,  259,  306,  307,
  622,  268,  624,  443,  123,  257,  271,  443,  256,  333,
  257,  318,  277,  278,  256,  296,  297,  361,  263,  358,
  335,  256,  271,  256,  360,  257,  257,  351,  309,  336,
  259,  355,  313,  314,  315,  316,  317,  257,  362,  417,
  321,  322,  323,  324,  351,  259,  260,  261,  262,  263,
  264,  410,  266,  318,  257,  123,  257,  257,  417,  418,
  419,  420,  421,  422,  423,  424,  425,  426,  427,  318,
  257,  336,  257,  257,  352,  257,  123,  268,  385,  257,
  396,  414,  317,  257,  257,  409,  351,  336,  396,  257,
  257,  284,  306,  286,  287,  288,  289,  290,  291,  292,
  293,  417,  351,  257,  257,  257,  387,  402,  123,  417,
  417,  418,  419,  420,  421,  422,  423,  424,  425,  443,
  347,  123,  257,  358,  359,  257,  257,  443,  409,  364,
  257,  257,  257,  257,  369,  443,  371,  372,  373,  374,
  375,  355,  125,  378,  379,  347,  257,  257,  383,  257,
  257,  125,  417,  418,  419,  420,  421,  422,  423,  424,
  425,  426,  427,  257,  257,  257,  123,  257,  417,  418,
  419,  420,  421,  422,  423,  424,  425,  259,  260,  261,
  262,  263,  264,  410,  266,  257,  268,  257,  257,  666,
  417,  257,  257,  257,  421,  422,  257,  257,  669,  527,
  333,  428,  429,  430,  431,  432,  433,  434,  435,  436,
  437,  438,  439,  440,  535,  417,  442,  441,  454,  421,
  422,  663,  456,   76,  306,  345,  428,  429,  430,  431,
  432,  433,  434,  435,  436,  437,  438,  439,  440,  259,
  260,  261,  262,  263,  264,  284,  266,  458,  287,  288,
  289,  290,  291,  292,  293,  116,  116,  436,   54,  685,
  173,  735,  202,  306,  163,  243,    9,   15,   91,  269,
  730,  739,  733,  608,  614,  612,  445,  199,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  306,
};
#define YYFINAL 8
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 443
#if YYDEBUG
char *yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,"'('","')'","'*'","'+'","','",0,"'.'",0,0,0,0,0,0,0,0,0,0,0,"':'",0,
0,0,0,"'?'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"'{'","'|'","'}'",0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,"L_EOS","L_ERROR","L_NUMBER","L_STRING","L_HNAME","L_KEYWORD",
"L_HEXSTRING","L_OCTETSTRING","L_HEXSTRING_ODD","L_ISOADDR","T_DIRECT",
"T_INTERFACE","T_INTERFACES","T_LCLADDR","T_PROTO","T_METRIC","T_METRICIN",
"T_METRICOUT","T_INFINITY","T_DOWN","T_PARSE","T_ADV","T_DEFAULT","T_DEFAULTS",
"T_YYDEBUG","T_YYSTATE","T_YYQUIT","T_DEBUG","T_SYSLOG","T_UPTO","T_EMERG",
"T_ALERT","T_CRIT","T_ERR","T_WARNING","T_NOTICE","T_INFO","T_ON","T_OFF",
"T_GATEWAY","T_PREFERENCE","T_DEFAULTMETRIC","T_NONBROADCAST","T_BROADCAST",
"T_TYPE","T_POINTOPOINT","T_MULTICAST","T_NETMASK","T_DEFINE","T_NOP","T_NOP1",
"T_PEERAS","T_LOCALAS","T_NEIGHBOR","T_GROUP","T_GENDEFAULT","T_NOGENDEFAULT",
"T_VERSION","T_DEFAULTIN","T_DEFAULTOUT","T_HOLDTIME","T_BGP","T_ALLOW",
"T_TEST","T_KEEPALL","T_SENDBUF","T_RECVBUF","T_SPOOLBUF","T_EGP","T_ASPATH",
"T_ORIGIN","T_INCOMPLETE","T_ANY","T_TAG","T_TRUSTEDGATEWAYS",
"T_SOURCEGATEWAYS","T_IP","T_DUAL","T_SNPA","T_ISIS","T_CIRCUIT","T_SYSTEMID",
"T_LEVEL","T_IPREACH","T_TROLL","T_SET","T_PREFIX","T_INTDOMINFO","T_MODE",
"T_AREA","T_SPF","T_HELLOINTERVAL","T_ROUTERDEADINTERVAL","T_PRIORITY","T_IDRP",
"T_RDI","T_OSISTATIC","T_NSAP","T_NET","T_NSAPPREFIX","T_OSILOCAL",
"T_MULTIEXIT","T_PROTOSOCK","T_SIP","T_PIP","T_UDP","T_LOCALNODE",
"T_PROTOSUPPORT","T_AUTHCODE","T_INTRAIS","T_RDC","T_ASRDI","T_OUTPDUS",
"T_MAXPDUSIZE","T_REXMIT","T_CLOSEWAIT","T_RIBCHECK","T_MINADV","T_MINADVRD",
"T_PROHIBITDIST","T_ALLOWDIST","T_ROUTESERVER","T_LISTENOPEN","T_REDIRECT",
"T_NOREDIRECTS","T_ICMP","T_AUTHTYPE","T_AUTHKEY","T_NONE","T_SIMPLE",
"T_PASSIVE","T_SIMPLEX","T_STRICTIFS","T_SCANINTERVAL","T_STATIC","T_MARTIANS",
"T_RETAIN","T_EXPORT","T_IMPORT","T_HOST","T_MASK","T_MASKLEN","T_REJECT",
"T_BLACKHOLE","T_RESTRICT","T_AS","T_ROUTERID","T_IGP","T_OPTIONS",
"T_NOINSTALL","T_NOSEND","T_NORESOLV","T_TRACEOPTIONS","T_EXCEPT","T_TRACEFILE",
"T_REPLACE","T_SIZE","T_FILES","T_K","T_M","T_ALL","T_GENERAL","T_INTERNAL",
"T_EXTERNAL","T_ROUTE","T_UPDATE","T_KERNEL","T_TASK","T_TIMER","T_NOSTAMP",
"T_MARK","TISIS_IIH","TISIS_DUMPLSP","TISIS_EVENTS","TISIS_LANADJ",
"TISIS_FLOODING","TISIS_BUILDLSP","TISIS_CSNP","TISIS_PSNP","TISIS_LSPINPUT",
"TISIS_P2PADJ","TISIS_LSPDB","TISIS_PATHS","TISIS_LSPCONTENT","TISIS_SUMMARY",
"T_INET","T_ISO",
};
char *yyrule[] = {
"$accept : config",
"config :",
"config : statements",
"statements : statement",
"statements : statements statement",
"statement : parse_statement",
"statement : trace_statement",
"statement : option_order option_statement",
"statement : interface_order interface_statement",
"statement : define_order define_statement",
"statement : proto_order proto_statement",
"statement : route_order route_statement",
"statement : control_order control_statement",
"statement : error L_EOS",
"statement : L_EOS",
"parse_statement : T_YYDEBUG onoff_option L_EOS",
"parse_statement : T_YYSTATE L_NUMBER L_EOS",
"parse_statement : T_YYQUIT L_EOS",
"trace_statement : T_TRACEOPTIONS trace_trace_options_none L_EOS",
"trace_statement : T_TRACEFILE trace_file trace_limits L_EOS",
"trace_file :",
"trace_file : string trace_replace",
"trace_size : number",
"trace_size : number T_K",
"trace_size : number T_M",
"trace_replace :",
"trace_replace : T_REPLACE",
"trace_limits :",
"trace_limits : T_SIZE trace_size T_FILES number",
"trace_trace_options_none : T_NONE",
"trace_trace_options_none : trace_trace_options",
"trace_trace_options : trace_option",
"trace_trace_options : trace_trace_options trace_trace_option",
"trace_trace_options : trace_trace_options T_EXCEPT trace_trace_option",
"trace_trace_option : trace_option",
"trace_trace_option : trace_option_global",
"trace_options_none : T_NONE",
"trace_options_none : trace_options",
"trace_options : trace_option",
"trace_options : trace_options trace_option",
"trace_option_global : T_NOSTAMP",
"trace_option_global : T_MARK",
"trace_option_global : T_PARSE",
"trace_option_global : T_ADV",
"trace_option : T_ALL",
"trace_option : T_GENERAL",
"trace_option : T_INTERNAL",
"trace_option : T_EXTERNAL",
"trace_option : T_ROUTE",
"trace_option : T_UPDATE",
"trace_option : T_TASK",
"trace_option : T_TIMER",
"trace_option : T_PROTO",
"trace_option : T_KERNEL",
"trace_option : T_BGP",
"trace_option : T_ISIS",
"trace_option : T_IDRP",
"define_order :",
"$$1 :",
"define_statement : T_MARTIANS $$1 '{' martian_list '}' L_EOS",
"define_statement : T_RDI osi_rdi L_EOS",
"define_statement : osi_address_name osi_nsap L_EOS",
"define_statement : T_AS as L_EOS",
"define_statement : T_ROUTERID ip_addr L_EOS",
"martian_list :",
"martian_list : martian_list martian L_EOS",
"martian_list : martian_list error L_EOS",
"martian : host_mask",
"martian : network_mask",
"martian : default_mask",
"option_order :",
"option_statement : T_OPTIONS option_list L_EOS",
"option_list : option",
"option_list : option_list option",
"option : T_NOINSTALL",
"option : T_GENDEFAULT preference_option",
"option : T_NOSEND",
"option : T_NORESOLV",
"option : T_SYSLOG syslog_mask",
"syslog_mask : syslog_level",
"syslog_mask : T_UPTO syslog_level",
"syslog_mask : syslog_mask syslog_level",
"syslog_level : T_EMERG",
"syslog_level : T_ALERT",
"syslog_level : T_CRIT",
"syslog_level : T_ERR",
"syslog_level : T_WARNING",
"syslog_level : T_NOTICE",
"syslog_level : T_INFO",
"syslog_level : T_DEBUG",
"interface_order :",
"$$2 :",
"interface_statement : T_INTERFACES $$2 '{' interface_stmts '}' L_EOS",
"interface_stmts :",
"interface_stmts : interface_stmts interface_stmt L_EOS",
"interface_stmts : interface_stmts error L_EOS",
"interface_stmt : T_OPTIONS interface_options",
"interface_stmt : T_INTERFACE interface_all_list interface_define_options",
"$$3 :",
"interface_stmt : T_DEFINE host $$3 interface_type_options interface_common_options",
"interface_options : interface_option",
"interface_options : interface_options interface_option",
"interface_option : T_STRICTIFS",
"interface_option : T_SCANINTERVAL time",
"interface_type_options : T_BROADCAST host",
"interface_type_options : T_POINTOPOINT host",
"interface_type_options :",
"interface_common_options :",
"interface_common_options : interface_common_options interface_common_option",
"interface_common_option : T_NETMASK mask",
"interface_common_option : T_MULTICAST",
"interface_define_options : interface_define_option",
"interface_define_options : interface_define_options interface_define_option",
"interface_define_option : T_PREFERENCE preference",
"interface_define_option : T_DOWN T_PREFERENCE preference",
"interface_define_option : T_PASSIVE",
"interface_define_option : T_SIMPLEX",
"interface_define_option : T_REJECT",
"interface_define_option : T_BLACKHOLE",
"interface_list_option :",
"interface_list_option : T_INTERFACE interface_list",
"interface_gateway_list : interface_list_option",
"interface_gateway_list : T_GATEWAY gateway_list",
"interface_all_list : T_ALL",
"interface_all_list : interface_list",
"interface_list : interface_all",
"interface_list : interface_list interface_all",
"interface_all : interface_all_adv",
"interface_all_adv : host_name",
"interface_all_adv : addr",
"interface_local : interface_addr",
"interface_addr : addr",
"interface_addr : host_name",
"proto_order :",
"proto_statement : redirect_statement L_EOS",
"proto_statement : bgp_statement L_EOS",
"proto_statement : isis_statement L_EOS",
"proto_statement : idrp_statement",
"$$4 :",
"isis_statement : T_ISIS $$4 isis_option isis_group",
"isis_option : onoff_option",
"isis_option : T_IP",
"isis_option : T_ISO",
"isis_option : T_DUAL",
"isis_group :",
"isis_group : '{' isis_group_stmts '}'",
"isis_group_stmts :",
"isis_group_stmts : isis_group_stmts isis_group_stmt L_EOS",
"isis_group_stmts : isis_group_stmts error L_EOS",
"isis_group_stmt : isis_level",
"$$5 :",
"isis_group_stmt : T_CIRCUIT string $$5 isis_coptions",
"isis_group_stmt : T_SYSTEMID string",
"isis_group_stmt : T_TRACEOPTIONS isis_trace_options",
"isis_group_stmt : T_SNPA number",
"isis_group_stmt : T_AREA string",
"isis_group_stmt : T_IPREACH isis_level ipreach_type network mask T_METRIC number",
"isis_group_stmt : T_PREFIX prefix_type T_METRIC number string",
"isis_group_stmt : T_INTDOMINFO string",
"isis_group_stmt : T_SET L_HNAME number",
"isis_level : T_LEVEL number",
"isis_level :",
"isis_mode : T_IP",
"isis_mode : T_ISO",
"isis_mode : T_DUAL",
"isis_coptions :",
"isis_coptions : isis_coptions isis_coption",
"isis_coption : T_METRIC isis_level number",
"isis_coption : T_PRIORITY isis_level number",
"ipreach_type : T_INTERNAL",
"ipreach_type : T_EXTERNAL",
"ipreach_type : TISIS_SUMMARY",
"prefix_type : T_INTERNAL",
"prefix_type : T_EXTERNAL",
"isis_trace_options : isis_trace_option",
"isis_trace_options : isis_trace_options isis_trace_option",
"isis_trace_options : isis_trace_options T_EXCEPT isis_trace_option",
"isis_trace_option : T_ALL",
"isis_trace_option : TISIS_IIH",
"isis_trace_option : TISIS_DUMPLSP",
"isis_trace_option : TISIS_EVENTS",
"isis_trace_option : TISIS_LANADJ",
"isis_trace_option : TISIS_FLOODING",
"isis_trace_option : TISIS_BUILDLSP",
"isis_trace_option : TISIS_CSNP",
"isis_trace_option : TISIS_PSNP",
"isis_trace_option : TISIS_LSPINPUT",
"isis_trace_option : TISIS_P2PADJ",
"isis_trace_option : T_SPF",
"isis_trace_option : TISIS_LSPDB",
"isis_trace_option : T_ROUTE",
"isis_trace_option : T_UPDATE",
"isis_trace_option : TISIS_PATHS",
"isis_trace_option : TISIS_LSPCONTENT",
"$$6 :",
"bgp_statement : T_BGP $$6 onoff_option bgp_group",
"bgp_group :",
"bgp_group : '{' bgp_group_stmts '}'",
"bgp_group_stmts :",
"bgp_group_stmts : bgp_group_stmts bgp_group_stmt L_EOS",
"bgp_group_stmts : bgp_group_stmts error L_EOS",
"bgp_group_stmt : T_PREFERENCE preference",
"bgp_group_stmt : T_DEFAULTMETRIC metric",
"bgp_group_stmt : T_TRACEOPTIONS bgp_trace_options",
"$$7 :",
"$$8 :",
"bgp_group_stmt : T_GROUP T_TYPE bgp_linktype T_PEERAS as $$7 bgp_peer_options $$8 '{' bgp_peer_stmts '}'",
"bgp_peer_options :",
"bgp_peer_options : bgp_peer_options bgp_peer_option",
"bgp_peer_stmts :",
"bgp_peer_stmts : bgp_peer_stmts bgp_peer_stmt L_EOS",
"bgp_peer_stmts : bgp_peer_stmts error L_EOS",
"$$9 :",
"bgp_peer_stmt : T_NEIGHBOR $$9 host bgp_peer_options",
"$$10 :",
"bgp_peer_stmt : T_ALLOW $$10 '{' bgp_allow_list '}'",
"bgp_peer_option : T_METRICOUT metric",
"bgp_peer_option : T_LOCALAS as",
"bgp_peer_option : T_NOGENDEFAULT",
"bgp_peer_option : T_GATEWAY gateway",
"bgp_peer_option : T_PREFERENCE preference",
"bgp_peer_option : T_LCLADDR interface_local",
"bgp_peer_option : T_HOLDTIME time",
"bgp_peer_option : T_TRACEOPTIONS bgp_trace_options",
"bgp_peer_option : T_VERSION L_NUMBER",
"bgp_peer_option : T_PASSIVE",
"bgp_peer_option : T_DEFAULTIN",
"bgp_peer_option : T_DEFAULTOUT",
"bgp_peer_option : T_KEEPALL",
"bgp_peer_option : T_SENDBUF bgp_kbufsize",
"bgp_peer_option : T_RECVBUF bgp_kbufsize",
"bgp_peer_option : T_SPOOLBUF number",
"bgp_kbufsize : number",
"bgp_linktype : T_INTERNAL",
"bgp_linktype : T_EXTERNAL",
"bgp_linktype : T_IGP",
"bgp_linktype : T_TEST",
"bgp_trace_options : trace_options",
"bgp_prop_init : T_BGP",
"bgp_allow_list :",
"bgp_allow_list : bgp_allow_list bgp_allow L_EOS",
"bgp_allow_list : bgp_allow_list error L_EOS",
"bgp_allow : all_mask",
"bgp_allow : host_mask",
"bgp_allow : network_mask",
"$$11 :",
"idrp_statement : T_IDRP $$11 onoff_option idrp_group L_EOS",
"idrp_group_stmt : T_TRACEOPTIONS idrp_trace_options",
"idrp_group_stmt : T_LOCALNODE '{' idrp_local_node '}'",
"$$12 :",
"idrp_group_stmt : T_GROUP $$12 idrp_group_options '{' idrp_peer_stmts '}'",
"idrp_group_stmt : T_OSILOCAL '{' idrp_local_routes '}'",
"idrp_peer_stmts :",
"idrp_peer_stmts : idrp_peer_stmts idrp_peer_stmt L_EOS",
"idrp_peer_stmts : idrp_peer_stmts error L_EOS",
"idrp_local_node :",
"idrp_local_node : idrp_local_node_stmts",
"idrp_local_node_stmts :",
"idrp_local_node_stmts : idrp_local_node_stmts idrp_local_node_stmt L_EOS",
"idrp_local_node_stmts : idrp_local_node_stmts error L_EOS",
"idrp_local_node_stmt :",
"idrp_local_node_stmt : T_PROTOSUPPORT idrp_proto_supp",
"idrp_local_node_stmt : T_ROUTESERVER onoff_option",
"idrp_local_node_stmt : T_MULTIEXIT onoff_option",
"idrp_local_node_stmt : idrp_auth",
"idrp_local_node_stmt : idrp_sock_support",
"idrp_local_node_stmt : T_OUTPDUS L_NUMBER",
"idrp_local_node_stmt : T_LISTENOPEN onoff_option",
"idrp_local_node_stmt : T_HOLDTIME L_NUMBER",
"idrp_local_node_stmt : T_CLOSEWAIT L_NUMBER",
"idrp_local_node_stmt : T_REXMIT L_NUMBER",
"idrp_local_node_stmt : T_RIBCHECK L_NUMBER",
"idrp_local_node_stmt : T_MINADV L_NUMBER",
"idrp_local_node_stmt : T_MINADVRD L_NUMBER",
"idrp_auth : T_AUTHTYPE L_NUMBER",
"idrp_auth : T_AUTHTYPE L_NUMBER T_AUTHCODE L_HEXSTRING",
"idrp_sock_support :",
"idrp_sock_support : T_PROTOSOCK idrp_sock_options",
"idrp_group :",
"idrp_group : '{' idrp_group_stmts '}'",
"idrp_group_stmts :",
"idrp_group_stmts : idrp_group_stmts idrp_group_stmt L_EOS",
"idrp_group_stmts : idrp_group_stmts error L_EOS",
"$$13 :",
"idrp_peer_stmt : T_NEIGHBOR $$13 onoff_option osi_address host T_RDI osi_address idrp_intf_option idrp_sock_options idrp_peer_options",
"idrp_local_routes :",
"idrp_local_routes : idrp_local_routes idrp_local_route L_EOS",
"idrp_local_routes : idrp_local_routes error L_EOS",
"idrp_local_route : osi_prefix osi_prefix",
"idrp_local_route : osi_prefix osi_prefix idrp_route_options",
"idrp_local_route : osi_prefix osi_prefix T_IP idrp_route_options",
"idrp_local_route : osi_prefix osi_prefix idrp_dist_options",
"idrp_local_route : osi_prefix osi_prefix idrp_route_options idrp_dist_options",
"idrp_route_options : idrp_route_options idrp_route_option L_EOS",
"idrp_route_options : idrp_route_option error L_EOS",
"idrp_route_option : T_SNPA byte_string",
"idrp_route_option : T_MULTIEXIT number",
"idrp_route_option : T_MULTIEXIT number T_SNPA byte_string",
"idrp_route_option : T_SNPA byte_string T_MULTIEXIT number",
"idrp_route_option : T_ROUTESERVER",
"idrp_dist_options : idrp_dist_options idrp_dist_option L_EOS",
"idrp_dist_options : idrp_dist_option error L_EOS",
"idrp_dist_option :",
"idrp_dist_option : T_PROHIBITDIST idrp_dist_list",
"idrp_dist_option : T_ALLOWDIST idrp_dist_list",
"idrp_dist_list : idrp_dist_list idrp_dist_rdi L_EOS",
"idrp_dist_list : idrp_dist_rdi error L_EOS",
"idrp_dist_rdi : osi_prefix",
"idrp_intf_option :",
"idrp_intf_option : T_INTERFACE host",
"idrp_intf_option : T_INTERFACE osi_address",
"idrp_intf_option : T_INTERFACE host osi_address",
"idrp_intf_option : T_INTERFACE osi_address host",
"idrp_group_options : idrp_group_option",
"idrp_group_options : idrp_group_options idrp_group_option",
"idrp_group_options : idrp_peer_option",
"idrp_group_options : idrp_peer_options idrp_peer_option",
"idrp_group_option : T_RDI osi_rdi",
"idrp_group_option : T_INTERNAL",
"idrp_group_option : T_EXTERNAL",
"idrp_sock_options :",
"idrp_sock_options : idrp_sock_options idrp_sock_option",
"idrp_sock_options : idrp_sock_option",
"idrp_sock_option : T_IP",
"idrp_sock_option : T_UDP",
"idrp_sock_option : T_ISO",
"idrp_sock_option : T_IDRP",
"idrp_proto_supp : T_ISO",
"idrp_proto_supp : T_IP",
"idrp_proto_supp : T_IP T_ISO",
"idrp_proto_supp : T_IP T_ISO T_PIP T_SIP",
"idrp_proto_supp : T_PIP",
"idrp_proto_supp : T_SIP",
"idrp_peer_options :",
"idrp_peer_options : idrp_peer_options idrp_peer_option",
"idrp_peer_option : T_TRACEOPTIONS idrp_trace_options",
"osi_address : osi_nsap",
"osi_address : osi_address_name osi_nsap",
"osi_nsap : L_HEXSTRING",
"osi_rdi : L_HEXSTRING",
"osi_prefix : L_HEXSTRING",
"osi_prefix : L_HEXSTRING_ODD",
"osi_address_name : T_NET",
"idrp_trace_options : trace_options",
"$$14 :",
"redirect_statement : T_REDIRECT $$14 onoff_option redirect_group",
"redirect_group :",
"redirect_group : '{' redirect_group_stmts '}'",
"redirect_group_stmts :",
"redirect_group_stmts : redirect_group_stmts redirect_group_stmt L_EOS",
"redirect_group_stmts : redirect_group_stmts error L_EOS",
"redirect_group_stmt : T_PREFERENCE preference",
"redirect_group_stmt : T_INTERFACE interface_all_list redirect_interface_options",
"redirect_group_stmt : T_TRUSTEDGATEWAYS gateway_list",
"redirect_group_stmt : T_TRACEOPTIONS redirect_trace_options",
"redirect_interface_options : redirect_interface_option",
"redirect_interface_options : redirect_interface_options redirect_interface_option",
"redirect_interface_option : T_NOREDIRECTS",
"redirect_trace_options : trace_options",
"route_order :",
"$$15 :",
"route_statement : T_STATIC $$15 '{' route_stmts '}'",
"route_stmts : route_stmt L_EOS",
"route_stmts : route_stmts route_stmt L_EOS",
"route_stmts : error L_EOS",
"route_stmt : route_dest T_GATEWAY gateway_list interface_list_option preference_option rts_options",
"route_stmt : route_dest T_INTERFACE interface_all preference_option rts_options",
"route_dest : host_mask",
"route_dest : network_mask",
"route_dest : T_DEFAULT",
"route_dest : T_ISO T_DEFAULT",
"rts_options :",
"rts_options : rts_options rts_option",
"rts_option : T_RETAIN",
"rts_option : T_REJECT",
"rts_option : T_BLACKHOLE",
"rts_option : T_NOINSTALL",
"control_order :",
"control_statement : T_IMPORT T_PROTO control_exterior T_AS as import_option L_EOS",
"control_statement : T_IMPORT T_PROTO T_BGP aspath_match import_option L_EOS",
"control_statement : T_IMPORT T_PROTO import_interior interface_gateway_list import_option L_EOS",
"control_statement : T_EXPORT T_PROTO control_exterior T_AS as prop_source_option L_EOS",
"control_statement : T_EXPORT T_PROTO export_interior interface_gateway_list prop_source_option L_EOS",
"control_exterior : proto_exterior",
"import_interior : proto_interior",
"import_option : T_RESTRICT",
"import_option : preference_option '{' import_list '}'",
"import_list :",
"import_list : import_list import_listen L_EOS",
"import_list : import_list error L_EOS",
"$$16 :",
"import_listen : $$16 dest_mask preference_restrict_option",
"export_interior : proto_interior",
"prop_source_option : T_RESTRICT",
"prop_source_option : metric_option '{' prop_source_list '}'",
"prop_source_list :",
"prop_source_list : prop_source_list prop_source L_EOS",
"prop_source_list : prop_source_list error L_EOS",
"prop_source : T_PROTO proto_exterior T_AS as prop_metric_option",
"prop_source : T_PROTO aspath_prop_init aspath_match prop_metric_option",
"prop_source : T_PROTO tag_prop_init T_TAG tag prop_metric_option",
"prop_source : T_PROTO prop_direct interface_list_option prop_metric_option",
"prop_source : T_PROTO prop_static interface_list_option prop_metric_option",
"prop_source : T_PROTO prop_kernel interface_list_option prop_metric_option",
"prop_source : T_PROTO prop_default prop_metric_option",
"prop_direct : T_DIRECT",
"prop_static : T_STATIC",
"prop_kernel : T_KERNEL",
"prop_default : T_DEFAULT",
"prop_metric_option : T_RESTRICT",
"prop_metric_option : metric_option prop_restrict_list_option",
"prop_restrict_list_option :",
"prop_restrict_list_option : '{' prop_restrict_list '}'",
"prop_restrict_list :",
"prop_restrict_list : prop_restrict_list prop_restrict L_EOS",
"prop_restrict_list : prop_restrict_list error L_EOS",
"$$17 :",
"prop_restrict : $$17 dest_mask metric_restrict_option",
"addr : T_NOP",
"addr : ip_addr",
"addr : iso_addr",
"dest_mask : all_mask",
"dest_mask : default_mask",
"dest_mask : host_mask",
"dest_mask : network_mask",
"all_mask : T_ALL",
"default_mask : T_NOP1",
"default_mask : T_DEFAULT",
"default_mask : T_ISO T_DEFAULT",
"mask : T_NOP",
"mask : in_addr",
"mask : iso_addr",
"gateway_list : gateway",
"gateway_list : gateway_list gateway",
"gateway : host",
"host : host_name",
"host : addr",
"host_mask : T_HOST host",
"network : host_name",
"network : addr",
"network_mask : network",
"network_mask : network T_MASKLEN number",
"network_mask : network T_MASK mask",
"ip_addr : in_addr",
"in_addr : L_NUMBER",
"in_addr : byte_string",
"host_name : L_HNAME",
"host_name : L_KEYWORD",
"host_name : string",
"proto_interior : T_REDIRECT",
"proto_exterior : T_NOP",
"proto_exterior : bgp_prop_init",
"onoff_option : T_ON",
"onoff_option : T_OFF",
"metric : number",
"metric : T_INFINITY",
"metric_option :",
"metric_option : T_METRIC metric",
"metric_restrict_option :",
"metric_restrict_option : T_RESTRICT",
"metric_restrict_option : T_METRIC metric",
"preference_option :",
"preference_option : T_PREFERENCE preference",
"preference_restrict_option : preference_option",
"preference_restrict_option : T_RESTRICT",
"preference : L_NUMBER",
"string : L_STRING",
"number : L_NUMBER",
"number : byte_string",
"byte_string : L_HEXSTRING",
"byte_string : L_OCTETSTRING",
"time : L_NUMBER",
"time : L_NUMBER ':' L_NUMBER",
"time : L_NUMBER ':' L_NUMBER ':' L_NUMBER",
"port : L_NUMBER",
"port : L_KEYWORD",
"as : L_NUMBER",
"as_list : as",
"as_list : as_list as",
"as_list_option :",
"as_list_option : T_AS as_list",
"tag_as_option :",
"tag_as_option : T_TAG tag_as",
"tag_as : tag",
"tag_as : T_AS",
"tag_as : T_AS number",
"tag_option :",
"tag_option : T_TAG tag",
"tag : number",
"tag_prop_init : proto_exterior",
"aspath_prop_init : proto_exterior",
"$$18 :",
"aspath_match : T_ASPATH $$18 aspath_regex T_ORIGIN aspath_origin",
"aspath_origin : T_ANY",
"aspath_origin : aspath_origin_list",
"aspath_origin_list : aspath_origins",
"aspath_origin_list : aspath_origin_list '|' aspath_origins",
"aspath_origins : T_IGP",
"aspath_origins : T_EGP",
"aspath_origins : T_INCOMPLETE",
"aspath_regex : aspath_sum",
"aspath_regex : aspath_sum '|' aspath_regex",
"aspath_sum : aspath_term",
"aspath_sum : aspath_term aspath_sum",
"aspath_term : aspath_symbol",
"aspath_term : aspath_symbol '*'",
"aspath_term : aspath_symbol '+'",
"aspath_term : aspath_symbol '?'",
"aspath_term : aspath_symbol '{' aspath_range '}'",
"aspath_symbol : as",
"aspath_symbol : '.'",
"aspath_symbol : '(' aspath_regex ')'",
"aspath_range : number",
"aspath_range : number ','",
"aspath_range : number ',' number",
"iso_addr : L_ISOADDR",
};
#endif
#define yyclearin (yychar=(-1))
#define yyerrok (yyerrflag=0)
#ifdef YYSTACKSIZE
#ifndef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#endif
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 500
#define YYMAXDEPTH 500
#endif
#endif
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short yyss[YYSTACKSIZE];
YYSTYPE yyvs[YYSTACKSIZE];
#define yystacksize YYSTACKSIZE
#line 4044 "parser.y"

/*
 *	Log any parsing errors
 */
static void
yyerror(s)
const char *s;
{
    byte *cp;

    trace(TR_ALL, 0, NULL);
    tracef("parse: %s ",
	   parse_where());

    switch (yychar) {
    case L_HEXSTRING:
	tracef("%s at '",
	       s);
	for (cp = yylval.hex.ptr; (cp - yylval.hex.ptr) < yylval.hex.len; cp++) {
	    tracef("%02x", *cp);
	}
	tracef("'");
	break;

    case L_OCTETSTRING:
	tracef("%s at '",
	       s);
	for (cp = yylval.hex.ptr; (cp - yylval.hex.ptr) < yylval.hex.len; cp++) {
	    tracef("%s%u",
		   (cp == yylval.hex.ptr) ? "" : ".",
		   *cp);
	}
	tracef("'");
	break;

    case L_NUMBER:
	tracef("%s at '%d'",
	       s,
	       yylval.num);
	break;

    case L_EOS:
	tracef("%s at 'end-of-statement'",
	       s);
	break;

    case L_ERROR:
	tracef("%s",
	       parse_error);
	break;

#ifdef	YYEOF
    case YYEOF:
#else	/* YYEOF */
    case 0:
#endif	/* YYEOF */
	tracef("%s at 'end-of-file'",
		   s);
	break;

    default:
	if (!parse_keyword_lookup(yychar)) {
#if	YYDEBUG != 0
#ifdef	YYTRANSLATE
	    tracef("%s at '%s'",
		   s,
		   yytname[YYTRANSLATE(yychar)]);
#else	/* YYTRANSLATE */
	    tracef("%s at '%s'",
		   s,
		   yyname[yychar]);
#endif	/* YYTRANSLATE */
#else	/* YYDEBUG */
	    tracef("%s",
		   s);
#endif	/* YYDEBUG */
	    break;
	}
	/* Fall Through */

    case L_STRING:
    case L_HNAME:
    case L_KEYWORD:
	tracef("%s at '%s' length %d",
	       s,
	       yylval.str.ptr,
	       yylval.str.len);
	break;

#ifdef	YYEMPTY
    case YYEMPTY:
	tracef("%s",
	       s);
	break;
#endif	/* YYEMPTY */
    }
    trace(TR_ALL, LOG_ERR, NULL);
    trace(TR_ALL, 0, NULL);
}



/*
 * ------------------------------------------------------------------------
 * 
 * 	GateD, Release 3
 * 
 * 	Copyright (c) 1990,1991,1992,1993 by Cornell University
 * 	    All rights reserved.
 * 
 * 	THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY
 * 	EXPRESS OR IMPLIED WARRANTIES, INCLUDING, WITHOUT
 * 	LIMITATION, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * 	AND FITNESS FOR A PARTICULAR PURPOSE.
 * 
 * 	Royalty-free licenses to redistribute GateD Release
 * 	3 in whole or in part may be obtained by writing to:
 * 
 * 	    GateDaemon Project
 * 	    Information Technologies/Network Resources
 * 	    200 CCC
 * 	    Cornell University
 * 	    Ithaca, NY  14853-2601  USA
 * 
 * 	GateD is based on Kirton's EGP, UC Berkeley's routing
 * 	daemon	 (routed), and DCN's HELLO routing Protocol.
 * 	Development of GateD has been supported in part by the
 * 	National Science Foundation.
 * 
 * 	Please forward bug fixes, enhancements and questions to the
 * 	gated mailing list: gated-people@gated.cornell.edu.
 * 
 * 	Authors:
 * 
 * 		Jeffrey C Honig <jch@gated.cornell.edu>
 * 		Scott W Brim <swb@gated.cornell.edu>
 * 
 * ------------------------------------------------------------------------
 * 
 *       Portions of this software may fall under the following
 *       copyrights:
 * 
 * 	Copyright (c) 1988 Regents of the University of California.
 * 	All rights reserved.
 * 
 * 	Redistribution and use in source and binary forms are
 * 	permitted provided that the above copyright notice and
 * 	this paragraph are duplicated in all such forms and that
 * 	any documentation, advertising materials, and other
 * 	materials related to such distribution and use
 * 	acknowledge that the software was developed by the
 * 	University of California, Berkeley.  The name of the
 * 	University may not be used to endorse or promote
 * 	products derived from this software without specific
 * 	prior written permission.  THIS SOFTWARE IS PROVIDED
 * 	``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES,
 * 	INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
 * 	MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */
#line 1718 "y.tab.c"
#define YYABORT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab
int
yyparse()
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register char *yys;
    extern char *getenv();

    if (yys = getenv("YYDEBUG"))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if (yyn = yydefred[yystate]) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("yydebug: state %d, reading %d (%s)\n", yystate,
                    yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("yydebug: state %d, shifting to state %d\n",
                    yystate, yytable[yyn]);
#endif
        if (yyssp >= yyss + yystacksize - 1)
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#ifdef lint
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#ifdef lint
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("yydebug: state %d, error recovery shifting\
 to state %d\n", *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yyss + yystacksize - 1)
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("yydebug: error recovery discarding state %d\n",
                            *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("yydebug: state %d, error recovery discards token %d (%s)\n",
                    yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("yydebug: state %d, reducing by rule %d (%s)\n",
                yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 13:
#line 344 "parser.y"
{
				yyerrok;
			}
break;
case 15:
#line 353 "parser.y"
{
#if	YYDEBUG != 0
			    if (yyvsp[-1].num == T_OFF) {
				yydebug = 0;
			    } else {
				yydebug = 1;
			    }
#endif	/* YYDEBUG */
			}
break;
case 16:
#line 363 "parser.y"
{
#if	YYDEBUG != 0
			    if (yyvsp[-1].num < 0 || yyvsp[-1].num > PS_MAX) {
				(void) sprintf(parse_error, "invalid yystate value: %d",
					       yyvsp[-1].num);
				PARSE_ERROR;
			    }
			    parse_state = yyvsp[-1].num;
#endif	/* YYDEBUG */
			}
break;
case 17:
#line 374 "parser.y"
{
#if	YYDEBUG != 0
			    task_quit(0);
#endif	/* YYDEBUG */
			}
break;
case 18:
#line 384 "parser.y"
{
			    if (!BIT_TEST(task_state, TASKS_TEST)) {
				if (yyvsp[-1].flag) {
				    if (trace_flags) {
					trace_flags = trace_flags_save = yyvsp[-1].flag;
					trace_display(trace_flags, TR_PARSE);
				    } else if (trace_opened) {
					trace_flags = trace_flags_save = yyvsp[-1].flag;
					trace_display(trace_flags, TR_PARSE);
				    }
				} else {
				    if (trace_flags) {
					trace_flags = trace_flags_save = yyvsp[-1].flag;
					trace_display(trace_flags, TR_PARSE);
					trace_off();
				    }
				}
			    }
			}
break;
case 19:
#line 404 "parser.y"
{
			    if (!BIT_TEST(task_state, TASKS_TEST)) {
				if (yyvsp[-2].str.len) {
				    int append = (int) yyvsp[-2].str.type;

				    if (trace_flags) {
					trace_flags_save = trace_flags;
					trace_off();
				    }
				    trace_on(yyvsp[-2].str.ptr, append);
				}
			    }
			}
break;
case 20:
#line 420 "parser.y"
{
			    yyval.str.len = 0;
			}
break;
case 21:
#line 424 "parser.y"
{
			    yyval.str = yyvsp[-1].str;
			    yyval.str.type = yyvsp[0].num;
			}
break;
case 23:
#line 432 "parser.y"
{
			    yyval.num = yyvsp[-1].num * 1024;
			}
break;
case 24:
#line 436 "parser.y"
{
			    yyval.num = yyvsp[-1].num * 1024 * 1024;
			}
break;
case 25:
#line 441 "parser.y"
{ yyval.num = TRUE; }
break;
case 26:
#line 442 "parser.y"
{ yyval.num = FALSE; }
break;
case 28:
#line 447 "parser.y"
{
			    if (parse_limit_check("file-size",
						  (u_int) yyvsp[-2].num,
						  TRACE_LIMIT_FILE_SIZE)) {
				PARSE_ERROR;
			    }
			    trace_limit_size = yyvsp[-2].num;

			    if (parse_limit_check("files",
						  (u_int) yyvsp[0].num,
						  TRACE_LIMIT_FILE_COUNT)) {
				PARSE_ERROR;
			    }
			    trace_limit_files = yyvsp[0].num;
			}
break;
case 29:
#line 466 "parser.y"
{
			    yyval.flag = (flag_t) 0;
			}
break;
case 30:
#line 470 "parser.y"
{
			    yyval.flag = yyval.flag;
			}
break;
case 32:
#line 478 "parser.y"
{
			    yyval.flag = yyvsp[-1].flag | yyvsp[0].flag;
			}
break;
case 33:
#line 482 "parser.y"
{
			    yyval.flag = yyvsp[-2].flag & ~yyvsp[0].flag;
			}
break;
case 36:
#line 494 "parser.y"
{
			    yyval.flag = (flag_t) 0;
			}
break;
case 39:
#line 502 "parser.y"
{
			    yyval.flag = yyvsp[-1].flag | yyvsp[0].flag;
			}
break;
case 40:
#line 510 "parser.y"
{
			    yyval.flag = TR_NOSTAMP;
			}
break;
case 41:
#line 514 "parser.y"
{
			    yyval.flag = TR_MARK;
			}
break;
case 42:
#line 518 "parser.y"
{
			    yyval.flag = TR_PARSE;
			}
break;
case 43:
#line 522 "parser.y"
{
#ifdef	TR_ADV
			    yyval.flag = TR_ADV;
#else	/* TR_ADV */
			    yyval.flag = 0;
#endif	/* TR_ADV */
			}
break;
case 44:
#line 533 "parser.y"
{
			    yyval.flag = TR_ALL;
			}
break;
case 45:
#line 537 "parser.y"
{
			    yyval.flag = TR_INT|TR_EXT|TR_RT;
			}
break;
case 46:
#line 541 "parser.y"
{
			    yyval.flag = TR_INT;
			}
break;
case 47:
#line 545 "parser.y"
{
			    yyval.flag = TR_EXT;
			}
break;
case 48:
#line 549 "parser.y"
{
			    yyval.flag = TR_RT;
			}
break;
case 49:
#line 553 "parser.y"
{
			    yyval.flag = TR_UPDATE;
			}
break;
case 50:
#line 557 "parser.y"
{
			    yyval.flag = TR_TASK;
			}
break;
case 51:
#line 561 "parser.y"
{
			    yyval.flag = TR_TIMER;
			}
break;
case 52:
#line 565 "parser.y"
{
			    yyval.flag = TR_PROTOCOL;
			}
break;
case 53:
#line 569 "parser.y"
{
			    yyval.flag = TR_KRT;
			}
break;
case 54:
#line 573 "parser.y"
{
			    yyval.flag = TR_BGP;
			}
break;
case 55:
#line 577 "parser.y"
{
			    yyval.flag = TR_ISIS;
			}
break;
case 56:
#line 580 "parser.y"
{ yyval.flag = TR_IDRP; }
break;
case 57:
#line 586 "parser.y"
{
				if (parse_new_state(PS_DEFINE)) {
					PARSE_ERROR;
				}
			}
break;
case 58:
#line 595 "parser.y"
{
			    parse_contig_masks = FALSE;
			}
break;
case 59:
#line 599 "parser.y"
{
			    parse_contig_masks = TRUE;
			    if (parse_adv_append(&martian_list, yyvsp[-2].adv, TRUE)) {
				PARSE_ERROR;
			    }
			}
break;
case 60:
#line 608 "parser.y"
{
				/* RDI indicates the Routing Domain IDRP peer in
				 * there for both IP and CLNP 
				 * - Kludge for now to save as AS_RDI until
				 * - more parsing code is written for IP 
				 */
 
                                bcopy(yyvsp[-1].hex.ptr,&rt_rdi.isoa_genaddr, yyvsp[-1].hex.len);
                                rt_rdi.isoa_len = yyvsp[-1].hex.len;
				trace (TR_PARSE,0,"rdi xxxx configured for idrp %A ", 
					sockbuild_iso(rt_rdi.isoa_genaddr, rt_rdi.isoa_len));
				rt_as_rdi.isoa_len = yyvsp[-1].hex.len - 2;
				bcopy(yyvsp[-1].hex.ptr,&rt_as_rdi.isoa_genaddr,rt_as_rdi.isoa_len);
				rt_as_rdi.isoa_family = AF_ISO;
				trace (TR_PARSE,0, "idrp finished call to rdi in parser.y");
                        }
break;
case 61:
#line 625 "parser.y"
{ 
				/* need an NET for this node 
				 * if we configure multiple ISO host addresses, 
				 * we need to nominate one as NET.
				 * Eventually maybe this could be discovered
				 */

                                bcopy(yyvsp[-1].hex.ptr, rt_net.isoa_genaddr, yyvsp[-1].hex.len);
                                rt_net.isoa_len = yyvsp[-1].hex.len;
                        }
break;
case 62:
#line 637 "parser.y"
{
			    if (inet_autonomous_system != yyvsp[-1].as) {
				if (inet_autonomous_system) {
				    inet_as_unlink(inet_autonomous_system);
				}
				inet_autonomous_system = yyvsp[-1].as;
				inet_as_link(inet_autonomous_system);
			    }
			}
break;
case 63:
#line 647 "parser.y"
{
			    if (inet_parse_routerid(yyvsp[-1].sockaddr, parse_error)) {
				PARSE_ERROR;
			    }
			}
break;
case 64:
#line 656 "parser.y"
{
			    yyval.adv = (adv_entry *) 0;
			}
break;
case 65:
#line 660 "parser.y"
{
			    yyval.adv = adv_alloc(ADVFT_DM, (proto_t) 0);
			    yyval.adv->adv_dm = yyvsp[-1].dm;
			    yyval.adv = parse_adv_dm_append(yyvsp[-2].adv, yyval.adv);
			    if (!yyval.adv) {
				PARSE_ERROR;
			    }
			}
break;
case 66:
#line 669 "parser.y"
{
			    yyerrok;
			}
break;
case 70:
#line 683 "parser.y"
{
				if (parse_new_state(PS_OPTIONS)) {
					PARSE_ERROR;
				}
			}
break;
case 74:
#line 700 "parser.y"
{
			    krt_install = FALSE;
			}
break;
case 75:
#line 704 "parser.y"
{
			    rt_default_needed = TRUE;
			    if (PARSE_METRIC_ISSET(&yyvsp[0].metric)) {
				rt_default_rtparms.rtp_preference = yyvsp[0].metric.metric;
			    }
			}
break;
case 76:
#line 711 "parser.y"
{
			    task_newstate(TASKS_NOSEND, 0);
			}
break;
case 77:
#line 715 "parser.y"
{
			    task_newstate(TASKS_NORESOLV, 0);
			}
break;
case 78:
#line 719 "parser.y"
{
#ifdef	LOG_DAEMON
			    (void) setlogmask(yyvsp[0].num);
#else	/* LOG_DAEMON */
			    (void) sprintf(parse_error, "system does not support setlogmask()");
			    PARSE_ERROR;
#endif	/* LOG_DAEMON */
			}
break;
case 79:
#line 731 "parser.y"
{
#ifdef	LOG_DAEMON
			    yyval.num = LOG_MASK(yyvsp[0].num);
#endif	/* LOG_DAEMON */
			}
break;
case 80:
#line 737 "parser.y"
{
#ifdef	LOG_DAEMON
			    yyval.num = LOG_UPTO(yyvsp[0].num);
#endif	/* LOG_DAEMON */
			}
break;
case 81:
#line 743 "parser.y"
{
#ifdef	LOG_DAEMON
			    yyval.num = yyvsp[-1].num | LOG_MASK(yyvsp[0].num);
#endif	/* LOG_DAEMON */
			}
break;
case 82:
#line 751 "parser.y"
{
			    yyval.num = LOG_EMERG;
			}
break;
case 83:
#line 755 "parser.y"
{
			    yyval.num = LOG_ALERT;
			}
break;
case 84:
#line 759 "parser.y"
{
			    yyval.num = LOG_CRIT;
			}
break;
case 85:
#line 763 "parser.y"
{
			    yyval.num = LOG_ERR;
			}
break;
case 86:
#line 767 "parser.y"
{
			    yyval.num = LOG_WARNING;
			}
break;
case 87:
#line 771 "parser.y"
{
			    yyval.num = LOG_NOTICE;
			}
break;
case 88:
#line 775 "parser.y"
{
			    yyval.num = LOG_INFO;
			}
break;
case 89:
#line 779 "parser.y"
{
			    yyval.num = LOG_EMERG;
			}
break;
case 90:
#line 787 "parser.y"
{
			    if (parse_new_state(PS_INTERFACE)) {
				PARSE_ERROR;
			    }
			}
break;
case 91:
#line 796 "parser.y"
{
			    PROTO_SEEN(RTPROTO_DIRECT);
			}
break;
case 95:
#line 806 "parser.y"
{
			    yyerrok;
			}
break;
case 97:
#line 814 "parser.y"
{
			    config_list *list = config_list_alloc(yyvsp[0].config, 0);

			    parse_adv_propagate_config(yyvsp[-1].adv, list, (proto_t) 0);

			    if (parse_adv_append(&int_policy, yyvsp[-1].adv, TRUE)) {
				PARSE_ERROR;
			    }

			    config_list_free(list);
			}
break;
case 98:
#line 826 "parser.y"
{
			    bzero((caddr_t) &parse_ifi, sizeof (parse_ifi));

			    parse_ifi.ifi_addr = yyvsp[0].sockaddr;
			}
break;
case 99:
#line 832 "parser.y"
{
			    if (if_parse_add(&parse_ifi, parse_error)) {
				PARSE_ERROR;
			    }
			}
break;
case 102:
#line 846 "parser.y"
{
			    task_newstate(TASKS_STRICTIFS, 0);
			}
break;
case 103:
#line 850 "parser.y"
{
			    if (parse_limit_check("scan-interval",
						  (u_int) yyvsp[0].time,
						  KRT_LIMIT_SCANTIMER)) {
				PARSE_ERROR;
			    }
			    
			    timer_set(krt_task->task_timer[KRT_TIMER_IFCHECK],
				      yyvsp[0].time,
				      (time_t) 0);
			}
break;
case 104:
#line 865 "parser.y"
{
			    parse_ifi.ifi_addr_broadcast = yyvsp[0].sockaddr;
			    BIT_SET(parse_ifi.ifi_state, IFS_BROADCAST);
			}
break;
case 105:
#line 870 "parser.y"
{
			    parse_ifi.ifi_addr_local = yyvsp[0].sockaddr;
			    BIT_SET(parse_ifi.ifi_state, IFS_POINTOPOINT);
			}
break;
case 106:
#line 875 "parser.y"
{
			}
break;
case 109:
#line 886 "parser.y"
{
			    parse_ifi.ifi_subnetmask = yyvsp[0].sockaddr;
			}
break;
case 110:
#line 890 "parser.y"
{
			    BIT_SET(parse_ifi.ifi_state, IFS_MULTICAST);
			}
break;
case 112:
#line 898 "parser.y"
{
			    yyval.config = config_append(yyvsp[-1].config, yyvsp[0].config);
			    if (!yyval.config) {
				PARSE_ERROR;
			    }
			}
break;
case 113:
#line 908 "parser.y"
{
			    yyval.config = config_alloc(IF_CONFIG_PREFERENCE_UP, (void_t) yyvsp[0].pref);
			}
break;
case 114:
#line 912 "parser.y"
{
			    yyval.config = config_alloc(IF_CONFIG_PREFERENCE_DOWN, (void_t) yyvsp[0].pref);
			}
break;
case 115:
#line 916 "parser.y"
{
			    yyval.config = config_alloc(IF_CONFIG_PASSIVE, (void_t) TRUE);
			}
break;
case 116:
#line 920 "parser.y"
{
			    yyval.config = config_alloc(IF_CONFIG_SIMPLEX, (void_t) TRUE);
			}
break;
case 117:
#line 924 "parser.y"
{
			    yyval.config = config_alloc(IF_CONFIG_REJECT, (void_t) TRUE);
			}
break;
case 118:
#line 928 "parser.y"
{
			    yyval.config = config_alloc(IF_CONFIG_BLACKHOLE, (void_t) TRUE);
			}
break;
case 119:
#line 935 "parser.y"
{
			    yyval.adv = adv_alloc(ADVFT_ANY|ADVF_FIRST, (proto_t) 0);
			}
break;
case 120:
#line 939 "parser.y"
{
			    yyval.adv = yyvsp[0].adv;
			}
break;
case 122:
#line 947 "parser.y"
{
			    yyval.adv = yyvsp[0].adv;
			}
break;
case 123:
#line 954 "parser.y"
{
			    yyval.adv = adv_alloc(ADVFT_ANY|ADVF_FIRST, (proto_t) 0);
			}
break;
case 125:
#line 962 "parser.y"
{
			    BIT_SET(yyvsp[0].adv->adv_flag, ADVF_FIRST);
			    yyval.adv = yyvsp[0].adv;
			}
break;
case 126:
#line 967 "parser.y"
{
			    yyval.adv = yyvsp[-1].adv;
			    if (parse_adv_append(&yyval.adv, yyvsp[0].adv, TRUE)) {
				PARSE_ERROR;
			    }
			}
break;
case 127:
#line 976 "parser.y"
{
			    switch (yyvsp[0].adv->adv_flag & ADVF_TYPE) {

			    case ADVFT_IFN:
				trace(TR_PARSE, 0, "parse: %s INTERFACE: %A*",
				      parse_where(),
				      yyval.adv->adv_ifn->ifae_addr);
				break;
				
			    case ADVFT_IFAE:
				trace(TR_PARSE, 0, "parse: %s INTERFACE: %A",
				      parse_where(),
				      yyval.adv->adv_ifae->ifae_addr);
			    }
			}
break;
case 128:
#line 995 "parser.y"
{
			    int valid_ifname = yyvsp[0].str.type == L_KEYWORD && yyvsp[0].str.len <= IFNAMSIZ;

			    if (valid_ifname) {
				/* First try to look up as an interface name */

				yyval.adv = if_parse_name(yyvsp[0].str.ptr, FALSE);
			    } else {
				/* Doesn't meet the criteria to be a name */

				yyval.adv = (adv_entry *) 0;
			    }
			    
			    if (!yyval.adv && !BIT_TEST(task_state, TASKS_NORESOLV)) {
				/* Try to resolve as a host name */

				sockaddr_un *addr = parse_addr_hostname(yyvsp[0].str.ptr);

				if (addr) {
				    yyval.adv = if_parse_address(addr);
				}

			    }

			    if (!yyval.adv) {
				if (valid_ifname && !BIT_TEST(task_state, TASKS_STRICTIFS)) {
				    /* Assume it is a reference to an interface that does not exist */

				    yyval.adv = if_parse_name(yyvsp[0].str.ptr, TRUE);
				} else {
				    /* Time to give up */
				    
				    (void) sprintf(parse_error, "Interface not found at '%s'",
						   yyvsp[0].str.ptr);
				    PARSE_ERROR;
				}
			    }
				
			    free_charstr(&yyvsp[0].str);
			}
break;
case 129:
#line 1036 "parser.y"
{
			    yyval.adv = if_parse_address(yyvsp[0].sockaddr);
			    if (!yyval.adv) {
				(void) sprintf(parse_error, "Interface not found at '%A'",
					       yyvsp[0].sockaddr);
				PARSE_ERROR;
			    }

			    sockfree(yyvsp[0].sockaddr);
			}
break;
case 130:
#line 1049 "parser.y"
{
			    if_addr *ifap;
			    
			    ifap = if_withlcladdr(yyvsp[0].sockaddr, FALSE);
			    if (ifap) {
				yyval.ifae = ifae_alloc(ifap->ifa_addrent_local);
			    } else {
				if (BIT_TEST(task_state, TASKS_STRICTIFS)) {
				    (void) sprintf(parse_error, "Invalid interface at '%A'",
						   yyvsp[0].sockaddr);
				    PARSE_ERROR;
				} else {
				    yyval.ifae = ifae_locate(yyvsp[0].sockaddr, &if_local_list);
				}
			    }
			    sockfree(yyvsp[0].sockaddr);
			    trace(TR_PARSE, 0, "parse: %s LOCAL ADDRESS: %A",
				  parse_where(),
				  yyval.ifae->ifae_addr);
			}
break;
case 132:
#line 1073 "parser.y"
{
			    sockaddr_un *addr;

			    if (BIT_TEST(task_state, TASKS_NORESOLV)
				|| !(addr = parse_addr_hostname(yyvsp[0].str.ptr))) {
				PARSE_ERROR;
			    }
			    yyval.sockaddr = sockdup(addr);
			    free_charstr(&yyvsp[0].str);
			}
break;
case 133:
#line 1088 "parser.y"
{
			    if (parse_new_state(PS_PROTO)) {
				PARSE_ERROR;
			    }
			}
break;
case 138:
#line 1117 "parser.y"
{
			    PROTO_SEEN(RTPROTO_ISIS);

#ifdef	notyet
			    parse_gwlist = &isis.gw_list;

			    isis_trace_flags = trace_flags;
#endif	/* notyet */

			    /* XXX - should be done by above */
			    isis_plevel = 1;
                        }
break;
case 139:
#line 1130 "parser.y"
{

			    ip_supported = 0;
			    clnp_supported = 0;
			    switch (yyvsp[-1].num) {
			    case T_OFF:
				break;
			    /* XXX - Check validity of configuration for the following */
			    case T_IP:
				ip_supported = 1;
				doing_isis = TRUE;
				break;
			    case T_ISO:
				clnp_supported = 1;
				doing_isis = TRUE;
				break;
			    case T_ON:
			    case T_DUAL:
				ip_supported = clnp_supported = 1;
				doing_isis = TRUE;
			    }
			}
break;
case 141:
#line 1155 "parser.y"
{ yyval.num = T_IP; }
break;
case 142:
#line 1156 "parser.y"
{ yyval.num = T_ISO; }
break;
case 143:
#line 1157 "parser.y"
{ yyval.num = T_DUAL; }
break;
case 148:
#line 1167 "parser.y"
{
				yyerrok;
			}
break;
case 149:
#line 1173 "parser.y"
{
			    isis_plevel = yyvsp[0].num;
			}
break;
case 150:
#line 1177 "parser.y"
{
			    if (BIT_TEST(task_state, TASKS_RECONFIG)) {
				if ((isis_ci = isis_GetIspcByName(yyvsp[0].str)) == 0) {
				    /* this is a config of a new circuit */    
				    isis_ci = ++isis_circuits_parsed;
				    bzero(&isis_ca[isis_ci], sizeof(struct is_pc));
				    strcpy(isis_ca[isis_ci].name, yyvsp[0].str.ptr);
			    	    /* isis_init_ca(&isis_ca[isis_ci], $2); */
				    trace(TR_ISIS, LOG_INFO, "IS-IS reconfig parsed new circuit #%d -> %s", isis_ci, yyvsp[0].str);
				} else {
					trace(TR_ISIS, LOG_INFO, "IS-IS reconfig parsed existing circuit #%d -> %s", isis_ci, yyvsp[0].str);
				} 
			    } else {
				/* remember new circuit */
			    	isis_ci = ++isis_circuits_parsed;
				trace(TR_ISIS, LOG_INFO, "IS-IS config parsed new circuit #%d -> %s", isis_ci, yyvsp[0].str);
				bzero(&isis_ca[isis_ci], sizeof(struct is_pc));
				strcpy(isis_ca[isis_ci].name, yyvsp[0].str.ptr);
			    	/* isis_init_ca(&isis_ca[isis_ci], $2); */
			    }
			}
break;
case 151:
#line 1199 "parser.y"
{
			}
break;
case 152:
#line 1202 "parser.y"
{
			    isis_set_sysid(yyvsp[0].str);
			}
break;
case 153:
#line 1206 "parser.y"
{
			    isis_save_trace(yyvsp[0].flag);
			}
break;
case 154:
#line 1210 "parser.y"
{
			    /* we need an index in lieu of the NSAP address; used to use getpid */
			    isis_snpa = yyvsp[0].num;
			}
break;
case 155:
#line 1215 "parser.y"
{
			    isis_saveArea(yyvsp[0].str);
			}
break;
case 156:
#line 1219 "parser.y"
{
			    save_ipreach(yyvsp[-5].num,yyvsp[-4].num,&yyvsp[-3].sockaddr,&yyvsp[-2].sockaddr,yyvsp[0].num);
			}
break;
case 157:
#line 1223 "parser.y"
{
			    isis_savePrefix(yyvsp[0].str.ptr, yyvsp[-1].num, yyvsp[-3].num);
			}
break;
case 158:
#line 1227 "parser.y"
{
			    isis_saveInterDomInfo(yyvsp[0].str);
			}
break;
case 159:
#line 1231 "parser.y"
{
			    isis_set_parm(yyvsp[-1].str,yyvsp[0].num);
			}
break;
case 160:
#line 1238 "parser.y"
{
			    yyval.num = yyvsp[0].num;
			}
break;
case 161:
#line 1242 "parser.y"
{
			    yyval.num = 1;
			}
break;
case 162:
#line 1248 "parser.y"
{
			    yyval.num = T_IP;
			}
break;
case 163:
#line 1252 "parser.y"
{
			    yyval.num = T_ISO;
			}
break;
case 164:
#line 1256 "parser.y"
{
			    yyval.num = T_DUAL;
			}
break;
case 167:
#line 1266 "parser.y"
{
			    if (yyvsp[-1].num == 2) {
				isis_ca[isis_ci].l2metric = yyvsp[0].num;
			    } else {
				isis_ca[isis_ci].metric = yyvsp[0].num;
			    }
			}
break;
case 168:
#line 1274 "parser.y"
{
			    if (yyvsp[-1].num == 2) {
				isis_ca[isis_ci].l2prior = yyvsp[0].num;
			    } else {
				isis_ca[isis_ci].prior = yyvsp[0].num;
			    }
			}
break;
case 169:
#line 1284 "parser.y"
{
			    yyval.num = ISIS_INTERNAL;
			}
break;
case 170:
#line 1288 "parser.y"
{
			    yyval.num = ISIS_EXTERNAL;
			}
break;
case 171:
#line 1292 "parser.y"
{
			    yyval.num = ISIS_SUMMARY;
			}
break;
case 172:
#line 1298 "parser.y"
{
			    yyval.num = ISIS_INTERNAL;
			}
break;
case 173:
#line 1302 "parser.y"
{
			    yyval.num = ISIS_EXTERNAL;
			}
break;
case 175:
#line 1309 "parser.y"
{
				    yyval.flag = yyvsp[-1].flag | yyvsp[0].flag;
				}
break;
case 176:
#line 1313 "parser.y"
{
				    yyval.flag = yyvsp[-2].flag & ~yyvsp[-1].num;
				}
break;
case 177:
#line 1319 "parser.y"
{ yyval.flag = T_ISISALL; }
break;
case 178:
#line 1320 "parser.y"
{ yyval.flag = T_DUMPIIH; }
break;
case 179:
#line 1321 "parser.y"
{ yyval.flag = T_DUMPLSP; }
break;
case 180:
#line 1322 "parser.y"
{ yyval.flag = T_EVENTS; }
break;
case 181:
#line 1323 "parser.y"
{ yyval.flag = T_LANADJ; }
break;
case 182:
#line 1324 "parser.y"
{ yyval.flag = T_FLOODING; }
break;
case 183:
#line 1325 "parser.y"
{ yyval.flag = T_BUILDLSP; }
break;
case 184:
#line 1326 "parser.y"
{ yyval.flag = T_CSNP; }
break;
case 185:
#line 1327 "parser.y"
{ yyval.flag = T_PSNP; }
break;
case 186:
#line 1328 "parser.y"
{ yyval.flag = T_LSPINPUT; }
break;
case 187:
#line 1329 "parser.y"
{ yyval.flag = T_P2PADJ; }
break;
case 188:
#line 1330 "parser.y"
{ yyval.flag = T_TRSPF; }
break;
case 189:
#line 1331 "parser.y"
{ yyval.flag = T_DUMPDB; }
break;
case 190:
#line 1332 "parser.y"
{ yyval.flag = T_ROUTE2; }
break;
case 191:
#line 1333 "parser.y"
{ yyval.flag = T_ROUTE1; }
break;
case 192:
#line 1334 "parser.y"
{ yyval.flag = T_ROUTE3; }
break;
case 193:
#line 1335 "parser.y"
{ yyval.flag = T_LSPCONTENT; }
break;
case 194:
#line 1353 "parser.y"
{
			    PROTO_SEEN(RTPROTO_BGP);

			    parse_gwlist = &parse_gwp;

			    bgp_default_trace_flags = trace_flags;
			}
break;
case 195:
#line 1361 "parser.y"
{
			    switch (yyvsp[-1].num) {
			    case T_ON:
				doing_bgp = TRUE;

				if (!bgp_conf_check(parse_error)) {
				    PARSE_ERROR;
				}
				break;

			    case T_OFF:
				doing_bgp = FALSE;
			    }

			    parse_gwlist = (gw_entry **) 0;
			}
break;
case 200:
#line 1386 "parser.y"
{
			    yyerrok;
			}
break;
case 201:
#line 1392 "parser.y"
{
			    bgp_default_preference = yyvsp[0].pref;
			}
break;
case 202:
#line 1396 "parser.y"
{
			    if (parse_metric_check(RTPROTO_BGP, &yyvsp[0].metric)) {
				PARSE_ERROR;
			    }
			    bgp_default_metric = yyvsp[0].metric.metric;
			}
break;
case 203:
#line 1403 "parser.y"
{
			    bgp_default_trace_flags = yyvsp[0].flag;
			}
break;
case 204:
#line 1407 "parser.y"
{
			    /* Allocate a Group structure */
			    bgp = bgp_conf_group_alloc();

			    /* Set the type and AS */
			    bgp->bgpg_type = yyvsp[-2].num;
			    bgp->bgpg_peer_as = yyvsp[0].as;

			    /* Point at this configuration information */
			    bcp = &bgp->bgpg_conf;

			    /* Inherit global trace flags */
			    bgp->bgpg_trace_flags = bgp_default_trace_flags;
			}
break;
case 205:
#line 1422 "parser.y"
{
			    /* Add this group */
			    bgp = bgp_conf_group_add(bgp, parse_error);
			    if (!bgp) {
				PARSE_ERROR;
			    }
			}
break;
case 206:
#line 1430 "parser.y"
{
			    /* Check group */
			    if (!bgp_conf_group_check(bgp, parse_error)) {
				PARSE_ERROR;
			    }
			}
break;
case 211:
#line 1446 "parser.y"
{
				yyerrok;
			}
break;
case 212:
#line 1452 "parser.y"
{
			    /* Allocate this peer */
			    bnp = bgp_conf_peer_alloc(bgp);

			    /* Point at this configuration information */
			    bcp = &bnp->bgp_conf;
			}
break;
case 213:
#line 1460 "parser.y"
{
			    /* Set peer address */
			    bnp->bgp_addr = yyvsp[-1].sockaddr;

			    bnp = bgp_conf_peer_add(bgp, bnp, parse_error);
			    if (!bnp) {
				PARSE_ERROR;
			    }
			}
break;
case 214:
#line 1470 "parser.y"
{
			    parse_contig_masks = FALSE;
			}
break;
case 215:
#line 1474 "parser.y"
{
			    parse_contig_masks = TRUE;

			    if (parse_adv_append(&bgp->bgpg_allow, yyvsp[-1].adv, TRUE)) {
				PARSE_ERROR;
			    }
			}
break;
case 216:
#line 1484 "parser.y"
{
			    if (parse_metric_check(RTPROTO_BGP, &yyvsp[0].metric)) {
				PARSE_ERROR;
			    }
			    BIT_SET(bcp->bgpc_options, BGPO_METRIC_OUT);
			    bcp->bgpc_metric_out = yyvsp[0].metric.metric;
			}
break;
case 217:
#line 1492 "parser.y"
{
			    BIT_SET(bcp->bgpc_options, BGPO_LOCAL_AS);
			    bcp->bgpc_local_as = yyvsp[0].as;
			}
break;
case 218:
#line 1497 "parser.y"
{
			    BIT_SET(bcp->bgpc_options, BGPO_NOGENDEFAULT);
			}
break;
case 219:
#line 1501 "parser.y"
{
			    if (bcp->bgpc_gateway) {
				/* Free the old one */
				sockfree(bcp->bgpc_gateway);
			    }
			    BIT_SET(bcp->bgpc_options, BGPO_GATEWAY);
			    bcp->bgpc_gateway = sockdup(yyvsp[0].gwp->gw_addr);
			    gw_freelist(*parse_gwlist);
			    *parse_gwlist = parse_gwp = (gw_entry *) 0;
			}
break;
case 220:
#line 1512 "parser.y"
{
			    BIT_SET(bcp->bgpc_options, BGPO_PREFERENCE);
			    bcp->bgpc_preference = yyvsp[0].pref;
			}
break;
case 221:
#line 1517 "parser.y"
{
			    if (bcp->bgpc_lcladdr) {
				/* Free the old one */
				ifae_free(bcp->bgpc_lcladdr);
			    }
			    BIT_SET(bcp->bgpc_options, BGPO_LCLADDR);
			    bcp->bgpc_lcladdr = yyvsp[0].ifae;
			}
break;
case 222:
#line 1526 "parser.y"
{
			    if (parse_limit_check("hold time",
						  (u_int) yyvsp[0].time,
						  BGP_LIMIT_HOLDTIME)) {
				PARSE_ERROR;
			    }
			    BIT_SET(bcp->bgpc_options, BGPO_HOLDTIME);
			    bcp->bgpc_holdtime_out = yyvsp[0].time;
			}
break;
case 223:
#line 1536 "parser.y"
{
			    bcp->bgpc_trace_flags = yyvsp[0].flag;
			}
break;
case 224:
#line 1540 "parser.y"
{
			    if (!BGP_KNOWN_VERSION(yyvsp[0].num)) {
				(void) sprintf(parse_error, "unsupported BGP version: %d",
					       yyvsp[0].num);
				PARSE_ERROR;
			    }
			    BIT_SET(bcp->bgpc_options, BGPO_VERSION);
			    bcp->bgpc_conf_version = yyvsp[0].num;
			}
break;
case 225:
#line 1550 "parser.y"
{
			    BIT_SET(bcp->bgpc_options, BGPO_PASSIVE);
			}
break;
case 226:
#line 1554 "parser.y"
{
			    BIT_SET(bcp->bgpc_options, BGPO_DEFAULTIN);
			}
break;
case 227:
#line 1558 "parser.y"
{
			    BIT_SET(bcp->bgpc_options, BGPO_DEFAULTOUT);
			}
break;
case 228:
#line 1562 "parser.y"
{
			    BIT_SET(bcp->bgpc_options, BGPO_KEEPALL);
			}
break;
case 229:
#line 1566 "parser.y"
{
			    bcp->bgpc_send_bufsize = yyvsp[0].num;
			}
break;
case 230:
#line 1570 "parser.y"
{
			    bcp->bgpc_recv_bufsize = yyvsp[0].num;
			}
break;
case 231:
#line 1574 "parser.y"
{
			    if (parse_limit_check("spool buffer size",
						  (u_int) yyvsp[0].num,
						  BGP_LIMIT_SBUF)) {
				PARSE_ERROR;
			    }
			    bcp->bgpc_spool_bufsize = yyvsp[0].num;
			}
break;
case 232:
#line 1585 "parser.y"
{
			    if (parse_limit_check("kernel buffer size",
						  (u_int) yyvsp[0].num,
						  BGP_LIMIT_KBUF)) {
				PARSE_ERROR;
			    }
			    yyval.num = yyvsp[0].num;
			}
break;
case 233:
#line 1596 "parser.y"
{
			    yyval.num = BGPG_INTERNAL;
			}
break;
case 234:
#line 1600 "parser.y"
{
			    yyval.num = BGPG_EXTERNAL;
			}
break;
case 235:
#line 1604 "parser.y"
{
			    yyval.num = BGPG_INTERNAL_IGP;
			}
break;
case 236:
#line 1608 "parser.y"
{
			    yyval.num = BGPG_TEST;
			}
break;
case 238:
#line 1619 "parser.y"
{
			    yyval.proto = parse_proto = RTPROTO_BGP;
			    parse_gwlist = (gw_entry **) 0;
			    trace(TR_PARSE, 0, "parse: %s PROTO: %s",
				  parse_where(),
				  gd_lower(trace_state(rt_proto_bits, yyval.proto)));
			}
break;
case 239:
#line 1630 "parser.y"
{
			    yyval.adv = (adv_entry *) 0;
			}
break;
case 240:
#line 1634 "parser.y"
{
			    yyval.adv = adv_alloc(ADVFT_DM, (proto_t) 0);
			    yyval.adv->adv_dm = yyvsp[-1].dm;
			    yyval.adv = parse_adv_dm_append(yyvsp[-2].adv, yyval.adv);
			    if (!yyval.adv) {
				PARSE_ERROR;
			    }
			}
break;
case 241:
#line 1643 "parser.y"
{
			    yyerrok;
			}
break;
case 245:
#line 1660 "parser.y"
{
					/* global parameters for protocol */
	
                                        idrp_trace_flags = trace_flags;
                                        parse_proto = RTPROTO_IDRP;
                                        idrp_parse_group_index = 0;
                                }
break;
case 246:
#line 1668 "parser.y"
{
			    		PROTO_SEEN(RTPROTO_IDRP);
                                        if (yyvsp[-2].num == T_OFF) {
                                                doing_idrp = FALSE;
                                                trace(TR_PARSE, 0, "parse: %s idrp off ;", parse_where());
                                        } else {
						/* set flag and initialize local nodes idrpPeer struct */
                                                doing_idrp = TRUE;
						idrp_local_peer_init();

						/* check to make sure RDI specified */
                                                if (!rt_rdi.isoa_len) {
                                                        (void) sprintf(parse_error, "RDI not specified");
                                                        PARSE_ERROR;
                                                }
                                                /* %% */
						/* here we need to change for */
						/* idrp for IP */
		
                                                if (!rt_net.isoa_len) {
                                                        (void) sprintf(parse_error, "NET not specified");
                                                        PARSE_ERROR;
                                                }

                                                if (!idrp_neighbors) {
                                                        (void) sprintf(parse_error, "no IDRP neighbors specified");
                                                        PARSE_ERROR;
                                                }
                                                IDRP_LIST(idgp) {
                                                        trace(TR_PARSE, 0, "parse:  %s, IDRP neighbor %s, addr %A",
								parse_where(), idgp->name, 
								sockbuild_iso((byte *)idgp->neighbor.isoa_genaddr,
								idgp->neighbor.isoa_len));
                                                } IDRP_LIST_END;
                                        }
                                }
break;
case 247:
#line 1708 "parser.y"
{
                                        idrp_trace_flags = yyvsp[0].flag;
                                }
break;
case 249:
#line 1716 "parser.y"
{
					/* zero the group address functions */
 
                                        bzero((caddr_t) &idrp_group, sizeof(idrp_group));
                                        gr_idrp = &idrp_group;
                                        gr_idrp->trace_flags = idrp_trace_flags;
                                        idrp_parse_group_index++;
                                }
break;
case 254:
#line 1732 "parser.y"
{
                                        yyerrok;
                                }
break;
case 259:
#line 1745 "parser.y"
{
                                        yyerrok;
                                }
break;
case 262:
#line 1753 "parser.y"
{
				idrp_this_node.route_server = FALSE;
				if (yyvsp[0].num == T_ON)
					{
					idrp_this_node.route_server = TRUE;
					}
				}
break;
case 263:
#line 1762 "parser.y"
{
				idrp_this_node.multi_exit = FALSE;
				if (yyvsp[0].num == T_ON)
					{
					idrp_this_node.multi_exit = TRUE;
					}
				}
break;
case 266:
#line 1773 "parser.y"
{
				idrp_this_node.rcv_credit = yyvsp[0].num;
				}
break;
case 267:
#line 1778 "parser.y"
{
				idrp_this_node.listen_for_open = FALSE;
				if (yyvsp[0].num == T_ON)
					{
					idrp_this_node.listen_for_open = TRUE;
					}
				}
break;
case 268:
#line 1787 "parser.y"
{
				idrp_this_node.hold_time = yyvsp[0].num;
				}
break;
case 269:
#line 1792 "parser.y"
{
				idrp_this_node.close_wait = yyvsp[0].num;
				}
break;
case 270:
#line 1797 "parser.y"
{
				idrp_this_node.rexmit_time = yyvsp[0].num;
				}
break;
case 271:
#line 1801 "parser.y"
{
				idrp_this_node.ribcheck_time = yyvsp[0].num;
				}
break;
case 272:
#line 1805 "parser.y"
{
				idrp_this_node.min_adv_time = yyvsp[0].num;
				}
break;
case 273:
#line 1809 "parser.y"
{
				idrp_this_node.min_advRD_time = yyvsp[0].num;
				}
break;
case 274:
#line 1815 "parser.y"
{
				idrp_this_node.AuthType = yyvsp[0].num; 
				}
break;
case 275:
#line 1819 "parser.y"
{
				idrp_this_node.AuthType = yyvsp[-2].num;
				bcopy(yyvsp[0].hex.ptr,&idrp_this_node.AuthCode[0],yyvsp[0].hex.len);
				}
break;
case 277:
#line 1827 "parser.y"
{
				idgp = &idrp_this_node;
				}
break;
case 282:
#line 1839 "parser.y"
{
                                        yyerrok;
                                }
break;
case 283:
#line 1846 "parser.y"
{
					/* allocate a peer */

					idgp = idrp_peer_alloc(0);

					/* if group has not been initialized - do it now */
					/* all of idrpPeer structure will be zero       */
	 
       	                               if (!gr_idrp)
						{	
						gr_idrp = idrp_peer_alloc(&idrp_group);
						}
                                }
break;
case 284:
#line 1860 "parser.y"
{
                                        idrpPeer *idgp2;

                                        if (yyvsp[-7].num == T_OFF)
						 {
						 idgp->idrp_flags = IDRPF_IDLED;
						}
					else	
						{
						idgp->idrp_flags = IDRPF_TRY_CONNECT;
						}   		

					/* copy in group trace flags 
					 * in this sequence, the RDI is not copied 
					 */
 
					idgp->trace_flags = gr_idrp->trace_flags;
					idgp->type = gr_idrp->type;

					/* copy rdi, NET, IP address for now */
					/* need to put interface someplace */

					bcopy(yyvsp[-6].hex.ptr, idgp->neighbor.isoa_genaddr,yyvsp[-6].hex.len);
					idgp->neighbor.isoa_len = yyvsp[-6].hex.len;
					idgp->neighbor.isoa_family = AF_ISO;
                                        bcopy(yyvsp[-3].hex.ptr, idgp->rdi.isoa_genaddr,yyvsp[-3].hex.len);
                                        idgp->rdi.isoa_len = yyvsp[-3].hex.len;

				        sprintf(idgp->name, "%A", 
						sockbuild_iso((byte *) idgp->neighbor.isoa_genaddr, 
						idgp->neighbor.isoa_len));
	
					/* is it my rdi - if so, internal neighbor */

					if (idgp->type == IDRP_PEER_INTERNAL)
						{
						if (isoaddrcmp(&idgp->rdi,&rt_rdi))
							{
							/* rdi does not match */
							trace ( TR_IDRP,0,"internal neighbor %s has internal neighbor but rdi is not ours", \
							idgp->name);
							}					 
						}

                                        idgp->ip_neighbor = yyvsp[-5].sockaddr;
                                        idgp->gw.gw_proto = RTPROTO_IDRP;
					idgp->gw.gw_addr->in.sin_port = IDRP_PORT;

					/* if reparsing - check for this peer in
					 * existing list
					 */

					/* check for this peer being on the chain
					 * already
					 */

					idgp2 = idrp_find_peer(idgp);
					if (idgp2)
						{
						/* found a peer structure */
						if (idrp_reparsing)
							{
							/* re-use old structure, update
							 * with the new parameters  so far
							 * and free duplicate peer structure
							 */
 
							idrp_peer_update(idgp2,idgp);
							idrp_big_blk_free(idgp);
							idgp = idgp2;	
							}
						else
							{
							trace (TR_IDRP,0,"duplicate peer %s",idgp->name);
							PARSE_ERROR;
							}	
						}
					else
						{
						/* not a duplicate and not a reparsing re-used
						 * peer structure 
						 */
		
						idrp_link_peer(idgp);
						}
                                }
break;
case 287:
#line 1951 "parser.y"
{
                                        yyerrok;
                                }
break;
case 288:
#line 1958 "parser.y"
{
				/* create a local route with this NLRI information */

				int bits; 
				idrpRoute_options	*p_opts = 0; 

				bits = yyvsp[-1].hex.len * 8; 
				if (!idrp_local_rt(yyvsp[-1].hex.ptr,yyvsp[-1].hex.len,bits,AF_ISO,yyvsp[0].hex.ptr,yyvsp[0].hex.len,p_opts))
					{ 
					trace (TR_PARSE,0,"maximum number of local routes exceeded, no more added to routing table");
					}
                                }
break;
case 289:
#line 1971 "parser.y"
{
				int bits; 
				bits = yyvsp[-2].hex.len * 8;
				if (!idrp_local_rt(yyvsp[-2].hex.ptr,yyvsp[-2].hex.len,bits,AF_ISO,yyvsp[-1].hex.ptr,yyvsp[-1].hex.len,&idrp_rt_opts))
					{ 
					trace (TR_PARSE,0,"maximum number of local routes exceeded, no more added to routing table");
					}
                                }
break;
case 290:
#line 1981 "parser.y"
{
				int bits; 
				bits = yyvsp[-3].hex.len * 8;
				if (!idrp_local_rt(yyvsp[-3].hex.ptr,yyvsp[-3].hex.len,bits,AF_INET,yyvsp[-2].hex.ptr,yyvsp[-2].hex.len,&idrp_rt_opts))
					{ 
					trace (TR_PARSE,0,"maximum number of local routes exceeded, no more added to routing table");
					}
				}
break;
case 291:
#line 1991 "parser.y"
{
				int bits;
				bits = yyvsp[-2].hex.len * 8;
				if (!idrp_local_rt(yyvsp[-2].hex.ptr,yyvsp[-2].hex.len,bits,AF_ISO,yyvsp[-1].hex.ptr,yyvsp[-1].hex.len,&idrp_rt_opts))
					{ 
					trace (TR_PARSE,0,"maximum number of local routes exceeded, no more added to routing table");
					}
				}
break;
case 292:
#line 2001 "parser.y"
{
				int bits;
				bits = yyvsp[-3].hex.len * 8;
				if (!idrp_local_rt(yyvsp[-3].hex.ptr,yyvsp[-3].hex.len,bits,AF_ISO,yyvsp[-2].hex.ptr,yyvsp[-2].hex.len,&idrp_rt_opts))
					{ 
					trace (TR_PARSE,0,"maximum number of local routes exceeded, no more added to routing table");
					}
				}
break;
case 294:
#line 2013 "parser.y"
{
                                        yyerrok;
				}
break;
case 295:
#line 2019 "parser.y"
{
				/* note I am using byte string and next hop gateway
				 * as the operative thing to insert into
				 * - gateway table, but this may have to be re-examined
				 * - is uses a number and then gets the byte string
				 */ 

				bcopy(yyvsp[0].hex.ptr,&idrp_rt_opts.next_hop_snpas.snpa1.snpa,yyvsp[0].hex.len);
				idrp_rt_opts.next_hop_snpas.cnt = 1;	
				idrp_rt_opts.next_hop_snpas.pdu_len = yyvsp[0].hex.len; 
				}
break;
case 296:
#line 2032 "parser.y"
{
				idrp_rt_opts.multi_exit = yyvsp[0].num;
				}
break;
case 297:
#line 2036 "parser.y"
{
				idrp_rt_opts.multi_exit = yyvsp[-2].num;
				bcopy(yyvsp[0].hex.ptr,&idrp_rt_opts.next_hop_snpas.snpa1.snpa,yyvsp[0].hex.len);
				idrp_rt_opts.next_hop_snpas.cnt = 1;	
				idrp_rt_opts.next_hop_snpas.pdu_len = yyvsp[0].hex.len; 
				}
break;
case 298:
#line 2043 "parser.y"
{
				bcopy(yyvsp[-2].hex.ptr,&idrp_rt_opts.next_hop_snpas.snpa1.snpa,yyvsp[-2].hex.len);
				idrp_rt_opts.next_hop_snpas.cnt = 1;	
				idrp_rt_opts.next_hop_snpas.pdu_len = yyvsp[-2].hex.len; 
				idrp_rt_opts.multi_exit = yyvsp[0].num;
				}
break;
case 299:
#line 2050 "parser.y"
{
				idrp_rt_opts.route_server = IDRP_SERVER_ALLOWED;
				}
break;
case 301:
#line 2057 "parser.y"
{
                                        yyerrok;
				}
break;
case 303:
#line 2064 "parser.y"
{
				if (idrp_rt_opts.p_DIST_LIST_EXCL)
					{
					p_idrp_excl_rdi_tail->p_next = p_rdi_head;
					p_idrp_excl_rdi_tail = p_rdi_tail;
					}
				else
					{
					p_idrp_excl_rdi_tail = p_idrp_excl_rdi_head = p_rdi_head;
					idrp_rt_opts.p_DIST_LIST_EXCL = p_rdi_head;
					} 
				}
break;
case 304:
#line 2078 "parser.y"
{
				if (idrp_rt_opts.p_DIST_LIST_INCL)
					{
					p_idrp_incl_rdi_tail->p_next = p_rdi_head;
					}
				else
					{
					p_idrp_incl_rdi_tail = p_idrp_incl_rdi_head = p_rdi_head;
					idrp_rt_opts.p_DIST_LIST_INCL = p_rdi_head;
					}
				}
break;
case 306:
#line 2094 "parser.y"
{
                                        yyerrok;
				}
break;
case 307:
#line 2100 "parser.y"
{
				if (!p_rdi_head)
					{
					p_rdi_head = p_rdi_tail = create_local_rd_path(yyvsp[0].hex.len,yyvsp[0].hex.ptr);
					}
				else
					{
					p_rdi_tail->p_next = create_local_rd_path(yyvsp[0].hex.len,yyvsp[0].hex.ptr);
					p_rdi_tail = p_rdi_tail->p_next;
					p_rdi_tail->p_next = (idrp_canon_rdpath *) 0;
					}
				}
break;
case 309:
#line 2117 "parser.y"
{
                                        idgp->ip_intf_addr = yyvsp[0].sockaddr;
					idgp->ip_intf_addr->in.sin_port = IDRP_PORT;
					trace (TR_PARSE, 0, "ip interface address configed"); 
                                }
break;
case 310:
#line 2123 "parser.y"
{
					idrp_set_iso_sockun((struct sockadd_un *)&idgp->iso_gw_addr,yyvsp[0].hex.len,yyvsp[0].hex.ptr);	
					trace (TR_PARSE, 0, "iso interface address configed"); 
				}
break;
case 311:
#line 2128 "parser.y"
{
	                                idgp->ip_intf_addr = yyvsp[-1].sockaddr;
					idgp->ip_intf_addr->in.sin_port = IDRP_PORT;
					trace (TR_PARSE, 0, "ip interface address configed"); 
					idrp_set_iso_sockun((struct sockadd_un *)&idgp->iso_gw_addr,yyvsp[0].hex.len,yyvsp[0].hex.ptr);	
					trace (TR_PARSE, 0, "iso interface address configured"); 
				}
break;
case 312:
#line 2136 "parser.y"
{
	                                idgp->ip_intf_addr = yyvsp[0].sockaddr;
					idgp->ip_intf_addr->in.sin_port = IDRP_PORT;
					trace (TR_PARSE, 0, "ip interface address configed"); 
					idrp_set_iso_sockun((struct sockadd_un *)&idgp->iso_gw_addr,yyvsp[-1].hex.len,yyvsp[-1].hex.ptr);	
					trace (TR_PARSE, 0, "iso interface address configured"); 
				}
break;
case 317:
#line 2153 "parser.y"
{
                                        bcopy(yyvsp[0].hex.ptr,&gr_idrp->rdi.isoa_genaddr, yyvsp[0].hex.len);
                                        gr_idrp->rdi.isoa_len = yyvsp[0].hex.len;
                                }
break;
case 318:
#line 2158 "parser.y"
{
                                        gr_idrp->type = IDRP_PEER_INTERNAL;
                                }
break;
case 319:
#line 2162 "parser.y"
{
                                        gr_idrp->type = IDRP_PEER_EXTERNAL;
                                }
break;
case 323:
#line 2174 "parser.y"
{
				idgp->proto_sock = IDRP_PDU_PROTO_IP_RAW;
				}
break;
case 324:
#line 2178 "parser.y"
{
				idgp->proto_sock = IDRP_PDU_PROTO_UDP;
				}
break;
case 325:
#line 2183 "parser.y"
{
				/*  raw clnp socket */
				idgp->proto_sock = IDRP_PDU_PROTO_CLNP;
				}
break;
case 326:
#line 2188 "parser.y"
{
				idgp->proto_sock = IDRP_PDU_PROTO_IDRP;
				}
break;
case 327:
#line 2193 "parser.y"
{
				idrp_this_node.nlri_supp[IDRP_NLRI_ISO] = TRUE;
				}
break;
case 328:
#line 2197 "parser.y"
{
				idrp_this_node.nlri_supp[IDRP_NLRI_IP] = TRUE;
				}
break;
case 329:
#line 2201 "parser.y"
{
				idrp_this_node.nlri_supp[IDRP_NLRI_IP] = TRUE;
				idrp_this_node.nlri_supp[IDRP_NLRI_ISO] = TRUE;
				idrp_this_node.nlri_supp[IDRP_NLRI_PIP] = TRUE;
				}
break;
case 330:
#line 2208 "parser.y"
{
				idrp_this_node.nlri_supp[IDRP_NLRI_IP] = TRUE;
				idrp_this_node.nlri_supp[IDRP_NLRI_ISO] = TRUE;
				idrp_this_node.nlri_supp[IDRP_NLRI_PIP] = TRUE;
				idrp_this_node.nlri_supp[IDRP_NLRI_SIP] = TRUE;
				}
break;
case 331:
#line 2215 "parser.y"
{
				idrp_this_node.nlri_supp[IDRP_NLRI_PIP] = TRUE;
				}
break;
case 332:
#line 2219 "parser.y"
{
				idrp_this_node.nlri_supp[IDRP_NLRI_SIP] = TRUE;
				}
break;
case 335:
#line 2229 "parser.y"
{
                                        idgp->trace_flags = yyvsp[0].flag;
                                }
break;
case 337:
#line 2236 "parser.y"
{
                                        yyval.hex = yyvsp[0].hex;
                                }
break;
case 344:
#line 2262 "parser.y"
{
#if	defined(PROTO_ICMP) || defined(KRT_RT_SOCK)
			    PROTO_SEEN(RTPROTO_REDIRECT);

			    parse_gwlist = &redirect_gw_list;

			    redirect_trace_flags = trace_flags;
#endif	/* defined(PROTO_ICMP) || defined(KRT_RT_SOCK) */
			}
break;
case 345:
#line 2272 "parser.y"
{
#if	defined(PROTO_ICMP) || defined(KRT_RT_SOCK)
			    switch (yyvsp[-1].num) {
			    case T_ON:
				/* Enabled by default */
				break;

			    case T_OFF:
				redirect_disable(RTPROTO_REDIRECT);
				break;
			    }
#endif	/* defined(PROTO_ICMP) || defined(KRT_RT_SOCK) */
			}
break;
case 350:
#line 2295 "parser.y"
{
			    yyerrok;
			}
break;
case 351:
#line 2301 "parser.y"
{
#if	defined(PROTO_ICMP) || defined(KRT_RT_SOCK)
			    redirect_preference = yyvsp[0].pref;
#endif	/* defined(PROTO_ICMP) || defined(KRT_RT_SOCK) */
			}
break;
case 352:
#line 2307 "parser.y"
{
#if	defined(PROTO_ICMP) || defined(KRT_RT_SOCK)
			    config_list *list = config_list_alloc(yyvsp[0].config, 0);

			    parse_adv_propagate_config(yyvsp[-1].adv, list, RTPROTO_REDIRECT);

			    if (parse_adv_append(&redirect_int_policy, yyvsp[-1].adv, TRUE)) {
				PARSE_ERROR;
			    }

			    config_list_free(list);
#endif	/* defined(PROTO_ICMP) || defined(KRT_RT_SOCK) */
			}
break;
case 353:
#line 2321 "parser.y"
{
#if	defined(PROTO_ICMP) || defined(KRT_RT_SOCK)
			    redirect_n_trusted += parse_gw_flag(yyvsp[0].adv, RTPROTO_REDIRECT, GWF_TRUSTED);
			    if (!redirect_n_trusted) {
				PARSE_ERROR;
			    }
#endif	/* defined(PROTO_ICMP) || defined(KRT_RT_SOCK) */
			}
break;
case 354:
#line 2330 "parser.y"
{
			    redirect_trace_flags = yyvsp[0].flag;
			}
break;
case 356:
#line 2338 "parser.y"
{
			    yyval.config = config_append(yyvsp[-1].config, yyvsp[0].config);
			    if (!yyval.config) {
				PARSE_ERROR;
			    }
			}
break;
case 357:
#line 2348 "parser.y"
{
#if	defined(PROTO_ICMP) || defined(KRT_RT_SOCK)
			    yyval.config = config_alloc(REDIRECT_CONFIG_NOIN, (void_t) TRUE);
#endif	/* defined(PROTO_ICMP) || defined(KRT_RT_SOCK) */
			}
break;
case 359:
#line 2369 "parser.y"
{
			    if (parse_new_state(PS_ROUTE)) {
				PARSE_ERROR;
			    }
			}
break;
case 360:
#line 2377 "parser.y"
{
			    /* Need to set this for static routes, not used for interface routes */
			    parse_proto = RTPROTO_STATIC;
			    parse_gwlist = &rt_gw_list;
			    rt_open(rt_task);
			}
break;
case 361:
#line 2384 "parser.y"
{
			    rt_close(rt_task, (gw_entry *) 0, 0, NULL);
			}
break;
case 364:
#line 2392 "parser.y"
{
				yyerrok;
			}
break;
case 365:
#line 2398 "parser.y"
{
			    /* Route to a gateway */

			    if (rt_parse_route(yyvsp[-5].dm.dm_dest,
					       yyvsp[-5].dm.dm_mask,
					       yyvsp[-3].adv,
					       yyvsp[-2].adv,
					       PARSE_METRIC_ISSET(&yyvsp[-1].metric) ? (pref_t) yyvsp[-1].metric.metric : RTPREF_STATIC,
					       yyvsp[0].flag | RTS_GATEWAY,
					       parse_error)) {
				PARSE_ERROR;
			    }

			    sockfree(yyvsp[-5].dm.dm_dest);
			}
break;
case 366:
#line 2414 "parser.y"
{
			    /* Route to an interface */

			    if (rt_parse_route(yyvsp[-4].dm.dm_dest,
					       yyvsp[-4].dm.dm_mask,
					       (adv_entry *) 0,
					       yyvsp[-2].adv,
					       PARSE_METRIC_ISSET(&yyvsp[-1].metric) ? (pref_t) yyvsp[-1].metric.metric : RTPREF_STATIC,
					       yyvsp[0].flag,
					       parse_error)) {
				PARSE_ERROR;
			    }

			    sockfree(yyvsp[-4].dm.dm_dest);
			}
break;
case 368:
#line 2433 "parser.y"
{
#ifndef	VARIABLE_MASKS
#ifdef	PROTO_INET
			    if (socktype(yyvsp[0].dm.dm_dest) == AF_INET) {
				sockaddr_un *ifmask = inet_ifsubnetmask(sock2in(yyvsp[0].dm.dm_dest));

				if (!ifmask) {
				    ifmask = inet_mask_natural(yyvsp[0].dm.dm_dest);
				}

				if (ifmask != yyvsp[0].dm.dm_mask) {
				    sprintf(parse_error, "variable subnet masks not supported on this system");
				    PARSE_ERROR;
				}
			    }
#endif	/* PROTO_INET */
#endif	/* VARIABLE_MASKS */
			    yyval.dm = yyvsp[0].dm;			/* struct copy */
			}
break;
case 369:
#line 2453 "parser.y"
{
			    yyval.dm.dm_dest = sockdup(inet_addr_default);
			    yyval.dm.dm_mask = inet_mask_default;
			    trace(TR_PARSE, 0, "parse: %s DEST: %A MASK: %A",
				  parse_where(),
				  yyval.dm.dm_dest,
				  yyval.dm.dm_mask);
			}
break;
case 370:
#line 2462 "parser.y"
{
			    yyval.dm.dm_dest = iso_addr_default;
			    yyval.dm.dm_mask = iso_mask_default;
			    trace(TR_PARSE, 0, "parse: %s DEST: %A MASK: %A",
				  parse_where(),
				  yyval.dm.dm_dest,
				  yyval.dm.dm_mask);
			}
break;
case 371:
#line 2473 "parser.y"
{
			    yyval.flag = 0;
			}
break;
case 372:
#line 2477 "parser.y"
{
			    yyval.flag = yyvsp[-1].flag | yyvsp[0].flag;
			}
break;
case 373:
#line 2483 "parser.y"
{
			    yyval.flag = RTS_RETAIN;
			}
break;
case 374:
#line 2487 "parser.y"
{
			    yyval.flag = RTS_REJECT;
			}
break;
case 375:
#line 2491 "parser.y"
{
			    yyval.flag = RTS_BLACKHOLE;
			}
break;
case 376:
#line 2495 "parser.y"
{
			    yyval.flag = RTS_NOTINSTALL;
			}
break;
case 377:
#line 2503 "parser.y"
{
			    if (parse_new_state(PS_CONTROL)) {
				PARSE_ERROR;
			    }
			}
break;
case 378:
#line 2512 "parser.y"
{
#if	defined(PROTO_EGP) || defined(PROTO_BGP)
			    adv_entry *adv;
			    pmet_t *pp = &yyvsp[-1].metric_adv.metric;

			    /*
			     *	Tack the list of destinations onto the end of the list
			     *	for neighbors with the specified AS.
			     */
			    adv = adv_alloc(ADVFT_AS, yyvsp[-4].proto_lists.proto);
			    adv->adv_as = yyvsp[-2].as;
			    adv->adv_list = yyvsp[-1].metric_adv.adv;
			    if (PARSE_METRIC_ISSET(pp)) {
				if (PARSE_METRIC_ISRESTRICT(pp)) {
				    BIT_SET(adv->adv_flag, ADVF_NO);
				} else {
				    BIT_SET(adv->adv_flag, ADVFOT_PREFERENCE);
				    adv->adv_result.res_preference = pp->metric;
				}
			    }

			    if (!parse_adv_as(yyvsp[-4].proto_lists.import_list, adv)) {
				PARSE_ERROR;
			    }
#endif	/* defined(PROTO_EGP) || defined(PROTO_BGP) */
			}
break;
case 379:
#line 2539 "parser.y"
{
			    adv_entry *adv;
			    pmet_t *pp = &yyvsp[-1].metric_adv.metric;

			    /*
			     *	Tack the list of destinations onto the end of the list
			     *	for neighbors with the specified AS.
			     */
			    adv = adv_alloc(ADVFT_ASPATH, RTPROTO_BGP);
			    adv->adv_aspath = (caddr_t) yyvsp[-2].asp_match;
			    adv->adv_list = yyvsp[-1].metric_adv.adv;
			    if (PARSE_METRIC_ISSET(pp)) {
				if (PARSE_METRIC_ISRESTRICT(pp)) {
				    BIT_SET(adv->adv_flag, ADVF_NO);
				} else {
				    BIT_SET(adv->adv_flag, ADVFOT_PREFERENCE);
				    adv->adv_result.res_preference = pp->metric;
				}
			    }

			    if (parse_adv_append(&bgp_import_aspath_list, adv, TRUE)) {
				PARSE_ERROR;
			    }
			}
break;
case 380:
#line 2564 "parser.y"
{
			    /*
			     *	Append the dest_mask list to the end of the import list
			     *	for the specified protocol.
			     */
			    if (!parse_adv_propagate_preference(yyvsp[-2].adv, yyvsp[-3].proto_lists.proto, &yyvsp[-1].metric_adv.metric, yyvsp[-1].metric_adv.adv)) {
				PARSE_ERROR;
			    }

			    adv_free_list(yyvsp[-1].metric_adv.adv);

			    switch (yyvsp[-2].adv->adv_flag & ADVF_TYPE) {
			    case ADVFT_GW:
				/* Gateway list */
			        {
				    adv_entry *adv = yyvsp[-2].adv;
				    adv_entry *advn;

				    do {
					advn = adv->adv_next;
					adv->adv_next = NULL;
					/* Reset the type */
					adv->adv_flag = (adv->adv_flag & ~ADVF_TYPE) | ADVFT_ANY;
					if (parse_adv_append(&adv->adv_gwp->gw_import, adv, TRUE)) {
					    PARSE_ERROR;
					}
				    } while (adv = advn);
				}
				break;

			    case ADVFT_ANY:
				/* Global list */
				if (parse_adv_append(yyvsp[-3].proto_lists.import_list, yyvsp[-2].adv, TRUE)) {
				    PARSE_ERROR;
				}
				break;

			    case ADVFT_IFN:
			    case ADVFT_IFAE:
				/* Interface list */
				if (parse_adv_append(&int_import[yyvsp[-3].proto_lists.proto], yyvsp[-2].adv, TRUE)) {
				    PARSE_ERROR;
				}
				break;

			    default:
				assert(FALSE);
			    }
			}
break;
case 381:
#line 2614 "parser.y"
{
#if	defined(PROTO_EGP) || defined(PROTO_BGP)
			    adv_entry *adv;
			    adv_entry *adv_prop = yyvsp[-1].metric_adv.adv;
			    pmet_t *mp = &yyvsp[-1].metric_adv.metric;

			    /*
			     *	Tack the list of destinations onto the end of the list
			     *	for neighbors with the specified AS.
			     */
			    adv = adv_alloc(ADVFT_AS, yyvsp[-4].proto_lists.proto);
			    adv->adv_as = yyvsp[-2].as;
			    adv->adv_list = adv_prop;
			    if (PARSE_METRIC_ISRESTRICT(mp)) {
				BIT_SET(adv->adv_flag, ADVF_NO);
			    } else if (PARSE_METRIC_ISSET(mp)) {
				BIT_SET(adv->adv_flag, ADVFOT_METRIC);
				adv->adv_result.res_metric = mp->metric;
			    }

			    if (!parse_adv_as(yyvsp[-4].proto_lists.export_list, adv)) {
				PARSE_ERROR;
			    }
#endif	/* defined(PROTO_EGP) || defined(PROTO_BGP) */
			}
break;
case 382:
#line 2640 "parser.y"
{
			    /*
			     *	Append the dest_mask list to the end of the export list
			     *	for the specified protocol.
			     */

			    if (!parse_adv_propagate_metric(yyvsp[-2].adv, yyvsp[-3].proto_lists.proto, &yyvsp[-1].metric_adv.metric, yyvsp[-1].metric_adv.adv)) {
				PARSE_ERROR;
			    }

			    adv_free_list(yyvsp[-1].metric_adv.adv);

			    switch (yyvsp[-2].adv->adv_flag & ADVF_TYPE) {
			    case ADVFT_GW:
				/* Gateway list */
			        {
				    adv_entry *adv = yyvsp[-2].adv;
				    adv_entry *advn;
				
				    do {
					advn = adv->adv_next;
					adv->adv_next = NULL;
					if (parse_adv_append(&adv->adv_gwp->gw_export, adv, TRUE)) {
					    PARSE_ERROR;
					}
				    } while (adv = advn);
				}
				break;

			    case ADVFT_ANY:
				/* Global list for the protocol */
				if (parse_adv_append(yyvsp[-3].proto_lists.export_list, yyvsp[-2].adv, TRUE)) {
				    PARSE_ERROR;
				}
				break;

			    case ADVFT_IFN:
			    case ADVFT_IFAE:
				/* Interface list */
				if (parse_adv_append(&int_export[yyvsp[-3].proto_lists.proto], yyvsp[-2].adv, TRUE)) {
				    PARSE_ERROR;
				}
				break;

			    default:
				assert(FALSE);
			    }
			}
break;
case 383:
#line 2698 "parser.y"
{
			    parse_export_proto = yyval.proto_lists.proto = yyvsp[0].proto;

			    switch (yyvsp[0].proto) {
#if	defined(PROTO_EGP)
			    case RTPROTO_EGP:
				yyval.proto_lists.import_list = &egp_import_list;
				yyval.proto_lists.export_list = &egp_export_list;
				break;
#endif

#if	defined(PROTO_BGP)
			    case RTPROTO_BGP:
				yyval.proto_lists.import_list = &bgp_import_list;
				yyval.proto_lists.export_list = &bgp_export_list;
				break;
#endif

			    default:
				(void) sprintf(parse_error,
					       "unknown import protocol: %s",
					       gd_lower(trace_state(rt_proto_bits, yyvsp[0].proto)));
				PARSE_ERROR;
			    }
			}
break;
case 384:
#line 2727 "parser.y"
{
			    yyval.proto_lists = yyvsp[0].proto_lists;
			    
			    parse_proto = yyvsp[0].proto_lists.proto;
			    parse_gwlist = yyvsp[0].proto_lists.gw_list;

			    if (!yyvsp[0].proto_lists.import_list) {
				(void) sprintf(parse_error,
					       "unknown import protocol: %s",
					       gd_lower(trace_state(rt_proto_bits, yyvsp[0].proto_lists.proto)));
				PARSE_ERROR;
			    }
			    
			    trace(TR_PARSE, 0, "parse: %s PROTO: %s",
				  parse_where(),
				  gd_lower(trace_state(rt_proto_bits, yyvsp[0].proto_lists.proto)));
			}
break;
case 385:
#line 2748 "parser.y"
{
			    PARSE_METRIC_RESTRICT(&yyval.metric_adv.metric);
			    yyval.metric_adv.adv = (adv_entry *) 0;
			}
break;
case 386:
#line 2753 "parser.y"
{
			    yyval.metric_adv.metric = yyvsp[-3].metric;
			    yyval.metric_adv.adv = yyvsp[-1].adv;
			}
break;
case 387:
#line 2760 "parser.y"
{
			    yyval.adv = (adv_entry *) 0;
			}
break;
case 388:
#line 2764 "parser.y"
{
			    
			    yyval.adv = parse_adv_dm_append(yyvsp[-2].adv, yyvsp[-1].adv);
			    if (!yyval.adv) {
				PARSE_ERROR;
			    }
			}
break;
case 389:
#line 2772 "parser.y"
{
			    yyerrok;
			}
break;
case 390:
#line 2778 "parser.y"
{
			    parse_contig_masks = FALSE;
			}
break;
case 391:
#line 2782 "parser.y"
{
			    parse_contig_masks = TRUE;

			    yyval.adv = adv_alloc(ADVFT_DM, parse_proto);
			    yyval.adv->adv_dm = yyvsp[-1].dm;
			    if (PARSE_METRIC_ISSET(&yyvsp[0].metric)) {
				if (PARSE_METRIC_ISRESTRICT(&yyvsp[0].metric)) {
				    BIT_SET(yyval.adv->adv_flag, ADVF_NO);
				} else {
				    BIT_SET(yyval.adv->adv_flag, ADVFOT_PREFERENCE);
				    yyval.adv->adv_result.res_preference = yyvsp[0].metric.metric;
				}
			    }
			}
break;
case 392:
#line 2803 "parser.y"
{
			    yyval.proto_lists = yyvsp[0].proto_lists;
			    
			    parse_export_proto = parse_proto = yyvsp[0].proto_lists.proto;
			    parse_gwlist = yyvsp[0].proto_lists.gw_list;

			    if (!yyvsp[0].proto_lists.export_list) {
				(void) sprintf(parse_error,
					       "unknown export protocol: %s",
					       gd_lower(trace_state(rt_proto_bits, yyvsp[0].proto_lists.proto)));
				PARSE_ERROR;
			    }
			    
			    trace(TR_PARSE, 0, "parse: %s PROTO: %s",
				  parse_where(),
				  gd_lower(trace_state(rt_proto_bits, yyvsp[0].proto_lists.proto)));
			}
break;
case 393:
#line 2827 "parser.y"
{
			    PARSE_METRIC_RESTRICT(&yyval.metric_adv.metric);
			    yyval.metric_adv.adv = (adv_entry *) 0;
			}
break;
case 394:
#line 2832 "parser.y"
{
			    yyval.metric_adv.metric = yyvsp[-3].metric;
			    yyval.metric_adv.adv = yyvsp[-1].adv;
			}
break;
case 395:
#line 2840 "parser.y"
{
			    yyval.adv = (adv_entry *) 0;
			}
break;
case 396:
#line 2844 "parser.y"
{
			    yyval.adv = yyvsp[-2].adv;
			    if (parse_adv_append(&yyval.adv, yyvsp[-1].adv, TRUE)) {
				PARSE_ERROR;
			    }
			}
break;
case 397:
#line 2851 "parser.y"
{
			    yyerrok;
			}
break;
case 398:
#line 2857 "parser.y"
{
			    yyval.adv = adv_alloc(ADVFT_AS | ADVF_FIRST, (proto_t) 0);
			    yyval.adv->adv_as = yyvsp[-1].as;
			    yyval.adv = parse_adv_propagate_metric(yyval.adv, yyvsp[-3].proto, &yyvsp[0].metric_adv.metric, yyvsp[0].metric_adv.adv);
			}
break;
case 399:
#line 2864 "parser.y"
{
			    yyval.adv = adv_alloc(ADVFT_ASPATH | ADVF_FIRST, (proto_t) 0);
			    yyval.adv->adv_aspath = (caddr_t) yyvsp[-1].asp_match;
			    yyval.adv = parse_adv_propagate_metric(yyval.adv, yyvsp[-2].proto, &yyvsp[0].metric_adv.metric, yyvsp[0].metric_adv.adv);
			}
break;
case 400:
#line 2871 "parser.y"
{
			    yyval.adv = adv_alloc(ADVFT_TAG|ADVF_FIRST, (proto_t) 0);
			    yyval.adv->adv_tag = yyvsp[-1].metric.metric;
			    yyval.adv = parse_adv_propagate_metric(yyval.adv, yyvsp[-3].proto, &yyvsp[0].metric_adv.metric, yyvsp[0].metric_adv.adv);
			}
break;
case 401:
#line 2878 "parser.y"
{
			    yyval.adv = parse_adv_propagate_metric(yyvsp[-1].adv, yyvsp[-2].proto, &yyvsp[0].metric_adv.metric, yyvsp[0].metric_adv.adv);
			}
break;
case 402:
#line 2883 "parser.y"
{
			    yyval.adv = parse_adv_propagate_metric(yyvsp[-1].adv, yyvsp[-2].proto, &yyvsp[0].metric_adv.metric, yyvsp[0].metric_adv.adv);
			}
break;
case 403:
#line 2888 "parser.y"
{
			    yyval.adv = parse_adv_propagate_metric(yyvsp[-1].adv, yyvsp[-2].proto, &yyvsp[0].metric_adv.metric, yyvsp[0].metric_adv.adv);
			}
break;
case 404:
#line 2893 "parser.y"
{
			    yyval.adv = adv_alloc(ADVFT_ANY | ADVF_FIRST, (proto_t) 0);
			    yyval.adv = parse_adv_propagate_metric(yyval.adv, yyvsp[-1].proto, &yyvsp[0].metric_adv.metric, yyvsp[0].metric_adv.adv);
			}
break;
case 405:
#line 2900 "parser.y"
{
			    yyval.proto = parse_proto = RTPROTO_DIRECT;
			    parse_gwlist = (gw_entry **)0;
			    trace(TR_PARSE, 0, "parse: %s PROTO: %s",
				  parse_where(),
				  gd_lower(trace_state(rt_proto_bits, yyval.proto)));
			}
break;
case 406:
#line 2910 "parser.y"
{
			    yyval.proto = parse_proto = RTPROTO_STATIC;
			    parse_gwlist = &rt_gw_list;
			    trace(TR_PARSE, 0, "parse: %s PROTO: %s",
				  parse_where(),
				  gd_lower(trace_state(rt_proto_bits, yyval.proto)));
			}
break;
case 407:
#line 2920 "parser.y"
{
			    yyval.proto = parse_proto = RTPROTO_KERNEL;
			    parse_gwlist = &krt_gw_list;
			    trace(TR_PARSE, 0, "parse: %s PROTO: %s",
				  parse_where(),
				  gd_lower(trace_state(rt_proto_bits, yyval.proto)));
			}
break;
case 408:
#line 2930 "parser.y"
{
			    yyval.proto = parse_proto = RTPROTO_DEFAULT;
			    parse_gwlist = (gw_entry **)0;
			    trace(TR_PARSE, 0, "parse: %s PROTO: %s",
				  parse_where(),
				  gd_lower(trace_state(rt_proto_bits, yyval.proto)));
			}
break;
case 409:
#line 2941 "parser.y"
{
			    PARSE_METRIC_RESTRICT(&yyval.metric_adv.metric);
			    yyval.metric_adv.adv = (adv_entry *) 0;
			}
break;
case 410:
#line 2946 "parser.y"
{
			    yyval.metric_adv.metric = yyvsp[-1].metric;
			    yyval.metric_adv.adv = yyvsp[0].adv;
			}
break;
case 411:
#line 2954 "parser.y"
{
			    yyval.adv = (adv_entry *) 0;
			}
break;
case 412:
#line 2958 "parser.y"
{
			    yyval.adv = yyvsp[-1].adv;
			}
break;
case 413:
#line 2966 "parser.y"
{
			    yyval.adv = (adv_entry *) 0;
			}
break;
case 414:
#line 2970 "parser.y"
{
			    yyval.adv = parse_adv_dm_append(yyvsp[-2].adv, yyvsp[-1].adv);
			    if (!yyval.adv) {
				PARSE_ERROR;
			    }
			}
break;
case 415:
#line 2977 "parser.y"
{
			    yyerrok;
			}
break;
case 416:
#line 2983 "parser.y"
{
			    parse_contig_masks = FALSE;
			}
break;
case 417:
#line 2987 "parser.y"
{
			    parse_contig_masks = TRUE;

			    yyval.adv = adv_alloc(ADVFT_DM, (proto_t) 0);
			    yyval.adv->adv_dm = yyvsp[-1].dm;
			    if (PARSE_METRIC_ISRESTRICT(&yyvsp[0].metric)) {
				BIT_SET(yyval.adv->adv_flag, ADVF_NO);
			    } else if (PARSE_METRIC_ISSET(&yyvsp[0].metric)) {
				yyval.adv->adv_result.res_metric = yyvsp[0].metric.metric;
				BIT_SET(yyval.adv->adv_flag, ADVFOT_METRIC);
			    }
			}
break;
case 418:
#line 3006 "parser.y"
{
			    assert(FALSE);
			}
break;
case 425:
#line 3022 "parser.y"
{
			    yyval.dm.dm_dest = yyval.dm.dm_mask = (sockaddr_un *) 0;
			    trace(TR_PARSE, 0, "parse: %s DEST: all",
				  parse_where());
			}
break;
case 426:
#line 3030 "parser.y"
{
			    assert(FALSE);
			}
break;
case 427:
#line 3034 "parser.y"
{
			    yyval.dm.dm_dest = sockdup(inet_addr_default);
			    yyval.dm.dm_mask = inet_mask_host;
			    trace(TR_PARSE, 0, "parse: %s DEST: %A",
				  parse_where(),
				  yyval.dm.dm_dest);
			}
break;
case 428:
#line 3042 "parser.y"
{
#ifdef	XXX
			    yyval.dm.dm_dest = sockdup(iso_addr_default);
			    yyval.dm.dm_dest = iso_mask_natural(iso_addr_default);
#endif	/* XXX */
			    assert(FALSE);
			}
break;
case 429:
#line 3052 "parser.y"
{
			    assert(FALSE);
			}
break;
case 430:
#line 3056 "parser.y"
{
			    yyval.sockaddr = inet_mask_locate(yyvsp[0].in_addr.s_addr);
			    if (!yyval.sockaddr) {
				if (parse_contig_masks) {
				    (void) sprintf(parse_error, "mask not contiguous");
				    PARSE_ERROR;
				} else {
				    yyval.sockaddr = mask_locate(sockbuild_in(0, yyvsp[0].in_addr.s_addr));
				}
			    }
			    trace(TR_PARSE, 0, "parse: %s MASK: %A",
				  parse_where(),
				  yyval.sockaddr);
			}
break;
case 431:
#line 3071 "parser.y"
{
			    yyval.sockaddr = iso_mask_locate(yyvsp[0].sockaddr);
			    sockfree(yyvsp[0].sockaddr);
			    trace(TR_PARSE, 0, "parse: %s MASK: %A",
				  parse_where(),
				  yyval.sockaddr);
			}
break;
case 432:
#line 3082 "parser.y"
{
			    yyval.adv = adv_alloc(ADVFT_GW | ADVF_FIRST, (proto_t) 0);
			    yyval.adv->adv_gwp = yyvsp[0].gwp;
			}
break;
case 433:
#line 3087 "parser.y"
{
			    adv_entry *adv = adv_alloc(ADVFT_GW, (proto_t) 0);

			    adv->adv_gwp = yyvsp[0].gwp;
			    yyval.adv = yyvsp[-1].adv;
			    if (parse_adv_append(&yyval.adv, adv, TRUE)) {
				PARSE_ERROR;
			    }
			}
break;
case 434:
#line 3100 "parser.y"
{
			    /*
			     *	Make sure host is on a locally attached network then
			     *	find or create a gw structure for it.  Requires that
			     *	parse_proto and parse_gwlist are previously set
			     */
			    if (!if_parse_withdst(yyvsp[0].sockaddr)) {
				(void) sprintf(parse_error, "gateway not a host address on an attached network: '%A'",
					       yyvsp[0].sockaddr);
				if (BIT_TEST(task_state, TASKS_STRICTIFS)) {
				    PARSE_ERROR;
				} else {
				    yyerror(parse_error);
				}
			    }
			    if (!parse_gwlist) {
				(void) sprintf(parse_error, "gateway specification not valid for %s",
					       trace_state(rt_proto_bits, parse_proto));
				PARSE_ERROR;
			    }
			    yyval.gwp = gw_locate(parse_gwlist,
					   parse_proto,
					   (task *) 0,
					   (as_t) 0,
					   (as_t) 0,
					   (time_t) 0,
					   yyvsp[0].sockaddr,
					   (flag_t) 0);
			    trace(TR_PARSE, 0, "parse: %s GATEWAY: %A  PROTO: %s",
				  parse_where(),
				  yyval.gwp->gw_addr,
				  gd_lower(trace_state(rt_proto_bits, yyval.gwp->gw_proto)));
			    sockfree(yyvsp[0].sockaddr);
			}
break;
case 435:
#line 3138 "parser.y"
{ 
			    sockaddr_un *addr;

			    if (BIT_TEST(task_state, TASKS_NORESOLV)
				|| !(addr = parse_addr_hostname(yyvsp[0].str.ptr))) {
				PARSE_ERROR;
			    }
			    yyval.sockaddr = sockdup(addr);
			    trace(TR_PARSE, 0, "parse: %s HOST: %A",
				  parse_where(),
				  yyval.sockaddr);
			    free_charstr(&yyvsp[0].str);
			}
break;
case 436:
#line 3152 "parser.y"
{
			    yyval.sockaddr = yyvsp[0].sockaddr;
			    trace(TR_PARSE, 0, "parse: %s HOST: %A",
				  parse_where(),
				  yyval.sockaddr);
			}
break;
case 437:
#line 3161 "parser.y"
{
			    yyval.dm.dm_dest = yyvsp[0].sockaddr;
			    yyval.dm.dm_mask = sockhostmask(yyvsp[0].sockaddr);

			    trace(TR_PARSE, 0, "parse: %s DEST: %A",
				  parse_where(),
				  yyval.dm.dm_dest);
			}
break;
case 438:
#line 3173 "parser.y"
{
			    sockaddr_un *addr;

			    if (BIT_TEST(task_state, TASKS_NORESOLV)
				|| !(addr = parse_addr_netname(yyvsp[0].str.ptr))) {
				PARSE_ERROR;
			    }
			    yyval.sockaddr = sockdup(addr);
			    trace(TR_PARSE, 0, "parse: %s NETWORK: %A",
				  parse_where(),
				  yyval.sockaddr);
			    free_charstr(&yyvsp[0].str);
			}
break;
case 439:
#line 3187 "parser.y"
{
			    yyval.sockaddr = yyvsp[0].sockaddr;
			    trace(TR_PARSE, 0, "parse: %s NETWORK: %A",
				  parse_where(),
				  yyval.sockaddr);
			}
break;
case 440:
#line 3196 "parser.y"
{
			    yyval.dm.dm_dest = yyvsp[0].sockaddr;
			    switch (socktype(yyvsp[0].sockaddr)) {
#ifdef	PROTO_INET
			    case AF_INET:
				yyval.dm.dm_mask = inet_mask_natural(yyvsp[0].sockaddr);
				if (sock2ip(yyval.dm.dm_dest) & ~sock2ip(yyval.dm.dm_mask)) {
				    sprintf(parse_error, "host or mask option needed");
				    PARSE_ERROR;
				}
				break;
#endif	/* PROTO_INET */
#ifdef	PROTO_ISO
			    case AF_ISO:
				yyval.dm.dm_mask = iso_mask_natural(yyvsp[0].sockaddr);
				break;
#endif	/* PROTO_ISO */
			    default:
				assert(FALSE);
			    }
			    
			    trace(TR_PARSE, 0, "parse: %s DEST: %A MASK: %A",
				  parse_where(),
				  yyval.dm.dm_dest,
				  yyval.dm.dm_mask);
			}
break;
case 441:
#line 3223 "parser.y"
{
			    yyval.dm.dm_dest = yyvsp[-2].sockaddr;
			    switch (socktype(yyvsp[-2].sockaddr)) {
#ifdef	PROTO_INET
			    case AF_INET:
				if (parse_limit_check("inet mask bits",
						      (u_int) yyvsp[0].num,
						      INET_LIMIT_MASKLEN)) {
				    PARSE_ERROR;
				}
				yyval.dm.dm_mask = inet_masks[yyvsp[0].num];
				break;
#endif	/* PROTO_INET */
#ifdef	PROTO_ISO
			    case AF_ISO:
				if (parse_limit_check("iso mask bits",
						      (u_int) yyvsp[0].num,
						      ISO_LIMIT_MASKLEN)) {
				    PARSE_ERROR;
				}
				yyval.dm.dm_mask = iso_masks[yyvsp[0].num];
				break;
#endif	/* PROTO_ISO */
			    default:
				assert(FALSE);
			    }
			    trace(TR_PARSE, 0, "parse: %s DEST: %A MASK: %A",
				  parse_where(),
				  yyval.dm.dm_dest,
				  yyval.dm.dm_mask);
			}
break;
case 442:
#line 3255 "parser.y"
{
			    register byte *ap = yyvsp[-2].sockaddr->a.sa_data;
			    register byte *mp = yyvsp[0].sockaddr->a.sa_data;
			    register byte *alp = (byte *) yyvsp[-2].sockaddr + socksize(yyvsp[-2].sockaddr);
			    register byte *mlp = (byte *) yyvsp[0].sockaddr + socksize(yyvsp[0].sockaddr);

			    if (socktype(yyvsp[-2].sockaddr) != socktype(yyvsp[0].sockaddr)) {
				sprintf(parse_error, "Network %A and mask %A are not the same family",
					yyvsp[-2].sockaddr,
					yyvsp[0].sockaddr);
				PARSE_ERROR;
			    }
			    
			    /* Skip zero fields */
			    while (!*ap && ap < alp) {
				ap++, mp++;
			    }
			    
			    while (ap < alp) {
				if (mp < mlp) {
				    if (*ap++ & ~*mp++) {
					break;
				    }
				} else {
				    if (*ap++) {
					break;
				    }
				}
			    }
			    if (ap < alp) {
				sprintf(parse_error, "Non-masked bits not zero for %A mask %A",
					yyvsp[-2].sockaddr,
					yyvsp[0].sockaddr);
				PARSE_ERROR;
			    }

			    yyval.dm.dm_dest = yyvsp[-2].sockaddr;
			    yyval.dm.dm_mask = yyvsp[0].sockaddr;
			    trace(TR_PARSE, 0, "parse: %s DEST: %A MASK: %A",
				  parse_where(),
				  yyval.dm.dm_dest,
				  yyval.dm.dm_mask);
			}
break;
case 443:
#line 3302 "parser.y"
{
			    yyval.sockaddr = sockdup(sockbuild_in(0, yyvsp[0].in_addr.s_addr));

			    trace(TR_PARSE, 0, "parse: %s IP_ADDR: %A",
				  parse_where(),
				  yyval.sockaddr);
			}
break;
case 444:
#line 3312 "parser.y"
{
			    u_int32 addr = yyvsp[0].num;
			    
			    if (addr) {
				/* Normalize the address */
				while (!(addr & 0xff000000)) {
				    addr <<= 8;
				}
			    }
			    yyval.in_addr.s_addr = htonl(addr);
			}
break;
case 445:
#line 3324 "parser.y"
{
			    int i;
			    u_int32 addr = 0;

			    if (yyvsp[0].hex.len > sizeof(addr)) {
				sprintf(parse_error, "octet or hex string too long to be an IP address");
				PARSE_ERROR;
			    }

			    for (i = 0; i < sizeof(addr); i++) {
				addr <<= 8;
				if (i < yyvsp[0].hex.len) {
				    BIT_SET(addr, yyvsp[0].hex.ptr[i]);
				}
			    }
			    yyval.in_addr.s_addr = htonl(addr);
			    free_bytestr(&yyvsp[0].hex);
			}
break;
case 446:
#line 3346 "parser.y"
{
			    yyval.str = yyvsp[0].str;
			    yyval.str.ptr = task_mem_strdup((task *) 0, yyvsp[0].str.ptr);
			}
break;
case 447:
#line 3351 "parser.y"
{
			    yyval.str = yyvsp[0].str;
			    yyval.str.ptr = task_mem_strdup((task *) 0, yyvsp[0].str.ptr);
			}
break;
case 449:
#line 3360 "parser.y"
{
#if	defined(PROTO_ICMP) || defined(KRT_RT_SOCK)
			    yyval.proto_lists.proto = RTPROTO_REDIRECT;
			    yyval.proto_lists.import_list = &redirect_import_list;
			    yyval.proto_lists.export_list = (adv_entry **) 0;
			    yyval.proto_lists.gw_list = &redirect_gw_list;
#endif	/* defined(PROTO_ICMP) || defined(KRT_RT_SOCK) */
			}
break;
case 450:
#line 3372 "parser.y"
{
			    assert(FALSE);
			}
break;
case 452:
#line 3378 "parser.y"
{ yyval.num = T_ON; }
break;
case 453:
#line 3379 "parser.y"
{ yyval.num = T_OFF; }
break;
case 454:
#line 3385 "parser.y"
{
			    PARSE_METRIC_SET(&yyval.metric, yyvsp[0].num);
			    trace(TR_PARSE, 0, "parse: %s METRIC: %d",
				  parse_where(),
				  yyval.metric.metric);
			}
break;
case 455:
#line 3392 "parser.y"
{
			    PARSE_METRIC_INFINITY(&yyval.metric);
			    trace(TR_PARSE, 0, "parse: %s METRIC: infinity",
				  parse_where());
			}
break;
case 456:
#line 3400 "parser.y"
{
			    PARSE_METRIC_CLEAR(&yyval.metric);
			}
break;
case 457:
#line 3404 "parser.y"
{
			    yyval.metric = yyvsp[0].metric;
			}
break;
case 458:
#line 3411 "parser.y"
{
			    PARSE_METRIC_CLEAR(&yyval.metric);
			}
break;
case 459:
#line 3415 "parser.y"
{
			    PARSE_METRIC_RESTRICT(&yyval.metric);
			}
break;
case 460:
#line 3419 "parser.y"
{
			    if (parse_metric_check(parse_export_proto, &yyvsp[0].metric)) {
				PARSE_ERROR;
			    }
			    yyval.metric = yyvsp[0].metric;
			}
break;
case 461:
#line 3430 "parser.y"
{
			    PARSE_METRIC_CLEAR(&yyval.metric);
			}
break;
case 462:
#line 3434 "parser.y"
{
			    PARSE_METRIC_SET(&yyval.metric, yyvsp[0].pref);
			}
break;
case 464:
#line 3442 "parser.y"
{
			    PARSE_METRIC_RESTRICT(&yyval.metric);
			}
break;
case 465:
#line 3448 "parser.y"
{
			    if (parse_limit_check("preference",
						  (u_int) yyvsp[0].num,
						  LIMIT_PREFERENCE)) {
				PARSE_ERROR;
			    }
			    yyval.pref = yyvsp[0].num;
			}
break;
case 466:
#line 3461 "parser.y"
{
			    /* Remove quotes from the string if present */
			    char *cp;

			    yyval.str = yyvsp[0].str;
				
			    switch (*yyval.str.ptr) {
			    case '<':
				*yyval.str.ptr = '>';
				/* Fall through */

			    case '"':
				cp = &yyval.str.ptr[yyval.str.len-1];
				if (*cp == *yyval.str.ptr) {
				    *cp = (char) 0;
				    yyval.str.len -= 2;
				    cp = yyval.str.ptr + 1;
				    break;
				}
				/* Fall Through */

			    default:
				cp = yyval.str.ptr;
			    }

			    yyval.str.ptr = task_mem_strdup((task *) 0, cp);
			    trace(TR_PARSE, 0, "parse: %s STRING: \"%s\" length: %d",
				  parse_where(),
				  yyval.str.ptr,
				  yyval.str.len);
			}
break;
case 468:
#line 3497 "parser.y"
{
			    int i = 0;
			    int len = sizeof(yyval.num);

			    yyval.num = 0;
			    if (yyvsp[0].hex.len > len) {
				sprintf(parse_error, "octet or hex string too long to be a number");
				PARSE_ERROR;
			    } else if (yyvsp[0].hex.len < len) {
				len = yyvsp[0].hex.len;
			    }

			    while (i < len) {
				yyval.num = (yyval.num << 8) | yyvsp[0].hex.ptr[i++];
			    }
			    free_bytestr(&yyvsp[0].hex);
			}
break;
case 471:
#line 3522 "parser.y"
{
			    if (parse_limit_check("seconds",
						  (u_int) yyvsp[0].num,
						  LIMIT_NATURAL)) {
				PARSE_ERROR;
			    };
			    yyval.time = yyvsp[0].num;
			}
break;
case 472:
#line 3531 "parser.y"
{
			    if (parse_limit_check("minutes",
						  (u_int) yyvsp[-2].num,
						  LIMIT_NATURAL)) {
				PARSE_ERROR;
			    }
			    if (parse_limit_check("seconds",
						  (u_int) yyvsp[0].num,
						  LIMIT_SECONDS)) {
				PARSE_ERROR;
			    }
			    yyval.time = (yyvsp[-2].num * 60) + yyvsp[0].num;
			}
break;
case 473:
#line 3545 "parser.y"
{
			    if (parse_limit_check("hours",
						  (u_int) yyvsp[-4].num,
						  LIMIT_NATURAL)) {
				PARSE_ERROR;
			    }
			    if (parse_limit_check("minutes",
						  (u_int) yyvsp[-2].num,
						  LIMIT_MINUTES)) {
				PARSE_ERROR;
			    }
			    if (parse_limit_check("seconds",
						  (u_int) yyvsp[0].num,
						  LIMIT_SECONDS)) {
				PARSE_ERROR;
			    }
			    yyval.time = ((yyvsp[-4].num * 60) + yyvsp[-2].num) * 60 + yyvsp[0].num;
			}
break;
case 474:
#line 3567 "parser.y"
{
			    if (parse_limit_check("port",
						  (u_int) yyvsp[0].num,
						  LIMIT_PORT)) {
				PARSE_ERROR;
			    }
			    yyval.num = htons(yyvsp[0].num);
			}
break;
case 475:
#line 3576 "parser.y"
{
			    const struct servent *sp;

			    if (!(sp = getservbyname(yyvsp[0].str.ptr, parse_serv_proto))) {
				(void) sprintf(parse_error, "unknown protocol %s/%s",
					yyvsp[0].str.ptr, parse_serv_proto);
				PARSE_ERROR;
			    }

			    yyval.num = sp->s_port;

			    trace(TR_PARSE, 0, "parse: %s PORT %s (%d)",
				  parse_where(),
				  yyvsp[0].str.ptr,
				  ntohs(yyval.num));
			}
break;
case 476:
#line 3598 "parser.y"
{
			    if (parse_limit_check("autonomous system",
						  (u_int) yyvsp[0].num,
						  LIMIT_AS)) {
				PARSE_ERROR;
			    }
			    yyval.as = yyvsp[0].num;
			}
break;
case 477:
#line 3609 "parser.y"
{
			    yyval.adv = adv_alloc(ADVFT_AS | ADVF_FIRST, (proto_t) 0);
			    yyval.adv->adv_as = yyvsp[0].as;
			}
break;
case 478:
#line 3614 "parser.y"
{
			    adv_entry *adv = adv_alloc(ADVFT_AS, (proto_t) 0);

			    adv->adv_as = yyvsp[0].as;
			    yyval.adv = yyvsp[-1].adv;
			    if (parse_adv_append(&yyval.adv, adv, TRUE)) {
				PARSE_ERROR;
			    }
			}
break;
case 479:
#line 3626 "parser.y"
{
			    yyval.adv = (adv_entry *) 0;
			}
break;
case 480:
#line 3630 "parser.y"
{
			    yyval.adv = yyvsp[0].adv;
			}
break;
case 481:
#line 3641 "parser.y"
{
			    PARSE_METRIC_CLEAR(&yyval.metric);
			}
break;
case 482:
#line 3645 "parser.y"
{
			    yyval.metric = yyvsp[0].metric;
			}
break;
case 484:
#line 3652 "parser.y"
{
			    PARSE_METRIC_ALTERNATE(&yyval.metric, 0);
			}
break;
case 485:
#line 3656 "parser.y"
{
			    if (parse_limit_check("external-route-tag",
						  (u_int) yyvsp[0].num,
						  PATH_OSPF_TAG_USR_LIMIT)) {
				PARSE_ERROR;
			    }
			    PARSE_METRIC_ALTERNATE(&yyval.metric, yyvsp[0].num);
			}
break;
case 486:
#line 3667 "parser.y"
{
			    PARSE_METRIC_CLEAR(&yyval.metric);
			}
break;
case 487:
#line 3671 "parser.y"
{
			    yyval.metric = yyvsp[0].metric;
			}
break;
case 488:
#line 3677 "parser.y"
{
			    if (parse_limit_check("external-route-tag",
						  (u_int) yyvsp[0].num,
						  PATH_OSPF_TAG_LIMIT)) {
				PARSE_ERROR;
			    }
			    PARSE_METRIC_SET(&yyval.metric, yyvsp[0].num);
			}
break;
case 491:
#line 3700 "parser.y"
{
			    aspath_state = 0;
			    aspath_current = (asmatch_t *) task_block_alloc(aspath_match_index);
			}
break;
case 492:
#line 3705 "parser.y"
{
			    yyval.asp_match = aspath_current;
			    yyval.asp_match->origin_mask = yyvsp[0].flag;
			    trace(TR_PARSE, 0, "%s: path %X origins %s",
				  parse_where(),
				  yyval.asp_match,
				  aspath_adv_origins(yyval.asp_match->origin_mask));
			    aspath_current = (asmatch_t *) 0;
			}
break;
case 493:
#line 3717 "parser.y"
{
			    /* Set all bits on */
			    yyval.flag = -1;
			}
break;
case 496:
#line 3727 "parser.y"
{
			    yyval.flag = yyvsp[-2].flag | yyvsp[0].flag;
			}
break;
case 497:
#line 3733 "parser.y"
{
			    yyval.flag = (1 << PATH_ORG_IGP);
			}
break;
case 498:
#line 3737 "parser.y"
{
			    yyval.flag = (1 << PATH_ORG_EGP);
			}
break;
case 499:
#line 3741 "parser.y"
{
			    yyval.flag = (1 << PATH_ORG_XX);
			}
break;
case 500:
#line 3747 "parser.y"
{
			    NFA_ASG(yyval.asp_stack.start, yyvsp[0].asp_stack.start);
			    NFA_ASG(aspath_current->start, yyval.asp_stack.start);
			    trace(TR_PARSE, 0, "%s: REDUCED:	regex : sum",
				  parse_where());
			}
break;
case 501:
#line 3754 "parser.y"
{
			    NFA_OR(yyval.asp_stack.start, yyvsp[-2].asp_stack.start, yyvsp[0].asp_stack.start);
			    NFA_OR(yyval.asp_stack.state, yyvsp[-2].asp_stack.state, yyvsp[0].asp_stack.state);
			    NFA_ASG(aspath_current->start, yyval.asp_stack.start);
			    trace(TR_PARSE, 0, "%s: REDUCED:	regex : sum | regex",
				  parse_where());
			}
break;
case 502:
#line 3764 "parser.y"
{
			    trace(TR_PARSE, 0, "%s: REDUCED:	sum : term",
				  parse_where());
			}
break;
case 503:
#line 3769 "parser.y"
{
			    int i;
			    
			    NFA_OR(yyval.asp_stack.state, yyvsp[-1].asp_stack.state, yyvsp[0].asp_stack.state);

			    for (i = 0; i < ASP_ACC; i++) {
				int nonzero;
				
				if (NFA_ISSET(yyvsp[-1].asp_stack.state, i)) {
				    if (NFA_ISSET(aspath_current->nfa[i].next, ASP_ACC)) {
					NFA_CLR(aspath_current->nfa[i].next, ASP_ACC);
					NFA_OR(aspath_current->nfa[i].next, aspath_current->nfa[i].next, yyvsp[0].asp_stack.start);
				    }
				    NFA_CLR(yyvsp[-1].asp_stack.state, i);
				    NFA_NONZERO(yyvsp[-1].asp_stack.state, nonzero);
				    if (nonzero) {
					break;
				    }
				}
			    }
			    if (i > ASP_ACC) {
				YYERROR;
			    }
			    if (NFA_ISSET(yyvsp[-1].asp_stack.start, ASP_ACC)) {
				NFA_CLR(yyvsp[-1].asp_stack.start, ASP_ACC);
				NFA_OR(yyvsp[-1].asp_stack.start, yyvsp[-1].asp_stack.start, yyvsp[0].asp_stack.start);
			    }
			    NFA_ASG(yyval.asp_stack.start, yyvsp[-1].asp_stack.start);
			    trace(TR_PARSE, 0, "%s: REDUCED:	sum : term sum",
				  parse_where());
			}
break;
case 504:
#line 3803 "parser.y"
{
			    trace(TR_PARSE, 0, "%s: REDUCED:	term : symbol",
				  parse_where());
			}
break;
case 505:
#line 3808 "parser.y"
{
			    int i;
			    
			    for (i = 0; i < ASP_ACC; i++) {
				if (NFA_ISSET(yyvsp[-1].asp_stack.state, i)) {
				    int nonzero;
				
				    if (NFA_ISSET(aspath_current->nfa[i].next, ASP_ACC)) {
					NFA_OR(aspath_current->nfa[i].next, aspath_current->nfa[i].next, yyvsp[-1].asp_stack.start);
				    }
				    NFA_CLR(yyvsp[-1].asp_stack.state, i);
				    NFA_NONZERO(yyvsp[-1].asp_stack.state, nonzero);
				    if (nonzero) {
					break;
				    }
				}
			    }
			    NFA_ASG(yyval.asp_stack.start, yyvsp[-1].asp_stack.start);
			    NFA_SET(yyval.asp_stack.start, ASP_ACC);
			    trace(TR_PARSE, 0, "%s: REDUCED:	term : symbol *",
				  parse_where());
			}
break;
case 506:
#line 3831 "parser.y"
{
			    int i;
			    
			    for (i = 0; i < ASP_ACC; i++) {
				if (NFA_ISSET(yyvsp[-1].asp_stack.state, i)) {
				    int nonzero;
				    
				    if (NFA_ISSET(aspath_current->nfa[i].next, ASP_ACC)) {
					NFA_OR(aspath_current->nfa[i].next, aspath_current->nfa[i].next, yyvsp[-1].asp_stack.start);
				    }
				    NFA_CLR(yyvsp[-1].asp_stack.state, i);
				    NFA_NONZERO(yyvsp[-1].asp_stack.state, nonzero);
				    if (nonzero) {
					break;
				    }
				}
			    }
			    NFA_ASG(yyval.asp_stack.start, yyvsp[-1].asp_stack.start);
			    trace(TR_PARSE, 0, "%s: REDUCED:	term : symbol +",
				  parse_where());
			}
break;
case 507:
#line 3853 "parser.y"
{
			    NFA_ASG(yyval.asp_stack.start, yyvsp[-1].asp_stack.start);
			    NFA_SET(yyval.asp_stack.start, ASP_ACC);
			    trace(TR_PARSE, 0, "%s: REDUCED:	term : symbol ?",
				  parse_where());
			}
break;
case 508:
#line 3860 "parser.y"
{
			    int copy;
			    flag_t finalstate[1 + ASP_ACC / ASP_WORD];
			    flag_t newstate[1 + ASP_ACC / ASP_WORD];
			    flag_t oldstate[1 + ASP_ACC / ASP_WORD];
			    flag_t newstart[1 + ASP_ACC / ASP_WORD];
			    
			    NFA_ASG(finalstate, yyvsp[-3].asp_stack.state);
			    NFA_ASG(newstate, yyvsp[-3].asp_stack.state);
			    NFA_ASG(yyval.asp_stack.start, yyvsp[-3].asp_stack.start);
			    NFA_ASG(newstart, yyvsp[-3].asp_stack.start);
			    if (!yyvsp[-1].asp_range.begin) {
				NFA_SET(yyval.asp_stack.start, ASP_ACC);
			    }
			    for (copy = 1; copy < yyvsp[-1].asp_range.begin; copy++) {
				int i;
				
				NFA_ASG(oldstate, yyvsp[-3].asp_stack.state);
				NFA_ZERO(newstart);
				NFA_ZERO(newstate);
				for (i = 0; i < ASP_ACC; i++) {
				    if (NFA_ISSET(yyvsp[-3].asp_stack.state, i)) {
					aspath_current->nfa[aspath_state].as = aspath_current->nfa[i].as;
					NFA_ASG(aspath_current->nfa[aspath_state].next, aspath_current->nfa[i].next);
					NFA_SHIFT(aspath_current->nfa[aspath_state].next, aspath_state-i);
					NFA_SET(newstate, aspath_state);
					if (NFA_ISSET(yyvsp[-3].asp_stack.start, i)) {
					    int nonzero;
					    
					    NFA_SET(newstart, aspath_state);
					    ASPATH_NEXT_STATE;
					    NFA_CLR(yyvsp[-3].asp_stack.state, i);
					    NFA_NONZERO(yyvsp[-3].asp_stack.state, nonzero);
					    if (nonzero) {
						break;
					    }
					}
				    }
				    if (NFA_ISSET(yyval.asp_stack.start, ASP_ACC)) {
					NFA_OR(yyval.asp_stack.start,yyval.asp_stack.start,newstart);
				    }
				    for (i = 0; i < ASP_ACC; i++) {
					if (NFA_ISSET(oldstate, i)) {
					    int nonzero;
					    
					    if (NFA_ISSET(aspath_current->nfa[i].next, ASP_ACC)) {
						if (copy < yyvsp[-1].asp_range.begin) {
						    NFA_CLR(aspath_current->nfa[i].next, ASP_ACC);
						}
						NFA_OR(aspath_current->nfa[i].next, aspath_current->nfa[i].next, newstart);
					    }
					    NFA_CLR(oldstate, i);
					    NFA_NONZERO(oldstate, nonzero);
					    if (nonzero) {
						break;
					    }
					}
				    }
				    NFA_OR(finalstate, finalstate, newstate);
				    NFA_ASG(yyvsp[-3].asp_stack.start, newstart);
				    NFA_ASG(yyvsp[-3].asp_stack.state, newstate);
				}
				if (yyvsp[-1].asp_range.end) {
				    for (i = 0; i < ASP_ACC; i++) {
					if (NFA_ISSET(newstate, i)) {
					    int nonzero;
					    
					    if (NFA_ISSET(aspath_current->nfa[i].next, ASP_ACC)) {
						NFA_OR(aspath_current->nfa[i].next, aspath_current->nfa[i].next, newstart);
					    }
					    NFA_CLR(newstate, i);
					    NFA_NONZERO(newstate, nonzero);
					    if (nonzero) {
						break;
					    }
					}
				    }
				}	
				NFA_ASG(yyval.asp_stack.state, finalstate);
				trace(TR_PARSE, 0, "%s: REDUCED:	term : symbol { range }",
				      parse_where());
			    }
			}
break;
case 509:
#line 3946 "parser.y"
{
			    NFA_ZERO(yyval.asp_stack.start);
			    NFA_ZERO(yyval.asp_stack.state);
			    NFA_SET(yyval.asp_stack.start, aspath_state);
			    NFA_SET(yyval.asp_stack.state, aspath_state);
			    aspath_current->nfa[aspath_state].as = htons(yyvsp[0].as);
			    NFA_SET(aspath_current->nfa[aspath_state].next, ASP_ACC);
			    ASPATH_NEXT_STATE;
			    trace(TR_PARSE, 0, "%s: REDUCED:	symbol : %d",
				  parse_where(),
				  yyvsp[0].as);
			}
break;
case 510:
#line 3959 "parser.y"
{
			    NFA_ZERO(yyval.asp_stack.start);
			    NFA_ZERO(yyval.asp_stack.state);
			    NFA_SET(yyval.asp_stack.start, aspath_state);
			    NFA_SET(yyval.asp_stack.state, aspath_state);
			    NFA_SET(aspath_current->nfa[aspath_state].next, ASP_ACC);
			    aspath_current->nfa[aspath_state].as = 0;
			    ASPATH_NEXT_STATE;
			    trace(TR_PARSE, 0, "%s: REDUCED:	symbol : .",
				  parse_where());
			}
break;
case 511:
#line 3971 "parser.y"
{
			    NFA_ASG(yyval.asp_stack.state, yyvsp[-1].asp_stack.state);
			    NFA_ASG(yyval.asp_stack.start, yyvsp[-1].asp_stack.start);
			    trace(TR_PARSE, 0, "%s: REDUCED:	symbol : ( regex )",
				  parse_where());
			}
break;
case 512:
#line 3979 "parser.y"
{
			    yyval.asp_range.begin = yyvsp[0].num;
			    yyval.asp_range.end = 0;
			    if (!yyvsp[0].num) {
				sprintf(parse_error, "invalid range start: %d",
					yyvsp[0].num);
				PARSE_ERROR;
			    }
			    trace(TR_PARSE, 0, "%s: RANGE: {%d}",
				  parse_where(),
				  yyval.asp_range.begin);
			}
break;
case 513:
#line 3992 "parser.y"
{
			    yyval.asp_range.begin = yyvsp[-1].num;
			    yyval.asp_range.end = 1;
			    if (!yyvsp[-1].num) {
				sprintf(parse_error, "invalid range start: %d",
					yyvsp[-1].num);
				PARSE_ERROR;
			    }
			    trace(TR_PARSE, 0, "%s: RANGE: {%d,}",
				  parse_where(),
				  yyval.asp_range.begin);
			}
break;
case 514:
#line 4005 "parser.y"
{
			    yyval.asp_range.begin = yyvsp[-2].num;
			    yyval.asp_range.end = yyvsp[0].num;
			    if (!yyvsp[-2].num) {
				sprintf(parse_error, "invalid range start: %d",
					yyvsp[-2].num);
				PARSE_ERROR;
			    }
			    if (yyvsp[0].num < yyvsp[-2].num || !yyvsp[0].num) {
				sprintf(parse_error, "invalid range end: %d",
					yyvsp[0].num);
				PARSE_ERROR;
			    }
			    trace(TR_PARSE, 0, "%s: RANGE: {%d,%d}",
				  parse_where(),
				  yyval.asp_range.begin,
				  yyval.asp_range.end);
			}
break;
case 515:
#line 4027 "parser.y"
{
			    if (yyvsp[0].hex.len > ISO_MAXADDRLEN) {
				sprintf(parse_error, "ISO address has too many bytes (%d), %d maximum",
					yyvsp[0].hex.len,
					ISO_MAXADDRLEN);
				PARSE_ERROR;
			    }
			    
			    yyval.sockaddr = sockdup(sockbuild_iso(yyvsp[0].hex.ptr, yyvsp[0].hex.len));

			    trace(TR_PARSE, 0, "parse: %s ISO_ADDR: %A",
				  parse_where(),
				  yyval.sockaddr);

			    free_bytestr(&yyvsp[0].hex);
			}
break;
#line 5674 "y.tab.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("yydebug: after reduction, shifting from state 0 to\
 state %d\n", YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("yydebug: state %d, reading %d (%s)\n",
                        YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("yydebug: after reduction, shifting from state %d \
to state %d\n", *yyssp, yystate);
#endif
    if (yyssp >= yyss + yystacksize - 1)
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
